import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * Amazon Certificate Manager.
 *
 * @stability stable
 */
export interface AcmpcaCertificateAuthorityConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#enabled AcmpcaCertificateAuthority#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#permanent_deletion_time_in_days AcmpcaCertificateAuthority#permanent_deletion_time_in_days}.
     *
     * @stability stable
     */
    readonly permanentDeletionTimeInDays?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#tags AcmpcaCertificateAuthority#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#tags_all AcmpcaCertificateAuthority#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#type AcmpcaCertificateAuthority#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * certificate_authority_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#certificate_authority_configuration AcmpcaCertificateAuthority#certificate_authority_configuration}
     *
     * @stability stable
     */
    readonly certificateAuthorityConfiguration: AcmpcaCertificateAuthorityCertificateAuthorityConfiguration;
    /**
     * revocation_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#revocation_configuration AcmpcaCertificateAuthority#revocation_configuration}
     *
     * @stability stable
     */
    readonly revocationConfiguration?: AcmpcaCertificateAuthorityRevocationConfiguration;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#timeouts AcmpcaCertificateAuthority#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: AcmpcaCertificateAuthorityTimeouts;
}
/**
 * @stability stable
 */
export interface AcmpcaCertificateAuthorityCertificateAuthorityConfigurationSubject {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#common_name AcmpcaCertificateAuthority#common_name}.
     *
     * @stability stable
     */
    readonly commonName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#country AcmpcaCertificateAuthority#country}.
     *
     * @stability stable
     */
    readonly country?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#distinguished_name_qualifier AcmpcaCertificateAuthority#distinguished_name_qualifier}.
     *
     * @stability stable
     */
    readonly distinguishedNameQualifier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#generation_qualifier AcmpcaCertificateAuthority#generation_qualifier}.
     *
     * @stability stable
     */
    readonly generationQualifier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#given_name AcmpcaCertificateAuthority#given_name}.
     *
     * @stability stable
     */
    readonly givenName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#initials AcmpcaCertificateAuthority#initials}.
     *
     * @stability stable
     */
    readonly initials?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#locality AcmpcaCertificateAuthority#locality}.
     *
     * @stability stable
     */
    readonly locality?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#organization AcmpcaCertificateAuthority#organization}.
     *
     * @stability stable
     */
    readonly organization?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#organizational_unit AcmpcaCertificateAuthority#organizational_unit}.
     *
     * @stability stable
     */
    readonly organizationalUnit?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#pseudonym AcmpcaCertificateAuthority#pseudonym}.
     *
     * @stability stable
     */
    readonly pseudonym?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#state AcmpcaCertificateAuthority#state}.
     *
     * @stability stable
     */
    readonly state?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#surname AcmpcaCertificateAuthority#surname}.
     *
     * @stability stable
     */
    readonly surname?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#title AcmpcaCertificateAuthority#title}.
     *
     * @stability stable
     */
    readonly title?: string;
}
export declare function acmpcaCertificateAuthorityCertificateAuthorityConfigurationSubjectToTerraform(struct?: AcmpcaCertificateAuthorityCertificateAuthorityConfigurationSubjectOutputReference | AcmpcaCertificateAuthorityCertificateAuthorityConfigurationSubject): any;
/**
 * @stability stable
 */
export declare class AcmpcaCertificateAuthorityCertificateAuthorityConfigurationSubjectOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AcmpcaCertificateAuthorityCertificateAuthorityConfigurationSubject | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AcmpcaCertificateAuthorityCertificateAuthorityConfigurationSubject | undefined);
    private _commonName?;
    /**
     * @stability stable
     */
    get commonName(): string;
    /**
     * @stability stable
     */
    set commonName(value: string);
    /**
     * @stability stable
     */
    resetCommonName(): void;
    /**
     * @stability stable
     */
    get commonNameInput(): string | undefined;
    private _country?;
    /**
     * @stability stable
     */
    get country(): string;
    /**
     * @stability stable
     */
    set country(value: string);
    /**
     * @stability stable
     */
    resetCountry(): void;
    /**
     * @stability stable
     */
    get countryInput(): string | undefined;
    private _distinguishedNameQualifier?;
    /**
     * @stability stable
     */
    get distinguishedNameQualifier(): string;
    /**
     * @stability stable
     */
    set distinguishedNameQualifier(value: string);
    /**
     * @stability stable
     */
    resetDistinguishedNameQualifier(): void;
    /**
     * @stability stable
     */
    get distinguishedNameQualifierInput(): string | undefined;
    private _generationQualifier?;
    /**
     * @stability stable
     */
    get generationQualifier(): string;
    /**
     * @stability stable
     */
    set generationQualifier(value: string);
    /**
     * @stability stable
     */
    resetGenerationQualifier(): void;
    /**
     * @stability stable
     */
    get generationQualifierInput(): string | undefined;
    private _givenName?;
    /**
     * @stability stable
     */
    get givenName(): string;
    /**
     * @stability stable
     */
    set givenName(value: string);
    /**
     * @stability stable
     */
    resetGivenName(): void;
    /**
     * @stability stable
     */
    get givenNameInput(): string | undefined;
    private _initials?;
    /**
     * @stability stable
     */
    get initials(): string;
    /**
     * @stability stable
     */
    set initials(value: string);
    /**
     * @stability stable
     */
    resetInitials(): void;
    /**
     * @stability stable
     */
    get initialsInput(): string | undefined;
    private _locality?;
    /**
     * @stability stable
     */
    get locality(): string;
    /**
     * @stability stable
     */
    set locality(value: string);
    /**
     * @stability stable
     */
    resetLocality(): void;
    /**
     * @stability stable
     */
    get localityInput(): string | undefined;
    private _organization?;
    /**
     * @stability stable
     */
    get organization(): string;
    /**
     * @stability stable
     */
    set organization(value: string);
    /**
     * @stability stable
     */
    resetOrganization(): void;
    /**
     * @stability stable
     */
    get organizationInput(): string | undefined;
    private _organizationalUnit?;
    /**
     * @stability stable
     */
    get organizationalUnit(): string;
    /**
     * @stability stable
     */
    set organizationalUnit(value: string);
    /**
     * @stability stable
     */
    resetOrganizationalUnit(): void;
    /**
     * @stability stable
     */
    get organizationalUnitInput(): string | undefined;
    private _pseudonym?;
    /**
     * @stability stable
     */
    get pseudonym(): string;
    /**
     * @stability stable
     */
    set pseudonym(value: string);
    /**
     * @stability stable
     */
    resetPseudonym(): void;
    /**
     * @stability stable
     */
    get pseudonymInput(): string | undefined;
    private _state?;
    /**
     * @stability stable
     */
    get state(): string;
    /**
     * @stability stable
     */
    set state(value: string);
    /**
     * @stability stable
     */
    resetState(): void;
    /**
     * @stability stable
     */
    get stateInput(): string | undefined;
    private _surname?;
    /**
     * @stability stable
     */
    get surname(): string;
    /**
     * @stability stable
     */
    set surname(value: string);
    /**
     * @stability stable
     */
    resetSurname(): void;
    /**
     * @stability stable
     */
    get surnameInput(): string | undefined;
    private _title?;
    /**
     * @stability stable
     */
    get title(): string;
    /**
     * @stability stable
     */
    set title(value: string);
    /**
     * @stability stable
     */
    resetTitle(): void;
    /**
     * @stability stable
     */
    get titleInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AcmpcaCertificateAuthorityCertificateAuthorityConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#key_algorithm AcmpcaCertificateAuthority#key_algorithm}.
     *
     * @stability stable
     */
    readonly keyAlgorithm: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#signing_algorithm AcmpcaCertificateAuthority#signing_algorithm}.
     *
     * @stability stable
     */
    readonly signingAlgorithm: string;
    /**
     * subject block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#subject AcmpcaCertificateAuthority#subject}
     *
     * @stability stable
     */
    readonly subject: AcmpcaCertificateAuthorityCertificateAuthorityConfigurationSubject;
}
export declare function acmpcaCertificateAuthorityCertificateAuthorityConfigurationToTerraform(struct?: AcmpcaCertificateAuthorityCertificateAuthorityConfigurationOutputReference | AcmpcaCertificateAuthorityCertificateAuthorityConfiguration): any;
/**
 * @stability stable
 */
export declare class AcmpcaCertificateAuthorityCertificateAuthorityConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AcmpcaCertificateAuthorityCertificateAuthorityConfiguration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AcmpcaCertificateAuthorityCertificateAuthorityConfiguration | undefined);
    private _keyAlgorithm?;
    /**
     * @stability stable
     */
    get keyAlgorithm(): string;
    /**
     * @stability stable
     */
    set keyAlgorithm(value: string);
    /**
     * @stability stable
     */
    get keyAlgorithmInput(): string | undefined;
    private _signingAlgorithm?;
    /**
     * @stability stable
     */
    get signingAlgorithm(): string;
    /**
     * @stability stable
     */
    set signingAlgorithm(value: string);
    /**
     * @stability stable
     */
    get signingAlgorithmInput(): string | undefined;
    private _subject;
    /**
     * @stability stable
     */
    get subject(): AcmpcaCertificateAuthorityCertificateAuthorityConfigurationSubjectOutputReference;
    /**
     * @stability stable
     */
    putSubject(value: AcmpcaCertificateAuthorityCertificateAuthorityConfigurationSubject): void;
    /**
     * @stability stable
     */
    get subjectInput(): AcmpcaCertificateAuthorityCertificateAuthorityConfigurationSubject | undefined;
}
/**
 * @stability stable
 */
export interface AcmpcaCertificateAuthorityRevocationConfigurationCrlConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#custom_cname AcmpcaCertificateAuthority#custom_cname}.
     *
     * @stability stable
     */
    readonly customCname?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#enabled AcmpcaCertificateAuthority#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#expiration_in_days AcmpcaCertificateAuthority#expiration_in_days}.
     *
     * @stability stable
     */
    readonly expirationInDays: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#s3_bucket_name AcmpcaCertificateAuthority#s3_bucket_name}.
     *
     * @stability stable
     */
    readonly s3BucketName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#s3_object_acl AcmpcaCertificateAuthority#s3_object_acl}.
     *
     * @stability stable
     */
    readonly s3ObjectAcl?: string;
}
export declare function acmpcaCertificateAuthorityRevocationConfigurationCrlConfigurationToTerraform(struct?: AcmpcaCertificateAuthorityRevocationConfigurationCrlConfigurationOutputReference | AcmpcaCertificateAuthorityRevocationConfigurationCrlConfiguration): any;
/**
 * @stability stable
 */
export declare class AcmpcaCertificateAuthorityRevocationConfigurationCrlConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AcmpcaCertificateAuthorityRevocationConfigurationCrlConfiguration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AcmpcaCertificateAuthorityRevocationConfigurationCrlConfiguration | undefined);
    private _customCname?;
    /**
     * @stability stable
     */
    get customCname(): string;
    /**
     * @stability stable
     */
    set customCname(value: string);
    /**
     * @stability stable
     */
    resetCustomCname(): void;
    /**
     * @stability stable
     */
    get customCnameInput(): string | undefined;
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _expirationInDays?;
    /**
     * @stability stable
     */
    get expirationInDays(): number;
    /**
     * @stability stable
     */
    set expirationInDays(value: number);
    /**
     * @stability stable
     */
    get expirationInDaysInput(): number | undefined;
    private _s3BucketName?;
    /**
     * @stability stable
     */
    get s3BucketName(): string;
    /**
     * @stability stable
     */
    set s3BucketName(value: string);
    /**
     * @stability stable
     */
    resetS3BucketName(): void;
    /**
     * @stability stable
     */
    get s3BucketNameInput(): string | undefined;
    private _s3ObjectAcl?;
    /**
     * @stability stable
     */
    get s3ObjectAcl(): string;
    /**
     * @stability stable
     */
    set s3ObjectAcl(value: string);
    /**
     * @stability stable
     */
    resetS3ObjectAcl(): void;
    /**
     * @stability stable
     */
    get s3ObjectAclInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AcmpcaCertificateAuthorityRevocationConfiguration {
    /**
     * crl_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#crl_configuration AcmpcaCertificateAuthority#crl_configuration}
     *
     * @stability stable
     */
    readonly crlConfiguration?: AcmpcaCertificateAuthorityRevocationConfigurationCrlConfiguration;
}
export declare function acmpcaCertificateAuthorityRevocationConfigurationToTerraform(struct?: AcmpcaCertificateAuthorityRevocationConfigurationOutputReference | AcmpcaCertificateAuthorityRevocationConfiguration): any;
/**
 * @stability stable
 */
export declare class AcmpcaCertificateAuthorityRevocationConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AcmpcaCertificateAuthorityRevocationConfiguration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AcmpcaCertificateAuthorityRevocationConfiguration | undefined);
    private _crlConfiguration;
    /**
     * @stability stable
     */
    get crlConfiguration(): AcmpcaCertificateAuthorityRevocationConfigurationCrlConfigurationOutputReference;
    /**
     * @stability stable
     */
    putCrlConfiguration(value: AcmpcaCertificateAuthorityRevocationConfigurationCrlConfiguration): void;
    /**
     * @stability stable
     */
    resetCrlConfiguration(): void;
    /**
     * @stability stable
     */
    get crlConfigurationInput(): AcmpcaCertificateAuthorityRevocationConfigurationCrlConfiguration | undefined;
}
/**
 * @stability stable
 */
export interface AcmpcaCertificateAuthorityTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority#create AcmpcaCertificateAuthority#create}.
     *
     * @stability stable
     */
    readonly create?: string;
}
export declare function acmpcaCertificateAuthorityTimeoutsToTerraform(struct?: AcmpcaCertificateAuthorityTimeoutsOutputReference | AcmpcaCertificateAuthorityTimeouts | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export declare class AcmpcaCertificateAuthorityTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AcmpcaCertificateAuthorityTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AcmpcaCertificateAuthorityTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority aws_acmpca_certificate_authority}.
 *
 * @stability stable
 */
export declare class AcmpcaCertificateAuthority extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/acmpca_certificate_authority aws_acmpca_certificate_authority} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AcmpcaCertificateAuthorityConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get certificate(): string;
    /**
     * @stability stable
     */
    get certificateChain(): string;
    /**
     * @stability stable
     */
    get certificateSigningRequest(): string;
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get notAfter(): string;
    /**
     * @stability stable
     */
    get notBefore(): string;
    private _permanentDeletionTimeInDays?;
    /**
     * @stability stable
     */
    get permanentDeletionTimeInDays(): number;
    /**
     * @stability stable
     */
    set permanentDeletionTimeInDays(value: number);
    /**
     * @stability stable
     */
    resetPermanentDeletionTimeInDays(): void;
    /**
     * @stability stable
     */
    get permanentDeletionTimeInDaysInput(): number | undefined;
    /**
     * @stability stable
     */
    get serial(): string;
    /**
     * @stability stable
     */
    get status(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    resetType(): void;
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _certificateAuthorityConfiguration;
    /**
     * @stability stable
     */
    get certificateAuthorityConfiguration(): AcmpcaCertificateAuthorityCertificateAuthorityConfigurationOutputReference;
    /**
     * @stability stable
     */
    putCertificateAuthorityConfiguration(value: AcmpcaCertificateAuthorityCertificateAuthorityConfiguration): void;
    /**
     * @stability stable
     */
    get certificateAuthorityConfigurationInput(): AcmpcaCertificateAuthorityCertificateAuthorityConfiguration | undefined;
    private _revocationConfiguration;
    /**
     * @stability stable
     */
    get revocationConfiguration(): AcmpcaCertificateAuthorityRevocationConfigurationOutputReference;
    /**
     * @stability stable
     */
    putRevocationConfiguration(value: AcmpcaCertificateAuthorityRevocationConfiguration): void;
    /**
     * @stability stable
     */
    resetRevocationConfiguration(): void;
    /**
     * @stability stable
     */
    get revocationConfigurationInput(): AcmpcaCertificateAuthorityRevocationConfiguration | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): AcmpcaCertificateAuthorityTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: AcmpcaCertificateAuthorityTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): AcmpcaCertificateAuthorityTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
