import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * API Gateway.
 *
 * @stability stable
 */
export interface ApiGatewayAuthorizerConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_authorizer#authorizer_credentials ApiGatewayAuthorizer#authorizer_credentials}.
     *
     * @stability stable
     */
    readonly authorizerCredentials?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_authorizer#authorizer_result_ttl_in_seconds ApiGatewayAuthorizer#authorizer_result_ttl_in_seconds}.
     *
     * @stability stable
     */
    readonly authorizerResultTtlInSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_authorizer#authorizer_uri ApiGatewayAuthorizer#authorizer_uri}.
     *
     * @stability stable
     */
    readonly authorizerUri?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_authorizer#identity_source ApiGatewayAuthorizer#identity_source}.
     *
     * @stability stable
     */
    readonly identitySource?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_authorizer#identity_validation_expression ApiGatewayAuthorizer#identity_validation_expression}.
     *
     * @stability stable
     */
    readonly identityValidationExpression?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_authorizer#name ApiGatewayAuthorizer#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_authorizer#provider_arns ApiGatewayAuthorizer#provider_arns}.
     *
     * @stability stable
     */
    readonly providerArns?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_authorizer#rest_api_id ApiGatewayAuthorizer#rest_api_id}.
     *
     * @stability stable
     */
    readonly restApiId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_authorizer#type ApiGatewayAuthorizer#type}.
     *
     * @stability stable
     */
    readonly type?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_authorizer aws_api_gateway_authorizer}.
 *
 * @stability stable
 */
export declare class ApiGatewayAuthorizer extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_authorizer aws_api_gateway_authorizer} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ApiGatewayAuthorizerConfig);
    private _authorizerCredentials?;
    /**
     * @stability stable
     */
    get authorizerCredentials(): string;
    /**
     * @stability stable
     */
    set authorizerCredentials(value: string);
    /**
     * @stability stable
     */
    resetAuthorizerCredentials(): void;
    /**
     * @stability stable
     */
    get authorizerCredentialsInput(): string | undefined;
    private _authorizerResultTtlInSeconds?;
    /**
     * @stability stable
     */
    get authorizerResultTtlInSeconds(): number;
    /**
     * @stability stable
     */
    set authorizerResultTtlInSeconds(value: number);
    /**
     * @stability stable
     */
    resetAuthorizerResultTtlInSeconds(): void;
    /**
     * @stability stable
     */
    get authorizerResultTtlInSecondsInput(): number | undefined;
    private _authorizerUri?;
    /**
     * @stability stable
     */
    get authorizerUri(): string;
    /**
     * @stability stable
     */
    set authorizerUri(value: string);
    /**
     * @stability stable
     */
    resetAuthorizerUri(): void;
    /**
     * @stability stable
     */
    get authorizerUriInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _identitySource?;
    /**
     * @stability stable
     */
    get identitySource(): string;
    /**
     * @stability stable
     */
    set identitySource(value: string);
    /**
     * @stability stable
     */
    resetIdentitySource(): void;
    /**
     * @stability stable
     */
    get identitySourceInput(): string | undefined;
    private _identityValidationExpression?;
    /**
     * @stability stable
     */
    get identityValidationExpression(): string;
    /**
     * @stability stable
     */
    set identityValidationExpression(value: string);
    /**
     * @stability stable
     */
    resetIdentityValidationExpression(): void;
    /**
     * @stability stable
     */
    get identityValidationExpressionInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _providerArns?;
    /**
     * @stability stable
     */
    get providerArns(): string[];
    /**
     * @stability stable
     */
    set providerArns(value: string[]);
    /**
     * @stability stable
     */
    resetProviderArns(): void;
    /**
     * @stability stable
     */
    get providerArnsInput(): string[] | undefined;
    private _restApiId?;
    /**
     * @stability stable
     */
    get restApiId(): string;
    /**
     * @stability stable
     */
    set restApiId(value: string);
    /**
     * @stability stable
     */
    get restApiIdInput(): string | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    resetType(): void;
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
