import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * API Gateway.
 *
 * @stability stable
 */
export interface DataAwsApiGatewayRestApiConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/api_gateway_rest_api#name DataAwsApiGatewayRestApi#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/api_gateway_rest_api#tags DataAwsApiGatewayRestApi#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataAwsApiGatewayRestApiEndpointConfiguration extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get types(): string[];
    /**
     * @stability stable
     */
    get vpcEndpointIds(): string[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/api_gateway_rest_api aws_api_gateway_rest_api}.
 *
 * @stability stable
 */
export declare class DataAwsApiGatewayRestApi extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/api_gateway_rest_api aws_api_gateway_rest_api} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsApiGatewayRestApiConfig);
    /**
     * @stability stable
     */
    get apiKeySource(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get binaryMediaTypes(): string[];
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    endpointConfiguration(index: string): DataAwsApiGatewayRestApiEndpointConfiguration;
    /**
     * @stability stable
     */
    get executionArn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get minimumCompressionSize(): number;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get policy(): string;
    /**
     * @stability stable
     */
    get rootResourceId(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
