import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * Amazon API Gateway Websocket and HTTP APIs.
 *
 * @stability stable
 */
export interface Apigatewayv2DomainNameConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name#domain_name Apigatewayv2DomainName#domain_name}.
     *
     * @stability stable
     */
    readonly domainName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name#tags Apigatewayv2DomainName#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name#tags_all Apigatewayv2DomainName#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * domain_name_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name#domain_name_configuration Apigatewayv2DomainName#domain_name_configuration}
     *
     * @stability stable
     */
    readonly domainNameConfiguration: Apigatewayv2DomainNameDomainNameConfiguration;
    /**
     * mutual_tls_authentication block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name#mutual_tls_authentication Apigatewayv2DomainName#mutual_tls_authentication}
     *
     * @stability stable
     */
    readonly mutualTlsAuthentication?: Apigatewayv2DomainNameMutualTlsAuthentication;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name#timeouts Apigatewayv2DomainName#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: Apigatewayv2DomainNameTimeouts;
}
/**
 * @stability stable
 */
export interface Apigatewayv2DomainNameDomainNameConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name#certificate_arn Apigatewayv2DomainName#certificate_arn}.
     *
     * @stability stable
     */
    readonly certificateArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name#endpoint_type Apigatewayv2DomainName#endpoint_type}.
     *
     * @stability stable
     */
    readonly endpointType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name#security_policy Apigatewayv2DomainName#security_policy}.
     *
     * @stability stable
     */
    readonly securityPolicy: string;
}
export declare function apigatewayv2DomainNameDomainNameConfigurationToTerraform(struct?: Apigatewayv2DomainNameDomainNameConfigurationOutputReference | Apigatewayv2DomainNameDomainNameConfiguration): any;
/**
 * @stability stable
 */
export declare class Apigatewayv2DomainNameDomainNameConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Apigatewayv2DomainNameDomainNameConfiguration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Apigatewayv2DomainNameDomainNameConfiguration | undefined);
    private _certificateArn?;
    /**
     * @stability stable
     */
    get certificateArn(): string;
    /**
     * @stability stable
     */
    set certificateArn(value: string);
    /**
     * @stability stable
     */
    get certificateArnInput(): string | undefined;
    private _endpointType?;
    /**
     * @stability stable
     */
    get endpointType(): string;
    /**
     * @stability stable
     */
    set endpointType(value: string);
    /**
     * @stability stable
     */
    get endpointTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get hostedZoneId(): string;
    private _securityPolicy?;
    /**
     * @stability stable
     */
    get securityPolicy(): string;
    /**
     * @stability stable
     */
    set securityPolicy(value: string);
    /**
     * @stability stable
     */
    get securityPolicyInput(): string | undefined;
    /**
     * @stability stable
     */
    get targetDomainName(): string;
}
/**
 * @stability stable
 */
export interface Apigatewayv2DomainNameMutualTlsAuthentication {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name#truststore_uri Apigatewayv2DomainName#truststore_uri}.
     *
     * @stability stable
     */
    readonly truststoreUri: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name#truststore_version Apigatewayv2DomainName#truststore_version}.
     *
     * @stability stable
     */
    readonly truststoreVersion?: string;
}
export declare function apigatewayv2DomainNameMutualTlsAuthenticationToTerraform(struct?: Apigatewayv2DomainNameMutualTlsAuthenticationOutputReference | Apigatewayv2DomainNameMutualTlsAuthentication): any;
/**
 * @stability stable
 */
export declare class Apigatewayv2DomainNameMutualTlsAuthenticationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Apigatewayv2DomainNameMutualTlsAuthentication | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Apigatewayv2DomainNameMutualTlsAuthentication | undefined);
    private _truststoreUri?;
    /**
     * @stability stable
     */
    get truststoreUri(): string;
    /**
     * @stability stable
     */
    set truststoreUri(value: string);
    /**
     * @stability stable
     */
    get truststoreUriInput(): string | undefined;
    private _truststoreVersion?;
    /**
     * @stability stable
     */
    get truststoreVersion(): string;
    /**
     * @stability stable
     */
    set truststoreVersion(value: string);
    /**
     * @stability stable
     */
    resetTruststoreVersion(): void;
    /**
     * @stability stable
     */
    get truststoreVersionInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface Apigatewayv2DomainNameTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name#create Apigatewayv2DomainName#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name#update Apigatewayv2DomainName#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function apigatewayv2DomainNameTimeoutsToTerraform(struct?: Apigatewayv2DomainNameTimeoutsOutputReference | Apigatewayv2DomainNameTimeouts | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export declare class Apigatewayv2DomainNameTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Apigatewayv2DomainNameTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Apigatewayv2DomainNameTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name aws_apigatewayv2_domain_name}.
 *
 * @stability stable
 */
export declare class Apigatewayv2DomainName extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_domain_name aws_apigatewayv2_domain_name} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Apigatewayv2DomainNameConfig);
    /**
     * @stability stable
     */
    get apiMappingSelectionExpression(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _domainName?;
    /**
     * @stability stable
     */
    get domainName(): string;
    /**
     * @stability stable
     */
    set domainName(value: string);
    /**
     * @stability stable
     */
    get domainNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _domainNameConfiguration;
    /**
     * @stability stable
     */
    get domainNameConfiguration(): Apigatewayv2DomainNameDomainNameConfigurationOutputReference;
    /**
     * @stability stable
     */
    putDomainNameConfiguration(value: Apigatewayv2DomainNameDomainNameConfiguration): void;
    /**
     * @stability stable
     */
    get domainNameConfigurationInput(): Apigatewayv2DomainNameDomainNameConfiguration | undefined;
    private _mutualTlsAuthentication;
    /**
     * @stability stable
     */
    get mutualTlsAuthentication(): Apigatewayv2DomainNameMutualTlsAuthenticationOutputReference;
    /**
     * @stability stable
     */
    putMutualTlsAuthentication(value: Apigatewayv2DomainNameMutualTlsAuthentication): void;
    /**
     * @stability stable
     */
    resetMutualTlsAuthentication(): void;
    /**
     * @stability stable
     */
    get mutualTlsAuthenticationInput(): Apigatewayv2DomainNameMutualTlsAuthentication | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): Apigatewayv2DomainNameTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: Apigatewayv2DomainNameTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): Apigatewayv2DomainNameTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
