import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * Amazon API Gateway Websocket and HTTP APIs.
 *
 * @stability stable
 */
export interface Apigatewayv2StageConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage#api_id Apigatewayv2Stage#api_id}.
     *
     * @stability stable
     */
    readonly apiId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage#auto_deploy Apigatewayv2Stage#auto_deploy}.
     *
     * @stability stable
     */
    readonly autoDeploy?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage#client_certificate_id Apigatewayv2Stage#client_certificate_id}.
     *
     * @stability stable
     */
    readonly clientCertificateId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage#deployment_id Apigatewayv2Stage#deployment_id}.
     *
     * @stability stable
     */
    readonly deploymentId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage#description Apigatewayv2Stage#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage#name Apigatewayv2Stage#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage#stage_variables Apigatewayv2Stage#stage_variables}.
     *
     * @stability stable
     */
    readonly stageVariables?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage#tags Apigatewayv2Stage#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage#tags_all Apigatewayv2Stage#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * access_log_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage#access_log_settings Apigatewayv2Stage#access_log_settings}
     *
     * @stability stable
     */
    readonly accessLogSettings?: Apigatewayv2StageAccessLogSettings;
    /**
     * default_route_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage#default_route_settings Apigatewayv2Stage#default_route_settings}
     *
     * @stability stable
     */
    readonly defaultRouteSettings?: Apigatewayv2StageDefaultRouteSettings;
    /**
     * route_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage#route_settings Apigatewayv2Stage#route_settings}
     *
     * @stability stable
     */
    readonly routeSettings?: Apigatewayv2StageRouteSettings[] | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface Apigatewayv2StageAccessLogSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage#destination_arn Apigatewayv2Stage#destination_arn}.
     *
     * @stability stable
     */
    readonly destinationArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage#format Apigatewayv2Stage#format}.
     *
     * @stability stable
     */
    readonly format: string;
}
export declare function apigatewayv2StageAccessLogSettingsToTerraform(struct?: Apigatewayv2StageAccessLogSettingsOutputReference | Apigatewayv2StageAccessLogSettings): any;
/**
 * @stability stable
 */
export declare class Apigatewayv2StageAccessLogSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Apigatewayv2StageAccessLogSettings | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Apigatewayv2StageAccessLogSettings | undefined);
    private _destinationArn?;
    /**
     * @stability stable
     */
    get destinationArn(): string;
    /**
     * @stability stable
     */
    set destinationArn(value: string);
    /**
     * @stability stable
     */
    get destinationArnInput(): string | undefined;
    private _format?;
    /**
     * @stability stable
     */
    get format(): string;
    /**
     * @stability stable
     */
    set format(value: string);
    /**
     * @stability stable
     */
    get formatInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface Apigatewayv2StageDefaultRouteSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage#data_trace_enabled Apigatewayv2Stage#data_trace_enabled}.
     *
     * @stability stable
     */
    readonly dataTraceEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage#detailed_metrics_enabled Apigatewayv2Stage#detailed_metrics_enabled}.
     *
     * @stability stable
     */
    readonly detailedMetricsEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage#logging_level Apigatewayv2Stage#logging_level}.
     *
     * @stability stable
     */
    readonly loggingLevel?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage#throttling_burst_limit Apigatewayv2Stage#throttling_burst_limit}.
     *
     * @stability stable
     */
    readonly throttlingBurstLimit?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage#throttling_rate_limit Apigatewayv2Stage#throttling_rate_limit}.
     *
     * @stability stable
     */
    readonly throttlingRateLimit?: number;
}
export declare function apigatewayv2StageDefaultRouteSettingsToTerraform(struct?: Apigatewayv2StageDefaultRouteSettingsOutputReference | Apigatewayv2StageDefaultRouteSettings): any;
/**
 * @stability stable
 */
export declare class Apigatewayv2StageDefaultRouteSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Apigatewayv2StageDefaultRouteSettings | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Apigatewayv2StageDefaultRouteSettings | undefined);
    private _dataTraceEnabled?;
    /**
     * @stability stable
     */
    get dataTraceEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set dataTraceEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDataTraceEnabled(): void;
    /**
     * @stability stable
     */
    get dataTraceEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _detailedMetricsEnabled?;
    /**
     * @stability stable
     */
    get detailedMetricsEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set detailedMetricsEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDetailedMetricsEnabled(): void;
    /**
     * @stability stable
     */
    get detailedMetricsEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _loggingLevel?;
    /**
     * @stability stable
     */
    get loggingLevel(): string;
    /**
     * @stability stable
     */
    set loggingLevel(value: string);
    /**
     * @stability stable
     */
    resetLoggingLevel(): void;
    /**
     * @stability stable
     */
    get loggingLevelInput(): string | undefined;
    private _throttlingBurstLimit?;
    /**
     * @stability stable
     */
    get throttlingBurstLimit(): number;
    /**
     * @stability stable
     */
    set throttlingBurstLimit(value: number);
    /**
     * @stability stable
     */
    resetThrottlingBurstLimit(): void;
    /**
     * @stability stable
     */
    get throttlingBurstLimitInput(): number | undefined;
    private _throttlingRateLimit?;
    /**
     * @stability stable
     */
    get throttlingRateLimit(): number;
    /**
     * @stability stable
     */
    set throttlingRateLimit(value: number);
    /**
     * @stability stable
     */
    resetThrottlingRateLimit(): void;
    /**
     * @stability stable
     */
    get throttlingRateLimitInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface Apigatewayv2StageRouteSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage#data_trace_enabled Apigatewayv2Stage#data_trace_enabled}.
     *
     * @stability stable
     */
    readonly dataTraceEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage#detailed_metrics_enabled Apigatewayv2Stage#detailed_metrics_enabled}.
     *
     * @stability stable
     */
    readonly detailedMetricsEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage#logging_level Apigatewayv2Stage#logging_level}.
     *
     * @stability stable
     */
    readonly loggingLevel?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage#route_key Apigatewayv2Stage#route_key}.
     *
     * @stability stable
     */
    readonly routeKey: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage#throttling_burst_limit Apigatewayv2Stage#throttling_burst_limit}.
     *
     * @stability stable
     */
    readonly throttlingBurstLimit?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage#throttling_rate_limit Apigatewayv2Stage#throttling_rate_limit}.
     *
     * @stability stable
     */
    readonly throttlingRateLimit?: number;
}
export declare function apigatewayv2StageRouteSettingsToTerraform(struct?: Apigatewayv2StageRouteSettings | cdktf.IResolvable): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage aws_apigatewayv2_stage}.
 *
 * @stability stable
 */
export declare class Apigatewayv2Stage extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_stage aws_apigatewayv2_stage} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Apigatewayv2StageConfig);
    private _apiId?;
    /**
     * @stability stable
     */
    get apiId(): string;
    /**
     * @stability stable
     */
    set apiId(value: string);
    /**
     * @stability stable
     */
    get apiIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoDeploy?;
    /**
     * @stability stable
     */
    get autoDeploy(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set autoDeploy(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAutoDeploy(): void;
    /**
     * @stability stable
     */
    get autoDeployInput(): boolean | cdktf.IResolvable | undefined;
    private _clientCertificateId?;
    /**
     * @stability stable
     */
    get clientCertificateId(): string;
    /**
     * @stability stable
     */
    set clientCertificateId(value: string);
    /**
     * @stability stable
     */
    resetClientCertificateId(): void;
    /**
     * @stability stable
     */
    get clientCertificateIdInput(): string | undefined;
    private _deploymentId?;
    /**
     * @stability stable
     */
    get deploymentId(): string;
    /**
     * @stability stable
     */
    set deploymentId(value: string);
    /**
     * @stability stable
     */
    resetDeploymentId(): void;
    /**
     * @stability stable
     */
    get deploymentIdInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get executionArn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get invokeUrl(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _stageVariables?;
    /**
     * @stability stable
     */
    get stageVariables(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set stageVariables(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetStageVariables(): void;
    /**
     * @stability stable
     */
    get stageVariablesInput(): {
        [key: string]: string;
    } | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _accessLogSettings;
    /**
     * @stability stable
     */
    get accessLogSettings(): Apigatewayv2StageAccessLogSettingsOutputReference;
    /**
     * @stability stable
     */
    putAccessLogSettings(value: Apigatewayv2StageAccessLogSettings): void;
    /**
     * @stability stable
     */
    resetAccessLogSettings(): void;
    /**
     * @stability stable
     */
    get accessLogSettingsInput(): Apigatewayv2StageAccessLogSettings | undefined;
    private _defaultRouteSettings;
    /**
     * @stability stable
     */
    get defaultRouteSettings(): Apigatewayv2StageDefaultRouteSettingsOutputReference;
    /**
     * @stability stable
     */
    putDefaultRouteSettings(value: Apigatewayv2StageDefaultRouteSettings): void;
    /**
     * @stability stable
     */
    resetDefaultRouteSettings(): void;
    /**
     * @stability stable
     */
    get defaultRouteSettingsInput(): Apigatewayv2StageDefaultRouteSettings | undefined;
    private _routeSettings?;
    /**
     * @stability stable
     */
    get routeSettings(): Apigatewayv2StageRouteSettings[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set routeSettings(value: Apigatewayv2StageRouteSettings[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetRouteSettings(): void;
    /**
     * @stability stable
     */
    get routeSettingsInput(): cdktf.IResolvable | Apigatewayv2StageRouteSettings[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
