import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * App Mesh.
 *
 * @stability stable
 */
export interface AppmeshVirtualServiceConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service#mesh_name AppmeshVirtualService#mesh_name}.
     *
     * @stability stable
     */
    readonly meshName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service#mesh_owner AppmeshVirtualService#mesh_owner}.
     *
     * @stability stable
     */
    readonly meshOwner?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service#name AppmeshVirtualService#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service#tags AppmeshVirtualService#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service#tags_all AppmeshVirtualService#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * spec block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service#spec AppmeshVirtualService#spec}
     *
     * @stability stable
     */
    readonly spec: AppmeshVirtualServiceSpec;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualServiceSpecProviderVirtualNode {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service#virtual_node_name AppmeshVirtualService#virtual_node_name}.
     *
     * @stability stable
     */
    readonly virtualNodeName: string;
}
export declare function appmeshVirtualServiceSpecProviderVirtualNodeToTerraform(struct?: AppmeshVirtualServiceSpecProviderVirtualNodeOutputReference | AppmeshVirtualServiceSpecProviderVirtualNode): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualServiceSpecProviderVirtualNodeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualServiceSpecProviderVirtualNode | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualServiceSpecProviderVirtualNode | undefined);
    private _virtualNodeName?;
    /**
     * @stability stable
     */
    get virtualNodeName(): string;
    /**
     * @stability stable
     */
    set virtualNodeName(value: string);
    /**
     * @stability stable
     */
    get virtualNodeNameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualServiceSpecProviderVirtualRouter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service#virtual_router_name AppmeshVirtualService#virtual_router_name}.
     *
     * @stability stable
     */
    readonly virtualRouterName: string;
}
export declare function appmeshVirtualServiceSpecProviderVirtualRouterToTerraform(struct?: AppmeshVirtualServiceSpecProviderVirtualRouterOutputReference | AppmeshVirtualServiceSpecProviderVirtualRouter): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualServiceSpecProviderVirtualRouterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualServiceSpecProviderVirtualRouter | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualServiceSpecProviderVirtualRouter | undefined);
    private _virtualRouterName?;
    /**
     * @stability stable
     */
    get virtualRouterName(): string;
    /**
     * @stability stable
     */
    set virtualRouterName(value: string);
    /**
     * @stability stable
     */
    get virtualRouterNameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualServiceSpecProvider {
    /**
     * virtual_node block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service#virtual_node AppmeshVirtualService#virtual_node}
     *
     * @stability stable
     */
    readonly virtualNode?: AppmeshVirtualServiceSpecProviderVirtualNode;
    /**
     * virtual_router block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service#virtual_router AppmeshVirtualService#virtual_router}
     *
     * @stability stable
     */
    readonly virtualRouter?: AppmeshVirtualServiceSpecProviderVirtualRouter;
}
export declare function appmeshVirtualServiceSpecProviderToTerraform(struct?: AppmeshVirtualServiceSpecProviderOutputReference | AppmeshVirtualServiceSpecProvider): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualServiceSpecProviderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualServiceSpecProvider | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualServiceSpecProvider | undefined);
    private _virtualNode;
    /**
     * @stability stable
     */
    get virtualNode(): AppmeshVirtualServiceSpecProviderVirtualNodeOutputReference;
    /**
     * @stability stable
     */
    putVirtualNode(value: AppmeshVirtualServiceSpecProviderVirtualNode): void;
    /**
     * @stability stable
     */
    resetVirtualNode(): void;
    /**
     * @stability stable
     */
    get virtualNodeInput(): AppmeshVirtualServiceSpecProviderVirtualNode | undefined;
    private _virtualRouter;
    /**
     * @stability stable
     */
    get virtualRouter(): AppmeshVirtualServiceSpecProviderVirtualRouterOutputReference;
    /**
     * @stability stable
     */
    putVirtualRouter(value: AppmeshVirtualServiceSpecProviderVirtualRouter): void;
    /**
     * @stability stable
     */
    resetVirtualRouter(): void;
    /**
     * @stability stable
     */
    get virtualRouterInput(): AppmeshVirtualServiceSpecProviderVirtualRouter | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualServiceSpec {
    /**
     * provider block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service#provider AppmeshVirtualService#provider}
     *
     * @stability stable
     */
    readonly provider?: AppmeshVirtualServiceSpecProvider;
}
export declare function appmeshVirtualServiceSpecToTerraform(struct?: AppmeshVirtualServiceSpecOutputReference | AppmeshVirtualServiceSpec): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualServiceSpecOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualServiceSpec | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualServiceSpec | undefined);
    private _provider;
    /**
     * @stability stable
     */
    get provider(): AppmeshVirtualServiceSpecProviderOutputReference;
    /**
     * @stability stable
     */
    putProvider(value: AppmeshVirtualServiceSpecProvider): void;
    /**
     * @stability stable
     */
    resetProvider(): void;
    /**
     * @stability stable
     */
    get providerInput(): AppmeshVirtualServiceSpecProvider | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service aws_appmesh_virtual_service}.
 *
 * @stability stable
 */
export declare class AppmeshVirtualService extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_service aws_appmesh_virtual_service} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppmeshVirtualServiceConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get createdDate(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastUpdatedDate(): string;
    private _meshName?;
    /**
     * @stability stable
     */
    get meshName(): string;
    /**
     * @stability stable
     */
    set meshName(value: string);
    /**
     * @stability stable
     */
    get meshNameInput(): string | undefined;
    private _meshOwner?;
    /**
     * @stability stable
     */
    get meshOwner(): string;
    /**
     * @stability stable
     */
    set meshOwner(value: string);
    /**
     * @stability stable
     */
    resetMeshOwner(): void;
    /**
     * @stability stable
     */
    get meshOwnerInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get resourceOwner(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _spec;
    /**
     * @stability stable
     */
    get spec(): AppmeshVirtualServiceSpecOutputReference;
    /**
     * @stability stable
     */
    putSpec(value: AppmeshVirtualServiceSpec): void;
    /**
     * @stability stable
     */
    get specInput(): AppmeshVirtualServiceSpec | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
