import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AppStream.
 *
 * @stability stable
 */
export interface AppstreamDirectoryConfigConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_directory_config#directory_name AppstreamDirectoryConfig#directory_name}.
     *
     * @stability stable
     */
    readonly directoryName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_directory_config#organizational_unit_distinguished_names AppstreamDirectoryConfig#organizational_unit_distinguished_names}.
     *
     * @stability stable
     */
    readonly organizationalUnitDistinguishedNames: string[];
    /**
     * service_account_credentials block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_directory_config#service_account_credentials AppstreamDirectoryConfig#service_account_credentials}
     *
     * @stability stable
     */
    readonly serviceAccountCredentials: AppstreamDirectoryConfigServiceAccountCredentials;
}
/**
 * @stability stable
 */
export interface AppstreamDirectoryConfigServiceAccountCredentials {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_directory_config#account_name AppstreamDirectoryConfig#account_name}.
     *
     * @stability stable
     */
    readonly accountName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_directory_config#account_password AppstreamDirectoryConfig#account_password}.
     *
     * @stability stable
     */
    readonly accountPassword: string;
}
export declare function appstreamDirectoryConfigServiceAccountCredentialsToTerraform(struct?: AppstreamDirectoryConfigServiceAccountCredentialsOutputReference | AppstreamDirectoryConfigServiceAccountCredentials): any;
/**
 * @stability stable
 */
export declare class AppstreamDirectoryConfigServiceAccountCredentialsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppstreamDirectoryConfigServiceAccountCredentials | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppstreamDirectoryConfigServiceAccountCredentials | undefined);
    private _accountName?;
    /**
     * @stability stable
     */
    get accountName(): string;
    /**
     * @stability stable
     */
    set accountName(value: string);
    /**
     * @stability stable
     */
    get accountNameInput(): string | undefined;
    private _accountPassword?;
    /**
     * @stability stable
     */
    get accountPassword(): string;
    /**
     * @stability stable
     */
    set accountPassword(value: string);
    /**
     * @stability stable
     */
    get accountPasswordInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appstream_directory_config aws_appstream_directory_config}.
 *
 * @stability stable
 */
export declare class AppstreamDirectoryConfig extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appstream_directory_config aws_appstream_directory_config} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppstreamDirectoryConfigConfig);
    /**
     * @stability stable
     */
    get createdTime(): string;
    private _directoryName?;
    /**
     * @stability stable
     */
    get directoryName(): string;
    /**
     * @stability stable
     */
    set directoryName(value: string);
    /**
     * @stability stable
     */
    get directoryNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _organizationalUnitDistinguishedNames?;
    /**
     * @stability stable
     */
    get organizationalUnitDistinguishedNames(): string[];
    /**
     * @stability stable
     */
    set organizationalUnitDistinguishedNames(value: string[]);
    /**
     * @stability stable
     */
    get organizationalUnitDistinguishedNamesInput(): string[] | undefined;
    private _serviceAccountCredentials;
    /**
     * @stability stable
     */
    get serviceAccountCredentials(): AppstreamDirectoryConfigServiceAccountCredentialsOutputReference;
    /**
     * @stability stable
     */
    putServiceAccountCredentials(value: AppstreamDirectoryConfigServiceAccountCredentials): void;
    /**
     * @stability stable
     */
    get serviceAccountCredentialsInput(): AppstreamDirectoryConfigServiceAccountCredentials | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
