import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AppStream.
 *
 * @stability stable
 */
export interface AppstreamImageBuilderConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder#appstream_agent_version AppstreamImageBuilder#appstream_agent_version}.
     *
     * @stability stable
     */
    readonly appstreamAgentVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder#description AppstreamImageBuilder#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder#display_name AppstreamImageBuilder#display_name}.
     *
     * @stability stable
     */
    readonly displayName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder#enable_default_internet_access AppstreamImageBuilder#enable_default_internet_access}.
     *
     * @stability stable
     */
    readonly enableDefaultInternetAccess?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder#iam_role_arn AppstreamImageBuilder#iam_role_arn}.
     *
     * @stability stable
     */
    readonly iamRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder#image_arn AppstreamImageBuilder#image_arn}.
     *
     * @stability stable
     */
    readonly imageArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder#image_name AppstreamImageBuilder#image_name}.
     *
     * @stability stable
     */
    readonly imageName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder#instance_type AppstreamImageBuilder#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder#name AppstreamImageBuilder#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder#tags AppstreamImageBuilder#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder#tags_all AppstreamImageBuilder#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * access_endpoint block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder#access_endpoint AppstreamImageBuilder#access_endpoint}
     *
     * @stability stable
     */
    readonly accessEndpoint?: AppstreamImageBuilderAccessEndpoint[] | cdktf.IResolvable;
    /**
     * domain_join_info block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder#domain_join_info AppstreamImageBuilder#domain_join_info}
     *
     * @stability stable
     */
    readonly domainJoinInfo?: AppstreamImageBuilderDomainJoinInfo;
    /**
     * vpc_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder#vpc_config AppstreamImageBuilder#vpc_config}
     *
     * @stability stable
     */
    readonly vpcConfig?: AppstreamImageBuilderVpcConfig;
}
/**
 * @stability stable
 */
export interface AppstreamImageBuilderAccessEndpoint {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder#endpoint_type AppstreamImageBuilder#endpoint_type}.
     *
     * @stability stable
     */
    readonly endpointType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder#vpce_id AppstreamImageBuilder#vpce_id}.
     *
     * @stability stable
     */
    readonly vpceId?: string;
}
export declare function appstreamImageBuilderAccessEndpointToTerraform(struct?: AppstreamImageBuilderAccessEndpoint | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface AppstreamImageBuilderDomainJoinInfo {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder#directory_name AppstreamImageBuilder#directory_name}.
     *
     * @stability stable
     */
    readonly directoryName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder#organizational_unit_distinguished_name AppstreamImageBuilder#organizational_unit_distinguished_name}.
     *
     * @stability stable
     */
    readonly organizationalUnitDistinguishedName?: string;
}
export declare function appstreamImageBuilderDomainJoinInfoToTerraform(struct?: AppstreamImageBuilderDomainJoinInfoOutputReference | AppstreamImageBuilderDomainJoinInfo): any;
/**
 * @stability stable
 */
export declare class AppstreamImageBuilderDomainJoinInfoOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppstreamImageBuilderDomainJoinInfo | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppstreamImageBuilderDomainJoinInfo | undefined);
    private _directoryName?;
    /**
     * @stability stable
     */
    get directoryName(): string;
    /**
     * @stability stable
     */
    set directoryName(value: string);
    /**
     * @stability stable
     */
    resetDirectoryName(): void;
    /**
     * @stability stable
     */
    get directoryNameInput(): string | undefined;
    private _organizationalUnitDistinguishedName?;
    /**
     * @stability stable
     */
    get organizationalUnitDistinguishedName(): string;
    /**
     * @stability stable
     */
    set organizationalUnitDistinguishedName(value: string);
    /**
     * @stability stable
     */
    resetOrganizationalUnitDistinguishedName(): void;
    /**
     * @stability stable
     */
    get organizationalUnitDistinguishedNameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppstreamImageBuilderVpcConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder#security_group_ids AppstreamImageBuilder#security_group_ids}.
     *
     * @stability stable
     */
    readonly securityGroupIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder#subnet_ids AppstreamImageBuilder#subnet_ids}.
     *
     * @stability stable
     */
    readonly subnetIds?: string[];
}
export declare function appstreamImageBuilderVpcConfigToTerraform(struct?: AppstreamImageBuilderVpcConfigOutputReference | AppstreamImageBuilderVpcConfig): any;
/**
 * @stability stable
 */
export declare class AppstreamImageBuilderVpcConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppstreamImageBuilderVpcConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppstreamImageBuilderVpcConfig | undefined);
    private _securityGroupIds?;
    /**
     * @stability stable
     */
    get securityGroupIds(): string[];
    /**
     * @stability stable
     */
    set securityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get securityGroupIdsInput(): string[] | undefined;
    private _subnetIds?;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    set subnetIds(value: string[]);
    /**
     * @stability stable
     */
    resetSubnetIds(): void;
    /**
     * @stability stable
     */
    get subnetIdsInput(): string[] | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder aws_appstream_image_builder}.
 *
 * @stability stable
 */
export declare class AppstreamImageBuilder extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appstream_image_builder aws_appstream_image_builder} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppstreamImageBuilderConfig);
    private _appstreamAgentVersion?;
    /**
     * @stability stable
     */
    get appstreamAgentVersion(): string;
    /**
     * @stability stable
     */
    set appstreamAgentVersion(value: string);
    /**
     * @stability stable
     */
    resetAppstreamAgentVersion(): void;
    /**
     * @stability stable
     */
    get appstreamAgentVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get createdTime(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _displayName?;
    /**
     * @stability stable
     */
    get displayName(): string;
    /**
     * @stability stable
     */
    set displayName(value: string);
    /**
     * @stability stable
     */
    resetDisplayName(): void;
    /**
     * @stability stable
     */
    get displayNameInput(): string | undefined;
    private _enableDefaultInternetAccess?;
    /**
     * @stability stable
     */
    get enableDefaultInternetAccess(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enableDefaultInternetAccess(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnableDefaultInternetAccess(): void;
    /**
     * @stability stable
     */
    get enableDefaultInternetAccessInput(): boolean | cdktf.IResolvable | undefined;
    private _iamRoleArn?;
    /**
     * @stability stable
     */
    get iamRoleArn(): string;
    /**
     * @stability stable
     */
    set iamRoleArn(value: string);
    /**
     * @stability stable
     */
    resetIamRoleArn(): void;
    /**
     * @stability stable
     */
    get iamRoleArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _imageArn?;
    /**
     * @stability stable
     */
    get imageArn(): string;
    /**
     * @stability stable
     */
    set imageArn(value: string);
    /**
     * @stability stable
     */
    resetImageArn(): void;
    /**
     * @stability stable
     */
    get imageArnInput(): string | undefined;
    private _imageName?;
    /**
     * @stability stable
     */
    get imageName(): string;
    /**
     * @stability stable
     */
    set imageName(value: string);
    /**
     * @stability stable
     */
    resetImageName(): void;
    /**
     * @stability stable
     */
    get imageNameInput(): string | undefined;
    private _instanceType?;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    set instanceType(value: string);
    /**
     * @stability stable
     */
    get instanceTypeInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get state(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _accessEndpoint?;
    /**
     * @stability stable
     */
    get accessEndpoint(): AppstreamImageBuilderAccessEndpoint[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set accessEndpoint(value: AppstreamImageBuilderAccessEndpoint[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAccessEndpoint(): void;
    /**
     * @stability stable
     */
    get accessEndpointInput(): cdktf.IResolvable | AppstreamImageBuilderAccessEndpoint[] | undefined;
    private _domainJoinInfo;
    /**
     * @stability stable
     */
    get domainJoinInfo(): AppstreamImageBuilderDomainJoinInfoOutputReference;
    /**
     * @stability stable
     */
    putDomainJoinInfo(value: AppstreamImageBuilderDomainJoinInfo): void;
    /**
     * @stability stable
     */
    resetDomainJoinInfo(): void;
    /**
     * @stability stable
     */
    get domainJoinInfoInput(): AppstreamImageBuilderDomainJoinInfo | undefined;
    private _vpcConfig;
    /**
     * @stability stable
     */
    get vpcConfig(): AppstreamImageBuilderVpcConfigOutputReference;
    /**
     * @stability stable
     */
    putVpcConfig(value: AppstreamImageBuilderVpcConfig): void;
    /**
     * @stability stable
     */
    resetVpcConfig(): void;
    /**
     * @stability stable
     */
    get vpcConfigInput(): AppstreamImageBuilderVpcConfig | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
