import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AppStream.
 *
 * @stability stable
 */
export interface AppstreamStackConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack#description AppstreamStack#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack#display_name AppstreamStack#display_name}.
     *
     * @stability stable
     */
    readonly displayName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack#embed_host_domains AppstreamStack#embed_host_domains}.
     *
     * @stability stable
     */
    readonly embedHostDomains?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack#feedback_url AppstreamStack#feedback_url}.
     *
     * @stability stable
     */
    readonly feedbackUrl?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack#name AppstreamStack#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack#redirect_url AppstreamStack#redirect_url}.
     *
     * @stability stable
     */
    readonly redirectUrl?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack#tags AppstreamStack#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack#tags_all AppstreamStack#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * access_endpoints block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack#access_endpoints AppstreamStack#access_endpoints}
     *
     * @stability stable
     */
    readonly accessEndpoints?: AppstreamStackAccessEndpoints[] | cdktf.IResolvable;
    /**
     * application_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack#application_settings AppstreamStack#application_settings}
     *
     * @stability stable
     */
    readonly applicationSettings?: AppstreamStackApplicationSettings;
    /**
     * storage_connectors block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack#storage_connectors AppstreamStack#storage_connectors}
     *
     * @stability stable
     */
    readonly storageConnectors?: AppstreamStackStorageConnectors[] | cdktf.IResolvable;
    /**
     * user_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack#user_settings AppstreamStack#user_settings}
     *
     * @stability stable
     */
    readonly userSettings?: AppstreamStackUserSettings[] | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface AppstreamStackAccessEndpoints {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack#endpoint_type AppstreamStack#endpoint_type}.
     *
     * @stability stable
     */
    readonly endpointType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack#vpce_id AppstreamStack#vpce_id}.
     *
     * @stability stable
     */
    readonly vpceId?: string;
}
export declare function appstreamStackAccessEndpointsToTerraform(struct?: AppstreamStackAccessEndpoints | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface AppstreamStackApplicationSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack#enabled AppstreamStack#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack#settings_group AppstreamStack#settings_group}.
     *
     * @stability stable
     */
    readonly settingsGroup?: string;
}
export declare function appstreamStackApplicationSettingsToTerraform(struct?: AppstreamStackApplicationSettingsOutputReference | AppstreamStackApplicationSettings): any;
/**
 * @stability stable
 */
export declare class AppstreamStackApplicationSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppstreamStackApplicationSettings | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppstreamStackApplicationSettings | undefined);
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _settingsGroup?;
    /**
     * @stability stable
     */
    get settingsGroup(): string;
    /**
     * @stability stable
     */
    set settingsGroup(value: string);
    /**
     * @stability stable
     */
    resetSettingsGroup(): void;
    /**
     * @stability stable
     */
    get settingsGroupInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppstreamStackStorageConnectors {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack#connector_type AppstreamStack#connector_type}.
     *
     * @stability stable
     */
    readonly connectorType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack#domains AppstreamStack#domains}.
     *
     * @stability stable
     */
    readonly domains?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack#resource_identifier AppstreamStack#resource_identifier}.
     *
     * @stability stable
     */
    readonly resourceIdentifier?: string;
}
export declare function appstreamStackStorageConnectorsToTerraform(struct?: AppstreamStackStorageConnectors | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface AppstreamStackUserSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack#action AppstreamStack#action}.
     *
     * @stability stable
     */
    readonly action: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack#permission AppstreamStack#permission}.
     *
     * @stability stable
     */
    readonly permission: string;
}
export declare function appstreamStackUserSettingsToTerraform(struct?: AppstreamStackUserSettings | cdktf.IResolvable): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack aws_appstream_stack}.
 *
 * @stability stable
 */
export declare class AppstreamStack extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appstream_stack aws_appstream_stack} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppstreamStackConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get createdTime(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _displayName?;
    /**
     * @stability stable
     */
    get displayName(): string;
    /**
     * @stability stable
     */
    set displayName(value: string);
    /**
     * @stability stable
     */
    resetDisplayName(): void;
    /**
     * @stability stable
     */
    get displayNameInput(): string | undefined;
    private _embedHostDomains?;
    /**
     * @stability stable
     */
    get embedHostDomains(): string[];
    /**
     * @stability stable
     */
    set embedHostDomains(value: string[]);
    /**
     * @stability stable
     */
    resetEmbedHostDomains(): void;
    /**
     * @stability stable
     */
    get embedHostDomainsInput(): string[] | undefined;
    private _feedbackUrl?;
    /**
     * @stability stable
     */
    get feedbackUrl(): string;
    /**
     * @stability stable
     */
    set feedbackUrl(value: string);
    /**
     * @stability stable
     */
    resetFeedbackUrl(): void;
    /**
     * @stability stable
     */
    get feedbackUrlInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _redirectUrl?;
    /**
     * @stability stable
     */
    get redirectUrl(): string;
    /**
     * @stability stable
     */
    set redirectUrl(value: string);
    /**
     * @stability stable
     */
    resetRedirectUrl(): void;
    /**
     * @stability stable
     */
    get redirectUrlInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _accessEndpoints?;
    /**
     * @stability stable
     */
    get accessEndpoints(): AppstreamStackAccessEndpoints[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set accessEndpoints(value: AppstreamStackAccessEndpoints[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAccessEndpoints(): void;
    /**
     * @stability stable
     */
    get accessEndpointsInput(): cdktf.IResolvable | AppstreamStackAccessEndpoints[] | undefined;
    private _applicationSettings;
    /**
     * @stability stable
     */
    get applicationSettings(): AppstreamStackApplicationSettingsOutputReference;
    /**
     * @stability stable
     */
    putApplicationSettings(value: AppstreamStackApplicationSettings): void;
    /**
     * @stability stable
     */
    resetApplicationSettings(): void;
    /**
     * @stability stable
     */
    get applicationSettingsInput(): AppstreamStackApplicationSettings | undefined;
    private _storageConnectors?;
    /**
     * @stability stable
     */
    get storageConnectors(): AppstreamStackStorageConnectors[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set storageConnectors(value: AppstreamStackStorageConnectors[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetStorageConnectors(): void;
    /**
     * @stability stable
     */
    get storageConnectorsInput(): cdktf.IResolvable | AppstreamStackStorageConnectors[] | undefined;
    private _userSettings?;
    /**
     * @stability stable
     */
    get userSettings(): AppstreamStackUserSettings[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set userSettings(value: AppstreamStackUserSettings[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetUserSettings(): void;
    /**
     * @stability stable
     */
    get userSettingsInput(): cdktf.IResolvable | AppstreamStackUserSettings[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
