import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AppStream.
 *
 * @stability stable
 */
export interface AppstreamUserStackAssociationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_user_stack_association#authentication_type AppstreamUserStackAssociation#authentication_type}.
     *
     * @stability stable
     */
    readonly authenticationType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_user_stack_association#send_email_notification AppstreamUserStackAssociation#send_email_notification}.
     *
     * @stability stable
     */
    readonly sendEmailNotification?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_user_stack_association#stack_name AppstreamUserStackAssociation#stack_name}.
     *
     * @stability stable
     */
    readonly stackName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_user_stack_association#user_name AppstreamUserStackAssociation#user_name}.
     *
     * @stability stable
     */
    readonly userName: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appstream_user_stack_association aws_appstream_user_stack_association}.
 *
 * @stability stable
 */
export declare class AppstreamUserStackAssociation extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appstream_user_stack_association aws_appstream_user_stack_association} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppstreamUserStackAssociationConfig);
    private _authenticationType?;
    /**
     * @stability stable
     */
    get authenticationType(): string;
    /**
     * @stability stable
     */
    set authenticationType(value: string);
    /**
     * @stability stable
     */
    get authenticationTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _sendEmailNotification?;
    /**
     * @stability stable
     */
    get sendEmailNotification(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set sendEmailNotification(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSendEmailNotification(): void;
    /**
     * @stability stable
     */
    get sendEmailNotificationInput(): boolean | cdktf.IResolvable | undefined;
    private _stackName?;
    /**
     * @stability stable
     */
    get stackName(): string;
    /**
     * @stability stable
     */
    set stackName(value: string);
    /**
     * @stability stable
     */
    get stackNameInput(): string | undefined;
    private _userName?;
    /**
     * @stability stable
     */
    get userName(): string;
    /**
     * @stability stable
     */
    set userName(value: string);
    /**
     * @stability stable
     */
    get userNameInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
