import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * Amazon Athena.
 *
 * @stability stable
 */
export interface AthenaWorkgroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/athena_workgroup#description AthenaWorkgroup#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/athena_workgroup#force_destroy AthenaWorkgroup#force_destroy}.
     *
     * @stability stable
     */
    readonly forceDestroy?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/athena_workgroup#name AthenaWorkgroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/athena_workgroup#state AthenaWorkgroup#state}.
     *
     * @stability stable
     */
    readonly state?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/athena_workgroup#tags AthenaWorkgroup#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/athena_workgroup#tags_all AthenaWorkgroup#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/athena_workgroup#configuration AthenaWorkgroup#configuration}
     *
     * @stability stable
     */
    readonly configuration?: AthenaWorkgroupConfiguration;
}
/**
 * @stability stable
 */
export interface AthenaWorkgroupConfigurationEngineVersion {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/athena_workgroup#selected_engine_version AthenaWorkgroup#selected_engine_version}.
     *
     * @stability stable
     */
    readonly selectedEngineVersion?: string;
}
export declare function athenaWorkgroupConfigurationEngineVersionToTerraform(struct?: AthenaWorkgroupConfigurationEngineVersionOutputReference | AthenaWorkgroupConfigurationEngineVersion): any;
/**
 * @stability stable
 */
export declare class AthenaWorkgroupConfigurationEngineVersionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AthenaWorkgroupConfigurationEngineVersion | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AthenaWorkgroupConfigurationEngineVersion | undefined);
    /**
     * @stability stable
     */
    get effectiveEngineVersion(): string;
    private _selectedEngineVersion?;
    /**
     * @stability stable
     */
    get selectedEngineVersion(): string;
    /**
     * @stability stable
     */
    set selectedEngineVersion(value: string);
    /**
     * @stability stable
     */
    resetSelectedEngineVersion(): void;
    /**
     * @stability stable
     */
    get selectedEngineVersionInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AthenaWorkgroupConfigurationResultConfigurationEncryptionConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/athena_workgroup#encryption_option AthenaWorkgroup#encryption_option}.
     *
     * @stability stable
     */
    readonly encryptionOption?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/athena_workgroup#kms_key_arn AthenaWorkgroup#kms_key_arn}.
     *
     * @stability stable
     */
    readonly kmsKeyArn?: string;
}
export declare function athenaWorkgroupConfigurationResultConfigurationEncryptionConfigurationToTerraform(struct?: AthenaWorkgroupConfigurationResultConfigurationEncryptionConfigurationOutputReference | AthenaWorkgroupConfigurationResultConfigurationEncryptionConfiguration): any;
/**
 * @stability stable
 */
export declare class AthenaWorkgroupConfigurationResultConfigurationEncryptionConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AthenaWorkgroupConfigurationResultConfigurationEncryptionConfiguration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AthenaWorkgroupConfigurationResultConfigurationEncryptionConfiguration | undefined);
    private _encryptionOption?;
    /**
     * @stability stable
     */
    get encryptionOption(): string;
    /**
     * @stability stable
     */
    set encryptionOption(value: string);
    /**
     * @stability stable
     */
    resetEncryptionOption(): void;
    /**
     * @stability stable
     */
    get encryptionOptionInput(): string | undefined;
    private _kmsKeyArn?;
    /**
     * @stability stable
     */
    get kmsKeyArn(): string;
    /**
     * @stability stable
     */
    set kmsKeyArn(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyArn(): void;
    /**
     * @stability stable
     */
    get kmsKeyArnInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AthenaWorkgroupConfigurationResultConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/athena_workgroup#output_location AthenaWorkgroup#output_location}.
     *
     * @stability stable
     */
    readonly outputLocation?: string;
    /**
     * encryption_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/athena_workgroup#encryption_configuration AthenaWorkgroup#encryption_configuration}
     *
     * @stability stable
     */
    readonly encryptionConfiguration?: AthenaWorkgroupConfigurationResultConfigurationEncryptionConfiguration;
}
export declare function athenaWorkgroupConfigurationResultConfigurationToTerraform(struct?: AthenaWorkgroupConfigurationResultConfigurationOutputReference | AthenaWorkgroupConfigurationResultConfiguration): any;
/**
 * @stability stable
 */
export declare class AthenaWorkgroupConfigurationResultConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AthenaWorkgroupConfigurationResultConfiguration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AthenaWorkgroupConfigurationResultConfiguration | undefined);
    private _outputLocation?;
    /**
     * @stability stable
     */
    get outputLocation(): string;
    /**
     * @stability stable
     */
    set outputLocation(value: string);
    /**
     * @stability stable
     */
    resetOutputLocation(): void;
    /**
     * @stability stable
     */
    get outputLocationInput(): string | undefined;
    private _encryptionConfiguration;
    /**
     * @stability stable
     */
    get encryptionConfiguration(): AthenaWorkgroupConfigurationResultConfigurationEncryptionConfigurationOutputReference;
    /**
     * @stability stable
     */
    putEncryptionConfiguration(value: AthenaWorkgroupConfigurationResultConfigurationEncryptionConfiguration): void;
    /**
     * @stability stable
     */
    resetEncryptionConfiguration(): void;
    /**
     * @stability stable
     */
    get encryptionConfigurationInput(): AthenaWorkgroupConfigurationResultConfigurationEncryptionConfiguration | undefined;
}
/**
 * @stability stable
 */
export interface AthenaWorkgroupConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/athena_workgroup#bytes_scanned_cutoff_per_query AthenaWorkgroup#bytes_scanned_cutoff_per_query}.
     *
     * @stability stable
     */
    readonly bytesScannedCutoffPerQuery?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/athena_workgroup#enforce_workgroup_configuration AthenaWorkgroup#enforce_workgroup_configuration}.
     *
     * @stability stable
     */
    readonly enforceWorkgroupConfiguration?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/athena_workgroup#publish_cloudwatch_metrics_enabled AthenaWorkgroup#publish_cloudwatch_metrics_enabled}.
     *
     * @stability stable
     */
    readonly publishCloudwatchMetricsEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/athena_workgroup#requester_pays_enabled AthenaWorkgroup#requester_pays_enabled}.
     *
     * @stability stable
     */
    readonly requesterPaysEnabled?: boolean | cdktf.IResolvable;
    /**
     * engine_version block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/athena_workgroup#engine_version AthenaWorkgroup#engine_version}
     *
     * @stability stable
     */
    readonly engineVersion?: AthenaWorkgroupConfigurationEngineVersion;
    /**
     * result_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/athena_workgroup#result_configuration AthenaWorkgroup#result_configuration}
     *
     * @stability stable
     */
    readonly resultConfiguration?: AthenaWorkgroupConfigurationResultConfiguration;
}
export declare function athenaWorkgroupConfigurationToTerraform(struct?: AthenaWorkgroupConfigurationOutputReference | AthenaWorkgroupConfiguration): any;
/**
 * @stability stable
 */
export declare class AthenaWorkgroupConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AthenaWorkgroupConfiguration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AthenaWorkgroupConfiguration | undefined);
    private _bytesScannedCutoffPerQuery?;
    /**
     * @stability stable
     */
    get bytesScannedCutoffPerQuery(): number;
    /**
     * @stability stable
     */
    set bytesScannedCutoffPerQuery(value: number);
    /**
     * @stability stable
     */
    resetBytesScannedCutoffPerQuery(): void;
    /**
     * @stability stable
     */
    get bytesScannedCutoffPerQueryInput(): number | undefined;
    private _enforceWorkgroupConfiguration?;
    /**
     * @stability stable
     */
    get enforceWorkgroupConfiguration(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enforceWorkgroupConfiguration(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnforceWorkgroupConfiguration(): void;
    /**
     * @stability stable
     */
    get enforceWorkgroupConfigurationInput(): boolean | cdktf.IResolvable | undefined;
    private _publishCloudwatchMetricsEnabled?;
    /**
     * @stability stable
     */
    get publishCloudwatchMetricsEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set publishCloudwatchMetricsEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetPublishCloudwatchMetricsEnabled(): void;
    /**
     * @stability stable
     */
    get publishCloudwatchMetricsEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _requesterPaysEnabled?;
    /**
     * @stability stable
     */
    get requesterPaysEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set requesterPaysEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetRequesterPaysEnabled(): void;
    /**
     * @stability stable
     */
    get requesterPaysEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _engineVersion;
    /**
     * @stability stable
     */
    get engineVersion(): AthenaWorkgroupConfigurationEngineVersionOutputReference;
    /**
     * @stability stable
     */
    putEngineVersion(value: AthenaWorkgroupConfigurationEngineVersion): void;
    /**
     * @stability stable
     */
    resetEngineVersion(): void;
    /**
     * @stability stable
     */
    get engineVersionInput(): AthenaWorkgroupConfigurationEngineVersion | undefined;
    private _resultConfiguration;
    /**
     * @stability stable
     */
    get resultConfiguration(): AthenaWorkgroupConfigurationResultConfigurationOutputReference;
    /**
     * @stability stable
     */
    putResultConfiguration(value: AthenaWorkgroupConfigurationResultConfiguration): void;
    /**
     * @stability stable
     */
    resetResultConfiguration(): void;
    /**
     * @stability stable
     */
    get resultConfigurationInput(): AthenaWorkgroupConfigurationResultConfiguration | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/athena_workgroup aws_athena_workgroup}.
 *
 * @stability stable
 */
export declare class AthenaWorkgroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/athena_workgroup aws_athena_workgroup} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AthenaWorkgroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _forceDestroy?;
    /**
     * @stability stable
     */
    get forceDestroy(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set forceDestroy(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetForceDestroy(): void;
    /**
     * @stability stable
     */
    get forceDestroyInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _state?;
    /**
     * @stability stable
     */
    get state(): string;
    /**
     * @stability stable
     */
    set state(value: string);
    /**
     * @stability stable
     */
    resetState(): void;
    /**
     * @stability stable
     */
    get stateInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _configuration;
    /**
     * @stability stable
     */
    get configuration(): AthenaWorkgroupConfigurationOutputReference;
    /**
     * @stability stable
     */
    putConfiguration(value: AthenaWorkgroupConfiguration): void;
    /**
     * @stability stable
     */
    resetConfiguration(): void;
    /**
     * @stability stable
     */
    get configurationInput(): AthenaWorkgroupConfiguration | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
