import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Auto Scaling.
 *
 * @stability stable
 */
export interface AutoscalingGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#availability_zones AutoscalingGroup#availability_zones}.
     *
     * @stability stable
     */
    readonly availabilityZones?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#capacity_rebalance AutoscalingGroup#capacity_rebalance}.
     *
     * @stability stable
     */
    readonly capacityRebalance?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#default_cooldown AutoscalingGroup#default_cooldown}.
     *
     * @stability stable
     */
    readonly defaultCooldown?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#desired_capacity AutoscalingGroup#desired_capacity}.
     *
     * @stability stable
     */
    readonly desiredCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#enabled_metrics AutoscalingGroup#enabled_metrics}.
     *
     * @stability stable
     */
    readonly enabledMetrics?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#force_delete AutoscalingGroup#force_delete}.
     *
     * @stability stable
     */
    readonly forceDelete?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#force_delete_warm_pool AutoscalingGroup#force_delete_warm_pool}.
     *
     * @stability stable
     */
    readonly forceDeleteWarmPool?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#health_check_grace_period AutoscalingGroup#health_check_grace_period}.
     *
     * @stability stable
     */
    readonly healthCheckGracePeriod?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#health_check_type AutoscalingGroup#health_check_type}.
     *
     * @stability stable
     */
    readonly healthCheckType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#launch_configuration AutoscalingGroup#launch_configuration}.
     *
     * @stability stable
     */
    readonly launchConfiguration?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#load_balancers AutoscalingGroup#load_balancers}.
     *
     * @stability stable
     */
    readonly loadBalancers?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#max_instance_lifetime AutoscalingGroup#max_instance_lifetime}.
     *
     * @stability stable
     */
    readonly maxInstanceLifetime?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#max_size AutoscalingGroup#max_size}.
     *
     * @stability stable
     */
    readonly maxSize: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#metrics_granularity AutoscalingGroup#metrics_granularity}.
     *
     * @stability stable
     */
    readonly metricsGranularity?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#min_elb_capacity AutoscalingGroup#min_elb_capacity}.
     *
     * @stability stable
     */
    readonly minElbCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#min_size AutoscalingGroup#min_size}.
     *
     * @stability stable
     */
    readonly minSize: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#name AutoscalingGroup#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#name_prefix AutoscalingGroup#name_prefix}.
     *
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#placement_group AutoscalingGroup#placement_group}.
     *
     * @stability stable
     */
    readonly placementGroup?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#protect_from_scale_in AutoscalingGroup#protect_from_scale_in}.
     *
     * @stability stable
     */
    readonly protectFromScaleIn?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#service_linked_role_arn AutoscalingGroup#service_linked_role_arn}.
     *
     * @stability stable
     */
    readonly serviceLinkedRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#suspended_processes AutoscalingGroup#suspended_processes}.
     *
     * @stability stable
     */
    readonly suspendedProcesses?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#tags AutoscalingGroup#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#target_group_arns AutoscalingGroup#target_group_arns}.
     *
     * @stability stable
     */
    readonly targetGroupArns?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#termination_policies AutoscalingGroup#termination_policies}.
     *
     * @stability stable
     */
    readonly terminationPolicies?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#vpc_zone_identifier AutoscalingGroup#vpc_zone_identifier}.
     *
     * @stability stable
     */
    readonly vpcZoneIdentifier?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#wait_for_capacity_timeout AutoscalingGroup#wait_for_capacity_timeout}.
     *
     * @stability stable
     */
    readonly waitForCapacityTimeout?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#wait_for_elb_capacity AutoscalingGroup#wait_for_elb_capacity}.
     *
     * @stability stable
     */
    readonly waitForElbCapacity?: number;
    /**
     * initial_lifecycle_hook block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#initial_lifecycle_hook AutoscalingGroup#initial_lifecycle_hook}
     *
     * @stability stable
     */
    readonly initialLifecycleHook?: AutoscalingGroupInitialLifecycleHook[] | cdktf.IResolvable;
    /**
     * instance_refresh block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#instance_refresh AutoscalingGroup#instance_refresh}
     *
     * @stability stable
     */
    readonly instanceRefresh?: AutoscalingGroupInstanceRefresh;
    /**
     * launch_template block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#launch_template AutoscalingGroup#launch_template}
     *
     * @stability stable
     */
    readonly launchTemplate?: AutoscalingGroupLaunchTemplate;
    /**
     * mixed_instances_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#mixed_instances_policy AutoscalingGroup#mixed_instances_policy}
     *
     * @stability stable
     */
    readonly mixedInstancesPolicy?: AutoscalingGroupMixedInstancesPolicy;
    /**
     * tag block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#tag AutoscalingGroup#tag}
     *
     * @stability stable
     */
    readonly tag?: AutoscalingGroupTag[] | cdktf.IResolvable;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#timeouts AutoscalingGroup#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: AutoscalingGroupTimeouts;
    /**
     * warm_pool block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#warm_pool AutoscalingGroup#warm_pool}
     *
     * @stability stable
     */
    readonly warmPool?: AutoscalingGroupWarmPool;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupInitialLifecycleHook {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#default_result AutoscalingGroup#default_result}.
     *
     * @stability stable
     */
    readonly defaultResult?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#heartbeat_timeout AutoscalingGroup#heartbeat_timeout}.
     *
     * @stability stable
     */
    readonly heartbeatTimeout?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#lifecycle_transition AutoscalingGroup#lifecycle_transition}.
     *
     * @stability stable
     */
    readonly lifecycleTransition: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#name AutoscalingGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#notification_metadata AutoscalingGroup#notification_metadata}.
     *
     * @stability stable
     */
    readonly notificationMetadata?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#notification_target_arn AutoscalingGroup#notification_target_arn}.
     *
     * @stability stable
     */
    readonly notificationTargetArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#role_arn AutoscalingGroup#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn?: string;
}
export declare function autoscalingGroupInitialLifecycleHookToTerraform(struct?: AutoscalingGroupInitialLifecycleHook | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface AutoscalingGroupInstanceRefreshPreferences {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#checkpoint_delay AutoscalingGroup#checkpoint_delay}.
     *
     * @stability stable
     */
    readonly checkpointDelay?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#checkpoint_percentages AutoscalingGroup#checkpoint_percentages}.
     *
     * @stability stable
     */
    readonly checkpointPercentages?: number[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#instance_warmup AutoscalingGroup#instance_warmup}.
     *
     * @stability stable
     */
    readonly instanceWarmup?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#min_healthy_percentage AutoscalingGroup#min_healthy_percentage}.
     *
     * @stability stable
     */
    readonly minHealthyPercentage?: number;
}
export declare function autoscalingGroupInstanceRefreshPreferencesToTerraform(struct?: AutoscalingGroupInstanceRefreshPreferencesOutputReference | AutoscalingGroupInstanceRefreshPreferences): any;
/**
 * @stability stable
 */
export declare class AutoscalingGroupInstanceRefreshPreferencesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AutoscalingGroupInstanceRefreshPreferences | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AutoscalingGroupInstanceRefreshPreferences | undefined);
    private _checkpointDelay?;
    /**
     * @stability stable
     */
    get checkpointDelay(): string;
    /**
     * @stability stable
     */
    set checkpointDelay(value: string);
    /**
     * @stability stable
     */
    resetCheckpointDelay(): void;
    /**
     * @stability stable
     */
    get checkpointDelayInput(): string | undefined;
    private _checkpointPercentages?;
    /**
     * @stability stable
     */
    get checkpointPercentages(): number[];
    /**
     * @stability stable
     */
    set checkpointPercentages(value: number[]);
    /**
     * @stability stable
     */
    resetCheckpointPercentages(): void;
    /**
     * @stability stable
     */
    get checkpointPercentagesInput(): number[] | undefined;
    private _instanceWarmup?;
    /**
     * @stability stable
     */
    get instanceWarmup(): string;
    /**
     * @stability stable
     */
    set instanceWarmup(value: string);
    /**
     * @stability stable
     */
    resetInstanceWarmup(): void;
    /**
     * @stability stable
     */
    get instanceWarmupInput(): string | undefined;
    private _minHealthyPercentage?;
    /**
     * @stability stable
     */
    get minHealthyPercentage(): number;
    /**
     * @stability stable
     */
    set minHealthyPercentage(value: number);
    /**
     * @stability stable
     */
    resetMinHealthyPercentage(): void;
    /**
     * @stability stable
     */
    get minHealthyPercentageInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupInstanceRefresh {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#strategy AutoscalingGroup#strategy}.
     *
     * @stability stable
     */
    readonly strategy: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#triggers AutoscalingGroup#triggers}.
     *
     * @stability stable
     */
    readonly triggers?: string[];
    /**
     * preferences block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#preferences AutoscalingGroup#preferences}
     *
     * @stability stable
     */
    readonly preferences?: AutoscalingGroupInstanceRefreshPreferences;
}
export declare function autoscalingGroupInstanceRefreshToTerraform(struct?: AutoscalingGroupInstanceRefreshOutputReference | AutoscalingGroupInstanceRefresh): any;
/**
 * @stability stable
 */
export declare class AutoscalingGroupInstanceRefreshOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AutoscalingGroupInstanceRefresh | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AutoscalingGroupInstanceRefresh | undefined);
    private _strategy?;
    /**
     * @stability stable
     */
    get strategy(): string;
    /**
     * @stability stable
     */
    set strategy(value: string);
    /**
     * @stability stable
     */
    get strategyInput(): string | undefined;
    private _triggers?;
    /**
     * @stability stable
     */
    get triggers(): string[];
    /**
     * @stability stable
     */
    set triggers(value: string[]);
    /**
     * @stability stable
     */
    resetTriggers(): void;
    /**
     * @stability stable
     */
    get triggersInput(): string[] | undefined;
    private _preferences;
    /**
     * @stability stable
     */
    get preferences(): AutoscalingGroupInstanceRefreshPreferencesOutputReference;
    /**
     * @stability stable
     */
    putPreferences(value: AutoscalingGroupInstanceRefreshPreferences): void;
    /**
     * @stability stable
     */
    resetPreferences(): void;
    /**
     * @stability stable
     */
    get preferencesInput(): AutoscalingGroupInstanceRefreshPreferences | undefined;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupLaunchTemplate {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#id AutoscalingGroup#id}.
     *
     * @stability stable
     */
    readonly id?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#name AutoscalingGroup#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#version AutoscalingGroup#version}.
     *
     * @stability stable
     */
    readonly version?: string;
}
export declare function autoscalingGroupLaunchTemplateToTerraform(struct?: AutoscalingGroupLaunchTemplateOutputReference | AutoscalingGroupLaunchTemplate): any;
/**
 * @stability stable
 */
export declare class AutoscalingGroupLaunchTemplateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AutoscalingGroupLaunchTemplate | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AutoscalingGroupLaunchTemplate | undefined);
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _version?;
    /**
     * @stability stable
     */
    get version(): string;
    /**
     * @stability stable
     */
    set version(value: string);
    /**
     * @stability stable
     */
    resetVersion(): void;
    /**
     * @stability stable
     */
    get versionInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupMixedInstancesPolicyInstancesDistribution {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#on_demand_allocation_strategy AutoscalingGroup#on_demand_allocation_strategy}.
     *
     * @stability stable
     */
    readonly onDemandAllocationStrategy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#on_demand_base_capacity AutoscalingGroup#on_demand_base_capacity}.
     *
     * @stability stable
     */
    readonly onDemandBaseCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#on_demand_percentage_above_base_capacity AutoscalingGroup#on_demand_percentage_above_base_capacity}.
     *
     * @stability stable
     */
    readonly onDemandPercentageAboveBaseCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#spot_allocation_strategy AutoscalingGroup#spot_allocation_strategy}.
     *
     * @stability stable
     */
    readonly spotAllocationStrategy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#spot_instance_pools AutoscalingGroup#spot_instance_pools}.
     *
     * @stability stable
     */
    readonly spotInstancePools?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#spot_max_price AutoscalingGroup#spot_max_price}.
     *
     * @stability stable
     */
    readonly spotMaxPrice?: string;
}
export declare function autoscalingGroupMixedInstancesPolicyInstancesDistributionToTerraform(struct?: AutoscalingGroupMixedInstancesPolicyInstancesDistributionOutputReference | AutoscalingGroupMixedInstancesPolicyInstancesDistribution): any;
/**
 * @stability stable
 */
export declare class AutoscalingGroupMixedInstancesPolicyInstancesDistributionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AutoscalingGroupMixedInstancesPolicyInstancesDistribution | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AutoscalingGroupMixedInstancesPolicyInstancesDistribution | undefined);
    private _onDemandAllocationStrategy?;
    /**
     * @stability stable
     */
    get onDemandAllocationStrategy(): string;
    /**
     * @stability stable
     */
    set onDemandAllocationStrategy(value: string);
    /**
     * @stability stable
     */
    resetOnDemandAllocationStrategy(): void;
    /**
     * @stability stable
     */
    get onDemandAllocationStrategyInput(): string | undefined;
    private _onDemandBaseCapacity?;
    /**
     * @stability stable
     */
    get onDemandBaseCapacity(): number;
    /**
     * @stability stable
     */
    set onDemandBaseCapacity(value: number);
    /**
     * @stability stable
     */
    resetOnDemandBaseCapacity(): void;
    /**
     * @stability stable
     */
    get onDemandBaseCapacityInput(): number | undefined;
    private _onDemandPercentageAboveBaseCapacity?;
    /**
     * @stability stable
     */
    get onDemandPercentageAboveBaseCapacity(): number;
    /**
     * @stability stable
     */
    set onDemandPercentageAboveBaseCapacity(value: number);
    /**
     * @stability stable
     */
    resetOnDemandPercentageAboveBaseCapacity(): void;
    /**
     * @stability stable
     */
    get onDemandPercentageAboveBaseCapacityInput(): number | undefined;
    private _spotAllocationStrategy?;
    /**
     * @stability stable
     */
    get spotAllocationStrategy(): string;
    /**
     * @stability stable
     */
    set spotAllocationStrategy(value: string);
    /**
     * @stability stable
     */
    resetSpotAllocationStrategy(): void;
    /**
     * @stability stable
     */
    get spotAllocationStrategyInput(): string | undefined;
    private _spotInstancePools?;
    /**
     * @stability stable
     */
    get spotInstancePools(): number;
    /**
     * @stability stable
     */
    set spotInstancePools(value: number);
    /**
     * @stability stable
     */
    resetSpotInstancePools(): void;
    /**
     * @stability stable
     */
    get spotInstancePoolsInput(): number | undefined;
    private _spotMaxPrice?;
    /**
     * @stability stable
     */
    get spotMaxPrice(): string;
    /**
     * @stability stable
     */
    set spotMaxPrice(value: string);
    /**
     * @stability stable
     */
    resetSpotMaxPrice(): void;
    /**
     * @stability stable
     */
    get spotMaxPriceInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupMixedInstancesPolicyLaunchTemplateLaunchTemplateSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#launch_template_id AutoscalingGroup#launch_template_id}.
     *
     * @stability stable
     */
    readonly launchTemplateId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#launch_template_name AutoscalingGroup#launch_template_name}.
     *
     * @stability stable
     */
    readonly launchTemplateName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#version AutoscalingGroup#version}.
     *
     * @stability stable
     */
    readonly version?: string;
}
export declare function autoscalingGroupMixedInstancesPolicyLaunchTemplateLaunchTemplateSpecificationToTerraform(struct?: AutoscalingGroupMixedInstancesPolicyLaunchTemplateLaunchTemplateSpecificationOutputReference | AutoscalingGroupMixedInstancesPolicyLaunchTemplateLaunchTemplateSpecification): any;
/**
 * @stability stable
 */
export declare class AutoscalingGroupMixedInstancesPolicyLaunchTemplateLaunchTemplateSpecificationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AutoscalingGroupMixedInstancesPolicyLaunchTemplateLaunchTemplateSpecification | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AutoscalingGroupMixedInstancesPolicyLaunchTemplateLaunchTemplateSpecification | undefined);
    private _launchTemplateId?;
    /**
     * @stability stable
     */
    get launchTemplateId(): string;
    /**
     * @stability stable
     */
    set launchTemplateId(value: string);
    /**
     * @stability stable
     */
    resetLaunchTemplateId(): void;
    /**
     * @stability stable
     */
    get launchTemplateIdInput(): string | undefined;
    private _launchTemplateName?;
    /**
     * @stability stable
     */
    get launchTemplateName(): string;
    /**
     * @stability stable
     */
    set launchTemplateName(value: string);
    /**
     * @stability stable
     */
    resetLaunchTemplateName(): void;
    /**
     * @stability stable
     */
    get launchTemplateNameInput(): string | undefined;
    private _version?;
    /**
     * @stability stable
     */
    get version(): string;
    /**
     * @stability stable
     */
    set version(value: string);
    /**
     * @stability stable
     */
    resetVersion(): void;
    /**
     * @stability stable
     */
    get versionInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupMixedInstancesPolicyLaunchTemplateOverrideLaunchTemplateSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#launch_template_id AutoscalingGroup#launch_template_id}.
     *
     * @stability stable
     */
    readonly launchTemplateId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#launch_template_name AutoscalingGroup#launch_template_name}.
     *
     * @stability stable
     */
    readonly launchTemplateName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#version AutoscalingGroup#version}.
     *
     * @stability stable
     */
    readonly version?: string;
}
export declare function autoscalingGroupMixedInstancesPolicyLaunchTemplateOverrideLaunchTemplateSpecificationToTerraform(struct?: AutoscalingGroupMixedInstancesPolicyLaunchTemplateOverrideLaunchTemplateSpecificationOutputReference | AutoscalingGroupMixedInstancesPolicyLaunchTemplateOverrideLaunchTemplateSpecification): any;
/**
 * @stability stable
 */
export declare class AutoscalingGroupMixedInstancesPolicyLaunchTemplateOverrideLaunchTemplateSpecificationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AutoscalingGroupMixedInstancesPolicyLaunchTemplateOverrideLaunchTemplateSpecification | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AutoscalingGroupMixedInstancesPolicyLaunchTemplateOverrideLaunchTemplateSpecification | undefined);
    private _launchTemplateId?;
    /**
     * @stability stable
     */
    get launchTemplateId(): string;
    /**
     * @stability stable
     */
    set launchTemplateId(value: string);
    /**
     * @stability stable
     */
    resetLaunchTemplateId(): void;
    /**
     * @stability stable
     */
    get launchTemplateIdInput(): string | undefined;
    private _launchTemplateName?;
    /**
     * @stability stable
     */
    get launchTemplateName(): string;
    /**
     * @stability stable
     */
    set launchTemplateName(value: string);
    /**
     * @stability stable
     */
    resetLaunchTemplateName(): void;
    /**
     * @stability stable
     */
    get launchTemplateNameInput(): string | undefined;
    private _version?;
    /**
     * @stability stable
     */
    get version(): string;
    /**
     * @stability stable
     */
    set version(value: string);
    /**
     * @stability stable
     */
    resetVersion(): void;
    /**
     * @stability stable
     */
    get versionInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupMixedInstancesPolicyLaunchTemplateOverride {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#instance_type AutoscalingGroup#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#weighted_capacity AutoscalingGroup#weighted_capacity}.
     *
     * @stability stable
     */
    readonly weightedCapacity?: string;
    /**
     * launch_template_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#launch_template_specification AutoscalingGroup#launch_template_specification}
     *
     * @stability stable
     */
    readonly launchTemplateSpecification?: AutoscalingGroupMixedInstancesPolicyLaunchTemplateOverrideLaunchTemplateSpecification;
}
export declare function autoscalingGroupMixedInstancesPolicyLaunchTemplateOverrideToTerraform(struct?: AutoscalingGroupMixedInstancesPolicyLaunchTemplateOverride | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface AutoscalingGroupMixedInstancesPolicyLaunchTemplate {
    /**
     * launch_template_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#launch_template_specification AutoscalingGroup#launch_template_specification}
     *
     * @stability stable
     */
    readonly launchTemplateSpecification: AutoscalingGroupMixedInstancesPolicyLaunchTemplateLaunchTemplateSpecification;
    /**
     * override block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#override AutoscalingGroup#override}
     *
     * @stability stable
     */
    readonly override?: AutoscalingGroupMixedInstancesPolicyLaunchTemplateOverride[] | cdktf.IResolvable;
}
export declare function autoscalingGroupMixedInstancesPolicyLaunchTemplateToTerraform(struct?: AutoscalingGroupMixedInstancesPolicyLaunchTemplateOutputReference | AutoscalingGroupMixedInstancesPolicyLaunchTemplate): any;
/**
 * @stability stable
 */
export declare class AutoscalingGroupMixedInstancesPolicyLaunchTemplateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AutoscalingGroupMixedInstancesPolicyLaunchTemplate | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AutoscalingGroupMixedInstancesPolicyLaunchTemplate | undefined);
    private _launchTemplateSpecification;
    /**
     * @stability stable
     */
    get launchTemplateSpecification(): AutoscalingGroupMixedInstancesPolicyLaunchTemplateLaunchTemplateSpecificationOutputReference;
    /**
     * @stability stable
     */
    putLaunchTemplateSpecification(value: AutoscalingGroupMixedInstancesPolicyLaunchTemplateLaunchTemplateSpecification): void;
    /**
     * @stability stable
     */
    get launchTemplateSpecificationInput(): AutoscalingGroupMixedInstancesPolicyLaunchTemplateLaunchTemplateSpecification | undefined;
    private _override?;
    /**
     * @stability stable
     */
    get override(): AutoscalingGroupMixedInstancesPolicyLaunchTemplateOverride[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set override(value: AutoscalingGroupMixedInstancesPolicyLaunchTemplateOverride[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetOverride(): void;
    /**
     * @stability stable
     */
    get overrideInput(): cdktf.IResolvable | AutoscalingGroupMixedInstancesPolicyLaunchTemplateOverride[] | undefined;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupMixedInstancesPolicy {
    /**
     * instances_distribution block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#instances_distribution AutoscalingGroup#instances_distribution}
     *
     * @stability stable
     */
    readonly instancesDistribution?: AutoscalingGroupMixedInstancesPolicyInstancesDistribution;
    /**
     * launch_template block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#launch_template AutoscalingGroup#launch_template}
     *
     * @stability stable
     */
    readonly launchTemplate: AutoscalingGroupMixedInstancesPolicyLaunchTemplate;
}
export declare function autoscalingGroupMixedInstancesPolicyToTerraform(struct?: AutoscalingGroupMixedInstancesPolicyOutputReference | AutoscalingGroupMixedInstancesPolicy): any;
/**
 * @stability stable
 */
export declare class AutoscalingGroupMixedInstancesPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AutoscalingGroupMixedInstancesPolicy | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AutoscalingGroupMixedInstancesPolicy | undefined);
    private _instancesDistribution;
    /**
     * @stability stable
     */
    get instancesDistribution(): AutoscalingGroupMixedInstancesPolicyInstancesDistributionOutputReference;
    /**
     * @stability stable
     */
    putInstancesDistribution(value: AutoscalingGroupMixedInstancesPolicyInstancesDistribution): void;
    /**
     * @stability stable
     */
    resetInstancesDistribution(): void;
    /**
     * @stability stable
     */
    get instancesDistributionInput(): AutoscalingGroupMixedInstancesPolicyInstancesDistribution | undefined;
    private _launchTemplate;
    /**
     * @stability stable
     */
    get launchTemplate(): AutoscalingGroupMixedInstancesPolicyLaunchTemplateOutputReference;
    /**
     * @stability stable
     */
    putLaunchTemplate(value: AutoscalingGroupMixedInstancesPolicyLaunchTemplate): void;
    /**
     * @stability stable
     */
    get launchTemplateInput(): AutoscalingGroupMixedInstancesPolicyLaunchTemplate | undefined;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupTag {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#key AutoscalingGroup#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#propagate_at_launch AutoscalingGroup#propagate_at_launch}.
     *
     * @stability stable
     */
    readonly propagateAtLaunch: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#value AutoscalingGroup#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function autoscalingGroupTagToTerraform(struct?: AutoscalingGroupTag | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface AutoscalingGroupTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#delete AutoscalingGroup#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
}
export declare function autoscalingGroupTimeoutsToTerraform(struct?: AutoscalingGroupTimeoutsOutputReference | AutoscalingGroupTimeouts | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export declare class AutoscalingGroupTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AutoscalingGroupTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AutoscalingGroupTimeouts | undefined);
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupWarmPool {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#max_group_prepared_capacity AutoscalingGroup#max_group_prepared_capacity}.
     *
     * @stability stable
     */
    readonly maxGroupPreparedCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#min_size AutoscalingGroup#min_size}.
     *
     * @stability stable
     */
    readonly minSize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group#pool_state AutoscalingGroup#pool_state}.
     *
     * @stability stable
     */
    readonly poolState?: string;
}
export declare function autoscalingGroupWarmPoolToTerraform(struct?: AutoscalingGroupWarmPoolOutputReference | AutoscalingGroupWarmPool): any;
/**
 * @stability stable
 */
export declare class AutoscalingGroupWarmPoolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AutoscalingGroupWarmPool | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AutoscalingGroupWarmPool | undefined);
    private _maxGroupPreparedCapacity?;
    /**
     * @stability stable
     */
    get maxGroupPreparedCapacity(): number;
    /**
     * @stability stable
     */
    set maxGroupPreparedCapacity(value: number);
    /**
     * @stability stable
     */
    resetMaxGroupPreparedCapacity(): void;
    /**
     * @stability stable
     */
    get maxGroupPreparedCapacityInput(): number | undefined;
    private _minSize?;
    /**
     * @stability stable
     */
    get minSize(): number;
    /**
     * @stability stable
     */
    set minSize(value: number);
    /**
     * @stability stable
     */
    resetMinSize(): void;
    /**
     * @stability stable
     */
    get minSizeInput(): number | undefined;
    private _poolState?;
    /**
     * @stability stable
     */
    get poolState(): string;
    /**
     * @stability stable
     */
    set poolState(value: string);
    /**
     * @stability stable
     */
    resetPoolState(): void;
    /**
     * @stability stable
     */
    get poolStateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group aws_autoscaling_group}.
 *
 * @stability stable
 */
export declare class AutoscalingGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group aws_autoscaling_group} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AutoscalingGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _availabilityZones?;
    /**
     * @stability stable
     */
    get availabilityZones(): string[];
    /**
     * @stability stable
     */
    set availabilityZones(value: string[]);
    /**
     * @stability stable
     */
    resetAvailabilityZones(): void;
    /**
     * @stability stable
     */
    get availabilityZonesInput(): string[] | undefined;
    private _capacityRebalance?;
    /**
     * @stability stable
     */
    get capacityRebalance(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set capacityRebalance(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetCapacityRebalance(): void;
    /**
     * @stability stable
     */
    get capacityRebalanceInput(): boolean | cdktf.IResolvable | undefined;
    private _defaultCooldown?;
    /**
     * @stability stable
     */
    get defaultCooldown(): number;
    /**
     * @stability stable
     */
    set defaultCooldown(value: number);
    /**
     * @stability stable
     */
    resetDefaultCooldown(): void;
    /**
     * @stability stable
     */
    get defaultCooldownInput(): number | undefined;
    private _desiredCapacity?;
    /**
     * @stability stable
     */
    get desiredCapacity(): number;
    /**
     * @stability stable
     */
    set desiredCapacity(value: number);
    /**
     * @stability stable
     */
    resetDesiredCapacity(): void;
    /**
     * @stability stable
     */
    get desiredCapacityInput(): number | undefined;
    private _enabledMetrics?;
    /**
     * @stability stable
     */
    get enabledMetrics(): string[];
    /**
     * @stability stable
     */
    set enabledMetrics(value: string[]);
    /**
     * @stability stable
     */
    resetEnabledMetrics(): void;
    /**
     * @stability stable
     */
    get enabledMetricsInput(): string[] | undefined;
    private _forceDelete?;
    /**
     * @stability stable
     */
    get forceDelete(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set forceDelete(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetForceDelete(): void;
    /**
     * @stability stable
     */
    get forceDeleteInput(): boolean | cdktf.IResolvable | undefined;
    private _forceDeleteWarmPool?;
    /**
     * @stability stable
     */
    get forceDeleteWarmPool(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set forceDeleteWarmPool(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetForceDeleteWarmPool(): void;
    /**
     * @stability stable
     */
    get forceDeleteWarmPoolInput(): boolean | cdktf.IResolvable | undefined;
    private _healthCheckGracePeriod?;
    /**
     * @stability stable
     */
    get healthCheckGracePeriod(): number;
    /**
     * @stability stable
     */
    set healthCheckGracePeriod(value: number);
    /**
     * @stability stable
     */
    resetHealthCheckGracePeriod(): void;
    /**
     * @stability stable
     */
    get healthCheckGracePeriodInput(): number | undefined;
    private _healthCheckType?;
    /**
     * @stability stable
     */
    get healthCheckType(): string;
    /**
     * @stability stable
     */
    set healthCheckType(value: string);
    /**
     * @stability stable
     */
    resetHealthCheckType(): void;
    /**
     * @stability stable
     */
    get healthCheckTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _launchConfiguration?;
    /**
     * @stability stable
     */
    get launchConfiguration(): string;
    /**
     * @stability stable
     */
    set launchConfiguration(value: string);
    /**
     * @stability stable
     */
    resetLaunchConfiguration(): void;
    /**
     * @stability stable
     */
    get launchConfigurationInput(): string | undefined;
    private _loadBalancers?;
    /**
     * @stability stable
     */
    get loadBalancers(): string[];
    /**
     * @stability stable
     */
    set loadBalancers(value: string[]);
    /**
     * @stability stable
     */
    resetLoadBalancers(): void;
    /**
     * @stability stable
     */
    get loadBalancersInput(): string[] | undefined;
    private _maxInstanceLifetime?;
    /**
     * @stability stable
     */
    get maxInstanceLifetime(): number;
    /**
     * @stability stable
     */
    set maxInstanceLifetime(value: number);
    /**
     * @stability stable
     */
    resetMaxInstanceLifetime(): void;
    /**
     * @stability stable
     */
    get maxInstanceLifetimeInput(): number | undefined;
    private _maxSize?;
    /**
     * @stability stable
     */
    get maxSize(): number;
    /**
     * @stability stable
     */
    set maxSize(value: number);
    /**
     * @stability stable
     */
    get maxSizeInput(): number | undefined;
    private _metricsGranularity?;
    /**
     * @stability stable
     */
    get metricsGranularity(): string;
    /**
     * @stability stable
     */
    set metricsGranularity(value: string);
    /**
     * @stability stable
     */
    resetMetricsGranularity(): void;
    /**
     * @stability stable
     */
    get metricsGranularityInput(): string | undefined;
    private _minElbCapacity?;
    /**
     * @stability stable
     */
    get minElbCapacity(): number;
    /**
     * @stability stable
     */
    set minElbCapacity(value: number);
    /**
     * @stability stable
     */
    resetMinElbCapacity(): void;
    /**
     * @stability stable
     */
    get minElbCapacityInput(): number | undefined;
    private _minSize?;
    /**
     * @stability stable
     */
    get minSize(): number;
    /**
     * @stability stable
     */
    set minSize(value: number);
    /**
     * @stability stable
     */
    get minSizeInput(): number | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    private _placementGroup?;
    /**
     * @stability stable
     */
    get placementGroup(): string;
    /**
     * @stability stable
     */
    set placementGroup(value: string);
    /**
     * @stability stable
     */
    resetPlacementGroup(): void;
    /**
     * @stability stable
     */
    get placementGroupInput(): string | undefined;
    private _protectFromScaleIn?;
    /**
     * @stability stable
     */
    get protectFromScaleIn(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set protectFromScaleIn(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetProtectFromScaleIn(): void;
    /**
     * @stability stable
     */
    get protectFromScaleInInput(): boolean | cdktf.IResolvable | undefined;
    private _serviceLinkedRoleArn?;
    /**
     * @stability stable
     */
    get serviceLinkedRoleArn(): string;
    /**
     * @stability stable
     */
    set serviceLinkedRoleArn(value: string);
    /**
     * @stability stable
     */
    resetServiceLinkedRoleArn(): void;
    /**
     * @stability stable
     */
    get serviceLinkedRoleArnInput(): string | undefined;
    private _suspendedProcesses?;
    /**
     * @stability stable
     */
    get suspendedProcesses(): string[];
    /**
     * @stability stable
     */
    set suspendedProcesses(value: string[]);
    /**
     * @stability stable
     */
    resetSuspendedProcesses(): void;
    /**
     * @stability stable
     */
    get suspendedProcessesInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _targetGroupArns?;
    /**
     * @stability stable
     */
    get targetGroupArns(): string[];
    /**
     * @stability stable
     */
    set targetGroupArns(value: string[]);
    /**
     * @stability stable
     */
    resetTargetGroupArns(): void;
    /**
     * @stability stable
     */
    get targetGroupArnsInput(): string[] | undefined;
    private _terminationPolicies?;
    /**
     * @stability stable
     */
    get terminationPolicies(): string[];
    /**
     * @stability stable
     */
    set terminationPolicies(value: string[]);
    /**
     * @stability stable
     */
    resetTerminationPolicies(): void;
    /**
     * @stability stable
     */
    get terminationPoliciesInput(): string[] | undefined;
    private _vpcZoneIdentifier?;
    /**
     * @stability stable
     */
    get vpcZoneIdentifier(): string[];
    /**
     * @stability stable
     */
    set vpcZoneIdentifier(value: string[]);
    /**
     * @stability stable
     */
    resetVpcZoneIdentifier(): void;
    /**
     * @stability stable
     */
    get vpcZoneIdentifierInput(): string[] | undefined;
    private _waitForCapacityTimeout?;
    /**
     * @stability stable
     */
    get waitForCapacityTimeout(): string;
    /**
     * @stability stable
     */
    set waitForCapacityTimeout(value: string);
    /**
     * @stability stable
     */
    resetWaitForCapacityTimeout(): void;
    /**
     * @stability stable
     */
    get waitForCapacityTimeoutInput(): string | undefined;
    private _waitForElbCapacity?;
    /**
     * @stability stable
     */
    get waitForElbCapacity(): number;
    /**
     * @stability stable
     */
    set waitForElbCapacity(value: number);
    /**
     * @stability stable
     */
    resetWaitForElbCapacity(): void;
    /**
     * @stability stable
     */
    get waitForElbCapacityInput(): number | undefined;
    private _initialLifecycleHook?;
    /**
     * @stability stable
     */
    get initialLifecycleHook(): AutoscalingGroupInitialLifecycleHook[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set initialLifecycleHook(value: AutoscalingGroupInitialLifecycleHook[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetInitialLifecycleHook(): void;
    /**
     * @stability stable
     */
    get initialLifecycleHookInput(): cdktf.IResolvable | AutoscalingGroupInitialLifecycleHook[] | undefined;
    private _instanceRefresh;
    /**
     * @stability stable
     */
    get instanceRefresh(): AutoscalingGroupInstanceRefreshOutputReference;
    /**
     * @stability stable
     */
    putInstanceRefresh(value: AutoscalingGroupInstanceRefresh): void;
    /**
     * @stability stable
     */
    resetInstanceRefresh(): void;
    /**
     * @stability stable
     */
    get instanceRefreshInput(): AutoscalingGroupInstanceRefresh | undefined;
    private _launchTemplate;
    /**
     * @stability stable
     */
    get launchTemplate(): AutoscalingGroupLaunchTemplateOutputReference;
    /**
     * @stability stable
     */
    putLaunchTemplate(value: AutoscalingGroupLaunchTemplate): void;
    /**
     * @stability stable
     */
    resetLaunchTemplate(): void;
    /**
     * @stability stable
     */
    get launchTemplateInput(): AutoscalingGroupLaunchTemplate | undefined;
    private _mixedInstancesPolicy;
    /**
     * @stability stable
     */
    get mixedInstancesPolicy(): AutoscalingGroupMixedInstancesPolicyOutputReference;
    /**
     * @stability stable
     */
    putMixedInstancesPolicy(value: AutoscalingGroupMixedInstancesPolicy): void;
    /**
     * @stability stable
     */
    resetMixedInstancesPolicy(): void;
    /**
     * @stability stable
     */
    get mixedInstancesPolicyInput(): AutoscalingGroupMixedInstancesPolicy | undefined;
    private _tag?;
    /**
     * @stability stable
     */
    get tag(): AutoscalingGroupTag[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tag(value: AutoscalingGroupTag[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTag(): void;
    /**
     * @stability stable
     */
    get tagInput(): cdktf.IResolvable | AutoscalingGroupTag[] | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): AutoscalingGroupTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: AutoscalingGroupTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): AutoscalingGroupTimeouts | undefined;
    private _warmPool;
    /**
     * @stability stable
     */
    get warmPool(): AutoscalingGroupWarmPoolOutputReference;
    /**
     * @stability stable
     */
    putWarmPool(value: AutoscalingGroupWarmPool): void;
    /**
     * @stability stable
     */
    resetWarmPool(): void;
    /**
     * @stability stable
     */
    get warmPoolInput(): AutoscalingGroupWarmPool | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
