import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Auto Scaling.
 *
 * @stability stable
 */
export interface AutoscalingNotificationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_notification#group_names AutoscalingNotification#group_names}.
     *
     * @stability stable
     */
    readonly groupNames: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_notification#notifications AutoscalingNotification#notifications}.
     *
     * @stability stable
     */
    readonly notifications: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_notification#topic_arn AutoscalingNotification#topic_arn}.
     *
     * @stability stable
     */
    readonly topicArn: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_notification aws_autoscaling_notification}.
 *
 * @stability stable
 */
export declare class AutoscalingNotification extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_notification aws_autoscaling_notification} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AutoscalingNotificationConfig);
    private _groupNames?;
    /**
     * @stability stable
     */
    get groupNames(): string[];
    /**
     * @stability stable
     */
    set groupNames(value: string[]);
    /**
     * @stability stable
     */
    get groupNamesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _notifications?;
    /**
     * @stability stable
     */
    get notifications(): string[];
    /**
     * @stability stable
     */
    set notifications(value: string[]);
    /**
     * @stability stable
     */
    get notificationsInput(): string[] | undefined;
    private _topicArn?;
    /**
     * @stability stable
     */
    get topicArn(): string;
    /**
     * @stability stable
     */
    set topicArn(value: string);
    /**
     * @stability stable
     */
    get topicArnInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
