import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Backup.
 *
 * @stability stable
 */
export interface BackupVaultLockConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/backup_vault_lock_configuration#backup_vault_name BackupVaultLockConfiguration#backup_vault_name}.
     *
     * @stability stable
     */
    readonly backupVaultName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/backup_vault_lock_configuration#changeable_for_days BackupVaultLockConfiguration#changeable_for_days}.
     *
     * @stability stable
     */
    readonly changeableForDays?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/backup_vault_lock_configuration#max_retention_days BackupVaultLockConfiguration#max_retention_days}.
     *
     * @stability stable
     */
    readonly maxRetentionDays?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/backup_vault_lock_configuration#min_retention_days BackupVaultLockConfiguration#min_retention_days}.
     *
     * @stability stable
     */
    readonly minRetentionDays?: number;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/backup_vault_lock_configuration aws_backup_vault_lock_configuration}.
 *
 * @stability stable
 */
export declare class BackupVaultLockConfiguration extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/backup_vault_lock_configuration aws_backup_vault_lock_configuration} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: BackupVaultLockConfigurationConfig);
    /**
     * @stability stable
     */
    get backupVaultArn(): string;
    private _backupVaultName?;
    /**
     * @stability stable
     */
    get backupVaultName(): string;
    /**
     * @stability stable
     */
    set backupVaultName(value: string);
    /**
     * @stability stable
     */
    get backupVaultNameInput(): string | undefined;
    private _changeableForDays?;
    /**
     * @stability stable
     */
    get changeableForDays(): number;
    /**
     * @stability stable
     */
    set changeableForDays(value: number);
    /**
     * @stability stable
     */
    resetChangeableForDays(): void;
    /**
     * @stability stable
     */
    get changeableForDaysInput(): number | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _maxRetentionDays?;
    /**
     * @stability stable
     */
    get maxRetentionDays(): number;
    /**
     * @stability stable
     */
    set maxRetentionDays(value: number);
    /**
     * @stability stable
     */
    resetMaxRetentionDays(): void;
    /**
     * @stability stable
     */
    get maxRetentionDaysInput(): number | undefined;
    private _minRetentionDays?;
    /**
     * @stability stable
     */
    get minRetentionDays(): number;
    /**
     * @stability stable
     */
    set minRetentionDays(value: number);
    /**
     * @stability stable
     */
    resetMinRetentionDays(): void;
    /**
     * @stability stable
     */
    get minRetentionDaysInput(): number | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
