import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Batch.
 *
 * @stability stable
 */
export interface BatchComputeEnvironmentConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#compute_environment_name BatchComputeEnvironment#compute_environment_name}.
     *
     * @stability stable
     */
    readonly computeEnvironmentName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#compute_environment_name_prefix BatchComputeEnvironment#compute_environment_name_prefix}.
     *
     * @stability stable
     */
    readonly computeEnvironmentNamePrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#service_role BatchComputeEnvironment#service_role}.
     *
     * @stability stable
     */
    readonly serviceRole?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#state BatchComputeEnvironment#state}.
     *
     * @stability stable
     */
    readonly state?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#tags BatchComputeEnvironment#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#tags_all BatchComputeEnvironment#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#type BatchComputeEnvironment#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * compute_resources block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#compute_resources BatchComputeEnvironment#compute_resources}
     *
     * @stability stable
     */
    readonly computeResources?: BatchComputeEnvironmentComputeResources;
}
/**
 * @stability stable
 */
export interface BatchComputeEnvironmentComputeResourcesEc2Configuration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#image_id_override BatchComputeEnvironment#image_id_override}.
     *
     * @stability stable
     */
    readonly imageIdOverride?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#image_type BatchComputeEnvironment#image_type}.
     *
     * @stability stable
     */
    readonly imageType?: string;
}
export declare function batchComputeEnvironmentComputeResourcesEc2ConfigurationToTerraform(struct?: BatchComputeEnvironmentComputeResourcesEc2ConfigurationOutputReference | BatchComputeEnvironmentComputeResourcesEc2Configuration): any;
/**
 * @stability stable
 */
export declare class BatchComputeEnvironmentComputeResourcesEc2ConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): BatchComputeEnvironmentComputeResourcesEc2Configuration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: BatchComputeEnvironmentComputeResourcesEc2Configuration | undefined);
    private _imageIdOverride?;
    /**
     * @stability stable
     */
    get imageIdOverride(): string;
    /**
     * @stability stable
     */
    set imageIdOverride(value: string);
    /**
     * @stability stable
     */
    resetImageIdOverride(): void;
    /**
     * @stability stable
     */
    get imageIdOverrideInput(): string | undefined;
    private _imageType?;
    /**
     * @stability stable
     */
    get imageType(): string;
    /**
     * @stability stable
     */
    set imageType(value: string);
    /**
     * @stability stable
     */
    resetImageType(): void;
    /**
     * @stability stable
     */
    get imageTypeInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface BatchComputeEnvironmentComputeResourcesLaunchTemplate {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#launch_template_id BatchComputeEnvironment#launch_template_id}.
     *
     * @stability stable
     */
    readonly launchTemplateId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#launch_template_name BatchComputeEnvironment#launch_template_name}.
     *
     * @stability stable
     */
    readonly launchTemplateName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#version BatchComputeEnvironment#version}.
     *
     * @stability stable
     */
    readonly version?: string;
}
export declare function batchComputeEnvironmentComputeResourcesLaunchTemplateToTerraform(struct?: BatchComputeEnvironmentComputeResourcesLaunchTemplateOutputReference | BatchComputeEnvironmentComputeResourcesLaunchTemplate): any;
/**
 * @stability stable
 */
export declare class BatchComputeEnvironmentComputeResourcesLaunchTemplateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): BatchComputeEnvironmentComputeResourcesLaunchTemplate | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: BatchComputeEnvironmentComputeResourcesLaunchTemplate | undefined);
    private _launchTemplateId?;
    /**
     * @stability stable
     */
    get launchTemplateId(): string;
    /**
     * @stability stable
     */
    set launchTemplateId(value: string);
    /**
     * @stability stable
     */
    resetLaunchTemplateId(): void;
    /**
     * @stability stable
     */
    get launchTemplateIdInput(): string | undefined;
    private _launchTemplateName?;
    /**
     * @stability stable
     */
    get launchTemplateName(): string;
    /**
     * @stability stable
     */
    set launchTemplateName(value: string);
    /**
     * @stability stable
     */
    resetLaunchTemplateName(): void;
    /**
     * @stability stable
     */
    get launchTemplateNameInput(): string | undefined;
    private _version?;
    /**
     * @stability stable
     */
    get version(): string;
    /**
     * @stability stable
     */
    set version(value: string);
    /**
     * @stability stable
     */
    resetVersion(): void;
    /**
     * @stability stable
     */
    get versionInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface BatchComputeEnvironmentComputeResources {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#allocation_strategy BatchComputeEnvironment#allocation_strategy}.
     *
     * @stability stable
     */
    readonly allocationStrategy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#bid_percentage BatchComputeEnvironment#bid_percentage}.
     *
     * @stability stable
     */
    readonly bidPercentage?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#desired_vcpus BatchComputeEnvironment#desired_vcpus}.
     *
     * @stability stable
     */
    readonly desiredVcpus?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#ec2_key_pair BatchComputeEnvironment#ec2_key_pair}.
     *
     * @stability stable
     */
    readonly ec2KeyPair?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#image_id BatchComputeEnvironment#image_id}.
     *
     * @stability stable
     */
    readonly imageId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#instance_role BatchComputeEnvironment#instance_role}.
     *
     * @stability stable
     */
    readonly instanceRole?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#instance_type BatchComputeEnvironment#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#max_vcpus BatchComputeEnvironment#max_vcpus}.
     *
     * @stability stable
     */
    readonly maxVcpus: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#min_vcpus BatchComputeEnvironment#min_vcpus}.
     *
     * @stability stable
     */
    readonly minVcpus?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#security_group_ids BatchComputeEnvironment#security_group_ids}.
     *
     * @stability stable
     */
    readonly securityGroupIds: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#spot_iam_fleet_role BatchComputeEnvironment#spot_iam_fleet_role}.
     *
     * @stability stable
     */
    readonly spotIamFleetRole?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#subnets BatchComputeEnvironment#subnets}.
     *
     * @stability stable
     */
    readonly subnets: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#tags BatchComputeEnvironment#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#type BatchComputeEnvironment#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * ec2_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#ec2_configuration BatchComputeEnvironment#ec2_configuration}
     *
     * @stability stable
     */
    readonly ec2Configuration?: BatchComputeEnvironmentComputeResourcesEc2Configuration;
    /**
     * launch_template block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment#launch_template BatchComputeEnvironment#launch_template}
     *
     * @stability stable
     */
    readonly launchTemplate?: BatchComputeEnvironmentComputeResourcesLaunchTemplate;
}
export declare function batchComputeEnvironmentComputeResourcesToTerraform(struct?: BatchComputeEnvironmentComputeResourcesOutputReference | BatchComputeEnvironmentComputeResources): any;
/**
 * @stability stable
 */
export declare class BatchComputeEnvironmentComputeResourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): BatchComputeEnvironmentComputeResources | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: BatchComputeEnvironmentComputeResources | undefined);
    private _allocationStrategy?;
    /**
     * @stability stable
     */
    get allocationStrategy(): string;
    /**
     * @stability stable
     */
    set allocationStrategy(value: string);
    /**
     * @stability stable
     */
    resetAllocationStrategy(): void;
    /**
     * @stability stable
     */
    get allocationStrategyInput(): string | undefined;
    private _bidPercentage?;
    /**
     * @stability stable
     */
    get bidPercentage(): number;
    /**
     * @stability stable
     */
    set bidPercentage(value: number);
    /**
     * @stability stable
     */
    resetBidPercentage(): void;
    /**
     * @stability stable
     */
    get bidPercentageInput(): number | undefined;
    private _desiredVcpus?;
    /**
     * @stability stable
     */
    get desiredVcpus(): number;
    /**
     * @stability stable
     */
    set desiredVcpus(value: number);
    /**
     * @stability stable
     */
    resetDesiredVcpus(): void;
    /**
     * @stability stable
     */
    get desiredVcpusInput(): number | undefined;
    private _ec2KeyPair?;
    /**
     * @stability stable
     */
    get ec2KeyPair(): string;
    /**
     * @stability stable
     */
    set ec2KeyPair(value: string);
    /**
     * @stability stable
     */
    resetEc2KeyPair(): void;
    /**
     * @stability stable
     */
    get ec2KeyPairInput(): string | undefined;
    private _imageId?;
    /**
     * @stability stable
     */
    get imageId(): string;
    /**
     * @stability stable
     */
    set imageId(value: string);
    /**
     * @stability stable
     */
    resetImageId(): void;
    /**
     * @stability stable
     */
    get imageIdInput(): string | undefined;
    private _instanceRole?;
    /**
     * @stability stable
     */
    get instanceRole(): string;
    /**
     * @stability stable
     */
    set instanceRole(value: string);
    /**
     * @stability stable
     */
    resetInstanceRole(): void;
    /**
     * @stability stable
     */
    get instanceRoleInput(): string | undefined;
    private _instanceType?;
    /**
     * @stability stable
     */
    get instanceType(): string[];
    /**
     * @stability stable
     */
    set instanceType(value: string[]);
    /**
     * @stability stable
     */
    resetInstanceType(): void;
    /**
     * @stability stable
     */
    get instanceTypeInput(): string[] | undefined;
    private _maxVcpus?;
    /**
     * @stability stable
     */
    get maxVcpus(): number;
    /**
     * @stability stable
     */
    set maxVcpus(value: number);
    /**
     * @stability stable
     */
    get maxVcpusInput(): number | undefined;
    private _minVcpus?;
    /**
     * @stability stable
     */
    get minVcpus(): number;
    /**
     * @stability stable
     */
    set minVcpus(value: number);
    /**
     * @stability stable
     */
    resetMinVcpus(): void;
    /**
     * @stability stable
     */
    get minVcpusInput(): number | undefined;
    private _securityGroupIds?;
    /**
     * @stability stable
     */
    get securityGroupIds(): string[];
    /**
     * @stability stable
     */
    set securityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    get securityGroupIdsInput(): string[] | undefined;
    private _spotIamFleetRole?;
    /**
     * @stability stable
     */
    get spotIamFleetRole(): string;
    /**
     * @stability stable
     */
    set spotIamFleetRole(value: string);
    /**
     * @stability stable
     */
    resetSpotIamFleetRole(): void;
    /**
     * @stability stable
     */
    get spotIamFleetRoleInput(): string | undefined;
    private _subnets?;
    /**
     * @stability stable
     */
    get subnets(): string[];
    /**
     * @stability stable
     */
    set subnets(value: string[]);
    /**
     * @stability stable
     */
    get subnetsInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _ec2Configuration;
    /**
     * @stability stable
     */
    get ec2Configuration(): BatchComputeEnvironmentComputeResourcesEc2ConfigurationOutputReference;
    /**
     * @stability stable
     */
    putEc2Configuration(value: BatchComputeEnvironmentComputeResourcesEc2Configuration): void;
    /**
     * @stability stable
     */
    resetEc2Configuration(): void;
    /**
     * @stability stable
     */
    get ec2ConfigurationInput(): BatchComputeEnvironmentComputeResourcesEc2Configuration | undefined;
    private _launchTemplate;
    /**
     * @stability stable
     */
    get launchTemplate(): BatchComputeEnvironmentComputeResourcesLaunchTemplateOutputReference;
    /**
     * @stability stable
     */
    putLaunchTemplate(value: BatchComputeEnvironmentComputeResourcesLaunchTemplate): void;
    /**
     * @stability stable
     */
    resetLaunchTemplate(): void;
    /**
     * @stability stable
     */
    get launchTemplateInput(): BatchComputeEnvironmentComputeResourcesLaunchTemplate | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment aws_batch_compute_environment}.
 *
 * @stability stable
 */
export declare class BatchComputeEnvironment extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/batch_compute_environment aws_batch_compute_environment} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: BatchComputeEnvironmentConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _computeEnvironmentName?;
    /**
     * @stability stable
     */
    get computeEnvironmentName(): string;
    /**
     * @stability stable
     */
    set computeEnvironmentName(value: string);
    /**
     * @stability stable
     */
    resetComputeEnvironmentName(): void;
    /**
     * @stability stable
     */
    get computeEnvironmentNameInput(): string | undefined;
    private _computeEnvironmentNamePrefix?;
    /**
     * @stability stable
     */
    get computeEnvironmentNamePrefix(): string;
    /**
     * @stability stable
     */
    set computeEnvironmentNamePrefix(value: string);
    /**
     * @stability stable
     */
    resetComputeEnvironmentNamePrefix(): void;
    /**
     * @stability stable
     */
    get computeEnvironmentNamePrefixInput(): string | undefined;
    /**
     * @stability stable
     */
    get ecsClusterArn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _serviceRole?;
    /**
     * @stability stable
     */
    get serviceRole(): string;
    /**
     * @stability stable
     */
    set serviceRole(value: string);
    /**
     * @stability stable
     */
    resetServiceRole(): void;
    /**
     * @stability stable
     */
    get serviceRoleInput(): string | undefined;
    private _state?;
    /**
     * @stability stable
     */
    get state(): string;
    /**
     * @stability stable
     */
    set state(value: string);
    /**
     * @stability stable
     */
    resetState(): void;
    /**
     * @stability stable
     */
    get stateInput(): string | undefined;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    get statusReason(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _computeResources;
    /**
     * @stability stable
     */
    get computeResources(): BatchComputeEnvironmentComputeResourcesOutputReference;
    /**
     * @stability stable
     */
    putComputeResources(value: BatchComputeEnvironmentComputeResources): void;
    /**
     * @stability stable
     */
    resetComputeResources(): void;
    /**
     * @stability stable
     */
    get computeResourcesInput(): BatchComputeEnvironmentComputeResources | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
