import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Batch.
 *
 * @stability stable
 */
export interface BatchSchedulingPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_scheduling_policy#name BatchSchedulingPolicy#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_scheduling_policy#tags BatchSchedulingPolicy#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_scheduling_policy#tags_all BatchSchedulingPolicy#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * fair_share_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_scheduling_policy#fair_share_policy BatchSchedulingPolicy#fair_share_policy}
     *
     * @stability stable
     */
    readonly fairSharePolicy?: BatchSchedulingPolicyFairSharePolicy;
}
/**
 * @stability stable
 */
export interface BatchSchedulingPolicyFairSharePolicyShareDistribution {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_scheduling_policy#share_identifier BatchSchedulingPolicy#share_identifier}.
     *
     * @stability stable
     */
    readonly shareIdentifier: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_scheduling_policy#weight_factor BatchSchedulingPolicy#weight_factor}.
     *
     * @stability stable
     */
    readonly weightFactor?: number;
}
export declare function batchSchedulingPolicyFairSharePolicyShareDistributionToTerraform(struct?: BatchSchedulingPolicyFairSharePolicyShareDistribution | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface BatchSchedulingPolicyFairSharePolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_scheduling_policy#compute_reservation BatchSchedulingPolicy#compute_reservation}.
     *
     * @stability stable
     */
    readonly computeReservation?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_scheduling_policy#share_decay_seconds BatchSchedulingPolicy#share_decay_seconds}.
     *
     * @stability stable
     */
    readonly shareDecaySeconds?: number;
    /**
     * share_distribution block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/batch_scheduling_policy#share_distribution BatchSchedulingPolicy#share_distribution}
     *
     * @stability stable
     */
    readonly shareDistribution?: BatchSchedulingPolicyFairSharePolicyShareDistribution[] | cdktf.IResolvable;
}
export declare function batchSchedulingPolicyFairSharePolicyToTerraform(struct?: BatchSchedulingPolicyFairSharePolicyOutputReference | BatchSchedulingPolicyFairSharePolicy): any;
/**
 * @stability stable
 */
export declare class BatchSchedulingPolicyFairSharePolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): BatchSchedulingPolicyFairSharePolicy | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: BatchSchedulingPolicyFairSharePolicy | undefined);
    private _computeReservation?;
    /**
     * @stability stable
     */
    get computeReservation(): number;
    /**
     * @stability stable
     */
    set computeReservation(value: number);
    /**
     * @stability stable
     */
    resetComputeReservation(): void;
    /**
     * @stability stable
     */
    get computeReservationInput(): number | undefined;
    private _shareDecaySeconds?;
    /**
     * @stability stable
     */
    get shareDecaySeconds(): number;
    /**
     * @stability stable
     */
    set shareDecaySeconds(value: number);
    /**
     * @stability stable
     */
    resetShareDecaySeconds(): void;
    /**
     * @stability stable
     */
    get shareDecaySecondsInput(): number | undefined;
    private _shareDistribution?;
    /**
     * @stability stable
     */
    get shareDistribution(): BatchSchedulingPolicyFairSharePolicyShareDistribution[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set shareDistribution(value: BatchSchedulingPolicyFairSharePolicyShareDistribution[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetShareDistribution(): void;
    /**
     * @stability stable
     */
    get shareDistributionInput(): cdktf.IResolvable | BatchSchedulingPolicyFairSharePolicyShareDistribution[] | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/batch_scheduling_policy aws_batch_scheduling_policy}.
 *
 * @stability stable
 */
export declare class BatchSchedulingPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/batch_scheduling_policy aws_batch_scheduling_policy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: BatchSchedulingPolicyConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _fairSharePolicy;
    /**
     * @stability stable
     */
    get fairSharePolicy(): BatchSchedulingPolicyFairSharePolicyOutputReference;
    /**
     * @stability stable
     */
    putFairSharePolicy(value: BatchSchedulingPolicyFairSharePolicy): void;
    /**
     * @stability stable
     */
    resetFairSharePolicy(): void;
    /**
     * @stability stable
     */
    get fairSharePolicyInput(): BatchSchedulingPolicyFairSharePolicy | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
