import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Budgets.
 *
 * @stability stable
 */
export interface BudgetsBudgetConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#account_id BudgetsBudget#account_id}.
     *
     * @stability stable
     */
    readonly accountId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#budget_type BudgetsBudget#budget_type}.
     *
     * @stability stable
     */
    readonly budgetType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#cost_filters BudgetsBudget#cost_filters}.
     *
     * @stability stable
     */
    readonly costFilters?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#limit_amount BudgetsBudget#limit_amount}.
     *
     * @stability stable
     */
    readonly limitAmount: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#limit_unit BudgetsBudget#limit_unit}.
     *
     * @stability stable
     */
    readonly limitUnit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#name BudgetsBudget#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#name_prefix BudgetsBudget#name_prefix}.
     *
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#time_period_end BudgetsBudget#time_period_end}.
     *
     * @stability stable
     */
    readonly timePeriodEnd?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#time_period_start BudgetsBudget#time_period_start}.
     *
     * @stability stable
     */
    readonly timePeriodStart?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#time_unit BudgetsBudget#time_unit}.
     *
     * @stability stable
     */
    readonly timeUnit: string;
    /**
     * cost_filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#cost_filter BudgetsBudget#cost_filter}
     *
     * @stability stable
     */
    readonly costFilter?: BudgetsBudgetCostFilter[] | cdktf.IResolvable;
    /**
     * cost_types block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#cost_types BudgetsBudget#cost_types}
     *
     * @stability stable
     */
    readonly costTypes?: BudgetsBudgetCostTypes;
    /**
     * notification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#notification BudgetsBudget#notification}
     *
     * @stability stable
     */
    readonly notification?: BudgetsBudgetNotification[] | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface BudgetsBudgetCostFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#name BudgetsBudget#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#values BudgetsBudget#values}.
     *
     * @stability stable
     */
    readonly values: string[];
}
export declare function budgetsBudgetCostFilterToTerraform(struct?: BudgetsBudgetCostFilter | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface BudgetsBudgetCostTypes {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#include_credit BudgetsBudget#include_credit}.
     *
     * @stability stable
     */
    readonly includeCredit?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#include_discount BudgetsBudget#include_discount}.
     *
     * @stability stable
     */
    readonly includeDiscount?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#include_other_subscription BudgetsBudget#include_other_subscription}.
     *
     * @stability stable
     */
    readonly includeOtherSubscription?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#include_recurring BudgetsBudget#include_recurring}.
     *
     * @stability stable
     */
    readonly includeRecurring?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#include_refund BudgetsBudget#include_refund}.
     *
     * @stability stable
     */
    readonly includeRefund?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#include_subscription BudgetsBudget#include_subscription}.
     *
     * @stability stable
     */
    readonly includeSubscription?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#include_support BudgetsBudget#include_support}.
     *
     * @stability stable
     */
    readonly includeSupport?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#include_tax BudgetsBudget#include_tax}.
     *
     * @stability stable
     */
    readonly includeTax?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#include_upfront BudgetsBudget#include_upfront}.
     *
     * @stability stable
     */
    readonly includeUpfront?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#use_amortized BudgetsBudget#use_amortized}.
     *
     * @stability stable
     */
    readonly useAmortized?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#use_blended BudgetsBudget#use_blended}.
     *
     * @stability stable
     */
    readonly useBlended?: boolean | cdktf.IResolvable;
}
export declare function budgetsBudgetCostTypesToTerraform(struct?: BudgetsBudgetCostTypesOutputReference | BudgetsBudgetCostTypes): any;
/**
 * @stability stable
 */
export declare class BudgetsBudgetCostTypesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): BudgetsBudgetCostTypes | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: BudgetsBudgetCostTypes | undefined);
    private _includeCredit?;
    /**
     * @stability stable
     */
    get includeCredit(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set includeCredit(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIncludeCredit(): void;
    /**
     * @stability stable
     */
    get includeCreditInput(): boolean | cdktf.IResolvable | undefined;
    private _includeDiscount?;
    /**
     * @stability stable
     */
    get includeDiscount(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set includeDiscount(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIncludeDiscount(): void;
    /**
     * @stability stable
     */
    get includeDiscountInput(): boolean | cdktf.IResolvable | undefined;
    private _includeOtherSubscription?;
    /**
     * @stability stable
     */
    get includeOtherSubscription(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set includeOtherSubscription(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIncludeOtherSubscription(): void;
    /**
     * @stability stable
     */
    get includeOtherSubscriptionInput(): boolean | cdktf.IResolvable | undefined;
    private _includeRecurring?;
    /**
     * @stability stable
     */
    get includeRecurring(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set includeRecurring(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIncludeRecurring(): void;
    /**
     * @stability stable
     */
    get includeRecurringInput(): boolean | cdktf.IResolvable | undefined;
    private _includeRefund?;
    /**
     * @stability stable
     */
    get includeRefund(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set includeRefund(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIncludeRefund(): void;
    /**
     * @stability stable
     */
    get includeRefundInput(): boolean | cdktf.IResolvable | undefined;
    private _includeSubscription?;
    /**
     * @stability stable
     */
    get includeSubscription(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set includeSubscription(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIncludeSubscription(): void;
    /**
     * @stability stable
     */
    get includeSubscriptionInput(): boolean | cdktf.IResolvable | undefined;
    private _includeSupport?;
    /**
     * @stability stable
     */
    get includeSupport(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set includeSupport(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIncludeSupport(): void;
    /**
     * @stability stable
     */
    get includeSupportInput(): boolean | cdktf.IResolvable | undefined;
    private _includeTax?;
    /**
     * @stability stable
     */
    get includeTax(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set includeTax(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIncludeTax(): void;
    /**
     * @stability stable
     */
    get includeTaxInput(): boolean | cdktf.IResolvable | undefined;
    private _includeUpfront?;
    /**
     * @stability stable
     */
    get includeUpfront(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set includeUpfront(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIncludeUpfront(): void;
    /**
     * @stability stable
     */
    get includeUpfrontInput(): boolean | cdktf.IResolvable | undefined;
    private _useAmortized?;
    /**
     * @stability stable
     */
    get useAmortized(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set useAmortized(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetUseAmortized(): void;
    /**
     * @stability stable
     */
    get useAmortizedInput(): boolean | cdktf.IResolvable | undefined;
    private _useBlended?;
    /**
     * @stability stable
     */
    get useBlended(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set useBlended(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetUseBlended(): void;
    /**
     * @stability stable
     */
    get useBlendedInput(): boolean | cdktf.IResolvable | undefined;
}
/**
 * @stability stable
 */
export interface BudgetsBudgetNotification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#comparison_operator BudgetsBudget#comparison_operator}.
     *
     * @stability stable
     */
    readonly comparisonOperator: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#notification_type BudgetsBudget#notification_type}.
     *
     * @stability stable
     */
    readonly notificationType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#subscriber_email_addresses BudgetsBudget#subscriber_email_addresses}.
     *
     * @stability stable
     */
    readonly subscriberEmailAddresses?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#subscriber_sns_topic_arns BudgetsBudget#subscriber_sns_topic_arns}.
     *
     * @stability stable
     */
    readonly subscriberSnsTopicArns?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#threshold BudgetsBudget#threshold}.
     *
     * @stability stable
     */
    readonly threshold: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget#threshold_type BudgetsBudget#threshold_type}.
     *
     * @stability stable
     */
    readonly thresholdType: string;
}
export declare function budgetsBudgetNotificationToTerraform(struct?: BudgetsBudgetNotification | cdktf.IResolvable): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget aws_budgets_budget}.
 *
 * @stability stable
 */
export declare class BudgetsBudget extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget aws_budgets_budget} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: BudgetsBudgetConfig);
    private _accountId?;
    /**
     * @stability stable
     */
    get accountId(): string;
    /**
     * @stability stable
     */
    set accountId(value: string);
    /**
     * @stability stable
     */
    resetAccountId(): void;
    /**
     * @stability stable
     */
    get accountIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _budgetType?;
    /**
     * @stability stable
     */
    get budgetType(): string;
    /**
     * @stability stable
     */
    set budgetType(value: string);
    /**
     * @stability stable
     */
    get budgetTypeInput(): string | undefined;
    private _costFilters?;
    /**
     * @stability stable
     */
    get costFilters(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set costFilters(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetCostFilters(): void;
    /**
     * @stability stable
     */
    get costFiltersInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _limitAmount?;
    /**
     * @stability stable
     */
    get limitAmount(): string;
    /**
     * @stability stable
     */
    set limitAmount(value: string);
    /**
     * @stability stable
     */
    get limitAmountInput(): string | undefined;
    private _limitUnit?;
    /**
     * @stability stable
     */
    get limitUnit(): string;
    /**
     * @stability stable
     */
    set limitUnit(value: string);
    /**
     * @stability stable
     */
    get limitUnitInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    private _timePeriodEnd?;
    /**
     * @stability stable
     */
    get timePeriodEnd(): string;
    /**
     * @stability stable
     */
    set timePeriodEnd(value: string);
    /**
     * @stability stable
     */
    resetTimePeriodEnd(): void;
    /**
     * @stability stable
     */
    get timePeriodEndInput(): string | undefined;
    private _timePeriodStart?;
    /**
     * @stability stable
     */
    get timePeriodStart(): string;
    /**
     * @stability stable
     */
    set timePeriodStart(value: string);
    /**
     * @stability stable
     */
    resetTimePeriodStart(): void;
    /**
     * @stability stable
     */
    get timePeriodStartInput(): string | undefined;
    private _timeUnit?;
    /**
     * @stability stable
     */
    get timeUnit(): string;
    /**
     * @stability stable
     */
    set timeUnit(value: string);
    /**
     * @stability stable
     */
    get timeUnitInput(): string | undefined;
    private _costFilter?;
    /**
     * @stability stable
     */
    get costFilter(): BudgetsBudgetCostFilter[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set costFilter(value: BudgetsBudgetCostFilter[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetCostFilter(): void;
    /**
     * @stability stable
     */
    get costFilterInput(): cdktf.IResolvable | BudgetsBudgetCostFilter[] | undefined;
    private _costTypes;
    /**
     * @stability stable
     */
    get costTypes(): BudgetsBudgetCostTypesOutputReference;
    /**
     * @stability stable
     */
    putCostTypes(value: BudgetsBudgetCostTypes): void;
    /**
     * @stability stable
     */
    resetCostTypes(): void;
    /**
     * @stability stable
     */
    get costTypesInput(): BudgetsBudgetCostTypes | undefined;
    private _notification?;
    /**
     * @stability stable
     */
    get notification(): BudgetsBudgetNotification[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set notification(value: BudgetsBudgetNotification[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetNotification(): void;
    /**
     * @stability stable
     */
    get notificationInput(): cdktf.IResolvable | BudgetsBudgetNotification[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
