import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS CloudFront.
 *
 * @stability stable
 */
export interface CloudfrontRealtimeLogConfigConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config#fields CloudfrontRealtimeLogConfig#fields}.
     *
     * @stability stable
     */
    readonly fields: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config#name CloudfrontRealtimeLogConfig#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config#sampling_rate CloudfrontRealtimeLogConfig#sampling_rate}.
     *
     * @stability stable
     */
    readonly samplingRate: number;
    /**
     * endpoint block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config#endpoint CloudfrontRealtimeLogConfig#endpoint}
     *
     * @stability stable
     */
    readonly endpoint: CloudfrontRealtimeLogConfigEndpoint;
}
/**
 * @stability stable
 */
export interface CloudfrontRealtimeLogConfigEndpointKinesisStreamConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config#role_arn CloudfrontRealtimeLogConfig#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config#stream_arn CloudfrontRealtimeLogConfig#stream_arn}.
     *
     * @stability stable
     */
    readonly streamArn: string;
}
export declare function cloudfrontRealtimeLogConfigEndpointKinesisStreamConfigToTerraform(struct?: CloudfrontRealtimeLogConfigEndpointKinesisStreamConfigOutputReference | CloudfrontRealtimeLogConfigEndpointKinesisStreamConfig): any;
/**
 * @stability stable
 */
export declare class CloudfrontRealtimeLogConfigEndpointKinesisStreamConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CloudfrontRealtimeLogConfigEndpointKinesisStreamConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CloudfrontRealtimeLogConfigEndpointKinesisStreamConfig | undefined);
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
    private _streamArn?;
    /**
     * @stability stable
     */
    get streamArn(): string;
    /**
     * @stability stable
     */
    set streamArn(value: string);
    /**
     * @stability stable
     */
    get streamArnInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface CloudfrontRealtimeLogConfigEndpoint {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config#stream_type CloudfrontRealtimeLogConfig#stream_type}.
     *
     * @stability stable
     */
    readonly streamType: string;
    /**
     * kinesis_stream_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config#kinesis_stream_config CloudfrontRealtimeLogConfig#kinesis_stream_config}
     *
     * @stability stable
     */
    readonly kinesisStreamConfig: CloudfrontRealtimeLogConfigEndpointKinesisStreamConfig;
}
export declare function cloudfrontRealtimeLogConfigEndpointToTerraform(struct?: CloudfrontRealtimeLogConfigEndpointOutputReference | CloudfrontRealtimeLogConfigEndpoint): any;
/**
 * @stability stable
 */
export declare class CloudfrontRealtimeLogConfigEndpointOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CloudfrontRealtimeLogConfigEndpoint | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CloudfrontRealtimeLogConfigEndpoint | undefined);
    private _streamType?;
    /**
     * @stability stable
     */
    get streamType(): string;
    /**
     * @stability stable
     */
    set streamType(value: string);
    /**
     * @stability stable
     */
    get streamTypeInput(): string | undefined;
    private _kinesisStreamConfig;
    /**
     * @stability stable
     */
    get kinesisStreamConfig(): CloudfrontRealtimeLogConfigEndpointKinesisStreamConfigOutputReference;
    /**
     * @stability stable
     */
    putKinesisStreamConfig(value: CloudfrontRealtimeLogConfigEndpointKinesisStreamConfig): void;
    /**
     * @stability stable
     */
    get kinesisStreamConfigInput(): CloudfrontRealtimeLogConfigEndpointKinesisStreamConfig | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config aws_cloudfront_realtime_log_config}.
 *
 * @stability stable
 */
export declare class CloudfrontRealtimeLogConfig extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_realtime_log_config aws_cloudfront_realtime_log_config} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudfrontRealtimeLogConfigConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _fields?;
    /**
     * @stability stable
     */
    get fields(): string[];
    /**
     * @stability stable
     */
    set fields(value: string[]);
    /**
     * @stability stable
     */
    get fieldsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _samplingRate?;
    /**
     * @stability stable
     */
    get samplingRate(): number;
    /**
     * @stability stable
     */
    set samplingRate(value: number);
    /**
     * @stability stable
     */
    get samplingRateInput(): number | undefined;
    private _endpoint;
    /**
     * @stability stable
     */
    get endpoint(): CloudfrontRealtimeLogConfigEndpointOutputReference;
    /**
     * @stability stable
     */
    putEndpoint(value: CloudfrontRealtimeLogConfigEndpoint): void;
    /**
     * @stability stable
     */
    get endpointInput(): CloudfrontRealtimeLogConfigEndpoint | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
