import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS CloudFront.
 *
 * @stability stable
 */
export interface DataAwsCloudfrontCachePolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_cache_policy#id DataAwsCloudfrontCachePolicy#id}.
     *
     * @stability stable
     */
    readonly id?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_cache_policy#name DataAwsCloudfrontCachePolicy#name}.
     *
     * @stability stable
     */
    readonly name?: string;
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginCookiesConfigCookies extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get items(): string[];
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginCookiesConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get cookieBehavior(): string;
    /**
     * @stability stable
     */
    get cookies(): cdktf.IResolvable;
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginHeadersConfigHeaders extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get items(): string[];
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginHeadersConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get headerBehavior(): string;
    /**
     * @stability stable
     */
    get headers(): cdktf.IResolvable;
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginQueryStringsConfigQueryStrings extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get items(): string[];
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginQueryStringsConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get queryStringBehavior(): string;
    /**
     * @stability stable
     */
    get queryStrings(): cdktf.IResolvable;
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontCachePolicyParametersInCacheKeyAndForwardedToOrigin extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get cookiesConfig(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get enableAcceptEncodingBrotli(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get enableAcceptEncodingGzip(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get headersConfig(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get queryStringsConfig(): cdktf.IResolvable;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_cache_policy aws_cloudfront_cache_policy}.
 *
 * @stability stable
 */
export declare class DataAwsCloudfrontCachePolicy extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_cache_policy aws_cloudfront_cache_policy} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsCloudfrontCachePolicyConfig);
    /**
     * @stability stable
     */
    get comment(): string;
    /**
     * @stability stable
     */
    get defaultTtl(): number;
    /**
     * @stability stable
     */
    get etag(): string;
    private _id?;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    set id(value: string);
    /**
     * @stability stable
     */
    resetId(): void;
    /**
     * @stability stable
     */
    get idInput(): string | undefined;
    /**
     * @stability stable
     */
    get maxTtl(): number;
    /**
     * @stability stable
     */
    get minTtl(): number;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    parametersInCacheKeyAndForwardedToOrigin(index: string): DataAwsCloudfrontCachePolicyParametersInCacheKeyAndForwardedToOrigin;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
