import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CloudsearchDomainConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudsearch_domain#multi_az CloudsearchDomain#multi_az}.
     *
     * @stability stable
     */
    readonly multiAz?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudsearch_domain#name CloudsearchDomain#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * endpoint_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudsearch_domain#endpoint_options CloudsearchDomain#endpoint_options}
     *
     * @stability stable
     */
    readonly endpointOptions?: CloudsearchDomainEndpointOptions;
    /**
     * index_field block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudsearch_domain#index_field CloudsearchDomain#index_field}
     *
     * @stability stable
     */
    readonly indexField?: CloudsearchDomainIndexField[] | cdktf.IResolvable;
    /**
     * scaling_parameters block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudsearch_domain#scaling_parameters CloudsearchDomain#scaling_parameters}
     *
     * @stability stable
     */
    readonly scalingParameters?: CloudsearchDomainScalingParameters;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudsearch_domain#timeouts CloudsearchDomain#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: CloudsearchDomainTimeouts;
}
/**
 * @stability stable
 */
export interface CloudsearchDomainEndpointOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudsearch_domain#enforce_https CloudsearchDomain#enforce_https}.
     *
     * @stability stable
     */
    readonly enforceHttps?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudsearch_domain#tls_security_policy CloudsearchDomain#tls_security_policy}.
     *
     * @stability stable
     */
    readonly tlsSecurityPolicy?: string;
}
export declare function cloudsearchDomainEndpointOptionsToTerraform(struct?: CloudsearchDomainEndpointOptionsOutputReference | CloudsearchDomainEndpointOptions): any;
/**
 * @stability stable
 */
export declare class CloudsearchDomainEndpointOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CloudsearchDomainEndpointOptions | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CloudsearchDomainEndpointOptions | undefined);
    private _enforceHttps?;
    /**
     * @stability stable
     */
    get enforceHttps(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enforceHttps(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnforceHttps(): void;
    /**
     * @stability stable
     */
    get enforceHttpsInput(): boolean | cdktf.IResolvable | undefined;
    private _tlsSecurityPolicy?;
    /**
     * @stability stable
     */
    get tlsSecurityPolicy(): string;
    /**
     * @stability stable
     */
    set tlsSecurityPolicy(value: string);
    /**
     * @stability stable
     */
    resetTlsSecurityPolicy(): void;
    /**
     * @stability stable
     */
    get tlsSecurityPolicyInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface CloudsearchDomainIndexField {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudsearch_domain#analysis_scheme CloudsearchDomain#analysis_scheme}.
     *
     * @stability stable
     */
    readonly analysisScheme?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudsearch_domain#default_value CloudsearchDomain#default_value}.
     *
     * @stability stable
     */
    readonly defaultValue?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudsearch_domain#facet CloudsearchDomain#facet}.
     *
     * @stability stable
     */
    readonly facet?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudsearch_domain#highlight CloudsearchDomain#highlight}.
     *
     * @stability stable
     */
    readonly highlight?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudsearch_domain#name CloudsearchDomain#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudsearch_domain#return CloudsearchDomain#return}.
     *
     * @stability stable
     */
    readonly return?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudsearch_domain#search CloudsearchDomain#search}.
     *
     * @stability stable
     */
    readonly search?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudsearch_domain#sort CloudsearchDomain#sort}.
     *
     * @stability stable
     */
    readonly sort?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudsearch_domain#type CloudsearchDomain#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
export declare function cloudsearchDomainIndexFieldToTerraform(struct?: CloudsearchDomainIndexField | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface CloudsearchDomainScalingParameters {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudsearch_domain#desired_instance_type CloudsearchDomain#desired_instance_type}.
     *
     * @stability stable
     */
    readonly desiredInstanceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudsearch_domain#desired_partition_count CloudsearchDomain#desired_partition_count}.
     *
     * @stability stable
     */
    readonly desiredPartitionCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudsearch_domain#desired_replication_count CloudsearchDomain#desired_replication_count}.
     *
     * @stability stable
     */
    readonly desiredReplicationCount?: number;
}
export declare function cloudsearchDomainScalingParametersToTerraform(struct?: CloudsearchDomainScalingParametersOutputReference | CloudsearchDomainScalingParameters): any;
/**
 * @stability stable
 */
export declare class CloudsearchDomainScalingParametersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CloudsearchDomainScalingParameters | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CloudsearchDomainScalingParameters | undefined);
    private _desiredInstanceType?;
    /**
     * @stability stable
     */
    get desiredInstanceType(): string;
    /**
     * @stability stable
     */
    set desiredInstanceType(value: string);
    /**
     * @stability stable
     */
    resetDesiredInstanceType(): void;
    /**
     * @stability stable
     */
    get desiredInstanceTypeInput(): string | undefined;
    private _desiredPartitionCount?;
    /**
     * @stability stable
     */
    get desiredPartitionCount(): number;
    /**
     * @stability stable
     */
    set desiredPartitionCount(value: number);
    /**
     * @stability stable
     */
    resetDesiredPartitionCount(): void;
    /**
     * @stability stable
     */
    get desiredPartitionCountInput(): number | undefined;
    private _desiredReplicationCount?;
    /**
     * @stability stable
     */
    get desiredReplicationCount(): number;
    /**
     * @stability stable
     */
    set desiredReplicationCount(value: number);
    /**
     * @stability stable
     */
    resetDesiredReplicationCount(): void;
    /**
     * @stability stable
     */
    get desiredReplicationCountInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface CloudsearchDomainTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudsearch_domain#create CloudsearchDomain#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudsearch_domain#delete CloudsearchDomain#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudsearch_domain#update CloudsearchDomain#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function cloudsearchDomainTimeoutsToTerraform(struct?: CloudsearchDomainTimeoutsOutputReference | CloudsearchDomainTimeouts | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export declare class CloudsearchDomainTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CloudsearchDomainTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CloudsearchDomainTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudsearch_domain aws_cloudsearch_domain}.
 *
 * @stability stable
 */
export declare class CloudsearchDomain extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudsearch_domain aws_cloudsearch_domain} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudsearchDomainConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get documentServiceEndpoint(): string;
    /**
     * @stability stable
     */
    get domainId(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _multiAz?;
    /**
     * @stability stable
     */
    get multiAz(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set multiAz(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetMultiAz(): void;
    /**
     * @stability stable
     */
    get multiAzInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get searchServiceEndpoint(): string;
    private _endpointOptions;
    /**
     * @stability stable
     */
    get endpointOptions(): CloudsearchDomainEndpointOptionsOutputReference;
    /**
     * @stability stable
     */
    putEndpointOptions(value: CloudsearchDomainEndpointOptions): void;
    /**
     * @stability stable
     */
    resetEndpointOptions(): void;
    /**
     * @stability stable
     */
    get endpointOptionsInput(): CloudsearchDomainEndpointOptions | undefined;
    private _indexField?;
    /**
     * @stability stable
     */
    get indexField(): CloudsearchDomainIndexField[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set indexField(value: CloudsearchDomainIndexField[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIndexField(): void;
    /**
     * @stability stable
     */
    get indexFieldInput(): cdktf.IResolvable | CloudsearchDomainIndexField[] | undefined;
    private _scalingParameters;
    /**
     * @stability stable
     */
    get scalingParameters(): CloudsearchDomainScalingParametersOutputReference;
    /**
     * @stability stable
     */
    putScalingParameters(value: CloudsearchDomainScalingParameters): void;
    /**
     * @stability stable
     */
    resetScalingParameters(): void;
    /**
     * @stability stable
     */
    get scalingParametersInput(): CloudsearchDomainScalingParameters | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): CloudsearchDomainTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: CloudsearchDomainTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): CloudsearchDomainTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
