import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS CodeArtifact.
 *
 * @stability stable
 */
export interface DataAwsCodeartifactAuthorizationTokenConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/codeartifact_authorization_token#domain DataAwsCodeartifactAuthorizationToken#domain}.
     *
     * @stability stable
     */
    readonly domain: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/codeartifact_authorization_token#domain_owner DataAwsCodeartifactAuthorizationToken#domain_owner}.
     *
     * @stability stable
     */
    readonly domainOwner?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/codeartifact_authorization_token#duration_seconds DataAwsCodeartifactAuthorizationToken#duration_seconds}.
     *
     * @stability stable
     */
    readonly durationSeconds?: number;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/codeartifact_authorization_token aws_codeartifact_authorization_token}.
 *
 * @stability stable
 */
export declare class DataAwsCodeartifactAuthorizationToken extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/codeartifact_authorization_token aws_codeartifact_authorization_token} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsCodeartifactAuthorizationTokenConfig);
    /**
     * @stability stable
     */
    get authorizationToken(): string;
    private _domain?;
    /**
     * @stability stable
     */
    get domain(): string;
    /**
     * @stability stable
     */
    set domain(value: string);
    /**
     * @stability stable
     */
    get domainInput(): string | undefined;
    private _domainOwner?;
    /**
     * @stability stable
     */
    get domainOwner(): string;
    /**
     * @stability stable
     */
    set domainOwner(value: string);
    /**
     * @stability stable
     */
    resetDomainOwner(): void;
    /**
     * @stability stable
     */
    get domainOwnerInput(): string | undefined;
    private _durationSeconds?;
    /**
     * @stability stable
     */
    get durationSeconds(): number;
    /**
     * @stability stable
     */
    set durationSeconds(value: number);
    /**
     * @stability stable
     */
    resetDurationSeconds(): void;
    /**
     * @stability stable
     */
    get durationSecondsInput(): number | undefined;
    /**
     * @stability stable
     */
    get expiration(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
