import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Cognito.
 *
 * @stability stable
 */
export interface CognitoIdentityPoolProviderPrincipalTagConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_pool_provider_principal_tag#identity_pool_id CognitoIdentityPoolProviderPrincipalTag#identity_pool_id}.
     *
     * @stability stable
     */
    readonly identityPoolId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_pool_provider_principal_tag#identity_provider_name CognitoIdentityPoolProviderPrincipalTag#identity_provider_name}.
     *
     * @stability stable
     */
    readonly identityProviderName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_pool_provider_principal_tag#principal_tags CognitoIdentityPoolProviderPrincipalTag#principal_tags}.
     *
     * @stability stable
     */
    readonly principalTags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_pool_provider_principal_tag#use_defaults CognitoIdentityPoolProviderPrincipalTag#use_defaults}.
     *
     * @stability stable
     */
    readonly useDefaults?: boolean | cdktf.IResolvable;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_pool_provider_principal_tag aws_cognito_identity_pool_provider_principal_tag}.
 *
 * @stability stable
 */
export declare class CognitoIdentityPoolProviderPrincipalTag extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_pool_provider_principal_tag aws_cognito_identity_pool_provider_principal_tag} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CognitoIdentityPoolProviderPrincipalTagConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _identityPoolId?;
    /**
     * @stability stable
     */
    get identityPoolId(): string;
    /**
     * @stability stable
     */
    set identityPoolId(value: string);
    /**
     * @stability stable
     */
    get identityPoolIdInput(): string | undefined;
    private _identityProviderName?;
    /**
     * @stability stable
     */
    get identityProviderName(): string;
    /**
     * @stability stable
     */
    set identityProviderName(value: string);
    /**
     * @stability stable
     */
    get identityProviderNameInput(): string | undefined;
    private _principalTags?;
    /**
     * @stability stable
     */
    get principalTags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set principalTags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetPrincipalTags(): void;
    /**
     * @stability stable
     */
    get principalTagsInput(): {
        [key: string]: string;
    } | undefined;
    private _useDefaults?;
    /**
     * @stability stable
     */
    get useDefaults(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set useDefaults(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetUseDefaults(): void;
    /**
     * @stability stable
     */
    get useDefaultsInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
