import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Cognito.
 *
 * @stability stable
 */
export interface CognitoUserPoolConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#alias_attributes CognitoUserPool#alias_attributes}.
     *
     * @stability stable
     */
    readonly aliasAttributes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#auto_verified_attributes CognitoUserPool#auto_verified_attributes}.
     *
     * @stability stable
     */
    readonly autoVerifiedAttributes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#email_verification_message CognitoUserPool#email_verification_message}.
     *
     * @stability stable
     */
    readonly emailVerificationMessage?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#email_verification_subject CognitoUserPool#email_verification_subject}.
     *
     * @stability stable
     */
    readonly emailVerificationSubject?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#mfa_configuration CognitoUserPool#mfa_configuration}.
     *
     * @stability stable
     */
    readonly mfaConfiguration?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#name CognitoUserPool#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#sms_authentication_message CognitoUserPool#sms_authentication_message}.
     *
     * @stability stable
     */
    readonly smsAuthenticationMessage?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#sms_verification_message CognitoUserPool#sms_verification_message}.
     *
     * @stability stable
     */
    readonly smsVerificationMessage?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#tags CognitoUserPool#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#tags_all CognitoUserPool#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#username_attributes CognitoUserPool#username_attributes}.
     *
     * @stability stable
     */
    readonly usernameAttributes?: string[];
    /**
     * account_recovery_setting block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#account_recovery_setting CognitoUserPool#account_recovery_setting}
     *
     * @stability stable
     */
    readonly accountRecoverySetting?: CognitoUserPoolAccountRecoverySetting;
    /**
     * admin_create_user_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#admin_create_user_config CognitoUserPool#admin_create_user_config}
     *
     * @stability stable
     */
    readonly adminCreateUserConfig?: CognitoUserPoolAdminCreateUserConfig;
    /**
     * device_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#device_configuration CognitoUserPool#device_configuration}
     *
     * @stability stable
     */
    readonly deviceConfiguration?: CognitoUserPoolDeviceConfiguration;
    /**
     * email_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#email_configuration CognitoUserPool#email_configuration}
     *
     * @stability stable
     */
    readonly emailConfiguration?: CognitoUserPoolEmailConfiguration;
    /**
     * lambda_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#lambda_config CognitoUserPool#lambda_config}
     *
     * @stability stable
     */
    readonly lambdaConfig?: CognitoUserPoolLambdaConfig;
    /**
     * password_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#password_policy CognitoUserPool#password_policy}
     *
     * @stability stable
     */
    readonly passwordPolicy?: CognitoUserPoolPasswordPolicy;
    /**
     * schema block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#schema CognitoUserPool#schema}
     *
     * @stability stable
     */
    readonly schema?: CognitoUserPoolSchema[] | cdktf.IResolvable;
    /**
     * sms_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#sms_configuration CognitoUserPool#sms_configuration}
     *
     * @stability stable
     */
    readonly smsConfiguration?: CognitoUserPoolSmsConfiguration;
    /**
     * software_token_mfa_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#software_token_mfa_configuration CognitoUserPool#software_token_mfa_configuration}
     *
     * @stability stable
     */
    readonly softwareTokenMfaConfiguration?: CognitoUserPoolSoftwareTokenMfaConfiguration;
    /**
     * user_pool_add_ons block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#user_pool_add_ons CognitoUserPool#user_pool_add_ons}
     *
     * @stability stable
     */
    readonly userPoolAddOns?: CognitoUserPoolUserPoolAddOns;
    /**
     * username_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#username_configuration CognitoUserPool#username_configuration}
     *
     * @stability stable
     */
    readonly usernameConfiguration?: CognitoUserPoolUsernameConfiguration;
    /**
     * verification_message_template block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#verification_message_template CognitoUserPool#verification_message_template}
     *
     * @stability stable
     */
    readonly verificationMessageTemplate?: CognitoUserPoolVerificationMessageTemplate;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolAccountRecoverySettingRecoveryMechanism {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#name CognitoUserPool#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#priority CognitoUserPool#priority}.
     *
     * @stability stable
     */
    readonly priority: number;
}
export declare function cognitoUserPoolAccountRecoverySettingRecoveryMechanismToTerraform(struct?: CognitoUserPoolAccountRecoverySettingRecoveryMechanism | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface CognitoUserPoolAccountRecoverySetting {
    /**
     * recovery_mechanism block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#recovery_mechanism CognitoUserPool#recovery_mechanism}
     *
     * @stability stable
     */
    readonly recoveryMechanism: CognitoUserPoolAccountRecoverySettingRecoveryMechanism[] | cdktf.IResolvable;
}
export declare function cognitoUserPoolAccountRecoverySettingToTerraform(struct?: CognitoUserPoolAccountRecoverySettingOutputReference | CognitoUserPoolAccountRecoverySetting): any;
/**
 * @stability stable
 */
export declare class CognitoUserPoolAccountRecoverySettingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CognitoUserPoolAccountRecoverySetting | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CognitoUserPoolAccountRecoverySetting | undefined);
    private _recoveryMechanism?;
    /**
     * @stability stable
     */
    get recoveryMechanism(): CognitoUserPoolAccountRecoverySettingRecoveryMechanism[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set recoveryMechanism(value: CognitoUserPoolAccountRecoverySettingRecoveryMechanism[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get recoveryMechanismInput(): cdktf.IResolvable | CognitoUserPoolAccountRecoverySettingRecoveryMechanism[] | undefined;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolAdminCreateUserConfigInviteMessageTemplate {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#email_message CognitoUserPool#email_message}.
     *
     * @stability stable
     */
    readonly emailMessage?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#email_subject CognitoUserPool#email_subject}.
     *
     * @stability stable
     */
    readonly emailSubject?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#sms_message CognitoUserPool#sms_message}.
     *
     * @stability stable
     */
    readonly smsMessage?: string;
}
export declare function cognitoUserPoolAdminCreateUserConfigInviteMessageTemplateToTerraform(struct?: CognitoUserPoolAdminCreateUserConfigInviteMessageTemplateOutputReference | CognitoUserPoolAdminCreateUserConfigInviteMessageTemplate): any;
/**
 * @stability stable
 */
export declare class CognitoUserPoolAdminCreateUserConfigInviteMessageTemplateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CognitoUserPoolAdminCreateUserConfigInviteMessageTemplate | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CognitoUserPoolAdminCreateUserConfigInviteMessageTemplate | undefined);
    private _emailMessage?;
    /**
     * @stability stable
     */
    get emailMessage(): string;
    /**
     * @stability stable
     */
    set emailMessage(value: string);
    /**
     * @stability stable
     */
    resetEmailMessage(): void;
    /**
     * @stability stable
     */
    get emailMessageInput(): string | undefined;
    private _emailSubject?;
    /**
     * @stability stable
     */
    get emailSubject(): string;
    /**
     * @stability stable
     */
    set emailSubject(value: string);
    /**
     * @stability stable
     */
    resetEmailSubject(): void;
    /**
     * @stability stable
     */
    get emailSubjectInput(): string | undefined;
    private _smsMessage?;
    /**
     * @stability stable
     */
    get smsMessage(): string;
    /**
     * @stability stable
     */
    set smsMessage(value: string);
    /**
     * @stability stable
     */
    resetSmsMessage(): void;
    /**
     * @stability stable
     */
    get smsMessageInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolAdminCreateUserConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#allow_admin_create_user_only CognitoUserPool#allow_admin_create_user_only}.
     *
     * @stability stable
     */
    readonly allowAdminCreateUserOnly?: boolean | cdktf.IResolvable;
    /**
     * invite_message_template block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#invite_message_template CognitoUserPool#invite_message_template}
     *
     * @stability stable
     */
    readonly inviteMessageTemplate?: CognitoUserPoolAdminCreateUserConfigInviteMessageTemplate;
}
export declare function cognitoUserPoolAdminCreateUserConfigToTerraform(struct?: CognitoUserPoolAdminCreateUserConfigOutputReference | CognitoUserPoolAdminCreateUserConfig): any;
/**
 * @stability stable
 */
export declare class CognitoUserPoolAdminCreateUserConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CognitoUserPoolAdminCreateUserConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CognitoUserPoolAdminCreateUserConfig | undefined);
    private _allowAdminCreateUserOnly?;
    /**
     * @stability stable
     */
    get allowAdminCreateUserOnly(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set allowAdminCreateUserOnly(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAllowAdminCreateUserOnly(): void;
    /**
     * @stability stable
     */
    get allowAdminCreateUserOnlyInput(): boolean | cdktf.IResolvable | undefined;
    private _inviteMessageTemplate;
    /**
     * @stability stable
     */
    get inviteMessageTemplate(): CognitoUserPoolAdminCreateUserConfigInviteMessageTemplateOutputReference;
    /**
     * @stability stable
     */
    putInviteMessageTemplate(value: CognitoUserPoolAdminCreateUserConfigInviteMessageTemplate): void;
    /**
     * @stability stable
     */
    resetInviteMessageTemplate(): void;
    /**
     * @stability stable
     */
    get inviteMessageTemplateInput(): CognitoUserPoolAdminCreateUserConfigInviteMessageTemplate | undefined;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolDeviceConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#challenge_required_on_new_device CognitoUserPool#challenge_required_on_new_device}.
     *
     * @stability stable
     */
    readonly challengeRequiredOnNewDevice?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#device_only_remembered_on_user_prompt CognitoUserPool#device_only_remembered_on_user_prompt}.
     *
     * @stability stable
     */
    readonly deviceOnlyRememberedOnUserPrompt?: boolean | cdktf.IResolvable;
}
export declare function cognitoUserPoolDeviceConfigurationToTerraform(struct?: CognitoUserPoolDeviceConfigurationOutputReference | CognitoUserPoolDeviceConfiguration): any;
/**
 * @stability stable
 */
export declare class CognitoUserPoolDeviceConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CognitoUserPoolDeviceConfiguration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CognitoUserPoolDeviceConfiguration | undefined);
    private _challengeRequiredOnNewDevice?;
    /**
     * @stability stable
     */
    get challengeRequiredOnNewDevice(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set challengeRequiredOnNewDevice(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetChallengeRequiredOnNewDevice(): void;
    /**
     * @stability stable
     */
    get challengeRequiredOnNewDeviceInput(): boolean | cdktf.IResolvable | undefined;
    private _deviceOnlyRememberedOnUserPrompt?;
    /**
     * @stability stable
     */
    get deviceOnlyRememberedOnUserPrompt(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set deviceOnlyRememberedOnUserPrompt(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDeviceOnlyRememberedOnUserPrompt(): void;
    /**
     * @stability stable
     */
    get deviceOnlyRememberedOnUserPromptInput(): boolean | cdktf.IResolvable | undefined;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolEmailConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#configuration_set CognitoUserPool#configuration_set}.
     *
     * @stability stable
     */
    readonly configurationSet?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#email_sending_account CognitoUserPool#email_sending_account}.
     *
     * @stability stable
     */
    readonly emailSendingAccount?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#from_email_address CognitoUserPool#from_email_address}.
     *
     * @stability stable
     */
    readonly fromEmailAddress?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#reply_to_email_address CognitoUserPool#reply_to_email_address}.
     *
     * @stability stable
     */
    readonly replyToEmailAddress?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#source_arn CognitoUserPool#source_arn}.
     *
     * @stability stable
     */
    readonly sourceArn?: string;
}
export declare function cognitoUserPoolEmailConfigurationToTerraform(struct?: CognitoUserPoolEmailConfigurationOutputReference | CognitoUserPoolEmailConfiguration): any;
/**
 * @stability stable
 */
export declare class CognitoUserPoolEmailConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CognitoUserPoolEmailConfiguration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CognitoUserPoolEmailConfiguration | undefined);
    private _configurationSet?;
    /**
     * @stability stable
     */
    get configurationSet(): string;
    /**
     * @stability stable
     */
    set configurationSet(value: string);
    /**
     * @stability stable
     */
    resetConfigurationSet(): void;
    /**
     * @stability stable
     */
    get configurationSetInput(): string | undefined;
    private _emailSendingAccount?;
    /**
     * @stability stable
     */
    get emailSendingAccount(): string;
    /**
     * @stability stable
     */
    set emailSendingAccount(value: string);
    /**
     * @stability stable
     */
    resetEmailSendingAccount(): void;
    /**
     * @stability stable
     */
    get emailSendingAccountInput(): string | undefined;
    private _fromEmailAddress?;
    /**
     * @stability stable
     */
    get fromEmailAddress(): string;
    /**
     * @stability stable
     */
    set fromEmailAddress(value: string);
    /**
     * @stability stable
     */
    resetFromEmailAddress(): void;
    /**
     * @stability stable
     */
    get fromEmailAddressInput(): string | undefined;
    private _replyToEmailAddress?;
    /**
     * @stability stable
     */
    get replyToEmailAddress(): string;
    /**
     * @stability stable
     */
    set replyToEmailAddress(value: string);
    /**
     * @stability stable
     */
    resetReplyToEmailAddress(): void;
    /**
     * @stability stable
     */
    get replyToEmailAddressInput(): string | undefined;
    private _sourceArn?;
    /**
     * @stability stable
     */
    get sourceArn(): string;
    /**
     * @stability stable
     */
    set sourceArn(value: string);
    /**
     * @stability stable
     */
    resetSourceArn(): void;
    /**
     * @stability stable
     */
    get sourceArnInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolLambdaConfigCustomEmailSender {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#lambda_arn CognitoUserPool#lambda_arn}.
     *
     * @stability stable
     */
    readonly lambdaArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#lambda_version CognitoUserPool#lambda_version}.
     *
     * @stability stable
     */
    readonly lambdaVersion: string;
}
export declare function cognitoUserPoolLambdaConfigCustomEmailSenderToTerraform(struct?: CognitoUserPoolLambdaConfigCustomEmailSenderOutputReference | CognitoUserPoolLambdaConfigCustomEmailSender): any;
/**
 * @stability stable
 */
export declare class CognitoUserPoolLambdaConfigCustomEmailSenderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CognitoUserPoolLambdaConfigCustomEmailSender | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CognitoUserPoolLambdaConfigCustomEmailSender | undefined);
    private _lambdaArn?;
    /**
     * @stability stable
     */
    get lambdaArn(): string;
    /**
     * @stability stable
     */
    set lambdaArn(value: string);
    /**
     * @stability stable
     */
    get lambdaArnInput(): string | undefined;
    private _lambdaVersion?;
    /**
     * @stability stable
     */
    get lambdaVersion(): string;
    /**
     * @stability stable
     */
    set lambdaVersion(value: string);
    /**
     * @stability stable
     */
    get lambdaVersionInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolLambdaConfigCustomSmsSender {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#lambda_arn CognitoUserPool#lambda_arn}.
     *
     * @stability stable
     */
    readonly lambdaArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#lambda_version CognitoUserPool#lambda_version}.
     *
     * @stability stable
     */
    readonly lambdaVersion: string;
}
export declare function cognitoUserPoolLambdaConfigCustomSmsSenderToTerraform(struct?: CognitoUserPoolLambdaConfigCustomSmsSenderOutputReference | CognitoUserPoolLambdaConfigCustomSmsSender): any;
/**
 * @stability stable
 */
export declare class CognitoUserPoolLambdaConfigCustomSmsSenderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CognitoUserPoolLambdaConfigCustomSmsSender | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CognitoUserPoolLambdaConfigCustomSmsSender | undefined);
    private _lambdaArn?;
    /**
     * @stability stable
     */
    get lambdaArn(): string;
    /**
     * @stability stable
     */
    set lambdaArn(value: string);
    /**
     * @stability stable
     */
    get lambdaArnInput(): string | undefined;
    private _lambdaVersion?;
    /**
     * @stability stable
     */
    get lambdaVersion(): string;
    /**
     * @stability stable
     */
    set lambdaVersion(value: string);
    /**
     * @stability stable
     */
    get lambdaVersionInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolLambdaConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#create_auth_challenge CognitoUserPool#create_auth_challenge}.
     *
     * @stability stable
     */
    readonly createAuthChallenge?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#custom_message CognitoUserPool#custom_message}.
     *
     * @stability stable
     */
    readonly customMessage?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#define_auth_challenge CognitoUserPool#define_auth_challenge}.
     *
     * @stability stable
     */
    readonly defineAuthChallenge?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#kms_key_id CognitoUserPool#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#post_authentication CognitoUserPool#post_authentication}.
     *
     * @stability stable
     */
    readonly postAuthentication?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#post_confirmation CognitoUserPool#post_confirmation}.
     *
     * @stability stable
     */
    readonly postConfirmation?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#pre_authentication CognitoUserPool#pre_authentication}.
     *
     * @stability stable
     */
    readonly preAuthentication?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#pre_sign_up CognitoUserPool#pre_sign_up}.
     *
     * @stability stable
     */
    readonly preSignUp?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#pre_token_generation CognitoUserPool#pre_token_generation}.
     *
     * @stability stable
     */
    readonly preTokenGeneration?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#user_migration CognitoUserPool#user_migration}.
     *
     * @stability stable
     */
    readonly userMigration?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#verify_auth_challenge_response CognitoUserPool#verify_auth_challenge_response}.
     *
     * @stability stable
     */
    readonly verifyAuthChallengeResponse?: string;
    /**
     * custom_email_sender block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#custom_email_sender CognitoUserPool#custom_email_sender}
     *
     * @stability stable
     */
    readonly customEmailSender?: CognitoUserPoolLambdaConfigCustomEmailSender;
    /**
     * custom_sms_sender block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#custom_sms_sender CognitoUserPool#custom_sms_sender}
     *
     * @stability stable
     */
    readonly customSmsSender?: CognitoUserPoolLambdaConfigCustomSmsSender;
}
export declare function cognitoUserPoolLambdaConfigToTerraform(struct?: CognitoUserPoolLambdaConfigOutputReference | CognitoUserPoolLambdaConfig): any;
/**
 * @stability stable
 */
export declare class CognitoUserPoolLambdaConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CognitoUserPoolLambdaConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CognitoUserPoolLambdaConfig | undefined);
    private _createAuthChallenge?;
    /**
     * @stability stable
     */
    get createAuthChallenge(): string;
    /**
     * @stability stable
     */
    set createAuthChallenge(value: string);
    /**
     * @stability stable
     */
    resetCreateAuthChallenge(): void;
    /**
     * @stability stable
     */
    get createAuthChallengeInput(): string | undefined;
    private _customMessage?;
    /**
     * @stability stable
     */
    get customMessage(): string;
    /**
     * @stability stable
     */
    set customMessage(value: string);
    /**
     * @stability stable
     */
    resetCustomMessage(): void;
    /**
     * @stability stable
     */
    get customMessageInput(): string | undefined;
    private _defineAuthChallenge?;
    /**
     * @stability stable
     */
    get defineAuthChallenge(): string;
    /**
     * @stability stable
     */
    set defineAuthChallenge(value: string);
    /**
     * @stability stable
     */
    resetDefineAuthChallenge(): void;
    /**
     * @stability stable
     */
    get defineAuthChallengeInput(): string | undefined;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    private _postAuthentication?;
    /**
     * @stability stable
     */
    get postAuthentication(): string;
    /**
     * @stability stable
     */
    set postAuthentication(value: string);
    /**
     * @stability stable
     */
    resetPostAuthentication(): void;
    /**
     * @stability stable
     */
    get postAuthenticationInput(): string | undefined;
    private _postConfirmation?;
    /**
     * @stability stable
     */
    get postConfirmation(): string;
    /**
     * @stability stable
     */
    set postConfirmation(value: string);
    /**
     * @stability stable
     */
    resetPostConfirmation(): void;
    /**
     * @stability stable
     */
    get postConfirmationInput(): string | undefined;
    private _preAuthentication?;
    /**
     * @stability stable
     */
    get preAuthentication(): string;
    /**
     * @stability stable
     */
    set preAuthentication(value: string);
    /**
     * @stability stable
     */
    resetPreAuthentication(): void;
    /**
     * @stability stable
     */
    get preAuthenticationInput(): string | undefined;
    private _preSignUp?;
    /**
     * @stability stable
     */
    get preSignUp(): string;
    /**
     * @stability stable
     */
    set preSignUp(value: string);
    /**
     * @stability stable
     */
    resetPreSignUp(): void;
    /**
     * @stability stable
     */
    get preSignUpInput(): string | undefined;
    private _preTokenGeneration?;
    /**
     * @stability stable
     */
    get preTokenGeneration(): string;
    /**
     * @stability stable
     */
    set preTokenGeneration(value: string);
    /**
     * @stability stable
     */
    resetPreTokenGeneration(): void;
    /**
     * @stability stable
     */
    get preTokenGenerationInput(): string | undefined;
    private _userMigration?;
    /**
     * @stability stable
     */
    get userMigration(): string;
    /**
     * @stability stable
     */
    set userMigration(value: string);
    /**
     * @stability stable
     */
    resetUserMigration(): void;
    /**
     * @stability stable
     */
    get userMigrationInput(): string | undefined;
    private _verifyAuthChallengeResponse?;
    /**
     * @stability stable
     */
    get verifyAuthChallengeResponse(): string;
    /**
     * @stability stable
     */
    set verifyAuthChallengeResponse(value: string);
    /**
     * @stability stable
     */
    resetVerifyAuthChallengeResponse(): void;
    /**
     * @stability stable
     */
    get verifyAuthChallengeResponseInput(): string | undefined;
    private _customEmailSender;
    /**
     * @stability stable
     */
    get customEmailSender(): CognitoUserPoolLambdaConfigCustomEmailSenderOutputReference;
    /**
     * @stability stable
     */
    putCustomEmailSender(value: CognitoUserPoolLambdaConfigCustomEmailSender): void;
    /**
     * @stability stable
     */
    resetCustomEmailSender(): void;
    /**
     * @stability stable
     */
    get customEmailSenderInput(): CognitoUserPoolLambdaConfigCustomEmailSender | undefined;
    private _customSmsSender;
    /**
     * @stability stable
     */
    get customSmsSender(): CognitoUserPoolLambdaConfigCustomSmsSenderOutputReference;
    /**
     * @stability stable
     */
    putCustomSmsSender(value: CognitoUserPoolLambdaConfigCustomSmsSender): void;
    /**
     * @stability stable
     */
    resetCustomSmsSender(): void;
    /**
     * @stability stable
     */
    get customSmsSenderInput(): CognitoUserPoolLambdaConfigCustomSmsSender | undefined;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolPasswordPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#minimum_length CognitoUserPool#minimum_length}.
     *
     * @stability stable
     */
    readonly minimumLength?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#require_lowercase CognitoUserPool#require_lowercase}.
     *
     * @stability stable
     */
    readonly requireLowercase?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#require_numbers CognitoUserPool#require_numbers}.
     *
     * @stability stable
     */
    readonly requireNumbers?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#require_symbols CognitoUserPool#require_symbols}.
     *
     * @stability stable
     */
    readonly requireSymbols?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#require_uppercase CognitoUserPool#require_uppercase}.
     *
     * @stability stable
     */
    readonly requireUppercase?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#temporary_password_validity_days CognitoUserPool#temporary_password_validity_days}.
     *
     * @stability stable
     */
    readonly temporaryPasswordValidityDays?: number;
}
export declare function cognitoUserPoolPasswordPolicyToTerraform(struct?: CognitoUserPoolPasswordPolicyOutputReference | CognitoUserPoolPasswordPolicy): any;
/**
 * @stability stable
 */
export declare class CognitoUserPoolPasswordPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CognitoUserPoolPasswordPolicy | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CognitoUserPoolPasswordPolicy | undefined);
    private _minimumLength?;
    /**
     * @stability stable
     */
    get minimumLength(): number;
    /**
     * @stability stable
     */
    set minimumLength(value: number);
    /**
     * @stability stable
     */
    resetMinimumLength(): void;
    /**
     * @stability stable
     */
    get minimumLengthInput(): number | undefined;
    private _requireLowercase?;
    /**
     * @stability stable
     */
    get requireLowercase(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set requireLowercase(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetRequireLowercase(): void;
    /**
     * @stability stable
     */
    get requireLowercaseInput(): boolean | cdktf.IResolvable | undefined;
    private _requireNumbers?;
    /**
     * @stability stable
     */
    get requireNumbers(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set requireNumbers(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetRequireNumbers(): void;
    /**
     * @stability stable
     */
    get requireNumbersInput(): boolean | cdktf.IResolvable | undefined;
    private _requireSymbols?;
    /**
     * @stability stable
     */
    get requireSymbols(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set requireSymbols(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetRequireSymbols(): void;
    /**
     * @stability stable
     */
    get requireSymbolsInput(): boolean | cdktf.IResolvable | undefined;
    private _requireUppercase?;
    /**
     * @stability stable
     */
    get requireUppercase(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set requireUppercase(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetRequireUppercase(): void;
    /**
     * @stability stable
     */
    get requireUppercaseInput(): boolean | cdktf.IResolvable | undefined;
    private _temporaryPasswordValidityDays?;
    /**
     * @stability stable
     */
    get temporaryPasswordValidityDays(): number;
    /**
     * @stability stable
     */
    set temporaryPasswordValidityDays(value: number);
    /**
     * @stability stable
     */
    resetTemporaryPasswordValidityDays(): void;
    /**
     * @stability stable
     */
    get temporaryPasswordValidityDaysInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolSchemaNumberAttributeConstraints {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#max_value CognitoUserPool#max_value}.
     *
     * @stability stable
     */
    readonly maxValue?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#min_value CognitoUserPool#min_value}.
     *
     * @stability stable
     */
    readonly minValue?: string;
}
export declare function cognitoUserPoolSchemaNumberAttributeConstraintsToTerraform(struct?: CognitoUserPoolSchemaNumberAttributeConstraintsOutputReference | CognitoUserPoolSchemaNumberAttributeConstraints): any;
/**
 * @stability stable
 */
export declare class CognitoUserPoolSchemaNumberAttributeConstraintsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CognitoUserPoolSchemaNumberAttributeConstraints | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CognitoUserPoolSchemaNumberAttributeConstraints | undefined);
    private _maxValue?;
    /**
     * @stability stable
     */
    get maxValue(): string;
    /**
     * @stability stable
     */
    set maxValue(value: string);
    /**
     * @stability stable
     */
    resetMaxValue(): void;
    /**
     * @stability stable
     */
    get maxValueInput(): string | undefined;
    private _minValue?;
    /**
     * @stability stable
     */
    get minValue(): string;
    /**
     * @stability stable
     */
    set minValue(value: string);
    /**
     * @stability stable
     */
    resetMinValue(): void;
    /**
     * @stability stable
     */
    get minValueInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolSchemaStringAttributeConstraints {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#max_length CognitoUserPool#max_length}.
     *
     * @stability stable
     */
    readonly maxLength?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#min_length CognitoUserPool#min_length}.
     *
     * @stability stable
     */
    readonly minLength?: string;
}
export declare function cognitoUserPoolSchemaStringAttributeConstraintsToTerraform(struct?: CognitoUserPoolSchemaStringAttributeConstraintsOutputReference | CognitoUserPoolSchemaStringAttributeConstraints): any;
/**
 * @stability stable
 */
export declare class CognitoUserPoolSchemaStringAttributeConstraintsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CognitoUserPoolSchemaStringAttributeConstraints | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CognitoUserPoolSchemaStringAttributeConstraints | undefined);
    private _maxLength?;
    /**
     * @stability stable
     */
    get maxLength(): string;
    /**
     * @stability stable
     */
    set maxLength(value: string);
    /**
     * @stability stable
     */
    resetMaxLength(): void;
    /**
     * @stability stable
     */
    get maxLengthInput(): string | undefined;
    private _minLength?;
    /**
     * @stability stable
     */
    get minLength(): string;
    /**
     * @stability stable
     */
    set minLength(value: string);
    /**
     * @stability stable
     */
    resetMinLength(): void;
    /**
     * @stability stable
     */
    get minLengthInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolSchema {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#attribute_data_type CognitoUserPool#attribute_data_type}.
     *
     * @stability stable
     */
    readonly attributeDataType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#developer_only_attribute CognitoUserPool#developer_only_attribute}.
     *
     * @stability stable
     */
    readonly developerOnlyAttribute?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#mutable CognitoUserPool#mutable}.
     *
     * @stability stable
     */
    readonly mutable?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#name CognitoUserPool#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#required CognitoUserPool#required}.
     *
     * @stability stable
     */
    readonly required?: boolean | cdktf.IResolvable;
    /**
     * number_attribute_constraints block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#number_attribute_constraints CognitoUserPool#number_attribute_constraints}
     *
     * @stability stable
     */
    readonly numberAttributeConstraints?: CognitoUserPoolSchemaNumberAttributeConstraints;
    /**
     * string_attribute_constraints block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#string_attribute_constraints CognitoUserPool#string_attribute_constraints}
     *
     * @stability stable
     */
    readonly stringAttributeConstraints?: CognitoUserPoolSchemaStringAttributeConstraints;
}
export declare function cognitoUserPoolSchemaToTerraform(struct?: CognitoUserPoolSchema | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface CognitoUserPoolSmsConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#external_id CognitoUserPool#external_id}.
     *
     * @stability stable
     */
    readonly externalId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#sns_caller_arn CognitoUserPool#sns_caller_arn}.
     *
     * @stability stable
     */
    readonly snsCallerArn: string;
}
export declare function cognitoUserPoolSmsConfigurationToTerraform(struct?: CognitoUserPoolSmsConfigurationOutputReference | CognitoUserPoolSmsConfiguration): any;
/**
 * @stability stable
 */
export declare class CognitoUserPoolSmsConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CognitoUserPoolSmsConfiguration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CognitoUserPoolSmsConfiguration | undefined);
    private _externalId?;
    /**
     * @stability stable
     */
    get externalId(): string;
    /**
     * @stability stable
     */
    set externalId(value: string);
    /**
     * @stability stable
     */
    get externalIdInput(): string | undefined;
    private _snsCallerArn?;
    /**
     * @stability stable
     */
    get snsCallerArn(): string;
    /**
     * @stability stable
     */
    set snsCallerArn(value: string);
    /**
     * @stability stable
     */
    get snsCallerArnInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolSoftwareTokenMfaConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#enabled CognitoUserPool#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean | cdktf.IResolvable;
}
export declare function cognitoUserPoolSoftwareTokenMfaConfigurationToTerraform(struct?: CognitoUserPoolSoftwareTokenMfaConfigurationOutputReference | CognitoUserPoolSoftwareTokenMfaConfiguration): any;
/**
 * @stability stable
 */
export declare class CognitoUserPoolSoftwareTokenMfaConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CognitoUserPoolSoftwareTokenMfaConfiguration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CognitoUserPoolSoftwareTokenMfaConfiguration | undefined);
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolUserPoolAddOns {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#advanced_security_mode CognitoUserPool#advanced_security_mode}.
     *
     * @stability stable
     */
    readonly advancedSecurityMode: string;
}
export declare function cognitoUserPoolUserPoolAddOnsToTerraform(struct?: CognitoUserPoolUserPoolAddOnsOutputReference | CognitoUserPoolUserPoolAddOns): any;
/**
 * @stability stable
 */
export declare class CognitoUserPoolUserPoolAddOnsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CognitoUserPoolUserPoolAddOns | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CognitoUserPoolUserPoolAddOns | undefined);
    private _advancedSecurityMode?;
    /**
     * @stability stable
     */
    get advancedSecurityMode(): string;
    /**
     * @stability stable
     */
    set advancedSecurityMode(value: string);
    /**
     * @stability stable
     */
    get advancedSecurityModeInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolUsernameConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#case_sensitive CognitoUserPool#case_sensitive}.
     *
     * @stability stable
     */
    readonly caseSensitive: boolean | cdktf.IResolvable;
}
export declare function cognitoUserPoolUsernameConfigurationToTerraform(struct?: CognitoUserPoolUsernameConfigurationOutputReference | CognitoUserPoolUsernameConfiguration): any;
/**
 * @stability stable
 */
export declare class CognitoUserPoolUsernameConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CognitoUserPoolUsernameConfiguration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CognitoUserPoolUsernameConfiguration | undefined);
    private _caseSensitive?;
    /**
     * @stability stable
     */
    get caseSensitive(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set caseSensitive(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get caseSensitiveInput(): boolean | cdktf.IResolvable | undefined;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolVerificationMessageTemplate {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#default_email_option CognitoUserPool#default_email_option}.
     *
     * @stability stable
     */
    readonly defaultEmailOption?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#email_message CognitoUserPool#email_message}.
     *
     * @stability stable
     */
    readonly emailMessage?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#email_message_by_link CognitoUserPool#email_message_by_link}.
     *
     * @stability stable
     */
    readonly emailMessageByLink?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#email_subject CognitoUserPool#email_subject}.
     *
     * @stability stable
     */
    readonly emailSubject?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#email_subject_by_link CognitoUserPool#email_subject_by_link}.
     *
     * @stability stable
     */
    readonly emailSubjectByLink?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool#sms_message CognitoUserPool#sms_message}.
     *
     * @stability stable
     */
    readonly smsMessage?: string;
}
export declare function cognitoUserPoolVerificationMessageTemplateToTerraform(struct?: CognitoUserPoolVerificationMessageTemplateOutputReference | CognitoUserPoolVerificationMessageTemplate): any;
/**
 * @stability stable
 */
export declare class CognitoUserPoolVerificationMessageTemplateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CognitoUserPoolVerificationMessageTemplate | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CognitoUserPoolVerificationMessageTemplate | undefined);
    private _defaultEmailOption?;
    /**
     * @stability stable
     */
    get defaultEmailOption(): string;
    /**
     * @stability stable
     */
    set defaultEmailOption(value: string);
    /**
     * @stability stable
     */
    resetDefaultEmailOption(): void;
    /**
     * @stability stable
     */
    get defaultEmailOptionInput(): string | undefined;
    private _emailMessage?;
    /**
     * @stability stable
     */
    get emailMessage(): string;
    /**
     * @stability stable
     */
    set emailMessage(value: string);
    /**
     * @stability stable
     */
    resetEmailMessage(): void;
    /**
     * @stability stable
     */
    get emailMessageInput(): string | undefined;
    private _emailMessageByLink?;
    /**
     * @stability stable
     */
    get emailMessageByLink(): string;
    /**
     * @stability stable
     */
    set emailMessageByLink(value: string);
    /**
     * @stability stable
     */
    resetEmailMessageByLink(): void;
    /**
     * @stability stable
     */
    get emailMessageByLinkInput(): string | undefined;
    private _emailSubject?;
    /**
     * @stability stable
     */
    get emailSubject(): string;
    /**
     * @stability stable
     */
    set emailSubject(value: string);
    /**
     * @stability stable
     */
    resetEmailSubject(): void;
    /**
     * @stability stable
     */
    get emailSubjectInput(): string | undefined;
    private _emailSubjectByLink?;
    /**
     * @stability stable
     */
    get emailSubjectByLink(): string;
    /**
     * @stability stable
     */
    set emailSubjectByLink(value: string);
    /**
     * @stability stable
     */
    resetEmailSubjectByLink(): void;
    /**
     * @stability stable
     */
    get emailSubjectByLinkInput(): string | undefined;
    private _smsMessage?;
    /**
     * @stability stable
     */
    get smsMessage(): string;
    /**
     * @stability stable
     */
    set smsMessage(value: string);
    /**
     * @stability stable
     */
    resetSmsMessage(): void;
    /**
     * @stability stable
     */
    get smsMessageInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool aws_cognito_user_pool}.
 *
 * @stability stable
 */
export declare class CognitoUserPool extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool aws_cognito_user_pool} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CognitoUserPoolConfig);
    private _aliasAttributes?;
    /**
     * @stability stable
     */
    get aliasAttributes(): string[];
    /**
     * @stability stable
     */
    set aliasAttributes(value: string[]);
    /**
     * @stability stable
     */
    resetAliasAttributes(): void;
    /**
     * @stability stable
     */
    get aliasAttributesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoVerifiedAttributes?;
    /**
     * @stability stable
     */
    get autoVerifiedAttributes(): string[];
    /**
     * @stability stable
     */
    set autoVerifiedAttributes(value: string[]);
    /**
     * @stability stable
     */
    resetAutoVerifiedAttributes(): void;
    /**
     * @stability stable
     */
    get autoVerifiedAttributesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get creationDate(): string;
    /**
     * @stability stable
     */
    get customDomain(): string;
    /**
     * @stability stable
     */
    get domain(): string;
    private _emailVerificationMessage?;
    /**
     * @stability stable
     */
    get emailVerificationMessage(): string;
    /**
     * @stability stable
     */
    set emailVerificationMessage(value: string);
    /**
     * @stability stable
     */
    resetEmailVerificationMessage(): void;
    /**
     * @stability stable
     */
    get emailVerificationMessageInput(): string | undefined;
    private _emailVerificationSubject?;
    /**
     * @stability stable
     */
    get emailVerificationSubject(): string;
    /**
     * @stability stable
     */
    set emailVerificationSubject(value: string);
    /**
     * @stability stable
     */
    resetEmailVerificationSubject(): void;
    /**
     * @stability stable
     */
    get emailVerificationSubjectInput(): string | undefined;
    /**
     * @stability stable
     */
    get endpoint(): string;
    /**
     * @stability stable
     */
    get estimatedNumberOfUsers(): number;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastModifiedDate(): string;
    private _mfaConfiguration?;
    /**
     * @stability stable
     */
    get mfaConfiguration(): string;
    /**
     * @stability stable
     */
    set mfaConfiguration(value: string);
    /**
     * @stability stable
     */
    resetMfaConfiguration(): void;
    /**
     * @stability stable
     */
    get mfaConfigurationInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _smsAuthenticationMessage?;
    /**
     * @stability stable
     */
    get smsAuthenticationMessage(): string;
    /**
     * @stability stable
     */
    set smsAuthenticationMessage(value: string);
    /**
     * @stability stable
     */
    resetSmsAuthenticationMessage(): void;
    /**
     * @stability stable
     */
    get smsAuthenticationMessageInput(): string | undefined;
    private _smsVerificationMessage?;
    /**
     * @stability stable
     */
    get smsVerificationMessage(): string;
    /**
     * @stability stable
     */
    set smsVerificationMessage(value: string);
    /**
     * @stability stable
     */
    resetSmsVerificationMessage(): void;
    /**
     * @stability stable
     */
    get smsVerificationMessageInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _usernameAttributes?;
    /**
     * @stability stable
     */
    get usernameAttributes(): string[];
    /**
     * @stability stable
     */
    set usernameAttributes(value: string[]);
    /**
     * @stability stable
     */
    resetUsernameAttributes(): void;
    /**
     * @stability stable
     */
    get usernameAttributesInput(): string[] | undefined;
    private _accountRecoverySetting;
    /**
     * @stability stable
     */
    get accountRecoverySetting(): CognitoUserPoolAccountRecoverySettingOutputReference;
    /**
     * @stability stable
     */
    putAccountRecoverySetting(value: CognitoUserPoolAccountRecoverySetting): void;
    /**
     * @stability stable
     */
    resetAccountRecoverySetting(): void;
    /**
     * @stability stable
     */
    get accountRecoverySettingInput(): CognitoUserPoolAccountRecoverySetting | undefined;
    private _adminCreateUserConfig;
    /**
     * @stability stable
     */
    get adminCreateUserConfig(): CognitoUserPoolAdminCreateUserConfigOutputReference;
    /**
     * @stability stable
     */
    putAdminCreateUserConfig(value: CognitoUserPoolAdminCreateUserConfig): void;
    /**
     * @stability stable
     */
    resetAdminCreateUserConfig(): void;
    /**
     * @stability stable
     */
    get adminCreateUserConfigInput(): CognitoUserPoolAdminCreateUserConfig | undefined;
    private _deviceConfiguration;
    /**
     * @stability stable
     */
    get deviceConfiguration(): CognitoUserPoolDeviceConfigurationOutputReference;
    /**
     * @stability stable
     */
    putDeviceConfiguration(value: CognitoUserPoolDeviceConfiguration): void;
    /**
     * @stability stable
     */
    resetDeviceConfiguration(): void;
    /**
     * @stability stable
     */
    get deviceConfigurationInput(): CognitoUserPoolDeviceConfiguration | undefined;
    private _emailConfiguration;
    /**
     * @stability stable
     */
    get emailConfiguration(): CognitoUserPoolEmailConfigurationOutputReference;
    /**
     * @stability stable
     */
    putEmailConfiguration(value: CognitoUserPoolEmailConfiguration): void;
    /**
     * @stability stable
     */
    resetEmailConfiguration(): void;
    /**
     * @stability stable
     */
    get emailConfigurationInput(): CognitoUserPoolEmailConfiguration | undefined;
    private _lambdaConfig;
    /**
     * @stability stable
     */
    get lambdaConfig(): CognitoUserPoolLambdaConfigOutputReference;
    /**
     * @stability stable
     */
    putLambdaConfig(value: CognitoUserPoolLambdaConfig): void;
    /**
     * @stability stable
     */
    resetLambdaConfig(): void;
    /**
     * @stability stable
     */
    get lambdaConfigInput(): CognitoUserPoolLambdaConfig | undefined;
    private _passwordPolicy;
    /**
     * @stability stable
     */
    get passwordPolicy(): CognitoUserPoolPasswordPolicyOutputReference;
    /**
     * @stability stable
     */
    putPasswordPolicy(value: CognitoUserPoolPasswordPolicy): void;
    /**
     * @stability stable
     */
    resetPasswordPolicy(): void;
    /**
     * @stability stable
     */
    get passwordPolicyInput(): CognitoUserPoolPasswordPolicy | undefined;
    private _schema?;
    /**
     * @stability stable
     */
    get schema(): CognitoUserPoolSchema[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set schema(value: CognitoUserPoolSchema[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSchema(): void;
    /**
     * @stability stable
     */
    get schemaInput(): cdktf.IResolvable | CognitoUserPoolSchema[] | undefined;
    private _smsConfiguration;
    /**
     * @stability stable
     */
    get smsConfiguration(): CognitoUserPoolSmsConfigurationOutputReference;
    /**
     * @stability stable
     */
    putSmsConfiguration(value: CognitoUserPoolSmsConfiguration): void;
    /**
     * @stability stable
     */
    resetSmsConfiguration(): void;
    /**
     * @stability stable
     */
    get smsConfigurationInput(): CognitoUserPoolSmsConfiguration | undefined;
    private _softwareTokenMfaConfiguration;
    /**
     * @stability stable
     */
    get softwareTokenMfaConfiguration(): CognitoUserPoolSoftwareTokenMfaConfigurationOutputReference;
    /**
     * @stability stable
     */
    putSoftwareTokenMfaConfiguration(value: CognitoUserPoolSoftwareTokenMfaConfiguration): void;
    /**
     * @stability stable
     */
    resetSoftwareTokenMfaConfiguration(): void;
    /**
     * @stability stable
     */
    get softwareTokenMfaConfigurationInput(): CognitoUserPoolSoftwareTokenMfaConfiguration | undefined;
    private _userPoolAddOns;
    /**
     * @stability stable
     */
    get userPoolAddOns(): CognitoUserPoolUserPoolAddOnsOutputReference;
    /**
     * @stability stable
     */
    putUserPoolAddOns(value: CognitoUserPoolUserPoolAddOns): void;
    /**
     * @stability stable
     */
    resetUserPoolAddOns(): void;
    /**
     * @stability stable
     */
    get userPoolAddOnsInput(): CognitoUserPoolUserPoolAddOns | undefined;
    private _usernameConfiguration;
    /**
     * @stability stable
     */
    get usernameConfiguration(): CognitoUserPoolUsernameConfigurationOutputReference;
    /**
     * @stability stable
     */
    putUsernameConfiguration(value: CognitoUserPoolUsernameConfiguration): void;
    /**
     * @stability stable
     */
    resetUsernameConfiguration(): void;
    /**
     * @stability stable
     */
    get usernameConfigurationInput(): CognitoUserPoolUsernameConfiguration | undefined;
    private _verificationMessageTemplate;
    /**
     * @stability stable
     */
    get verificationMessageTemplate(): CognitoUserPoolVerificationMessageTemplateOutputReference;
    /**
     * @stability stable
     */
    putVerificationMessageTemplate(value: CognitoUserPoolVerificationMessageTemplate): void;
    /**
     * @stability stable
     */
    resetVerificationMessageTemplate(): void;
    /**
     * @stability stable
     */
    get verificationMessageTemplateInput(): CognitoUserPoolVerificationMessageTemplate | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
