import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Cognito.
 *
 * @stability stable
 */
export interface DataAwsCognitoUserPoolClientConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cognito_user_pool_client#client_id DataAwsCognitoUserPoolClient#client_id}.
     *
     * @stability stable
     */
    readonly clientId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cognito_user_pool_client#user_pool_id DataAwsCognitoUserPoolClient#user_pool_id}.
     *
     * @stability stable
     */
    readonly userPoolId: string;
}
/**
 * @stability stable
 */
export declare class DataAwsCognitoUserPoolClientAnalyticsConfiguration extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get applicationArn(): string;
    /**
     * @stability stable
     */
    get applicationId(): string;
    /**
     * @stability stable
     */
    get externalId(): string;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    get userDataShared(): cdktf.IResolvable;
}
/**
 * @stability stable
 */
export declare class DataAwsCognitoUserPoolClientTokenValidityUnits extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get accessToken(): string;
    /**
     * @stability stable
     */
    get idToken(): string;
    /**
     * @stability stable
     */
    get refreshToken(): string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/cognito_user_pool_client aws_cognito_user_pool_client}.
 *
 * @stability stable
 */
export declare class DataAwsCognitoUserPoolClient extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/cognito_user_pool_client aws_cognito_user_pool_client} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsCognitoUserPoolClientConfig);
    /**
     * @stability stable
     */
    get accessTokenValidity(): number;
    /**
     * @stability stable
     */
    get allowedOauthFlows(): string[];
    /**
     * @stability stable
     */
    get allowedOauthFlowsUserPoolClient(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get allowedOauthScopes(): string[];
    /**
     * @stability stable
     */
    analyticsConfiguration(index: string): DataAwsCognitoUserPoolClientAnalyticsConfiguration;
    /**
     * @stability stable
     */
    get callbackUrls(): string[];
    private _clientId?;
    /**
     * @stability stable
     */
    get clientId(): string;
    /**
     * @stability stable
     */
    set clientId(value: string);
    /**
     * @stability stable
     */
    get clientIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get clientSecret(): string;
    /**
     * @stability stable
     */
    get defaultRedirectUri(): string;
    /**
     * @stability stable
     */
    get enableTokenRevocation(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get explicitAuthFlows(): string[];
    /**
     * @stability stable
     */
    get generateSecret(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get idTokenValidity(): number;
    /**
     * @stability stable
     */
    get logoutUrls(): string[];
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get preventUserExistenceErrors(): string;
    /**
     * @stability stable
     */
    get readAttributes(): string[];
    /**
     * @stability stable
     */
    get refreshTokenValidity(): number;
    /**
     * @stability stable
     */
    get supportedIdentityProviders(): string[];
    /**
     * @stability stable
     */
    tokenValidityUnits(index: string): DataAwsCognitoUserPoolClientTokenValidityUnits;
    private _userPoolId?;
    /**
     * @stability stable
     */
    get userPoolId(): string;
    /**
     * @stability stable
     */
    set userPoolId(value: string);
    /**
     * @stability stable
     */
    get userPoolIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get writeAttributes(): string[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
