import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Config.
 *
 * @stability stable
 */
export interface ConfigConfigRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule#description ConfigConfigRule#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule#input_parameters ConfigConfigRule#input_parameters}.
     *
     * @stability stable
     */
    readonly inputParameters?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule#maximum_execution_frequency ConfigConfigRule#maximum_execution_frequency}.
     *
     * @stability stable
     */
    readonly maximumExecutionFrequency?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule#name ConfigConfigRule#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule#tags ConfigConfigRule#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule#tags_all ConfigConfigRule#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * scope block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule#scope ConfigConfigRule#scope}
     *
     * @stability stable
     */
    readonly scope?: ConfigConfigRuleScope;
    /**
     * source block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule#source ConfigConfigRule#source}
     *
     * @stability stable
     */
    readonly source: ConfigConfigRuleSource;
}
/**
 * @stability stable
 */
export interface ConfigConfigRuleScope {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule#compliance_resource_id ConfigConfigRule#compliance_resource_id}.
     *
     * @stability stable
     */
    readonly complianceResourceId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule#compliance_resource_types ConfigConfigRule#compliance_resource_types}.
     *
     * @stability stable
     */
    readonly complianceResourceTypes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule#tag_key ConfigConfigRule#tag_key}.
     *
     * @stability stable
     */
    readonly tagKey?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule#tag_value ConfigConfigRule#tag_value}.
     *
     * @stability stable
     */
    readonly tagValue?: string;
}
export declare function configConfigRuleScopeToTerraform(struct?: ConfigConfigRuleScopeOutputReference | ConfigConfigRuleScope): any;
/**
 * @stability stable
 */
export declare class ConfigConfigRuleScopeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): ConfigConfigRuleScope | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: ConfigConfigRuleScope | undefined);
    private _complianceResourceId?;
    /**
     * @stability stable
     */
    get complianceResourceId(): string;
    /**
     * @stability stable
     */
    set complianceResourceId(value: string);
    /**
     * @stability stable
     */
    resetComplianceResourceId(): void;
    /**
     * @stability stable
     */
    get complianceResourceIdInput(): string | undefined;
    private _complianceResourceTypes?;
    /**
     * @stability stable
     */
    get complianceResourceTypes(): string[];
    /**
     * @stability stable
     */
    set complianceResourceTypes(value: string[]);
    /**
     * @stability stable
     */
    resetComplianceResourceTypes(): void;
    /**
     * @stability stable
     */
    get complianceResourceTypesInput(): string[] | undefined;
    private _tagKey?;
    /**
     * @stability stable
     */
    get tagKey(): string;
    /**
     * @stability stable
     */
    set tagKey(value: string);
    /**
     * @stability stable
     */
    resetTagKey(): void;
    /**
     * @stability stable
     */
    get tagKeyInput(): string | undefined;
    private _tagValue?;
    /**
     * @stability stable
     */
    get tagValue(): string;
    /**
     * @stability stable
     */
    set tagValue(value: string);
    /**
     * @stability stable
     */
    resetTagValue(): void;
    /**
     * @stability stable
     */
    get tagValueInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface ConfigConfigRuleSourceSourceDetail {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule#event_source ConfigConfigRule#event_source}.
     *
     * @stability stable
     */
    readonly eventSource?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule#maximum_execution_frequency ConfigConfigRule#maximum_execution_frequency}.
     *
     * @stability stable
     */
    readonly maximumExecutionFrequency?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule#message_type ConfigConfigRule#message_type}.
     *
     * @stability stable
     */
    readonly messageType?: string;
}
export declare function configConfigRuleSourceSourceDetailToTerraform(struct?: ConfigConfigRuleSourceSourceDetail | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface ConfigConfigRuleSource {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule#owner ConfigConfigRule#owner}.
     *
     * @stability stable
     */
    readonly owner: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule#source_identifier ConfigConfigRule#source_identifier}.
     *
     * @stability stable
     */
    readonly sourceIdentifier: string;
    /**
     * source_detail block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule#source_detail ConfigConfigRule#source_detail}
     *
     * @stability stable
     */
    readonly sourceDetail?: ConfigConfigRuleSourceSourceDetail[] | cdktf.IResolvable;
}
export declare function configConfigRuleSourceToTerraform(struct?: ConfigConfigRuleSourceOutputReference | ConfigConfigRuleSource): any;
/**
 * @stability stable
 */
export declare class ConfigConfigRuleSourceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): ConfigConfigRuleSource | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: ConfigConfigRuleSource | undefined);
    private _owner?;
    /**
     * @stability stable
     */
    get owner(): string;
    /**
     * @stability stable
     */
    set owner(value: string);
    /**
     * @stability stable
     */
    get ownerInput(): string | undefined;
    private _sourceIdentifier?;
    /**
     * @stability stable
     */
    get sourceIdentifier(): string;
    /**
     * @stability stable
     */
    set sourceIdentifier(value: string);
    /**
     * @stability stable
     */
    get sourceIdentifierInput(): string | undefined;
    private _sourceDetail?;
    /**
     * @stability stable
     */
    get sourceDetail(): ConfigConfigRuleSourceSourceDetail[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set sourceDetail(value: ConfigConfigRuleSourceSourceDetail[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSourceDetail(): void;
    /**
     * @stability stable
     */
    get sourceDetailInput(): cdktf.IResolvable | ConfigConfigRuleSourceSourceDetail[] | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule aws_config_config_rule}.
 *
 * @stability stable
 */
export declare class ConfigConfigRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/config_config_rule aws_config_config_rule} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ConfigConfigRuleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _inputParameters?;
    /**
     * @stability stable
     */
    get inputParameters(): string;
    /**
     * @stability stable
     */
    set inputParameters(value: string);
    /**
     * @stability stable
     */
    resetInputParameters(): void;
    /**
     * @stability stable
     */
    get inputParametersInput(): string | undefined;
    private _maximumExecutionFrequency?;
    /**
     * @stability stable
     */
    get maximumExecutionFrequency(): string;
    /**
     * @stability stable
     */
    set maximumExecutionFrequency(value: string);
    /**
     * @stability stable
     */
    resetMaximumExecutionFrequency(): void;
    /**
     * @stability stable
     */
    get maximumExecutionFrequencyInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get ruleId(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _scope;
    /**
     * @stability stable
     */
    get scope(): ConfigConfigRuleScopeOutputReference;
    /**
     * @stability stable
     */
    putScope(value: ConfigConfigRuleScope): void;
    /**
     * @stability stable
     */
    resetScope(): void;
    /**
     * @stability stable
     */
    get scopeInput(): ConfigConfigRuleScope | undefined;
    private _source;
    /**
     * @stability stable
     */
    get source(): ConfigConfigRuleSourceOutputReference;
    /**
     * @stability stable
     */
    putSource(value: ConfigConfigRuleSource): void;
    /**
     * @stability stable
     */
    get sourceInput(): ConfigConfigRuleSource | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
