import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Config.
 *
 * @stability stable
 */
export interface ConfigOrganizationCustomRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule#description ConfigOrganizationCustomRule#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule#excluded_accounts ConfigOrganizationCustomRule#excluded_accounts}.
     *
     * @stability stable
     */
    readonly excludedAccounts?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule#input_parameters ConfigOrganizationCustomRule#input_parameters}.
     *
     * @stability stable
     */
    readonly inputParameters?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule#lambda_function_arn ConfigOrganizationCustomRule#lambda_function_arn}.
     *
     * @stability stable
     */
    readonly lambdaFunctionArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule#maximum_execution_frequency ConfigOrganizationCustomRule#maximum_execution_frequency}.
     *
     * @stability stable
     */
    readonly maximumExecutionFrequency?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule#name ConfigOrganizationCustomRule#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule#resource_id_scope ConfigOrganizationCustomRule#resource_id_scope}.
     *
     * @stability stable
     */
    readonly resourceIdScope?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule#resource_types_scope ConfigOrganizationCustomRule#resource_types_scope}.
     *
     * @stability stable
     */
    readonly resourceTypesScope?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule#tag_key_scope ConfigOrganizationCustomRule#tag_key_scope}.
     *
     * @stability stable
     */
    readonly tagKeyScope?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule#tag_value_scope ConfigOrganizationCustomRule#tag_value_scope}.
     *
     * @stability stable
     */
    readonly tagValueScope?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule#trigger_types ConfigOrganizationCustomRule#trigger_types}.
     *
     * @stability stable
     */
    readonly triggerTypes: string[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule#timeouts ConfigOrganizationCustomRule#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: ConfigOrganizationCustomRuleTimeouts;
}
/**
 * @stability stable
 */
export interface ConfigOrganizationCustomRuleTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule#create ConfigOrganizationCustomRule#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule#delete ConfigOrganizationCustomRule#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule#update ConfigOrganizationCustomRule#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function configOrganizationCustomRuleTimeoutsToTerraform(struct?: ConfigOrganizationCustomRuleTimeoutsOutputReference | ConfigOrganizationCustomRuleTimeouts | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export declare class ConfigOrganizationCustomRuleTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): ConfigOrganizationCustomRuleTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: ConfigOrganizationCustomRuleTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule aws_config_organization_custom_rule}.
 *
 * @stability stable
 */
export declare class ConfigOrganizationCustomRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/config_organization_custom_rule aws_config_organization_custom_rule} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ConfigOrganizationCustomRuleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _excludedAccounts?;
    /**
     * @stability stable
     */
    get excludedAccounts(): string[];
    /**
     * @stability stable
     */
    set excludedAccounts(value: string[]);
    /**
     * @stability stable
     */
    resetExcludedAccounts(): void;
    /**
     * @stability stable
     */
    get excludedAccountsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _inputParameters?;
    /**
     * @stability stable
     */
    get inputParameters(): string;
    /**
     * @stability stable
     */
    set inputParameters(value: string);
    /**
     * @stability stable
     */
    resetInputParameters(): void;
    /**
     * @stability stable
     */
    get inputParametersInput(): string | undefined;
    private _lambdaFunctionArn?;
    /**
     * @stability stable
     */
    get lambdaFunctionArn(): string;
    /**
     * @stability stable
     */
    set lambdaFunctionArn(value: string);
    /**
     * @stability stable
     */
    get lambdaFunctionArnInput(): string | undefined;
    private _maximumExecutionFrequency?;
    /**
     * @stability stable
     */
    get maximumExecutionFrequency(): string;
    /**
     * @stability stable
     */
    set maximumExecutionFrequency(value: string);
    /**
     * @stability stable
     */
    resetMaximumExecutionFrequency(): void;
    /**
     * @stability stable
     */
    get maximumExecutionFrequencyInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _resourceIdScope?;
    /**
     * @stability stable
     */
    get resourceIdScope(): string;
    /**
     * @stability stable
     */
    set resourceIdScope(value: string);
    /**
     * @stability stable
     */
    resetResourceIdScope(): void;
    /**
     * @stability stable
     */
    get resourceIdScopeInput(): string | undefined;
    private _resourceTypesScope?;
    /**
     * @stability stable
     */
    get resourceTypesScope(): string[];
    /**
     * @stability stable
     */
    set resourceTypesScope(value: string[]);
    /**
     * @stability stable
     */
    resetResourceTypesScope(): void;
    /**
     * @stability stable
     */
    get resourceTypesScopeInput(): string[] | undefined;
    private _tagKeyScope?;
    /**
     * @stability stable
     */
    get tagKeyScope(): string;
    /**
     * @stability stable
     */
    set tagKeyScope(value: string);
    /**
     * @stability stable
     */
    resetTagKeyScope(): void;
    /**
     * @stability stable
     */
    get tagKeyScopeInput(): string | undefined;
    private _tagValueScope?;
    /**
     * @stability stable
     */
    get tagValueScope(): string;
    /**
     * @stability stable
     */
    set tagValueScope(value: string);
    /**
     * @stability stable
     */
    resetTagValueScope(): void;
    /**
     * @stability stable
     */
    get tagValueScopeInput(): string | undefined;
    private _triggerTypes?;
    /**
     * @stability stable
     */
    get triggerTypes(): string[];
    /**
     * @stability stable
     */
    set triggerTypes(value: string[]);
    /**
     * @stability stable
     */
    get triggerTypesInput(): string[] | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): ConfigOrganizationCustomRuleTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: ConfigOrganizationCustomRuleTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): ConfigOrganizationCustomRuleTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
