import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Config.
 *
 * @stability stable
 */
export interface ConfigOrganizationManagedRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule#description ConfigOrganizationManagedRule#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule#excluded_accounts ConfigOrganizationManagedRule#excluded_accounts}.
     *
     * @stability stable
     */
    readonly excludedAccounts?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule#input_parameters ConfigOrganizationManagedRule#input_parameters}.
     *
     * @stability stable
     */
    readonly inputParameters?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule#maximum_execution_frequency ConfigOrganizationManagedRule#maximum_execution_frequency}.
     *
     * @stability stable
     */
    readonly maximumExecutionFrequency?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule#name ConfigOrganizationManagedRule#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule#resource_id_scope ConfigOrganizationManagedRule#resource_id_scope}.
     *
     * @stability stable
     */
    readonly resourceIdScope?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule#resource_types_scope ConfigOrganizationManagedRule#resource_types_scope}.
     *
     * @stability stable
     */
    readonly resourceTypesScope?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule#rule_identifier ConfigOrganizationManagedRule#rule_identifier}.
     *
     * @stability stable
     */
    readonly ruleIdentifier: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule#tag_key_scope ConfigOrganizationManagedRule#tag_key_scope}.
     *
     * @stability stable
     */
    readonly tagKeyScope?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule#tag_value_scope ConfigOrganizationManagedRule#tag_value_scope}.
     *
     * @stability stable
     */
    readonly tagValueScope?: string;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule#timeouts ConfigOrganizationManagedRule#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: ConfigOrganizationManagedRuleTimeouts;
}
/**
 * @stability stable
 */
export interface ConfigOrganizationManagedRuleTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule#create ConfigOrganizationManagedRule#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule#delete ConfigOrganizationManagedRule#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule#update ConfigOrganizationManagedRule#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function configOrganizationManagedRuleTimeoutsToTerraform(struct?: ConfigOrganizationManagedRuleTimeoutsOutputReference | ConfigOrganizationManagedRuleTimeouts | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export declare class ConfigOrganizationManagedRuleTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): ConfigOrganizationManagedRuleTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: ConfigOrganizationManagedRuleTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule aws_config_organization_managed_rule}.
 *
 * @stability stable
 */
export declare class ConfigOrganizationManagedRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/config_organization_managed_rule aws_config_organization_managed_rule} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ConfigOrganizationManagedRuleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _excludedAccounts?;
    /**
     * @stability stable
     */
    get excludedAccounts(): string[];
    /**
     * @stability stable
     */
    set excludedAccounts(value: string[]);
    /**
     * @stability stable
     */
    resetExcludedAccounts(): void;
    /**
     * @stability stable
     */
    get excludedAccountsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _inputParameters?;
    /**
     * @stability stable
     */
    get inputParameters(): string;
    /**
     * @stability stable
     */
    set inputParameters(value: string);
    /**
     * @stability stable
     */
    resetInputParameters(): void;
    /**
     * @stability stable
     */
    get inputParametersInput(): string | undefined;
    private _maximumExecutionFrequency?;
    /**
     * @stability stable
     */
    get maximumExecutionFrequency(): string;
    /**
     * @stability stable
     */
    set maximumExecutionFrequency(value: string);
    /**
     * @stability stable
     */
    resetMaximumExecutionFrequency(): void;
    /**
     * @stability stable
     */
    get maximumExecutionFrequencyInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _resourceIdScope?;
    /**
     * @stability stable
     */
    get resourceIdScope(): string;
    /**
     * @stability stable
     */
    set resourceIdScope(value: string);
    /**
     * @stability stable
     */
    resetResourceIdScope(): void;
    /**
     * @stability stable
     */
    get resourceIdScopeInput(): string | undefined;
    private _resourceTypesScope?;
    /**
     * @stability stable
     */
    get resourceTypesScope(): string[];
    /**
     * @stability stable
     */
    set resourceTypesScope(value: string[]);
    /**
     * @stability stable
     */
    resetResourceTypesScope(): void;
    /**
     * @stability stable
     */
    get resourceTypesScopeInput(): string[] | undefined;
    private _ruleIdentifier?;
    /**
     * @stability stable
     */
    get ruleIdentifier(): string;
    /**
     * @stability stable
     */
    set ruleIdentifier(value: string);
    /**
     * @stability stable
     */
    get ruleIdentifierInput(): string | undefined;
    private _tagKeyScope?;
    /**
     * @stability stable
     */
    get tagKeyScope(): string;
    /**
     * @stability stable
     */
    set tagKeyScope(value: string);
    /**
     * @stability stable
     */
    resetTagKeyScope(): void;
    /**
     * @stability stable
     */
    get tagKeyScopeInput(): string | undefined;
    private _tagValueScope?;
    /**
     * @stability stable
     */
    get tagValueScope(): string;
    /**
     * @stability stable
     */
    set tagValueScope(value: string);
    /**
     * @stability stable
     */
    resetTagValueScope(): void;
    /**
     * @stability stable
     */
    get tagValueScopeInput(): string | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): ConfigOrganizationManagedRuleTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: ConfigOrganizationManagedRuleTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): ConfigOrganizationManagedRuleTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
