import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Config.
 *
 * @stability stable
 */
export interface ConfigRemediationConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration#automatic ConfigRemediationConfiguration#automatic}.
     *
     * @stability stable
     */
    readonly automatic?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration#config_rule_name ConfigRemediationConfiguration#config_rule_name}.
     *
     * @stability stable
     */
    readonly configRuleName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration#maximum_automatic_attempts ConfigRemediationConfiguration#maximum_automatic_attempts}.
     *
     * @stability stable
     */
    readonly maximumAutomaticAttempts?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration#resource_type ConfigRemediationConfiguration#resource_type}.
     *
     * @stability stable
     */
    readonly resourceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration#retry_attempt_seconds ConfigRemediationConfiguration#retry_attempt_seconds}.
     *
     * @stability stable
     */
    readonly retryAttemptSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration#target_id ConfigRemediationConfiguration#target_id}.
     *
     * @stability stable
     */
    readonly targetId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration#target_type ConfigRemediationConfiguration#target_type}.
     *
     * @stability stable
     */
    readonly targetType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration#target_version ConfigRemediationConfiguration#target_version}.
     *
     * @stability stable
     */
    readonly targetVersion?: string;
    /**
     * execution_controls block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration#execution_controls ConfigRemediationConfiguration#execution_controls}
     *
     * @stability stable
     */
    readonly executionControls?: ConfigRemediationConfigurationExecutionControls;
    /**
     * parameter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration#parameter ConfigRemediationConfiguration#parameter}
     *
     * @stability stable
     */
    readonly parameter?: ConfigRemediationConfigurationParameter[] | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface ConfigRemediationConfigurationExecutionControlsSsmControls {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration#concurrent_execution_rate_percentage ConfigRemediationConfiguration#concurrent_execution_rate_percentage}.
     *
     * @stability stable
     */
    readonly concurrentExecutionRatePercentage?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration#error_percentage ConfigRemediationConfiguration#error_percentage}.
     *
     * @stability stable
     */
    readonly errorPercentage?: number;
}
export declare function configRemediationConfigurationExecutionControlsSsmControlsToTerraform(struct?: ConfigRemediationConfigurationExecutionControlsSsmControlsOutputReference | ConfigRemediationConfigurationExecutionControlsSsmControls): any;
/**
 * @stability stable
 */
export declare class ConfigRemediationConfigurationExecutionControlsSsmControlsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): ConfigRemediationConfigurationExecutionControlsSsmControls | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: ConfigRemediationConfigurationExecutionControlsSsmControls | undefined);
    private _concurrentExecutionRatePercentage?;
    /**
     * @stability stable
     */
    get concurrentExecutionRatePercentage(): number;
    /**
     * @stability stable
     */
    set concurrentExecutionRatePercentage(value: number);
    /**
     * @stability stable
     */
    resetConcurrentExecutionRatePercentage(): void;
    /**
     * @stability stable
     */
    get concurrentExecutionRatePercentageInput(): number | undefined;
    private _errorPercentage?;
    /**
     * @stability stable
     */
    get errorPercentage(): number;
    /**
     * @stability stable
     */
    set errorPercentage(value: number);
    /**
     * @stability stable
     */
    resetErrorPercentage(): void;
    /**
     * @stability stable
     */
    get errorPercentageInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface ConfigRemediationConfigurationExecutionControls {
    /**
     * ssm_controls block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration#ssm_controls ConfigRemediationConfiguration#ssm_controls}
     *
     * @stability stable
     */
    readonly ssmControls?: ConfigRemediationConfigurationExecutionControlsSsmControls;
}
export declare function configRemediationConfigurationExecutionControlsToTerraform(struct?: ConfigRemediationConfigurationExecutionControlsOutputReference | ConfigRemediationConfigurationExecutionControls): any;
/**
 * @stability stable
 */
export declare class ConfigRemediationConfigurationExecutionControlsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): ConfigRemediationConfigurationExecutionControls | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: ConfigRemediationConfigurationExecutionControls | undefined);
    private _ssmControls;
    /**
     * @stability stable
     */
    get ssmControls(): ConfigRemediationConfigurationExecutionControlsSsmControlsOutputReference;
    /**
     * @stability stable
     */
    putSsmControls(value: ConfigRemediationConfigurationExecutionControlsSsmControls): void;
    /**
     * @stability stable
     */
    resetSsmControls(): void;
    /**
     * @stability stable
     */
    get ssmControlsInput(): ConfigRemediationConfigurationExecutionControlsSsmControls | undefined;
}
/**
 * @stability stable
 */
export interface ConfigRemediationConfigurationParameter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration#name ConfigRemediationConfiguration#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration#resource_value ConfigRemediationConfiguration#resource_value}.
     *
     * @stability stable
     */
    readonly resourceValue?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration#static_value ConfigRemediationConfiguration#static_value}.
     *
     * @stability stable
     */
    readonly staticValue?: string;
}
export declare function configRemediationConfigurationParameterToTerraform(struct?: ConfigRemediationConfigurationParameter | cdktf.IResolvable): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration aws_config_remediation_configuration}.
 *
 * @stability stable
 */
export declare class ConfigRemediationConfiguration extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/config_remediation_configuration aws_config_remediation_configuration} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ConfigRemediationConfigurationConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _automatic?;
    /**
     * @stability stable
     */
    get automatic(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set automatic(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAutomatic(): void;
    /**
     * @stability stable
     */
    get automaticInput(): boolean | cdktf.IResolvable | undefined;
    private _configRuleName?;
    /**
     * @stability stable
     */
    get configRuleName(): string;
    /**
     * @stability stable
     */
    set configRuleName(value: string);
    /**
     * @stability stable
     */
    get configRuleNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _maximumAutomaticAttempts?;
    /**
     * @stability stable
     */
    get maximumAutomaticAttempts(): number;
    /**
     * @stability stable
     */
    set maximumAutomaticAttempts(value: number);
    /**
     * @stability stable
     */
    resetMaximumAutomaticAttempts(): void;
    /**
     * @stability stable
     */
    get maximumAutomaticAttemptsInput(): number | undefined;
    private _resourceType?;
    /**
     * @stability stable
     */
    get resourceType(): string;
    /**
     * @stability stable
     */
    set resourceType(value: string);
    /**
     * @stability stable
     */
    resetResourceType(): void;
    /**
     * @stability stable
     */
    get resourceTypeInput(): string | undefined;
    private _retryAttemptSeconds?;
    /**
     * @stability stable
     */
    get retryAttemptSeconds(): number;
    /**
     * @stability stable
     */
    set retryAttemptSeconds(value: number);
    /**
     * @stability stable
     */
    resetRetryAttemptSeconds(): void;
    /**
     * @stability stable
     */
    get retryAttemptSecondsInput(): number | undefined;
    private _targetId?;
    /**
     * @stability stable
     */
    get targetId(): string;
    /**
     * @stability stable
     */
    set targetId(value: string);
    /**
     * @stability stable
     */
    get targetIdInput(): string | undefined;
    private _targetType?;
    /**
     * @stability stable
     */
    get targetType(): string;
    /**
     * @stability stable
     */
    set targetType(value: string);
    /**
     * @stability stable
     */
    get targetTypeInput(): string | undefined;
    private _targetVersion?;
    /**
     * @stability stable
     */
    get targetVersion(): string;
    /**
     * @stability stable
     */
    set targetVersion(value: string);
    /**
     * @stability stable
     */
    resetTargetVersion(): void;
    /**
     * @stability stable
     */
    get targetVersionInput(): string | undefined;
    private _executionControls;
    /**
     * @stability stable
     */
    get executionControls(): ConfigRemediationConfigurationExecutionControlsOutputReference;
    /**
     * @stability stable
     */
    putExecutionControls(value: ConfigRemediationConfigurationExecutionControls): void;
    /**
     * @stability stable
     */
    resetExecutionControls(): void;
    /**
     * @stability stable
     */
    get executionControlsInput(): ConfigRemediationConfigurationExecutionControls | undefined;
    private _parameter?;
    /**
     * @stability stable
     */
    get parameter(): ConfigRemediationConfigurationParameter[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set parameter(value: ConfigRemediationConfigurationParameter[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetParameter(): void;
    /**
     * @stability stable
     */
    get parameterInput(): cdktf.IResolvable | ConfigRemediationConfigurationParameter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
