import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Connect.
 *
 * @stability stable
 */
export interface ConnectBotAssociationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_bot_association#instance_id ConnectBotAssociation#instance_id}.
     *
     * @stability stable
     */
    readonly instanceId: string;
    /**
     * lex_bot block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_bot_association#lex_bot ConnectBotAssociation#lex_bot}
     *
     * @stability stable
     */
    readonly lexBot: ConnectBotAssociationLexBot;
}
/**
 * @stability stable
 */
export interface ConnectBotAssociationLexBot {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_bot_association#lex_region ConnectBotAssociation#lex_region}.
     *
     * @stability stable
     */
    readonly lexRegion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_bot_association#name ConnectBotAssociation#name}.
     *
     * @stability stable
     */
    readonly name: string;
}
export declare function connectBotAssociationLexBotToTerraform(struct?: ConnectBotAssociationLexBotOutputReference | ConnectBotAssociationLexBot): any;
/**
 * @stability stable
 */
export declare class ConnectBotAssociationLexBotOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): ConnectBotAssociationLexBot | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: ConnectBotAssociationLexBot | undefined);
    private _lexRegion?;
    /**
     * @stability stable
     */
    get lexRegion(): string;
    /**
     * @stability stable
     */
    set lexRegion(value: string);
    /**
     * @stability stable
     */
    resetLexRegion(): void;
    /**
     * @stability stable
     */
    get lexRegionInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/connect_bot_association aws_connect_bot_association}.
 *
 * @stability stable
 */
export declare class ConnectBotAssociation extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/connect_bot_association aws_connect_bot_association} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ConnectBotAssociationConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceId?;
    /**
     * @stability stable
     */
    get instanceId(): string;
    /**
     * @stability stable
     */
    set instanceId(value: string);
    /**
     * @stability stable
     */
    get instanceIdInput(): string | undefined;
    private _lexBot;
    /**
     * @stability stable
     */
    get lexBot(): ConnectBotAssociationLexBotOutputReference;
    /**
     * @stability stable
     */
    putLexBot(value: ConnectBotAssociationLexBot): void;
    /**
     * @stability stable
     */
    get lexBotInput(): ConnectBotAssociationLexBot | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
