import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Connect.
 *
 * @stability stable
 */
export interface ConnectQuickConnectConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_quick_connect#description ConnectQuickConnect#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_quick_connect#instance_id ConnectQuickConnect#instance_id}.
     *
     * @stability stable
     */
    readonly instanceId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_quick_connect#name ConnectQuickConnect#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_quick_connect#tags ConnectQuickConnect#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_quick_connect#tags_all ConnectQuickConnect#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * quick_connect_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_quick_connect#quick_connect_config ConnectQuickConnect#quick_connect_config}
     *
     * @stability stable
     */
    readonly quickConnectConfig: ConnectQuickConnectQuickConnectConfig;
}
/**
 * @stability stable
 */
export interface ConnectQuickConnectQuickConnectConfigPhoneConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_quick_connect#phone_number ConnectQuickConnect#phone_number}.
     *
     * @stability stable
     */
    readonly phoneNumber: string;
}
export declare function connectQuickConnectQuickConnectConfigPhoneConfigToTerraform(struct?: ConnectQuickConnectQuickConnectConfigPhoneConfig | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface ConnectQuickConnectQuickConnectConfigQueueConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_quick_connect#contact_flow_id ConnectQuickConnect#contact_flow_id}.
     *
     * @stability stable
     */
    readonly contactFlowId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_quick_connect#queue_id ConnectQuickConnect#queue_id}.
     *
     * @stability stable
     */
    readonly queueId: string;
}
export declare function connectQuickConnectQuickConnectConfigQueueConfigToTerraform(struct?: ConnectQuickConnectQuickConnectConfigQueueConfig | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface ConnectQuickConnectQuickConnectConfigUserConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_quick_connect#contact_flow_id ConnectQuickConnect#contact_flow_id}.
     *
     * @stability stable
     */
    readonly contactFlowId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_quick_connect#user_id ConnectQuickConnect#user_id}.
     *
     * @stability stable
     */
    readonly userId: string;
}
export declare function connectQuickConnectQuickConnectConfigUserConfigToTerraform(struct?: ConnectQuickConnectQuickConnectConfigUserConfig | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface ConnectQuickConnectQuickConnectConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_quick_connect#quick_connect_type ConnectQuickConnect#quick_connect_type}.
     *
     * @stability stable
     */
    readonly quickConnectType: string;
    /**
     * phone_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_quick_connect#phone_config ConnectQuickConnect#phone_config}
     *
     * @stability stable
     */
    readonly phoneConfig?: ConnectQuickConnectQuickConnectConfigPhoneConfig[] | cdktf.IResolvable;
    /**
     * queue_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_quick_connect#queue_config ConnectQuickConnect#queue_config}
     *
     * @stability stable
     */
    readonly queueConfig?: ConnectQuickConnectQuickConnectConfigQueueConfig[] | cdktf.IResolvable;
    /**
     * user_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/connect_quick_connect#user_config ConnectQuickConnect#user_config}
     *
     * @stability stable
     */
    readonly userConfig?: ConnectQuickConnectQuickConnectConfigUserConfig[] | cdktf.IResolvable;
}
export declare function connectQuickConnectQuickConnectConfigToTerraform(struct?: ConnectQuickConnectQuickConnectConfigOutputReference | ConnectQuickConnectQuickConnectConfig): any;
/**
 * @stability stable
 */
export declare class ConnectQuickConnectQuickConnectConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): ConnectQuickConnectQuickConnectConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: ConnectQuickConnectQuickConnectConfig | undefined);
    private _quickConnectType?;
    /**
     * @stability stable
     */
    get quickConnectType(): string;
    /**
     * @stability stable
     */
    set quickConnectType(value: string);
    /**
     * @stability stable
     */
    get quickConnectTypeInput(): string | undefined;
    private _phoneConfig?;
    /**
     * @stability stable
     */
    get phoneConfig(): ConnectQuickConnectQuickConnectConfigPhoneConfig[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set phoneConfig(value: ConnectQuickConnectQuickConnectConfigPhoneConfig[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetPhoneConfig(): void;
    /**
     * @stability stable
     */
    get phoneConfigInput(): cdktf.IResolvable | ConnectQuickConnectQuickConnectConfigPhoneConfig[] | undefined;
    private _queueConfig?;
    /**
     * @stability stable
     */
    get queueConfig(): ConnectQuickConnectQuickConnectConfigQueueConfig[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set queueConfig(value: ConnectQuickConnectQuickConnectConfigQueueConfig[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetQueueConfig(): void;
    /**
     * @stability stable
     */
    get queueConfigInput(): cdktf.IResolvable | ConnectQuickConnectQuickConnectConfigQueueConfig[] | undefined;
    private _userConfig?;
    /**
     * @stability stable
     */
    get userConfig(): ConnectQuickConnectQuickConnectConfigUserConfig[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set userConfig(value: ConnectQuickConnectQuickConnectConfigUserConfig[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetUserConfig(): void;
    /**
     * @stability stable
     */
    get userConfigInput(): cdktf.IResolvable | ConnectQuickConnectQuickConnectConfigUserConfig[] | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/connect_quick_connect aws_connect_quick_connect}.
 *
 * @stability stable
 */
export declare class ConnectQuickConnect extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/connect_quick_connect aws_connect_quick_connect} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ConnectQuickConnectConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceId?;
    /**
     * @stability stable
     */
    get instanceId(): string;
    /**
     * @stability stable
     */
    set instanceId(value: string);
    /**
     * @stability stable
     */
    get instanceIdInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get quickConnectId(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _quickConnectConfig;
    /**
     * @stability stable
     */
    get quickConnectConfig(): ConnectQuickConnectQuickConnectConfigOutputReference;
    /**
     * @stability stable
     */
    putQuickConnectConfig(value: ConnectQuickConnectQuickConnectConfig): void;
    /**
     * @stability stable
     */
    get quickConnectConfigInput(): ConnectQuickConnectQuickConnectConfig | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
