import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Connect.
 *
 * @stability stable
 */
export interface DataAwsConnectHoursOfOperationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/connect_hours_of_operation#hours_of_operation_id DataAwsConnectHoursOfOperation#hours_of_operation_id}.
     *
     * @stability stable
     */
    readonly hoursOfOperationId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/connect_hours_of_operation#instance_id DataAwsConnectHoursOfOperation#instance_id}.
     *
     * @stability stable
     */
    readonly instanceId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/connect_hours_of_operation#name DataAwsConnectHoursOfOperation#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/connect_hours_of_operation#tags DataAwsConnectHoursOfOperation#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataAwsConnectHoursOfOperationConfigEndTime extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get hours(): number;
    /**
     * @stability stable
     */
    get minutes(): number;
}
/**
 * @stability stable
 */
export declare class DataAwsConnectHoursOfOperationConfigStartTime extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get hours(): number;
    /**
     * @stability stable
     */
    get minutes(): number;
}
/**
 * @stability stable
 */
export declare class DataAwsConnectHoursOfOperationConfigA extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get day(): string;
    /**
     * @stability stable
     */
    get endTime(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get startTime(): cdktf.IResolvable;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/connect_hours_of_operation aws_connect_hours_of_operation}.
 *
 * @stability stable
 */
export declare class DataAwsConnectHoursOfOperation extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/connect_hours_of_operation aws_connect_hours_of_operation} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsConnectHoursOfOperationConfig);
    /**
     * @stability stable
     */
    config(index: string): DataAwsConnectHoursOfOperationConfigA;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get hoursOfOperationArn(): string;
    private _hoursOfOperationId?;
    /**
     * @stability stable
     */
    get hoursOfOperationId(): string;
    /**
     * @stability stable
     */
    set hoursOfOperationId(value: string);
    /**
     * @stability stable
     */
    resetHoursOfOperationId(): void;
    /**
     * @stability stable
     */
    get hoursOfOperationIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceId?;
    /**
     * @stability stable
     */
    get instanceId(): string;
    /**
     * @stability stable
     */
    set instanceId(value: string);
    /**
     * @stability stable
     */
    get instanceIdInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get timeZone(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
