import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Cost and Usage Report.
 *
 * @stability stable
 */
export interface CurReportDefinitionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cur_report_definition#additional_artifacts CurReportDefinition#additional_artifacts}.
     *
     * @stability stable
     */
    readonly additionalArtifacts?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cur_report_definition#additional_schema_elements CurReportDefinition#additional_schema_elements}.
     *
     * @stability stable
     */
    readonly additionalSchemaElements: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cur_report_definition#compression CurReportDefinition#compression}.
     *
     * @stability stable
     */
    readonly compression: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cur_report_definition#format CurReportDefinition#format}.
     *
     * @stability stable
     */
    readonly format: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cur_report_definition#refresh_closed_reports CurReportDefinition#refresh_closed_reports}.
     *
     * @stability stable
     */
    readonly refreshClosedReports?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cur_report_definition#report_name CurReportDefinition#report_name}.
     *
     * @stability stable
     */
    readonly reportName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cur_report_definition#report_versioning CurReportDefinition#report_versioning}.
     *
     * @stability stable
     */
    readonly reportVersioning?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cur_report_definition#s3_bucket CurReportDefinition#s3_bucket}.
     *
     * @stability stable
     */
    readonly s3Bucket: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cur_report_definition#s3_prefix CurReportDefinition#s3_prefix}.
     *
     * @stability stable
     */
    readonly s3Prefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cur_report_definition#s3_region CurReportDefinition#s3_region}.
     *
     * @stability stable
     */
    readonly s3Region: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cur_report_definition#time_unit CurReportDefinition#time_unit}.
     *
     * @stability stable
     */
    readonly timeUnit: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cur_report_definition aws_cur_report_definition}.
 *
 * @stability stable
 */
export declare class CurReportDefinition extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cur_report_definition aws_cur_report_definition} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CurReportDefinitionConfig);
    private _additionalArtifacts?;
    /**
     * @stability stable
     */
    get additionalArtifacts(): string[];
    /**
     * @stability stable
     */
    set additionalArtifacts(value: string[]);
    /**
     * @stability stable
     */
    resetAdditionalArtifacts(): void;
    /**
     * @stability stable
     */
    get additionalArtifactsInput(): string[] | undefined;
    private _additionalSchemaElements?;
    /**
     * @stability stable
     */
    get additionalSchemaElements(): string[];
    /**
     * @stability stable
     */
    set additionalSchemaElements(value: string[]);
    /**
     * @stability stable
     */
    get additionalSchemaElementsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _compression?;
    /**
     * @stability stable
     */
    get compression(): string;
    /**
     * @stability stable
     */
    set compression(value: string);
    /**
     * @stability stable
     */
    get compressionInput(): string | undefined;
    private _format?;
    /**
     * @stability stable
     */
    get format(): string;
    /**
     * @stability stable
     */
    set format(value: string);
    /**
     * @stability stable
     */
    get formatInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _refreshClosedReports?;
    /**
     * @stability stable
     */
    get refreshClosedReports(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set refreshClosedReports(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetRefreshClosedReports(): void;
    /**
     * @stability stable
     */
    get refreshClosedReportsInput(): boolean | cdktf.IResolvable | undefined;
    private _reportName?;
    /**
     * @stability stable
     */
    get reportName(): string;
    /**
     * @stability stable
     */
    set reportName(value: string);
    /**
     * @stability stable
     */
    get reportNameInput(): string | undefined;
    private _reportVersioning?;
    /**
     * @stability stable
     */
    get reportVersioning(): string;
    /**
     * @stability stable
     */
    set reportVersioning(value: string);
    /**
     * @stability stable
     */
    resetReportVersioning(): void;
    /**
     * @stability stable
     */
    get reportVersioningInput(): string | undefined;
    private _s3Bucket?;
    /**
     * @stability stable
     */
    get s3Bucket(): string;
    /**
     * @stability stable
     */
    set s3Bucket(value: string);
    /**
     * @stability stable
     */
    get s3BucketInput(): string | undefined;
    private _s3Prefix?;
    /**
     * @stability stable
     */
    get s3Prefix(): string;
    /**
     * @stability stable
     */
    set s3Prefix(value: string);
    /**
     * @stability stable
     */
    resetS3Prefix(): void;
    /**
     * @stability stable
     */
    get s3PrefixInput(): string | undefined;
    private _s3Region?;
    /**
     * @stability stable
     */
    get s3Region(): string;
    /**
     * @stability stable
     */
    set s3Region(value: string);
    /**
     * @stability stable
     */
    get s3RegionInput(): string | undefined;
    private _timeUnit?;
    /**
     * @stability stable
     */
    get timeUnit(): string;
    /**
     * @stability stable
     */
    set timeUnit(value: string);
    /**
     * @stability stable
     */
    get timeUnitInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
