import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Cost and Usage Report.
 *
 * @stability stable
 */
export interface DataAwsCurReportDefinitionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cur_report_definition#report_name DataAwsCurReportDefinition#report_name}.
     *
     * @stability stable
     */
    readonly reportName: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/cur_report_definition aws_cur_report_definition}.
 *
 * @stability stable
 */
export declare class DataAwsCurReportDefinition extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/cur_report_definition aws_cur_report_definition} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsCurReportDefinitionConfig);
    /**
     * @stability stable
     */
    get additionalArtifacts(): string[];
    /**
     * @stability stable
     */
    get additionalSchemaElements(): string[];
    /**
     * @stability stable
     */
    get compression(): string;
    /**
     * @stability stable
     */
    get format(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get refreshClosedReports(): cdktf.IResolvable;
    private _reportName?;
    /**
     * @stability stable
     */
    get reportName(): string;
    /**
     * @stability stable
     */
    set reportName(value: string);
    /**
     * @stability stable
     */
    get reportNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get reportVersioning(): string;
    /**
     * @stability stable
     */
    get s3Bucket(): string;
    /**
     * @stability stable
     */
    get s3Prefix(): string;
    /**
     * @stability stable
     */
    get s3Region(): string;
    /**
     * @stability stable
     */
    get timeUnit(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
