import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Data Sources.
 *
 * @stability stable
 */
export interface DataAwsAvailabilityZoneConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/availability_zone#all_availability_zones DataAwsAvailabilityZone#all_availability_zones}.
     *
     * @stability stable
     */
    readonly allAvailabilityZones?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/availability_zone#name DataAwsAvailabilityZone#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/availability_zone#state DataAwsAvailabilityZone#state}.
     *
     * @stability stable
     */
    readonly state?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/availability_zone#zone_id DataAwsAvailabilityZone#zone_id}.
     *
     * @stability stable
     */
    readonly zoneId?: string;
    /**
     * filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/availability_zone#filter DataAwsAvailabilityZone#filter}
     *
     * @stability stable
     */
    readonly filter?: DataAwsAvailabilityZoneFilter[] | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface DataAwsAvailabilityZoneFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/availability_zone#name DataAwsAvailabilityZone#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/availability_zone#values DataAwsAvailabilityZone#values}.
     *
     * @stability stable
     */
    readonly values: string[];
}
export declare function dataAwsAvailabilityZoneFilterToTerraform(struct?: DataAwsAvailabilityZoneFilter | cdktf.IResolvable): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/availability_zone aws_availability_zone}.
 *
 * @stability stable
 */
export declare class DataAwsAvailabilityZone extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/availability_zone aws_availability_zone} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsAvailabilityZoneConfig);
    private _allAvailabilityZones?;
    /**
     * @stability stable
     */
    get allAvailabilityZones(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set allAvailabilityZones(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAllAvailabilityZones(): void;
    /**
     * @stability stable
     */
    get allAvailabilityZonesInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get groupName(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get nameSuffix(): string;
    /**
     * @stability stable
     */
    get networkBorderGroup(): string;
    /**
     * @stability stable
     */
    get optInStatus(): string;
    /**
     * @stability stable
     */
    get parentZoneId(): string;
    /**
     * @stability stable
     */
    get parentZoneName(): string;
    /**
     * @stability stable
     */
    get region(): string;
    private _state?;
    /**
     * @stability stable
     */
    get state(): string;
    /**
     * @stability stable
     */
    set state(value: string);
    /**
     * @stability stable
     */
    resetState(): void;
    /**
     * @stability stable
     */
    get stateInput(): string | undefined;
    private _zoneId?;
    /**
     * @stability stable
     */
    get zoneId(): string;
    /**
     * @stability stable
     */
    set zoneId(value: string);
    /**
     * @stability stable
     */
    resetZoneId(): void;
    /**
     * @stability stable
     */
    get zoneIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get zoneType(): string;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsAvailabilityZoneFilter[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set filter(value: DataAwsAvailabilityZoneFilter[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): cdktf.IResolvable | DataAwsAvailabilityZoneFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
