import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS DataSync.
 *
 * @stability stable
 */
export interface DatasyncTaskConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#cloudwatch_log_group_arn DatasyncTask#cloudwatch_log_group_arn}.
     *
     * @stability stable
     */
    readonly cloudwatchLogGroupArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#destination_location_arn DatasyncTask#destination_location_arn}.
     *
     * @stability stable
     */
    readonly destinationLocationArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#name DatasyncTask#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#source_location_arn DatasyncTask#source_location_arn}.
     *
     * @stability stable
     */
    readonly sourceLocationArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#tags DatasyncTask#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#tags_all DatasyncTask#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * excludes block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#excludes DatasyncTask#excludes}
     *
     * @stability stable
     */
    readonly excludes?: DatasyncTaskExcludes;
    /**
     * options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#options DatasyncTask#options}
     *
     * @stability stable
     */
    readonly options?: DatasyncTaskOptions;
    /**
     * schedule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#schedule DatasyncTask#schedule}
     *
     * @stability stable
     */
    readonly schedule?: DatasyncTaskSchedule;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#timeouts DatasyncTask#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: DatasyncTaskTimeouts;
}
/**
 * @stability stable
 */
export interface DatasyncTaskExcludes {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#filter_type DatasyncTask#filter_type}.
     *
     * @stability stable
     */
    readonly filterType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#value DatasyncTask#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
export declare function datasyncTaskExcludesToTerraform(struct?: DatasyncTaskExcludesOutputReference | DatasyncTaskExcludes): any;
/**
 * @stability stable
 */
export declare class DatasyncTaskExcludesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DatasyncTaskExcludes | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DatasyncTaskExcludes | undefined);
    private _filterType?;
    /**
     * @stability stable
     */
    get filterType(): string;
    /**
     * @stability stable
     */
    set filterType(value: string);
    /**
     * @stability stable
     */
    resetFilterType(): void;
    /**
     * @stability stable
     */
    get filterTypeInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): string;
    /**
     * @stability stable
     */
    set value(value: string);
    /**
     * @stability stable
     */
    resetValue(): void;
    /**
     * @stability stable
     */
    get valueInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DatasyncTaskOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#atime DatasyncTask#atime}.
     *
     * @stability stable
     */
    readonly atime?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#bytes_per_second DatasyncTask#bytes_per_second}.
     *
     * @stability stable
     */
    readonly bytesPerSecond?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#gid DatasyncTask#gid}.
     *
     * @stability stable
     */
    readonly gid?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#log_level DatasyncTask#log_level}.
     *
     * @stability stable
     */
    readonly logLevel?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#mtime DatasyncTask#mtime}.
     *
     * @stability stable
     */
    readonly mtime?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#overwrite_mode DatasyncTask#overwrite_mode}.
     *
     * @stability stable
     */
    readonly overwriteMode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#posix_permissions DatasyncTask#posix_permissions}.
     *
     * @stability stable
     */
    readonly posixPermissions?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#preserve_deleted_files DatasyncTask#preserve_deleted_files}.
     *
     * @stability stable
     */
    readonly preserveDeletedFiles?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#preserve_devices DatasyncTask#preserve_devices}.
     *
     * @stability stable
     */
    readonly preserveDevices?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#task_queueing DatasyncTask#task_queueing}.
     *
     * @stability stable
     */
    readonly taskQueueing?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#transfer_mode DatasyncTask#transfer_mode}.
     *
     * @stability stable
     */
    readonly transferMode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#uid DatasyncTask#uid}.
     *
     * @stability stable
     */
    readonly uid?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#verify_mode DatasyncTask#verify_mode}.
     *
     * @stability stable
     */
    readonly verifyMode?: string;
}
export declare function datasyncTaskOptionsToTerraform(struct?: DatasyncTaskOptionsOutputReference | DatasyncTaskOptions): any;
/**
 * @stability stable
 */
export declare class DatasyncTaskOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DatasyncTaskOptions | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DatasyncTaskOptions | undefined);
    private _atime?;
    /**
     * @stability stable
     */
    get atime(): string;
    /**
     * @stability stable
     */
    set atime(value: string);
    /**
     * @stability stable
     */
    resetAtime(): void;
    /**
     * @stability stable
     */
    get atimeInput(): string | undefined;
    private _bytesPerSecond?;
    /**
     * @stability stable
     */
    get bytesPerSecond(): number;
    /**
     * @stability stable
     */
    set bytesPerSecond(value: number);
    /**
     * @stability stable
     */
    resetBytesPerSecond(): void;
    /**
     * @stability stable
     */
    get bytesPerSecondInput(): number | undefined;
    private _gid?;
    /**
     * @stability stable
     */
    get gid(): string;
    /**
     * @stability stable
     */
    set gid(value: string);
    /**
     * @stability stable
     */
    resetGid(): void;
    /**
     * @stability stable
     */
    get gidInput(): string | undefined;
    private _logLevel?;
    /**
     * @stability stable
     */
    get logLevel(): string;
    /**
     * @stability stable
     */
    set logLevel(value: string);
    /**
     * @stability stable
     */
    resetLogLevel(): void;
    /**
     * @stability stable
     */
    get logLevelInput(): string | undefined;
    private _mtime?;
    /**
     * @stability stable
     */
    get mtime(): string;
    /**
     * @stability stable
     */
    set mtime(value: string);
    /**
     * @stability stable
     */
    resetMtime(): void;
    /**
     * @stability stable
     */
    get mtimeInput(): string | undefined;
    private _overwriteMode?;
    /**
     * @stability stable
     */
    get overwriteMode(): string;
    /**
     * @stability stable
     */
    set overwriteMode(value: string);
    /**
     * @stability stable
     */
    resetOverwriteMode(): void;
    /**
     * @stability stable
     */
    get overwriteModeInput(): string | undefined;
    private _posixPermissions?;
    /**
     * @stability stable
     */
    get posixPermissions(): string;
    /**
     * @stability stable
     */
    set posixPermissions(value: string);
    /**
     * @stability stable
     */
    resetPosixPermissions(): void;
    /**
     * @stability stable
     */
    get posixPermissionsInput(): string | undefined;
    private _preserveDeletedFiles?;
    /**
     * @stability stable
     */
    get preserveDeletedFiles(): string;
    /**
     * @stability stable
     */
    set preserveDeletedFiles(value: string);
    /**
     * @stability stable
     */
    resetPreserveDeletedFiles(): void;
    /**
     * @stability stable
     */
    get preserveDeletedFilesInput(): string | undefined;
    private _preserveDevices?;
    /**
     * @stability stable
     */
    get preserveDevices(): string;
    /**
     * @stability stable
     */
    set preserveDevices(value: string);
    /**
     * @stability stable
     */
    resetPreserveDevices(): void;
    /**
     * @stability stable
     */
    get preserveDevicesInput(): string | undefined;
    private _taskQueueing?;
    /**
     * @stability stable
     */
    get taskQueueing(): string;
    /**
     * @stability stable
     */
    set taskQueueing(value: string);
    /**
     * @stability stable
     */
    resetTaskQueueing(): void;
    /**
     * @stability stable
     */
    get taskQueueingInput(): string | undefined;
    private _transferMode?;
    /**
     * @stability stable
     */
    get transferMode(): string;
    /**
     * @stability stable
     */
    set transferMode(value: string);
    /**
     * @stability stable
     */
    resetTransferMode(): void;
    /**
     * @stability stable
     */
    get transferModeInput(): string | undefined;
    private _uid?;
    /**
     * @stability stable
     */
    get uid(): string;
    /**
     * @stability stable
     */
    set uid(value: string);
    /**
     * @stability stable
     */
    resetUid(): void;
    /**
     * @stability stable
     */
    get uidInput(): string | undefined;
    private _verifyMode?;
    /**
     * @stability stable
     */
    get verifyMode(): string;
    /**
     * @stability stable
     */
    set verifyMode(value: string);
    /**
     * @stability stable
     */
    resetVerifyMode(): void;
    /**
     * @stability stable
     */
    get verifyModeInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DatasyncTaskSchedule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#schedule_expression DatasyncTask#schedule_expression}.
     *
     * @stability stable
     */
    readonly scheduleExpression: string;
}
export declare function datasyncTaskScheduleToTerraform(struct?: DatasyncTaskScheduleOutputReference | DatasyncTaskSchedule): any;
/**
 * @stability stable
 */
export declare class DatasyncTaskScheduleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DatasyncTaskSchedule | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DatasyncTaskSchedule | undefined);
    private _scheduleExpression?;
    /**
     * @stability stable
     */
    get scheduleExpression(): string;
    /**
     * @stability stable
     */
    set scheduleExpression(value: string);
    /**
     * @stability stable
     */
    get scheduleExpressionInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DatasyncTaskTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/datasync_task#create DatasyncTask#create}.
     *
     * @stability stable
     */
    readonly create?: string;
}
export declare function datasyncTaskTimeoutsToTerraform(struct?: DatasyncTaskTimeoutsOutputReference | DatasyncTaskTimeouts | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export declare class DatasyncTaskTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DatasyncTaskTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DatasyncTaskTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/datasync_task aws_datasync_task}.
 *
 * @stability stable
 */
export declare class DatasyncTask extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/datasync_task aws_datasync_task} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DatasyncTaskConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _cloudwatchLogGroupArn?;
    /**
     * @stability stable
     */
    get cloudwatchLogGroupArn(): string;
    /**
     * @stability stable
     */
    set cloudwatchLogGroupArn(value: string);
    /**
     * @stability stable
     */
    resetCloudwatchLogGroupArn(): void;
    /**
     * @stability stable
     */
    get cloudwatchLogGroupArnInput(): string | undefined;
    private _destinationLocationArn?;
    /**
     * @stability stable
     */
    get destinationLocationArn(): string;
    /**
     * @stability stable
     */
    set destinationLocationArn(value: string);
    /**
     * @stability stable
     */
    get destinationLocationArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _sourceLocationArn?;
    /**
     * @stability stable
     */
    get sourceLocationArn(): string;
    /**
     * @stability stable
     */
    set sourceLocationArn(value: string);
    /**
     * @stability stable
     */
    get sourceLocationArnInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _excludes;
    /**
     * @stability stable
     */
    get excludes(): DatasyncTaskExcludesOutputReference;
    /**
     * @stability stable
     */
    putExcludes(value: DatasyncTaskExcludes): void;
    /**
     * @stability stable
     */
    resetExcludes(): void;
    /**
     * @stability stable
     */
    get excludesInput(): DatasyncTaskExcludes | undefined;
    private _options;
    /**
     * @stability stable
     */
    get options(): DatasyncTaskOptionsOutputReference;
    /**
     * @stability stable
     */
    putOptions(value: DatasyncTaskOptions): void;
    /**
     * @stability stable
     */
    resetOptions(): void;
    /**
     * @stability stable
     */
    get optionsInput(): DatasyncTaskOptions | undefined;
    private _schedule;
    /**
     * @stability stable
     */
    get schedule(): DatasyncTaskScheduleOutputReference;
    /**
     * @stability stable
     */
    putSchedule(value: DatasyncTaskSchedule): void;
    /**
     * @stability stable
     */
    resetSchedule(): void;
    /**
     * @stability stable
     */
    get scheduleInput(): DatasyncTaskSchedule | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): DatasyncTaskTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: DatasyncTaskTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DatasyncTaskTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
