import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DetectiveMemberConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/detective_member#account_id DetectiveMember#account_id}.
     *
     * @stability stable
     */
    readonly accountId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/detective_member#disable_email_notification DetectiveMember#disable_email_notification}.
     *
     * @stability stable
     */
    readonly disableEmailNotification?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/detective_member#email_address DetectiveMember#email_address}.
     *
     * @stability stable
     */
    readonly emailAddress: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/detective_member#graph_arn DetectiveMember#graph_arn}.
     *
     * @stability stable
     */
    readonly graphArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/detective_member#message DetectiveMember#message}.
     *
     * @stability stable
     */
    readonly message?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/detective_member aws_detective_member}.
 *
 * @stability stable
 */
export declare class DetectiveMember extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/detective_member aws_detective_member} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DetectiveMemberConfig);
    private _accountId?;
    /**
     * @stability stable
     */
    get accountId(): string;
    /**
     * @stability stable
     */
    set accountId(value: string);
    /**
     * @stability stable
     */
    get accountIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get administratorId(): string;
    private _disableEmailNotification?;
    /**
     * @stability stable
     */
    get disableEmailNotification(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set disableEmailNotification(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDisableEmailNotification(): void;
    /**
     * @stability stable
     */
    get disableEmailNotificationInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get disabledReason(): string;
    private _emailAddress?;
    /**
     * @stability stable
     */
    get emailAddress(): string;
    /**
     * @stability stable
     */
    set emailAddress(value: string);
    /**
     * @stability stable
     */
    get emailAddressInput(): string | undefined;
    private _graphArn?;
    /**
     * @stability stable
     */
    get graphArn(): string;
    /**
     * @stability stable
     */
    set graphArn(value: string);
    /**
     * @stability stable
     */
    get graphArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get invitedTime(): string;
    private _message?;
    /**
     * @stability stable
     */
    get message(): string;
    /**
     * @stability stable
     */
    set message(value: string);
    /**
     * @stability stable
     */
    resetMessage(): void;
    /**
     * @stability stable
     */
    get messageInput(): string | undefined;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    get updatedTime(): string;
    /**
     * @stability stable
     */
    get volumeUsageInBytes(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
