import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Database Migration Service.
 *
 * @stability stable
 */
export interface DmsEndpointConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#certificate_arn DmsEndpoint#certificate_arn}.
     *
     * @stability stable
     */
    readonly certificateArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#database_name DmsEndpoint#database_name}.
     *
     * @stability stable
     */
    readonly databaseName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#endpoint_id DmsEndpoint#endpoint_id}.
     *
     * @stability stable
     */
    readonly endpointId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#endpoint_type DmsEndpoint#endpoint_type}.
     *
     * @stability stable
     */
    readonly endpointType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#engine_name DmsEndpoint#engine_name}.
     *
     * @stability stable
     */
    readonly engineName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#extra_connection_attributes DmsEndpoint#extra_connection_attributes}.
     *
     * @stability stable
     */
    readonly extraConnectionAttributes?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#kms_key_arn DmsEndpoint#kms_key_arn}.
     *
     * @stability stable
     */
    readonly kmsKeyArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#password DmsEndpoint#password}.
     *
     * @stability stable
     */
    readonly password?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#port DmsEndpoint#port}.
     *
     * @stability stable
     */
    readonly port?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#secrets_manager_access_role_arn DmsEndpoint#secrets_manager_access_role_arn}.
     *
     * @stability stable
     */
    readonly secretsManagerAccessRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#secrets_manager_arn DmsEndpoint#secrets_manager_arn}.
     *
     * @stability stable
     */
    readonly secretsManagerArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#server_name DmsEndpoint#server_name}.
     *
     * @stability stable
     */
    readonly serverName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#service_access_role DmsEndpoint#service_access_role}.
     *
     * @stability stable
     */
    readonly serviceAccessRole?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#ssl_mode DmsEndpoint#ssl_mode}.
     *
     * @stability stable
     */
    readonly sslMode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#tags DmsEndpoint#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#tags_all DmsEndpoint#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#username DmsEndpoint#username}.
     *
     * @stability stable
     */
    readonly username?: string;
    /**
     * elasticsearch_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#elasticsearch_settings DmsEndpoint#elasticsearch_settings}
     *
     * @stability stable
     */
    readonly elasticsearchSettings?: DmsEndpointElasticsearchSettings;
    /**
     * kafka_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#kafka_settings DmsEndpoint#kafka_settings}
     *
     * @stability stable
     */
    readonly kafkaSettings?: DmsEndpointKafkaSettings;
    /**
     * kinesis_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#kinesis_settings DmsEndpoint#kinesis_settings}
     *
     * @stability stable
     */
    readonly kinesisSettings?: DmsEndpointKinesisSettings;
    /**
     * mongodb_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#mongodb_settings DmsEndpoint#mongodb_settings}
     *
     * @stability stable
     */
    readonly mongodbSettings?: DmsEndpointMongodbSettings;
    /**
     * s3_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#s3_settings DmsEndpoint#s3_settings}
     *
     * @stability stable
     */
    readonly s3Settings?: DmsEndpointS3Settings;
}
/**
 * @stability stable
 */
export interface DmsEndpointElasticsearchSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#endpoint_uri DmsEndpoint#endpoint_uri}.
     *
     * @stability stable
     */
    readonly endpointUri: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#error_retry_duration DmsEndpoint#error_retry_duration}.
     *
     * @stability stable
     */
    readonly errorRetryDuration?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#full_load_error_percentage DmsEndpoint#full_load_error_percentage}.
     *
     * @stability stable
     */
    readonly fullLoadErrorPercentage?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#service_access_role_arn DmsEndpoint#service_access_role_arn}.
     *
     * @stability stable
     */
    readonly serviceAccessRoleArn: string;
}
export declare function dmsEndpointElasticsearchSettingsToTerraform(struct?: DmsEndpointElasticsearchSettingsOutputReference | DmsEndpointElasticsearchSettings): any;
/**
 * @stability stable
 */
export declare class DmsEndpointElasticsearchSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DmsEndpointElasticsearchSettings | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DmsEndpointElasticsearchSettings | undefined);
    private _endpointUri?;
    /**
     * @stability stable
     */
    get endpointUri(): string;
    /**
     * @stability stable
     */
    set endpointUri(value: string);
    /**
     * @stability stable
     */
    get endpointUriInput(): string | undefined;
    private _errorRetryDuration?;
    /**
     * @stability stable
     */
    get errorRetryDuration(): number;
    /**
     * @stability stable
     */
    set errorRetryDuration(value: number);
    /**
     * @stability stable
     */
    resetErrorRetryDuration(): void;
    /**
     * @stability stable
     */
    get errorRetryDurationInput(): number | undefined;
    private _fullLoadErrorPercentage?;
    /**
     * @stability stable
     */
    get fullLoadErrorPercentage(): number;
    /**
     * @stability stable
     */
    set fullLoadErrorPercentage(value: number);
    /**
     * @stability stable
     */
    resetFullLoadErrorPercentage(): void;
    /**
     * @stability stable
     */
    get fullLoadErrorPercentageInput(): number | undefined;
    private _serviceAccessRoleArn?;
    /**
     * @stability stable
     */
    get serviceAccessRoleArn(): string;
    /**
     * @stability stable
     */
    set serviceAccessRoleArn(value: string);
    /**
     * @stability stable
     */
    get serviceAccessRoleArnInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DmsEndpointKafkaSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#broker DmsEndpoint#broker}.
     *
     * @stability stable
     */
    readonly broker: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#include_control_details DmsEndpoint#include_control_details}.
     *
     * @stability stable
     */
    readonly includeControlDetails?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#include_null_and_empty DmsEndpoint#include_null_and_empty}.
     *
     * @stability stable
     */
    readonly includeNullAndEmpty?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#include_partition_value DmsEndpoint#include_partition_value}.
     *
     * @stability stable
     */
    readonly includePartitionValue?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#include_table_alter_operations DmsEndpoint#include_table_alter_operations}.
     *
     * @stability stable
     */
    readonly includeTableAlterOperations?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#include_transaction_details DmsEndpoint#include_transaction_details}.
     *
     * @stability stable
     */
    readonly includeTransactionDetails?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#message_format DmsEndpoint#message_format}.
     *
     * @stability stable
     */
    readonly messageFormat?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#message_max_bytes DmsEndpoint#message_max_bytes}.
     *
     * @stability stable
     */
    readonly messageMaxBytes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#no_hex_prefix DmsEndpoint#no_hex_prefix}.
     *
     * @stability stable
     */
    readonly noHexPrefix?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#partition_include_schema_table DmsEndpoint#partition_include_schema_table}.
     *
     * @stability stable
     */
    readonly partitionIncludeSchemaTable?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#sasl_password DmsEndpoint#sasl_password}.
     *
     * @stability stable
     */
    readonly saslPassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#sasl_username DmsEndpoint#sasl_username}.
     *
     * @stability stable
     */
    readonly saslUsername?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#security_protocol DmsEndpoint#security_protocol}.
     *
     * @stability stable
     */
    readonly securityProtocol?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#ssl_ca_certificate_arn DmsEndpoint#ssl_ca_certificate_arn}.
     *
     * @stability stable
     */
    readonly sslCaCertificateArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#ssl_client_certificate_arn DmsEndpoint#ssl_client_certificate_arn}.
     *
     * @stability stable
     */
    readonly sslClientCertificateArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#ssl_client_key_arn DmsEndpoint#ssl_client_key_arn}.
     *
     * @stability stable
     */
    readonly sslClientKeyArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#ssl_client_key_password DmsEndpoint#ssl_client_key_password}.
     *
     * @stability stable
     */
    readonly sslClientKeyPassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#topic DmsEndpoint#topic}.
     *
     * @stability stable
     */
    readonly topic?: string;
}
export declare function dmsEndpointKafkaSettingsToTerraform(struct?: DmsEndpointKafkaSettingsOutputReference | DmsEndpointKafkaSettings): any;
/**
 * @stability stable
 */
export declare class DmsEndpointKafkaSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DmsEndpointKafkaSettings | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DmsEndpointKafkaSettings | undefined);
    private _broker?;
    /**
     * @stability stable
     */
    get broker(): string;
    /**
     * @stability stable
     */
    set broker(value: string);
    /**
     * @stability stable
     */
    get brokerInput(): string | undefined;
    private _includeControlDetails?;
    /**
     * @stability stable
     */
    get includeControlDetails(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set includeControlDetails(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIncludeControlDetails(): void;
    /**
     * @stability stable
     */
    get includeControlDetailsInput(): boolean | cdktf.IResolvable | undefined;
    private _includeNullAndEmpty?;
    /**
     * @stability stable
     */
    get includeNullAndEmpty(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set includeNullAndEmpty(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIncludeNullAndEmpty(): void;
    /**
     * @stability stable
     */
    get includeNullAndEmptyInput(): boolean | cdktf.IResolvable | undefined;
    private _includePartitionValue?;
    /**
     * @stability stable
     */
    get includePartitionValue(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set includePartitionValue(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIncludePartitionValue(): void;
    /**
     * @stability stable
     */
    get includePartitionValueInput(): boolean | cdktf.IResolvable | undefined;
    private _includeTableAlterOperations?;
    /**
     * @stability stable
     */
    get includeTableAlterOperations(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set includeTableAlterOperations(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIncludeTableAlterOperations(): void;
    /**
     * @stability stable
     */
    get includeTableAlterOperationsInput(): boolean | cdktf.IResolvable | undefined;
    private _includeTransactionDetails?;
    /**
     * @stability stable
     */
    get includeTransactionDetails(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set includeTransactionDetails(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIncludeTransactionDetails(): void;
    /**
     * @stability stable
     */
    get includeTransactionDetailsInput(): boolean | cdktf.IResolvable | undefined;
    private _messageFormat?;
    /**
     * @stability stable
     */
    get messageFormat(): string;
    /**
     * @stability stable
     */
    set messageFormat(value: string);
    /**
     * @stability stable
     */
    resetMessageFormat(): void;
    /**
     * @stability stable
     */
    get messageFormatInput(): string | undefined;
    private _messageMaxBytes?;
    /**
     * @stability stable
     */
    get messageMaxBytes(): number;
    /**
     * @stability stable
     */
    set messageMaxBytes(value: number);
    /**
     * @stability stable
     */
    resetMessageMaxBytes(): void;
    /**
     * @stability stable
     */
    get messageMaxBytesInput(): number | undefined;
    private _noHexPrefix?;
    /**
     * @stability stable
     */
    get noHexPrefix(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set noHexPrefix(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetNoHexPrefix(): void;
    /**
     * @stability stable
     */
    get noHexPrefixInput(): boolean | cdktf.IResolvable | undefined;
    private _partitionIncludeSchemaTable?;
    /**
     * @stability stable
     */
    get partitionIncludeSchemaTable(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set partitionIncludeSchemaTable(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetPartitionIncludeSchemaTable(): void;
    /**
     * @stability stable
     */
    get partitionIncludeSchemaTableInput(): boolean | cdktf.IResolvable | undefined;
    private _saslPassword?;
    /**
     * @stability stable
     */
    get saslPassword(): string;
    /**
     * @stability stable
     */
    set saslPassword(value: string);
    /**
     * @stability stable
     */
    resetSaslPassword(): void;
    /**
     * @stability stable
     */
    get saslPasswordInput(): string | undefined;
    private _saslUsername?;
    /**
     * @stability stable
     */
    get saslUsername(): string;
    /**
     * @stability stable
     */
    set saslUsername(value: string);
    /**
     * @stability stable
     */
    resetSaslUsername(): void;
    /**
     * @stability stable
     */
    get saslUsernameInput(): string | undefined;
    private _securityProtocol?;
    /**
     * @stability stable
     */
    get securityProtocol(): string;
    /**
     * @stability stable
     */
    set securityProtocol(value: string);
    /**
     * @stability stable
     */
    resetSecurityProtocol(): void;
    /**
     * @stability stable
     */
    get securityProtocolInput(): string | undefined;
    private _sslCaCertificateArn?;
    /**
     * @stability stable
     */
    get sslCaCertificateArn(): string;
    /**
     * @stability stable
     */
    set sslCaCertificateArn(value: string);
    /**
     * @stability stable
     */
    resetSslCaCertificateArn(): void;
    /**
     * @stability stable
     */
    get sslCaCertificateArnInput(): string | undefined;
    private _sslClientCertificateArn?;
    /**
     * @stability stable
     */
    get sslClientCertificateArn(): string;
    /**
     * @stability stable
     */
    set sslClientCertificateArn(value: string);
    /**
     * @stability stable
     */
    resetSslClientCertificateArn(): void;
    /**
     * @stability stable
     */
    get sslClientCertificateArnInput(): string | undefined;
    private _sslClientKeyArn?;
    /**
     * @stability stable
     */
    get sslClientKeyArn(): string;
    /**
     * @stability stable
     */
    set sslClientKeyArn(value: string);
    /**
     * @stability stable
     */
    resetSslClientKeyArn(): void;
    /**
     * @stability stable
     */
    get sslClientKeyArnInput(): string | undefined;
    private _sslClientKeyPassword?;
    /**
     * @stability stable
     */
    get sslClientKeyPassword(): string;
    /**
     * @stability stable
     */
    set sslClientKeyPassword(value: string);
    /**
     * @stability stable
     */
    resetSslClientKeyPassword(): void;
    /**
     * @stability stable
     */
    get sslClientKeyPasswordInput(): string | undefined;
    private _topic?;
    /**
     * @stability stable
     */
    get topic(): string;
    /**
     * @stability stable
     */
    set topic(value: string);
    /**
     * @stability stable
     */
    resetTopic(): void;
    /**
     * @stability stable
     */
    get topicInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DmsEndpointKinesisSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#include_control_details DmsEndpoint#include_control_details}.
     *
     * @stability stable
     */
    readonly includeControlDetails?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#include_null_and_empty DmsEndpoint#include_null_and_empty}.
     *
     * @stability stable
     */
    readonly includeNullAndEmpty?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#include_partition_value DmsEndpoint#include_partition_value}.
     *
     * @stability stable
     */
    readonly includePartitionValue?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#include_table_alter_operations DmsEndpoint#include_table_alter_operations}.
     *
     * @stability stable
     */
    readonly includeTableAlterOperations?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#include_transaction_details DmsEndpoint#include_transaction_details}.
     *
     * @stability stable
     */
    readonly includeTransactionDetails?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#message_format DmsEndpoint#message_format}.
     *
     * @stability stable
     */
    readonly messageFormat?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#partition_include_schema_table DmsEndpoint#partition_include_schema_table}.
     *
     * @stability stable
     */
    readonly partitionIncludeSchemaTable?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#service_access_role_arn DmsEndpoint#service_access_role_arn}.
     *
     * @stability stable
     */
    readonly serviceAccessRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#stream_arn DmsEndpoint#stream_arn}.
     *
     * @stability stable
     */
    readonly streamArn?: string;
}
export declare function dmsEndpointKinesisSettingsToTerraform(struct?: DmsEndpointKinesisSettingsOutputReference | DmsEndpointKinesisSettings): any;
/**
 * @stability stable
 */
export declare class DmsEndpointKinesisSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DmsEndpointKinesisSettings | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DmsEndpointKinesisSettings | undefined);
    private _includeControlDetails?;
    /**
     * @stability stable
     */
    get includeControlDetails(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set includeControlDetails(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIncludeControlDetails(): void;
    /**
     * @stability stable
     */
    get includeControlDetailsInput(): boolean | cdktf.IResolvable | undefined;
    private _includeNullAndEmpty?;
    /**
     * @stability stable
     */
    get includeNullAndEmpty(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set includeNullAndEmpty(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIncludeNullAndEmpty(): void;
    /**
     * @stability stable
     */
    get includeNullAndEmptyInput(): boolean | cdktf.IResolvable | undefined;
    private _includePartitionValue?;
    /**
     * @stability stable
     */
    get includePartitionValue(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set includePartitionValue(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIncludePartitionValue(): void;
    /**
     * @stability stable
     */
    get includePartitionValueInput(): boolean | cdktf.IResolvable | undefined;
    private _includeTableAlterOperations?;
    /**
     * @stability stable
     */
    get includeTableAlterOperations(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set includeTableAlterOperations(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIncludeTableAlterOperations(): void;
    /**
     * @stability stable
     */
    get includeTableAlterOperationsInput(): boolean | cdktf.IResolvable | undefined;
    private _includeTransactionDetails?;
    /**
     * @stability stable
     */
    get includeTransactionDetails(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set includeTransactionDetails(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIncludeTransactionDetails(): void;
    /**
     * @stability stable
     */
    get includeTransactionDetailsInput(): boolean | cdktf.IResolvable | undefined;
    private _messageFormat?;
    /**
     * @stability stable
     */
    get messageFormat(): string;
    /**
     * @stability stable
     */
    set messageFormat(value: string);
    /**
     * @stability stable
     */
    resetMessageFormat(): void;
    /**
     * @stability stable
     */
    get messageFormatInput(): string | undefined;
    private _partitionIncludeSchemaTable?;
    /**
     * @stability stable
     */
    get partitionIncludeSchemaTable(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set partitionIncludeSchemaTable(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetPartitionIncludeSchemaTable(): void;
    /**
     * @stability stable
     */
    get partitionIncludeSchemaTableInput(): boolean | cdktf.IResolvable | undefined;
    private _serviceAccessRoleArn?;
    /**
     * @stability stable
     */
    get serviceAccessRoleArn(): string;
    /**
     * @stability stable
     */
    set serviceAccessRoleArn(value: string);
    /**
     * @stability stable
     */
    resetServiceAccessRoleArn(): void;
    /**
     * @stability stable
     */
    get serviceAccessRoleArnInput(): string | undefined;
    private _streamArn?;
    /**
     * @stability stable
     */
    get streamArn(): string;
    /**
     * @stability stable
     */
    set streamArn(value: string);
    /**
     * @stability stable
     */
    resetStreamArn(): void;
    /**
     * @stability stable
     */
    get streamArnInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DmsEndpointMongodbSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#auth_mechanism DmsEndpoint#auth_mechanism}.
     *
     * @stability stable
     */
    readonly authMechanism?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#auth_source DmsEndpoint#auth_source}.
     *
     * @stability stable
     */
    readonly authSource?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#auth_type DmsEndpoint#auth_type}.
     *
     * @stability stable
     */
    readonly authType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#docs_to_investigate DmsEndpoint#docs_to_investigate}.
     *
     * @stability stable
     */
    readonly docsToInvestigate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#extract_doc_id DmsEndpoint#extract_doc_id}.
     *
     * @stability stable
     */
    readonly extractDocId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#nesting_level DmsEndpoint#nesting_level}.
     *
     * @stability stable
     */
    readonly nestingLevel?: string;
}
export declare function dmsEndpointMongodbSettingsToTerraform(struct?: DmsEndpointMongodbSettingsOutputReference | DmsEndpointMongodbSettings): any;
/**
 * @stability stable
 */
export declare class DmsEndpointMongodbSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DmsEndpointMongodbSettings | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DmsEndpointMongodbSettings | undefined);
    private _authMechanism?;
    /**
     * @stability stable
     */
    get authMechanism(): string;
    /**
     * @stability stable
     */
    set authMechanism(value: string);
    /**
     * @stability stable
     */
    resetAuthMechanism(): void;
    /**
     * @stability stable
     */
    get authMechanismInput(): string | undefined;
    private _authSource?;
    /**
     * @stability stable
     */
    get authSource(): string;
    /**
     * @stability stable
     */
    set authSource(value: string);
    /**
     * @stability stable
     */
    resetAuthSource(): void;
    /**
     * @stability stable
     */
    get authSourceInput(): string | undefined;
    private _authType?;
    /**
     * @stability stable
     */
    get authType(): string;
    /**
     * @stability stable
     */
    set authType(value: string);
    /**
     * @stability stable
     */
    resetAuthType(): void;
    /**
     * @stability stable
     */
    get authTypeInput(): string | undefined;
    private _docsToInvestigate?;
    /**
     * @stability stable
     */
    get docsToInvestigate(): string;
    /**
     * @stability stable
     */
    set docsToInvestigate(value: string);
    /**
     * @stability stable
     */
    resetDocsToInvestigate(): void;
    /**
     * @stability stable
     */
    get docsToInvestigateInput(): string | undefined;
    private _extractDocId?;
    /**
     * @stability stable
     */
    get extractDocId(): string;
    /**
     * @stability stable
     */
    set extractDocId(value: string);
    /**
     * @stability stable
     */
    resetExtractDocId(): void;
    /**
     * @stability stable
     */
    get extractDocIdInput(): string | undefined;
    private _nestingLevel?;
    /**
     * @stability stable
     */
    get nestingLevel(): string;
    /**
     * @stability stable
     */
    set nestingLevel(value: string);
    /**
     * @stability stable
     */
    resetNestingLevel(): void;
    /**
     * @stability stable
     */
    get nestingLevelInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DmsEndpointS3Settings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#bucket_folder DmsEndpoint#bucket_folder}.
     *
     * @stability stable
     */
    readonly bucketFolder?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#bucket_name DmsEndpoint#bucket_name}.
     *
     * @stability stable
     */
    readonly bucketName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#compression_type DmsEndpoint#compression_type}.
     *
     * @stability stable
     */
    readonly compressionType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#csv_delimiter DmsEndpoint#csv_delimiter}.
     *
     * @stability stable
     */
    readonly csvDelimiter?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#csv_row_delimiter DmsEndpoint#csv_row_delimiter}.
     *
     * @stability stable
     */
    readonly csvRowDelimiter?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#data_format DmsEndpoint#data_format}.
     *
     * @stability stable
     */
    readonly dataFormat?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#date_partition_enabled DmsEndpoint#date_partition_enabled}.
     *
     * @stability stable
     */
    readonly datePartitionEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#encryption_mode DmsEndpoint#encryption_mode}.
     *
     * @stability stable
     */
    readonly encryptionMode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#external_table_definition DmsEndpoint#external_table_definition}.
     *
     * @stability stable
     */
    readonly externalTableDefinition?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#parquet_timestamp_in_millisecond DmsEndpoint#parquet_timestamp_in_millisecond}.
     *
     * @stability stable
     */
    readonly parquetTimestampInMillisecond?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#parquet_version DmsEndpoint#parquet_version}.
     *
     * @stability stable
     */
    readonly parquetVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#server_side_encryption_kms_key_id DmsEndpoint#server_side_encryption_kms_key_id}.
     *
     * @stability stable
     */
    readonly serverSideEncryptionKmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint#service_access_role_arn DmsEndpoint#service_access_role_arn}.
     *
     * @stability stable
     */
    readonly serviceAccessRoleArn?: string;
}
export declare function dmsEndpointS3SettingsToTerraform(struct?: DmsEndpointS3SettingsOutputReference | DmsEndpointS3Settings): any;
/**
 * @stability stable
 */
export declare class DmsEndpointS3SettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DmsEndpointS3Settings | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DmsEndpointS3Settings | undefined);
    private _bucketFolder?;
    /**
     * @stability stable
     */
    get bucketFolder(): string;
    /**
     * @stability stable
     */
    set bucketFolder(value: string);
    /**
     * @stability stable
     */
    resetBucketFolder(): void;
    /**
     * @stability stable
     */
    get bucketFolderInput(): string | undefined;
    private _bucketName?;
    /**
     * @stability stable
     */
    get bucketName(): string;
    /**
     * @stability stable
     */
    set bucketName(value: string);
    /**
     * @stability stable
     */
    resetBucketName(): void;
    /**
     * @stability stable
     */
    get bucketNameInput(): string | undefined;
    private _compressionType?;
    /**
     * @stability stable
     */
    get compressionType(): string;
    /**
     * @stability stable
     */
    set compressionType(value: string);
    /**
     * @stability stable
     */
    resetCompressionType(): void;
    /**
     * @stability stable
     */
    get compressionTypeInput(): string | undefined;
    private _csvDelimiter?;
    /**
     * @stability stable
     */
    get csvDelimiter(): string;
    /**
     * @stability stable
     */
    set csvDelimiter(value: string);
    /**
     * @stability stable
     */
    resetCsvDelimiter(): void;
    /**
     * @stability stable
     */
    get csvDelimiterInput(): string | undefined;
    private _csvRowDelimiter?;
    /**
     * @stability stable
     */
    get csvRowDelimiter(): string;
    /**
     * @stability stable
     */
    set csvRowDelimiter(value: string);
    /**
     * @stability stable
     */
    resetCsvRowDelimiter(): void;
    /**
     * @stability stable
     */
    get csvRowDelimiterInput(): string | undefined;
    private _dataFormat?;
    /**
     * @stability stable
     */
    get dataFormat(): string;
    /**
     * @stability stable
     */
    set dataFormat(value: string);
    /**
     * @stability stable
     */
    resetDataFormat(): void;
    /**
     * @stability stable
     */
    get dataFormatInput(): string | undefined;
    private _datePartitionEnabled?;
    /**
     * @stability stable
     */
    get datePartitionEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set datePartitionEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDatePartitionEnabled(): void;
    /**
     * @stability stable
     */
    get datePartitionEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _encryptionMode?;
    /**
     * @stability stable
     */
    get encryptionMode(): string;
    /**
     * @stability stable
     */
    set encryptionMode(value: string);
    /**
     * @stability stable
     */
    resetEncryptionMode(): void;
    /**
     * @stability stable
     */
    get encryptionModeInput(): string | undefined;
    private _externalTableDefinition?;
    /**
     * @stability stable
     */
    get externalTableDefinition(): string;
    /**
     * @stability stable
     */
    set externalTableDefinition(value: string);
    /**
     * @stability stable
     */
    resetExternalTableDefinition(): void;
    /**
     * @stability stable
     */
    get externalTableDefinitionInput(): string | undefined;
    private _parquetTimestampInMillisecond?;
    /**
     * @stability stable
     */
    get parquetTimestampInMillisecond(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set parquetTimestampInMillisecond(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetParquetTimestampInMillisecond(): void;
    /**
     * @stability stable
     */
    get parquetTimestampInMillisecondInput(): boolean | cdktf.IResolvable | undefined;
    private _parquetVersion?;
    /**
     * @stability stable
     */
    get parquetVersion(): string;
    /**
     * @stability stable
     */
    set parquetVersion(value: string);
    /**
     * @stability stable
     */
    resetParquetVersion(): void;
    /**
     * @stability stable
     */
    get parquetVersionInput(): string | undefined;
    private _serverSideEncryptionKmsKeyId?;
    /**
     * @stability stable
     */
    get serverSideEncryptionKmsKeyId(): string;
    /**
     * @stability stable
     */
    set serverSideEncryptionKmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetServerSideEncryptionKmsKeyId(): void;
    /**
     * @stability stable
     */
    get serverSideEncryptionKmsKeyIdInput(): string | undefined;
    private _serviceAccessRoleArn?;
    /**
     * @stability stable
     */
    get serviceAccessRoleArn(): string;
    /**
     * @stability stable
     */
    set serviceAccessRoleArn(value: string);
    /**
     * @stability stable
     */
    resetServiceAccessRoleArn(): void;
    /**
     * @stability stable
     */
    get serviceAccessRoleArnInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint aws_dms_endpoint}.
 *
 * @stability stable
 */
export declare class DmsEndpoint extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/dms_endpoint aws_dms_endpoint} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DmsEndpointConfig);
    private _certificateArn?;
    /**
     * @stability stable
     */
    get certificateArn(): string;
    /**
     * @stability stable
     */
    set certificateArn(value: string);
    /**
     * @stability stable
     */
    resetCertificateArn(): void;
    /**
     * @stability stable
     */
    get certificateArnInput(): string | undefined;
    private _databaseName?;
    /**
     * @stability stable
     */
    get databaseName(): string;
    /**
     * @stability stable
     */
    set databaseName(value: string);
    /**
     * @stability stable
     */
    resetDatabaseName(): void;
    /**
     * @stability stable
     */
    get databaseNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get endpointArn(): string;
    private _endpointId?;
    /**
     * @stability stable
     */
    get endpointId(): string;
    /**
     * @stability stable
     */
    set endpointId(value: string);
    /**
     * @stability stable
     */
    get endpointIdInput(): string | undefined;
    private _endpointType?;
    /**
     * @stability stable
     */
    get endpointType(): string;
    /**
     * @stability stable
     */
    set endpointType(value: string);
    /**
     * @stability stable
     */
    get endpointTypeInput(): string | undefined;
    private _engineName?;
    /**
     * @stability stable
     */
    get engineName(): string;
    /**
     * @stability stable
     */
    set engineName(value: string);
    /**
     * @stability stable
     */
    get engineNameInput(): string | undefined;
    private _extraConnectionAttributes?;
    /**
     * @stability stable
     */
    get extraConnectionAttributes(): string;
    /**
     * @stability stable
     */
    set extraConnectionAttributes(value: string);
    /**
     * @stability stable
     */
    resetExtraConnectionAttributes(): void;
    /**
     * @stability stable
     */
    get extraConnectionAttributesInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsKeyArn?;
    /**
     * @stability stable
     */
    get kmsKeyArn(): string;
    /**
     * @stability stable
     */
    set kmsKeyArn(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyArn(): void;
    /**
     * @stability stable
     */
    get kmsKeyArnInput(): string | undefined;
    private _password?;
    /**
     * @stability stable
     */
    get password(): string;
    /**
     * @stability stable
     */
    set password(value: string);
    /**
     * @stability stable
     */
    resetPassword(): void;
    /**
     * @stability stable
     */
    get passwordInput(): string | undefined;
    private _port?;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    set port(value: number);
    /**
     * @stability stable
     */
    resetPort(): void;
    /**
     * @stability stable
     */
    get portInput(): number | undefined;
    private _secretsManagerAccessRoleArn?;
    /**
     * @stability stable
     */
    get secretsManagerAccessRoleArn(): string;
    /**
     * @stability stable
     */
    set secretsManagerAccessRoleArn(value: string);
    /**
     * @stability stable
     */
    resetSecretsManagerAccessRoleArn(): void;
    /**
     * @stability stable
     */
    get secretsManagerAccessRoleArnInput(): string | undefined;
    private _secretsManagerArn?;
    /**
     * @stability stable
     */
    get secretsManagerArn(): string;
    /**
     * @stability stable
     */
    set secretsManagerArn(value: string);
    /**
     * @stability stable
     */
    resetSecretsManagerArn(): void;
    /**
     * @stability stable
     */
    get secretsManagerArnInput(): string | undefined;
    private _serverName?;
    /**
     * @stability stable
     */
    get serverName(): string;
    /**
     * @stability stable
     */
    set serverName(value: string);
    /**
     * @stability stable
     */
    resetServerName(): void;
    /**
     * @stability stable
     */
    get serverNameInput(): string | undefined;
    private _serviceAccessRole?;
    /**
     * @stability stable
     */
    get serviceAccessRole(): string;
    /**
     * @stability stable
     */
    set serviceAccessRole(value: string);
    /**
     * @stability stable
     */
    resetServiceAccessRole(): void;
    /**
     * @stability stable
     */
    get serviceAccessRoleInput(): string | undefined;
    private _sslMode?;
    /**
     * @stability stable
     */
    get sslMode(): string;
    /**
     * @stability stable
     */
    set sslMode(value: string);
    /**
     * @stability stable
     */
    resetSslMode(): void;
    /**
     * @stability stable
     */
    get sslModeInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _username?;
    /**
     * @stability stable
     */
    get username(): string;
    /**
     * @stability stable
     */
    set username(value: string);
    /**
     * @stability stable
     */
    resetUsername(): void;
    /**
     * @stability stable
     */
    get usernameInput(): string | undefined;
    private _elasticsearchSettings;
    /**
     * @stability stable
     */
    get elasticsearchSettings(): DmsEndpointElasticsearchSettingsOutputReference;
    /**
     * @stability stable
     */
    putElasticsearchSettings(value: DmsEndpointElasticsearchSettings): void;
    /**
     * @stability stable
     */
    resetElasticsearchSettings(): void;
    /**
     * @stability stable
     */
    get elasticsearchSettingsInput(): DmsEndpointElasticsearchSettings | undefined;
    private _kafkaSettings;
    /**
     * @stability stable
     */
    get kafkaSettings(): DmsEndpointKafkaSettingsOutputReference;
    /**
     * @stability stable
     */
    putKafkaSettings(value: DmsEndpointKafkaSettings): void;
    /**
     * @stability stable
     */
    resetKafkaSettings(): void;
    /**
     * @stability stable
     */
    get kafkaSettingsInput(): DmsEndpointKafkaSettings | undefined;
    private _kinesisSettings;
    /**
     * @stability stable
     */
    get kinesisSettings(): DmsEndpointKinesisSettingsOutputReference;
    /**
     * @stability stable
     */
    putKinesisSettings(value: DmsEndpointKinesisSettings): void;
    /**
     * @stability stable
     */
    resetKinesisSettings(): void;
    /**
     * @stability stable
     */
    get kinesisSettingsInput(): DmsEndpointKinesisSettings | undefined;
    private _mongodbSettings;
    /**
     * @stability stable
     */
    get mongodbSettings(): DmsEndpointMongodbSettingsOutputReference;
    /**
     * @stability stable
     */
    putMongodbSettings(value: DmsEndpointMongodbSettings): void;
    /**
     * @stability stable
     */
    resetMongodbSettings(): void;
    /**
     * @stability stable
     */
    get mongodbSettingsInput(): DmsEndpointMongodbSettings | undefined;
    private _s3Settings;
    /**
     * @stability stable
     */
    get s3Settings(): DmsEndpointS3SettingsOutputReference;
    /**
     * @stability stable
     */
    putS3Settings(value: DmsEndpointS3Settings): void;
    /**
     * @stability stable
     */
    resetS3Settings(): void;
    /**
     * @stability stable
     */
    get s3SettingsInput(): DmsEndpointS3Settings | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
