import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Database Migration Service.
 *
 * @stability stable
 */
export interface DmsReplicationTaskConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_replication_task#cdc_start_position DmsReplicationTask#cdc_start_position}.
     *
     * @stability stable
     */
    readonly cdcStartPosition?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_replication_task#cdc_start_time DmsReplicationTask#cdc_start_time}.
     *
     * @stability stable
     */
    readonly cdcStartTime?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_replication_task#migration_type DmsReplicationTask#migration_type}.
     *
     * @stability stable
     */
    readonly migrationType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_replication_task#replication_instance_arn DmsReplicationTask#replication_instance_arn}.
     *
     * @stability stable
     */
    readonly replicationInstanceArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_replication_task#replication_task_id DmsReplicationTask#replication_task_id}.
     *
     * @stability stable
     */
    readonly replicationTaskId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_replication_task#replication_task_settings DmsReplicationTask#replication_task_settings}.
     *
     * @stability stable
     */
    readonly replicationTaskSettings?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_replication_task#source_endpoint_arn DmsReplicationTask#source_endpoint_arn}.
     *
     * @stability stable
     */
    readonly sourceEndpointArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_replication_task#table_mappings DmsReplicationTask#table_mappings}.
     *
     * @stability stable
     */
    readonly tableMappings: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_replication_task#tags DmsReplicationTask#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_replication_task#tags_all DmsReplicationTask#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dms_replication_task#target_endpoint_arn DmsReplicationTask#target_endpoint_arn}.
     *
     * @stability stable
     */
    readonly targetEndpointArn: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/dms_replication_task aws_dms_replication_task}.
 *
 * @stability stable
 */
export declare class DmsReplicationTask extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/dms_replication_task aws_dms_replication_task} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DmsReplicationTaskConfig);
    private _cdcStartPosition?;
    /**
     * @stability stable
     */
    get cdcStartPosition(): string;
    /**
     * @stability stable
     */
    set cdcStartPosition(value: string);
    /**
     * @stability stable
     */
    resetCdcStartPosition(): void;
    /**
     * @stability stable
     */
    get cdcStartPositionInput(): string | undefined;
    private _cdcStartTime?;
    /**
     * @stability stable
     */
    get cdcStartTime(): string;
    /**
     * @stability stable
     */
    set cdcStartTime(value: string);
    /**
     * @stability stable
     */
    resetCdcStartTime(): void;
    /**
     * @stability stable
     */
    get cdcStartTimeInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _migrationType?;
    /**
     * @stability stable
     */
    get migrationType(): string;
    /**
     * @stability stable
     */
    set migrationType(value: string);
    /**
     * @stability stable
     */
    get migrationTypeInput(): string | undefined;
    private _replicationInstanceArn?;
    /**
     * @stability stable
     */
    get replicationInstanceArn(): string;
    /**
     * @stability stable
     */
    set replicationInstanceArn(value: string);
    /**
     * @stability stable
     */
    get replicationInstanceArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get replicationTaskArn(): string;
    private _replicationTaskId?;
    /**
     * @stability stable
     */
    get replicationTaskId(): string;
    /**
     * @stability stable
     */
    set replicationTaskId(value: string);
    /**
     * @stability stable
     */
    get replicationTaskIdInput(): string | undefined;
    private _replicationTaskSettings?;
    /**
     * @stability stable
     */
    get replicationTaskSettings(): string;
    /**
     * @stability stable
     */
    set replicationTaskSettings(value: string);
    /**
     * @stability stable
     */
    resetReplicationTaskSettings(): void;
    /**
     * @stability stable
     */
    get replicationTaskSettingsInput(): string | undefined;
    private _sourceEndpointArn?;
    /**
     * @stability stable
     */
    get sourceEndpointArn(): string;
    /**
     * @stability stable
     */
    set sourceEndpointArn(value: string);
    /**
     * @stability stable
     */
    get sourceEndpointArnInput(): string | undefined;
    private _tableMappings?;
    /**
     * @stability stable
     */
    get tableMappings(): string;
    /**
     * @stability stable
     */
    set tableMappings(value: string);
    /**
     * @stability stable
     */
    get tableMappingsInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _targetEndpointArn?;
    /**
     * @stability stable
     */
    get targetEndpointArn(): string;
    /**
     * @stability stable
     */
    set targetEndpointArn(value: string);
    /**
     * @stability stable
     */
    get targetEndpointArnInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
