import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS EC2.
 *
 * @stability stable
 */
export interface DataAwsEbsSnapshotConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot#most_recent DataAwsEbsSnapshot#most_recent}.
     *
     * @stability stable
     */
    readonly mostRecent?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot#owners DataAwsEbsSnapshot#owners}.
     *
     * @stability stable
     */
    readonly owners?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot#restorable_by_user_ids DataAwsEbsSnapshot#restorable_by_user_ids}.
     *
     * @stability stable
     */
    readonly restorableByUserIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot#snapshot_ids DataAwsEbsSnapshot#snapshot_ids}.
     *
     * @stability stable
     */
    readonly snapshotIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot#tags DataAwsEbsSnapshot#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot#filter DataAwsEbsSnapshot#filter}
     *
     * @stability stable
     */
    readonly filter?: DataAwsEbsSnapshotFilter[] | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface DataAwsEbsSnapshotFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot#name DataAwsEbsSnapshot#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot#values DataAwsEbsSnapshot#values}.
     *
     * @stability stable
     */
    readonly values: string[];
}
export declare function dataAwsEbsSnapshotFilterToTerraform(struct?: DataAwsEbsSnapshotFilter | cdktf.IResolvable): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot aws_ebs_snapshot}.
 *
 * @stability stable
 */
export declare class DataAwsEbsSnapshot extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ebs_snapshot aws_ebs_snapshot} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsEbsSnapshotConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get dataEncryptionKeyId(): string;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get encrypted(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    private _mostRecent?;
    /**
     * @stability stable
     */
    get mostRecent(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set mostRecent(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetMostRecent(): void;
    /**
     * @stability stable
     */
    get mostRecentInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get outpostArn(): string;
    /**
     * @stability stable
     */
    get ownerAlias(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _owners?;
    /**
     * @stability stable
     */
    get owners(): string[];
    /**
     * @stability stable
     */
    set owners(value: string[]);
    /**
     * @stability stable
     */
    resetOwners(): void;
    /**
     * @stability stable
     */
    get ownersInput(): string[] | undefined;
    private _restorableByUserIds?;
    /**
     * @stability stable
     */
    get restorableByUserIds(): string[];
    /**
     * @stability stable
     */
    set restorableByUserIds(value: string[]);
    /**
     * @stability stable
     */
    resetRestorableByUserIds(): void;
    /**
     * @stability stable
     */
    get restorableByUserIdsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get snapshotId(): string;
    private _snapshotIds?;
    /**
     * @stability stable
     */
    get snapshotIds(): string[];
    /**
     * @stability stable
     */
    set snapshotIds(value: string[]);
    /**
     * @stability stable
     */
    resetSnapshotIds(): void;
    /**
     * @stability stable
     */
    get snapshotIdsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get state(): string;
    /**
     * @stability stable
     */
    get storageTier(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get volumeId(): string;
    /**
     * @stability stable
     */
    get volumeSize(): number;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsEbsSnapshotFilter[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set filter(value: DataAwsEbsSnapshotFilter[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): cdktf.IResolvable | DataAwsEbsSnapshotFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
