import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS EC2 Container Registry.
 *
 * @stability stable
 */
export interface DataAwsEcrAuthorizationTokenConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ecr_authorization_token#registry_id DataAwsEcrAuthorizationToken#registry_id}.
     *
     * @stability stable
     */
    readonly registryId?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ecr_authorization_token aws_ecr_authorization_token}.
 *
 * @stability stable
 */
export declare class DataAwsEcrAuthorizationToken extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ecr_authorization_token aws_ecr_authorization_token} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsEcrAuthorizationTokenConfig);
    /**
     * @stability stable
     */
    get authorizationToken(): string;
    /**
     * @stability stable
     */
    get expiresAt(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get password(): string;
    /**
     * @stability stable
     */
    get proxyEndpoint(): string;
    private _registryId?;
    /**
     * @stability stable
     */
    get registryId(): string;
    /**
     * @stability stable
     */
    set registryId(value: string);
    /**
     * @stability stable
     */
    resetRegistryId(): void;
    /**
     * @stability stable
     */
    get registryIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get userName(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
