import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS EC2 Container Registry.
 *
 * @stability stable
 */
export interface EcrPullThroughCacheRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecr_pull_through_cache_rule#ecr_repository_prefix EcrPullThroughCacheRule#ecr_repository_prefix}.
     *
     * @stability stable
     */
    readonly ecrRepositoryPrefix: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ecr_pull_through_cache_rule#upstream_registry_url EcrPullThroughCacheRule#upstream_registry_url}.
     *
     * @stability stable
     */
    readonly upstreamRegistryUrl: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ecr_pull_through_cache_rule aws_ecr_pull_through_cache_rule}.
 *
 * @stability stable
 */
export declare class EcrPullThroughCacheRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ecr_pull_through_cache_rule aws_ecr_pull_through_cache_rule} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: EcrPullThroughCacheRuleConfig);
    private _ecrRepositoryPrefix?;
    /**
     * @stability stable
     */
    get ecrRepositoryPrefix(): string;
    /**
     * @stability stable
     */
    set ecrRepositoryPrefix(value: string);
    /**
     * @stability stable
     */
    get ecrRepositoryPrefixInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get registryId(): string;
    private _upstreamRegistryUrl?;
    /**
     * @stability stable
     */
    get upstreamRegistryUrl(): string;
    /**
     * @stability stable
     */
    set upstreamRegistryUrl(value: string);
    /**
     * @stability stable
     */
    get upstreamRegistryUrlInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
