import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS EFS.
 *
 * @stability stable
 */
export interface EfsBackupPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/efs_backup_policy#file_system_id EfsBackupPolicy#file_system_id}.
     *
     * @stability stable
     */
    readonly fileSystemId: string;
    /**
     * backup_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/efs_backup_policy#backup_policy EfsBackupPolicy#backup_policy}
     *
     * @stability stable
     */
    readonly backupPolicy: EfsBackupPolicyBackupPolicy;
}
/**
 * @stability stable
 */
export interface EfsBackupPolicyBackupPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/efs_backup_policy#status EfsBackupPolicy#status}.
     *
     * @stability stable
     */
    readonly status: string;
}
export declare function efsBackupPolicyBackupPolicyToTerraform(struct?: EfsBackupPolicyBackupPolicyOutputReference | EfsBackupPolicyBackupPolicy): any;
/**
 * @stability stable
 */
export declare class EfsBackupPolicyBackupPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): EfsBackupPolicyBackupPolicy | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: EfsBackupPolicyBackupPolicy | undefined);
    private _status?;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    set status(value: string);
    /**
     * @stability stable
     */
    get statusInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/efs_backup_policy aws_efs_backup_policy}.
 *
 * @stability stable
 */
export declare class EfsBackupPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/efs_backup_policy aws_efs_backup_policy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: EfsBackupPolicyConfig);
    private _fileSystemId?;
    /**
     * @stability stable
     */
    get fileSystemId(): string;
    /**
     * @stability stable
     */
    set fileSystemId(value: string);
    /**
     * @stability stable
     */
    get fileSystemIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _backupPolicy;
    /**
     * @stability stable
     */
    get backupPolicy(): EfsBackupPolicyBackupPolicyOutputReference;
    /**
     * @stability stable
     */
    putBackupPolicy(value: EfsBackupPolicyBackupPolicy): void;
    /**
     * @stability stable
     */
    get backupPolicyInput(): EfsBackupPolicyBackupPolicy | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
