import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Elastic Kubernetes Service.
 *
 * @stability stable
 */
export interface DataAwsEksNodeGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/eks_node_group#cluster_name DataAwsEksNodeGroup#cluster_name}.
     *
     * @stability stable
     */
    readonly clusterName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/eks_node_group#node_group_name DataAwsEksNodeGroup#node_group_name}.
     *
     * @stability stable
     */
    readonly nodeGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/eks_node_group#tags DataAwsEksNodeGroup#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataAwsEksNodeGroupRemoteAccess extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get ec2SshKey(): string;
    /**
     * @stability stable
     */
    get sourceSecurityGroupIds(): string[];
}
/**
 * @stability stable
 */
export declare class DataAwsEksNodeGroupResourcesAutoscalingGroups extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get name(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsEksNodeGroupResources extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get autoscalingGroups(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get remoteAccessSecurityGroupId(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsEksNodeGroupScalingConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get desiredSize(): number;
    /**
     * @stability stable
     */
    get maxSize(): number;
    /**
     * @stability stable
     */
    get minSize(): number;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/eks_node_group aws_eks_node_group}.
 *
 * @stability stable
 */
export declare class DataAwsEksNodeGroup extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/eks_node_group aws_eks_node_group} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsEksNodeGroupConfig);
    /**
     * @stability stable
     */
    get amiType(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _clusterName?;
    /**
     * @stability stable
     */
    get clusterName(): string;
    /**
     * @stability stable
     */
    set clusterName(value: string);
    /**
     * @stability stable
     */
    get clusterNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get diskSize(): number;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get instanceTypes(): string[];
    /**
     * @stability stable
     */
    labels(key: string): string | cdktf.IResolvable;
    private _nodeGroupName?;
    /**
     * @stability stable
     */
    get nodeGroupName(): string;
    /**
     * @stability stable
     */
    set nodeGroupName(value: string);
    /**
     * @stability stable
     */
    get nodeGroupNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get nodeRoleArn(): string;
    /**
     * @stability stable
     */
    get releaseVersion(): string;
    /**
     * @stability stable
     */
    remoteAccess(index: string): DataAwsEksNodeGroupRemoteAccess;
    /**
     * @stability stable
     */
    resources(index: string): DataAwsEksNodeGroupResources;
    /**
     * @stability stable
     */
    scalingConfig(index: string): DataAwsEksNodeGroupScalingConfig;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get version(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
