import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS ElastiCache.
 *
 * @stability stable
 */
export interface DataAwsElasticacheReplicationGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/elasticache_replication_group#replication_group_id DataAwsElasticacheReplicationGroup#replication_group_id}.
     *
     * @stability stable
     */
    readonly replicationGroupId: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/elasticache_replication_group aws_elasticache_replication_group}.
 *
 * @stability stable
 */
export declare class DataAwsElasticacheReplicationGroup extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/elasticache_replication_group aws_elasticache_replication_group} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsElasticacheReplicationGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get authTokenEnabled(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get automaticFailoverEnabled(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get configurationEndpointAddress(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get memberClusters(): string[];
    /**
     * @stability stable
     */
    get multiAzEnabled(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get nodeType(): string;
    /**
     * @stability stable
     */
    get numberCacheClusters(): number;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    get primaryEndpointAddress(): string;
    /**
     * @stability stable
     */
    get readerEndpointAddress(): string;
    /**
     * @stability stable
     */
    get replicationGroupDescription(): string;
    private _replicationGroupId?;
    /**
     * @stability stable
     */
    get replicationGroupId(): string;
    /**
     * @stability stable
     */
    set replicationGroupId(value: string);
    /**
     * @stability stable
     */
    get replicationGroupIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get snapshotRetentionLimit(): number;
    /**
     * @stability stable
     */
    get snapshotWindow(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
