import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS ElastiCache.
 *
 * @stability stable
 */
export interface ElasticacheReplicationGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#apply_immediately ElasticacheReplicationGroup#apply_immediately}.
     *
     * @stability stable
     */
    readonly applyImmediately?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#at_rest_encryption_enabled ElasticacheReplicationGroup#at_rest_encryption_enabled}.
     *
     * @stability stable
     */
    readonly atRestEncryptionEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#auth_token ElasticacheReplicationGroup#auth_token}.
     *
     * @stability stable
     */
    readonly authToken?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#auto_minor_version_upgrade ElasticacheReplicationGroup#auto_minor_version_upgrade}.
     *
     * @stability stable
     */
    readonly autoMinorVersionUpgrade?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#automatic_failover_enabled ElasticacheReplicationGroup#automatic_failover_enabled}.
     *
     * @stability stable
     */
    readonly automaticFailoverEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#availability_zones ElasticacheReplicationGroup#availability_zones}.
     *
     * @stability stable
     */
    readonly availabilityZones?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#data_tiering_enabled ElasticacheReplicationGroup#data_tiering_enabled}.
     *
     * @stability stable
     */
    readonly dataTieringEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#engine ElasticacheReplicationGroup#engine}.
     *
     * @stability stable
     */
    readonly engine?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#engine_version ElasticacheReplicationGroup#engine_version}.
     *
     * @stability stable
     */
    readonly engineVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#final_snapshot_identifier ElasticacheReplicationGroup#final_snapshot_identifier}.
     *
     * @stability stable
     */
    readonly finalSnapshotIdentifier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#global_replication_group_id ElasticacheReplicationGroup#global_replication_group_id}.
     *
     * @stability stable
     */
    readonly globalReplicationGroupId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#kms_key_id ElasticacheReplicationGroup#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#maintenance_window ElasticacheReplicationGroup#maintenance_window}.
     *
     * @stability stable
     */
    readonly maintenanceWindow?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#multi_az_enabled ElasticacheReplicationGroup#multi_az_enabled}.
     *
     * @stability stable
     */
    readonly multiAzEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#node_type ElasticacheReplicationGroup#node_type}.
     *
     * @stability stable
     */
    readonly nodeType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#notification_topic_arn ElasticacheReplicationGroup#notification_topic_arn}.
     *
     * @stability stable
     */
    readonly notificationTopicArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#number_cache_clusters ElasticacheReplicationGroup#number_cache_clusters}.
     *
     * @stability stable
     */
    readonly numberCacheClusters?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#parameter_group_name ElasticacheReplicationGroup#parameter_group_name}.
     *
     * @stability stable
     */
    readonly parameterGroupName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#port ElasticacheReplicationGroup#port}.
     *
     * @stability stable
     */
    readonly port?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#replication_group_description ElasticacheReplicationGroup#replication_group_description}.
     *
     * @stability stable
     */
    readonly replicationGroupDescription: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#replication_group_id ElasticacheReplicationGroup#replication_group_id}.
     *
     * @stability stable
     */
    readonly replicationGroupId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#security_group_ids ElasticacheReplicationGroup#security_group_ids}.
     *
     * @stability stable
     */
    readonly securityGroupIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#security_group_names ElasticacheReplicationGroup#security_group_names}.
     *
     * @stability stable
     */
    readonly securityGroupNames?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#snapshot_arns ElasticacheReplicationGroup#snapshot_arns}.
     *
     * @stability stable
     */
    readonly snapshotArns?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#snapshot_name ElasticacheReplicationGroup#snapshot_name}.
     *
     * @stability stable
     */
    readonly snapshotName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#snapshot_retention_limit ElasticacheReplicationGroup#snapshot_retention_limit}.
     *
     * @stability stable
     */
    readonly snapshotRetentionLimit?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#snapshot_window ElasticacheReplicationGroup#snapshot_window}.
     *
     * @stability stable
     */
    readonly snapshotWindow?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#subnet_group_name ElasticacheReplicationGroup#subnet_group_name}.
     *
     * @stability stable
     */
    readonly subnetGroupName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#tags ElasticacheReplicationGroup#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#tags_all ElasticacheReplicationGroup#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#transit_encryption_enabled ElasticacheReplicationGroup#transit_encryption_enabled}.
     *
     * @stability stable
     */
    readonly transitEncryptionEnabled?: boolean | cdktf.IResolvable;
    /**
     * cluster_mode block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#cluster_mode ElasticacheReplicationGroup#cluster_mode}
     *
     * @stability stable
     */
    readonly clusterMode?: ElasticacheReplicationGroupClusterMode;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#timeouts ElasticacheReplicationGroup#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: ElasticacheReplicationGroupTimeouts;
}
/**
 * @stability stable
 */
export interface ElasticacheReplicationGroupClusterMode {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#num_node_groups ElasticacheReplicationGroup#num_node_groups}.
     *
     * @stability stable
     */
    readonly numNodeGroups?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#replicas_per_node_group ElasticacheReplicationGroup#replicas_per_node_group}.
     *
     * @stability stable
     */
    readonly replicasPerNodeGroup: number;
}
export declare function elasticacheReplicationGroupClusterModeToTerraform(struct?: ElasticacheReplicationGroupClusterModeOutputReference | ElasticacheReplicationGroupClusterMode): any;
/**
 * @stability stable
 */
export declare class ElasticacheReplicationGroupClusterModeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): ElasticacheReplicationGroupClusterMode | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: ElasticacheReplicationGroupClusterMode | undefined);
    private _numNodeGroups?;
    /**
     * @stability stable
     */
    get numNodeGroups(): number;
    /**
     * @stability stable
     */
    set numNodeGroups(value: number);
    /**
     * @stability stable
     */
    resetNumNodeGroups(): void;
    /**
     * @stability stable
     */
    get numNodeGroupsInput(): number | undefined;
    private _replicasPerNodeGroup?;
    /**
     * @stability stable
     */
    get replicasPerNodeGroup(): number;
    /**
     * @stability stable
     */
    set replicasPerNodeGroup(value: number);
    /**
     * @stability stable
     */
    get replicasPerNodeGroupInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface ElasticacheReplicationGroupTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#create ElasticacheReplicationGroup#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#delete ElasticacheReplicationGroup#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group#update ElasticacheReplicationGroup#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function elasticacheReplicationGroupTimeoutsToTerraform(struct?: ElasticacheReplicationGroupTimeoutsOutputReference | ElasticacheReplicationGroupTimeouts | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export declare class ElasticacheReplicationGroupTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): ElasticacheReplicationGroupTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: ElasticacheReplicationGroupTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group aws_elasticache_replication_group}.
 *
 * @stability stable
 */
export declare class ElasticacheReplicationGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/elasticache_replication_group aws_elasticache_replication_group} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ElasticacheReplicationGroupConfig);
    private _applyImmediately?;
    /**
     * @stability stable
     */
    get applyImmediately(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set applyImmediately(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetApplyImmediately(): void;
    /**
     * @stability stable
     */
    get applyImmediatelyInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _atRestEncryptionEnabled?;
    /**
     * @stability stable
     */
    get atRestEncryptionEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set atRestEncryptionEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAtRestEncryptionEnabled(): void;
    /**
     * @stability stable
     */
    get atRestEncryptionEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _authToken?;
    /**
     * @stability stable
     */
    get authToken(): string;
    /**
     * @stability stable
     */
    set authToken(value: string);
    /**
     * @stability stable
     */
    resetAuthToken(): void;
    /**
     * @stability stable
     */
    get authTokenInput(): string | undefined;
    private _autoMinorVersionUpgrade?;
    /**
     * @stability stable
     */
    get autoMinorVersionUpgrade(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set autoMinorVersionUpgrade(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAutoMinorVersionUpgrade(): void;
    /**
     * @stability stable
     */
    get autoMinorVersionUpgradeInput(): boolean | cdktf.IResolvable | undefined;
    private _automaticFailoverEnabled?;
    /**
     * @stability stable
     */
    get automaticFailoverEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set automaticFailoverEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAutomaticFailoverEnabled(): void;
    /**
     * @stability stable
     */
    get automaticFailoverEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _availabilityZones?;
    /**
     * @stability stable
     */
    get availabilityZones(): string[];
    /**
     * @stability stable
     */
    set availabilityZones(value: string[]);
    /**
     * @stability stable
     */
    resetAvailabilityZones(): void;
    /**
     * @stability stable
     */
    get availabilityZonesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get clusterEnabled(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get configurationEndpointAddress(): string;
    private _dataTieringEnabled?;
    /**
     * @stability stable
     */
    get dataTieringEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set dataTieringEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDataTieringEnabled(): void;
    /**
     * @stability stable
     */
    get dataTieringEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _engine?;
    /**
     * @stability stable
     */
    get engine(): string;
    /**
     * @stability stable
     */
    set engine(value: string);
    /**
     * @stability stable
     */
    resetEngine(): void;
    /**
     * @stability stable
     */
    get engineInput(): string | undefined;
    private _engineVersion?;
    /**
     * @stability stable
     */
    get engineVersion(): string;
    /**
     * @stability stable
     */
    set engineVersion(value: string);
    /**
     * @stability stable
     */
    resetEngineVersion(): void;
    /**
     * @stability stable
     */
    get engineVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get engineVersionActual(): string;
    private _finalSnapshotIdentifier?;
    /**
     * @stability stable
     */
    get finalSnapshotIdentifier(): string;
    /**
     * @stability stable
     */
    set finalSnapshotIdentifier(value: string);
    /**
     * @stability stable
     */
    resetFinalSnapshotIdentifier(): void;
    /**
     * @stability stable
     */
    get finalSnapshotIdentifierInput(): string | undefined;
    private _globalReplicationGroupId?;
    /**
     * @stability stable
     */
    get globalReplicationGroupId(): string;
    /**
     * @stability stable
     */
    set globalReplicationGroupId(value: string);
    /**
     * @stability stable
     */
    resetGlobalReplicationGroupId(): void;
    /**
     * @stability stable
     */
    get globalReplicationGroupIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    private _maintenanceWindow?;
    /**
     * @stability stable
     */
    get maintenanceWindow(): string;
    /**
     * @stability stable
     */
    set maintenanceWindow(value: string);
    /**
     * @stability stable
     */
    resetMaintenanceWindow(): void;
    /**
     * @stability stable
     */
    get maintenanceWindowInput(): string | undefined;
    /**
     * @stability stable
     */
    get memberClusters(): string[];
    private _multiAzEnabled?;
    /**
     * @stability stable
     */
    get multiAzEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set multiAzEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetMultiAzEnabled(): void;
    /**
     * @stability stable
     */
    get multiAzEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _nodeType?;
    /**
     * @stability stable
     */
    get nodeType(): string;
    /**
     * @stability stable
     */
    set nodeType(value: string);
    /**
     * @stability stable
     */
    resetNodeType(): void;
    /**
     * @stability stable
     */
    get nodeTypeInput(): string | undefined;
    private _notificationTopicArn?;
    /**
     * @stability stable
     */
    get notificationTopicArn(): string;
    /**
     * @stability stable
     */
    set notificationTopicArn(value: string);
    /**
     * @stability stable
     */
    resetNotificationTopicArn(): void;
    /**
     * @stability stable
     */
    get notificationTopicArnInput(): string | undefined;
    private _numberCacheClusters?;
    /**
     * @stability stable
     */
    get numberCacheClusters(): number;
    /**
     * @stability stable
     */
    set numberCacheClusters(value: number);
    /**
     * @stability stable
     */
    resetNumberCacheClusters(): void;
    /**
     * @stability stable
     */
    get numberCacheClustersInput(): number | undefined;
    private _parameterGroupName?;
    /**
     * @stability stable
     */
    get parameterGroupName(): string;
    /**
     * @stability stable
     */
    set parameterGroupName(value: string);
    /**
     * @stability stable
     */
    resetParameterGroupName(): void;
    /**
     * @stability stable
     */
    get parameterGroupNameInput(): string | undefined;
    private _port?;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    set port(value: number);
    /**
     * @stability stable
     */
    resetPort(): void;
    /**
     * @stability stable
     */
    get portInput(): number | undefined;
    /**
     * @stability stable
     */
    get primaryEndpointAddress(): string;
    /**
     * @stability stable
     */
    get readerEndpointAddress(): string;
    private _replicationGroupDescription?;
    /**
     * @stability stable
     */
    get replicationGroupDescription(): string;
    /**
     * @stability stable
     */
    set replicationGroupDescription(value: string);
    /**
     * @stability stable
     */
    get replicationGroupDescriptionInput(): string | undefined;
    private _replicationGroupId?;
    /**
     * @stability stable
     */
    get replicationGroupId(): string;
    /**
     * @stability stable
     */
    set replicationGroupId(value: string);
    /**
     * @stability stable
     */
    get replicationGroupIdInput(): string | undefined;
    private _securityGroupIds?;
    /**
     * @stability stable
     */
    get securityGroupIds(): string[];
    /**
     * @stability stable
     */
    set securityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get securityGroupIdsInput(): string[] | undefined;
    private _securityGroupNames?;
    /**
     * @stability stable
     */
    get securityGroupNames(): string[];
    /**
     * @stability stable
     */
    set securityGroupNames(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroupNames(): void;
    /**
     * @stability stable
     */
    get securityGroupNamesInput(): string[] | undefined;
    private _snapshotArns?;
    /**
     * @stability stable
     */
    get snapshotArns(): string[];
    /**
     * @stability stable
     */
    set snapshotArns(value: string[]);
    /**
     * @stability stable
     */
    resetSnapshotArns(): void;
    /**
     * @stability stable
     */
    get snapshotArnsInput(): string[] | undefined;
    private _snapshotName?;
    /**
     * @stability stable
     */
    get snapshotName(): string;
    /**
     * @stability stable
     */
    set snapshotName(value: string);
    /**
     * @stability stable
     */
    resetSnapshotName(): void;
    /**
     * @stability stable
     */
    get snapshotNameInput(): string | undefined;
    private _snapshotRetentionLimit?;
    /**
     * @stability stable
     */
    get snapshotRetentionLimit(): number;
    /**
     * @stability stable
     */
    set snapshotRetentionLimit(value: number);
    /**
     * @stability stable
     */
    resetSnapshotRetentionLimit(): void;
    /**
     * @stability stable
     */
    get snapshotRetentionLimitInput(): number | undefined;
    private _snapshotWindow?;
    /**
     * @stability stable
     */
    get snapshotWindow(): string;
    /**
     * @stability stable
     */
    set snapshotWindow(value: string);
    /**
     * @stability stable
     */
    resetSnapshotWindow(): void;
    /**
     * @stability stable
     */
    get snapshotWindowInput(): string | undefined;
    private _subnetGroupName?;
    /**
     * @stability stable
     */
    get subnetGroupName(): string;
    /**
     * @stability stable
     */
    set subnetGroupName(value: string);
    /**
     * @stability stable
     */
    resetSubnetGroupName(): void;
    /**
     * @stability stable
     */
    get subnetGroupNameInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _transitEncryptionEnabled?;
    /**
     * @stability stable
     */
    get transitEncryptionEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set transitEncryptionEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTransitEncryptionEnabled(): void;
    /**
     * @stability stable
     */
    get transitEncryptionEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _clusterMode;
    /**
     * @stability stable
     */
    get clusterMode(): ElasticacheReplicationGroupClusterModeOutputReference;
    /**
     * @stability stable
     */
    putClusterMode(value: ElasticacheReplicationGroupClusterMode): void;
    /**
     * @stability stable
     */
    resetClusterMode(): void;
    /**
     * @stability stable
     */
    get clusterModeInput(): ElasticacheReplicationGroupClusterMode | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): ElasticacheReplicationGroupTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: ElasticacheReplicationGroupTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): ElasticacheReplicationGroupTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
