import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Elastic Beanstalk.
 *
 * @stability stable
 */
export interface ElasticBeanstalkEnvironmentConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment#application ElasticBeanstalkEnvironment#application}.
     *
     * @stability stable
     */
    readonly application: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment#cname_prefix ElasticBeanstalkEnvironment#cname_prefix}.
     *
     * @stability stable
     */
    readonly cnamePrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment#description ElasticBeanstalkEnvironment#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment#name ElasticBeanstalkEnvironment#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment#platform_arn ElasticBeanstalkEnvironment#platform_arn}.
     *
     * @stability stable
     */
    readonly platformArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment#poll_interval ElasticBeanstalkEnvironment#poll_interval}.
     *
     * @stability stable
     */
    readonly pollInterval?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment#solution_stack_name ElasticBeanstalkEnvironment#solution_stack_name}.
     *
     * @stability stable
     */
    readonly solutionStackName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment#tags ElasticBeanstalkEnvironment#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment#tags_all ElasticBeanstalkEnvironment#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment#template_name ElasticBeanstalkEnvironment#template_name}.
     *
     * @stability stable
     */
    readonly templateName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment#tier ElasticBeanstalkEnvironment#tier}.
     *
     * @stability stable
     */
    readonly tier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment#version_label ElasticBeanstalkEnvironment#version_label}.
     *
     * @stability stable
     */
    readonly versionLabel?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment#wait_for_ready_timeout ElasticBeanstalkEnvironment#wait_for_ready_timeout}.
     *
     * @stability stable
     */
    readonly waitForReadyTimeout?: string;
    /**
     * setting block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment#setting ElasticBeanstalkEnvironment#setting}
     *
     * @stability stable
     */
    readonly setting?: ElasticBeanstalkEnvironmentSetting[] | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export declare class ElasticBeanstalkEnvironmentAllSettings extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get namespace(): string;
    /**
     * @stability stable
     */
    get resource(): string;
    /**
     * @stability stable
     */
    get value(): string;
}
/**
 * @stability stable
 */
export interface ElasticBeanstalkEnvironmentSetting {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment#name ElasticBeanstalkEnvironment#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment#namespace ElasticBeanstalkEnvironment#namespace}.
     *
     * @stability stable
     */
    readonly namespace: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment#resource ElasticBeanstalkEnvironment#resource}.
     *
     * @stability stable
     */
    readonly resource?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment#value ElasticBeanstalkEnvironment#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function elasticBeanstalkEnvironmentSettingToTerraform(struct?: ElasticBeanstalkEnvironmentSetting | cdktf.IResolvable): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment aws_elastic_beanstalk_environment}.
 *
 * @stability stable
 */
export declare class ElasticBeanstalkEnvironment extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/elastic_beanstalk_environment aws_elastic_beanstalk_environment} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ElasticBeanstalkEnvironmentConfig);
    /**
     * @stability stable
     */
    allSettings(index: string): ElasticBeanstalkEnvironmentAllSettings;
    private _application?;
    /**
     * @stability stable
     */
    get application(): string;
    /**
     * @stability stable
     */
    set application(value: string);
    /**
     * @stability stable
     */
    get applicationInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get autoscalingGroups(): string[];
    /**
     * @stability stable
     */
    get cname(): string;
    private _cnamePrefix?;
    /**
     * @stability stable
     */
    get cnamePrefix(): string;
    /**
     * @stability stable
     */
    set cnamePrefix(value: string);
    /**
     * @stability stable
     */
    resetCnamePrefix(): void;
    /**
     * @stability stable
     */
    get cnamePrefixInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get endpointUrl(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get instances(): string[];
    /**
     * @stability stable
     */
    get launchConfigurations(): string[];
    /**
     * @stability stable
     */
    get loadBalancers(): string[];
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _platformArn?;
    /**
     * @stability stable
     */
    get platformArn(): string;
    /**
     * @stability stable
     */
    set platformArn(value: string);
    /**
     * @stability stable
     */
    resetPlatformArn(): void;
    /**
     * @stability stable
     */
    get platformArnInput(): string | undefined;
    private _pollInterval?;
    /**
     * @stability stable
     */
    get pollInterval(): string;
    /**
     * @stability stable
     */
    set pollInterval(value: string);
    /**
     * @stability stable
     */
    resetPollInterval(): void;
    /**
     * @stability stable
     */
    get pollIntervalInput(): string | undefined;
    /**
     * @stability stable
     */
    get queues(): string[];
    private _solutionStackName?;
    /**
     * @stability stable
     */
    get solutionStackName(): string;
    /**
     * @stability stable
     */
    set solutionStackName(value: string);
    /**
     * @stability stable
     */
    resetSolutionStackName(): void;
    /**
     * @stability stable
     */
    get solutionStackNameInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _templateName?;
    /**
     * @stability stable
     */
    get templateName(): string;
    /**
     * @stability stable
     */
    set templateName(value: string);
    /**
     * @stability stable
     */
    resetTemplateName(): void;
    /**
     * @stability stable
     */
    get templateNameInput(): string | undefined;
    private _tier?;
    /**
     * @stability stable
     */
    get tier(): string;
    /**
     * @stability stable
     */
    set tier(value: string);
    /**
     * @stability stable
     */
    resetTier(): void;
    /**
     * @stability stable
     */
    get tierInput(): string | undefined;
    /**
     * @stability stable
     */
    get triggers(): string[];
    private _versionLabel?;
    /**
     * @stability stable
     */
    get versionLabel(): string;
    /**
     * @stability stable
     */
    set versionLabel(value: string);
    /**
     * @stability stable
     */
    resetVersionLabel(): void;
    /**
     * @stability stable
     */
    get versionLabelInput(): string | undefined;
    private _waitForReadyTimeout?;
    /**
     * @stability stable
     */
    get waitForReadyTimeout(): string;
    /**
     * @stability stable
     */
    set waitForReadyTimeout(value: string);
    /**
     * @stability stable
     */
    resetWaitForReadyTimeout(): void;
    /**
     * @stability stable
     */
    get waitForReadyTimeoutInput(): string | undefined;
    private _setting?;
    /**
     * @stability stable
     */
    get setting(): ElasticBeanstalkEnvironmentSetting[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set setting(value: ElasticBeanstalkEnvironmentSetting[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSetting(): void;
    /**
     * @stability stable
     */
    get settingInput(): cdktf.IResolvable | ElasticBeanstalkEnvironmentSetting[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
