import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS ElasticSearch Service.
 *
 * @stability stable
 */
export interface DataAwsElasticsearchDomainConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/elasticsearch_domain#domain_name DataAwsElasticsearchDomain#domain_name}.
     *
     * @stability stable
     */
    readonly domainName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/elasticsearch_domain#tags DataAwsElasticsearchDomain#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataAwsElasticsearchDomainAdvancedSecurityOptions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get enabled(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get internalUserDatabaseEnabled(): cdktf.IResolvable;
}
/**
 * @stability stable
 */
export declare class DataAwsElasticsearchDomainAutoTuneOptionsMaintenanceScheduleDuration extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    get value(): number;
}
/**
 * @stability stable
 */
export declare class DataAwsElasticsearchDomainAutoTuneOptionsMaintenanceSchedule extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get cronExpressionForRecurrence(): string;
    /**
     * @stability stable
     */
    get duration(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get startAt(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsElasticsearchDomainAutoTuneOptions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get desiredState(): string;
    /**
     * @stability stable
     */
    get maintenanceSchedule(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get rollbackOnDisable(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsElasticsearchDomainClusterConfigZoneAwarenessConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get availabilityZoneCount(): number;
}
/**
 * @stability stable
 */
export declare class DataAwsElasticsearchDomainClusterConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get dedicatedMasterCount(): number;
    /**
     * @stability stable
     */
    get dedicatedMasterEnabled(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get dedicatedMasterType(): string;
    /**
     * @stability stable
     */
    get instanceCount(): number;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    get warmCount(): number;
    /**
     * @stability stable
     */
    get warmEnabled(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get warmType(): string;
    /**
     * @stability stable
     */
    get zoneAwarenessConfig(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get zoneAwarenessEnabled(): cdktf.IResolvable;
}
/**
 * @stability stable
 */
export declare class DataAwsElasticsearchDomainCognitoOptions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get enabled(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get identityPoolId(): string;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    get userPoolId(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsElasticsearchDomainEbsOptions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get ebsEnabled(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get iops(): number;
    /**
     * @stability stable
     */
    get volumeSize(): number;
    /**
     * @stability stable
     */
    get volumeType(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsElasticsearchDomainEncryptionAtRest extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get enabled(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsElasticsearchDomainLogPublishingOptions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get cloudwatchLogGroupArn(): string;
    /**
     * @stability stable
     */
    get enabled(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get logType(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsElasticsearchDomainNodeToNodeEncryption extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get enabled(): cdktf.IResolvable;
}
/**
 * @stability stable
 */
export declare class DataAwsElasticsearchDomainSnapshotOptions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get automatedSnapshotStartHour(): number;
}
/**
 * @stability stable
 */
export declare class DataAwsElasticsearchDomainVpcOptions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get availabilityZones(): string[];
    /**
     * @stability stable
     */
    get securityGroupIds(): string[];
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    get vpcId(): string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/elasticsearch_domain aws_elasticsearch_domain}.
 *
 * @stability stable
 */
export declare class DataAwsElasticsearchDomain extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/elasticsearch_domain aws_elasticsearch_domain} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsElasticsearchDomainConfig);
    /**
     * @stability stable
     */
    get accessPolicies(): string;
    /**
     * @stability stable
     */
    advancedOptions(key: string): string | cdktf.IResolvable;
    /**
     * @stability stable
     */
    advancedSecurityOptions(index: string): DataAwsElasticsearchDomainAdvancedSecurityOptions;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    autoTuneOptions(index: string): DataAwsElasticsearchDomainAutoTuneOptions;
    /**
     * @stability stable
     */
    clusterConfig(index: string): DataAwsElasticsearchDomainClusterConfig;
    /**
     * @stability stable
     */
    cognitoOptions(index: string): DataAwsElasticsearchDomainCognitoOptions;
    /**
     * @stability stable
     */
    get created(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get deleted(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get domainId(): string;
    private _domainName?;
    /**
     * @stability stable
     */
    get domainName(): string;
    /**
     * @stability stable
     */
    set domainName(value: string);
    /**
     * @stability stable
     */
    get domainNameInput(): string | undefined;
    /**
     * @stability stable
     */
    ebsOptions(index: string): DataAwsElasticsearchDomainEbsOptions;
    /**
     * @stability stable
     */
    get elasticsearchVersion(): string;
    /**
     * @stability stable
     */
    encryptionAtRest(index: string): DataAwsElasticsearchDomainEncryptionAtRest;
    /**
     * @stability stable
     */
    get endpoint(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get kibanaEndpoint(): string;
    /**
     * @stability stable
     */
    logPublishingOptions(index: string): DataAwsElasticsearchDomainLogPublishingOptions;
    /**
     * @stability stable
     */
    nodeToNodeEncryption(index: string): DataAwsElasticsearchDomainNodeToNodeEncryption;
    /**
     * @stability stable
     */
    get processing(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    snapshotOptions(index: string): DataAwsElasticsearchDomainSnapshotOptions;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    vpcOptions(index: string): DataAwsElasticsearchDomainVpcOptions;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
