import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Elastic Load Balancer.
 *
 * @stability stable
 */
export interface DataAwsAlbListenerConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/alb_listener#load_balancer_arn DataAwsAlbListener#load_balancer_arn}.
     *
     * @stability stable
     */
    readonly loadBalancerArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/alb_listener#port DataAwsAlbListener#port}.
     *
     * @stability stable
     */
    readonly port?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/alb_listener#tags DataAwsAlbListener#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataAwsAlbListenerDefaultActionAuthenticateCognito extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get authenticationRequestExtraParams(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    get onUnauthenticatedRequest(): string;
    /**
     * @stability stable
     */
    get scope(): string;
    /**
     * @stability stable
     */
    get sessionCookieName(): string;
    /**
     * @stability stable
     */
    get sessionTimeout(): number;
    /**
     * @stability stable
     */
    get userPoolArn(): string;
    /**
     * @stability stable
     */
    get userPoolClientId(): string;
    /**
     * @stability stable
     */
    get userPoolDomain(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsAlbListenerDefaultActionAuthenticateOidc extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get authenticationRequestExtraParams(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    get authorizationEndpoint(): string;
    /**
     * @stability stable
     */
    get clientId(): string;
    /**
     * @stability stable
     */
    get clientSecret(): string;
    /**
     * @stability stable
     */
    get issuer(): string;
    /**
     * @stability stable
     */
    get onUnauthenticatedRequest(): string;
    /**
     * @stability stable
     */
    get scope(): string;
    /**
     * @stability stable
     */
    get sessionCookieName(): string;
    /**
     * @stability stable
     */
    get sessionTimeout(): number;
    /**
     * @stability stable
     */
    get tokenEndpoint(): string;
    /**
     * @stability stable
     */
    get userInfoEndpoint(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsAlbListenerDefaultActionFixedResponse extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get contentType(): string;
    /**
     * @stability stable
     */
    get messageBody(): string;
    /**
     * @stability stable
     */
    get statusCode(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsAlbListenerDefaultActionForwardStickiness extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get duration(): number;
    /**
     * @stability stable
     */
    get enabled(): cdktf.IResolvable;
}
/**
 * @stability stable
 */
export declare class DataAwsAlbListenerDefaultActionForwardTargetGroup extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get weight(): number;
}
/**
 * @stability stable
 */
export declare class DataAwsAlbListenerDefaultActionForward extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get stickiness(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get targetGroup(): cdktf.IResolvable;
}
/**
 * @stability stable
 */
export declare class DataAwsAlbListenerDefaultActionRedirect extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get host(): string;
    /**
     * @stability stable
     */
    get path(): string;
    /**
     * @stability stable
     */
    get port(): string;
    /**
     * @stability stable
     */
    get protocol(): string;
    /**
     * @stability stable
     */
    get query(): string;
    /**
     * @stability stable
     */
    get statusCode(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsAlbListenerDefaultAction extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get authenticateCognito(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get authenticateOidc(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get fixedResponse(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get forward(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get order(): number;
    /**
     * @stability stable
     */
    get redirect(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get targetGroupArn(): string;
    /**
     * @stability stable
     */
    get type(): string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/alb_listener aws_alb_listener}.
 *
 * @stability stable
 */
export declare class DataAwsAlbListener extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/alb_listener aws_alb_listener} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsAlbListenerConfig);
    /**
     * @stability stable
     */
    get alpnPolicy(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get certificateArn(): string;
    /**
     * @stability stable
     */
    defaultAction(index: string): DataAwsAlbListenerDefaultAction;
    /**
     * @stability stable
     */
    get id(): string;
    private _loadBalancerArn?;
    /**
     * @stability stable
     */
    get loadBalancerArn(): string;
    /**
     * @stability stable
     */
    set loadBalancerArn(value: string);
    /**
     * @stability stable
     */
    resetLoadBalancerArn(): void;
    /**
     * @stability stable
     */
    get loadBalancerArnInput(): string | undefined;
    private _port?;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    set port(value: number);
    /**
     * @stability stable
     */
    resetPort(): void;
    /**
     * @stability stable
     */
    get portInput(): number | undefined;
    /**
     * @stability stable
     */
    get protocol(): string;
    /**
     * @stability stable
     */
    get sslPolicy(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
