import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Elastic MapReduce.
 *
 * @stability stable
 */
export interface EmrClusterConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#additional_info EmrCluster#additional_info}.
     *
     * @stability stable
     */
    readonly additionalInfo?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#applications EmrCluster#applications}.
     *
     * @stability stable
     */
    readonly applications?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#autoscaling_role EmrCluster#autoscaling_role}.
     *
     * @stability stable
     */
    readonly autoscalingRole?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#configurations EmrCluster#configurations}.
     *
     * @stability stable
     */
    readonly configurations?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#configurations_json EmrCluster#configurations_json}.
     *
     * @stability stable
     */
    readonly configurationsJson?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#custom_ami_id EmrCluster#custom_ami_id}.
     *
     * @stability stable
     */
    readonly customAmiId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#ebs_root_volume_size EmrCluster#ebs_root_volume_size}.
     *
     * @stability stable
     */
    readonly ebsRootVolumeSize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#keep_job_flow_alive_when_no_steps EmrCluster#keep_job_flow_alive_when_no_steps}.
     *
     * @stability stable
     */
    readonly keepJobFlowAliveWhenNoSteps?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#log_encryption_kms_key_id EmrCluster#log_encryption_kms_key_id}.
     *
     * @stability stable
     */
    readonly logEncryptionKmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#log_uri EmrCluster#log_uri}.
     *
     * @stability stable
     */
    readonly logUri?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#name EmrCluster#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#release_label EmrCluster#release_label}.
     *
     * @stability stable
     */
    readonly releaseLabel: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#scale_down_behavior EmrCluster#scale_down_behavior}.
     *
     * @stability stable
     */
    readonly scaleDownBehavior?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#security_configuration EmrCluster#security_configuration}.
     *
     * @stability stable
     */
    readonly securityConfiguration?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#service_role EmrCluster#service_role}.
     *
     * @stability stable
     */
    readonly serviceRole: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#step EmrCluster#step}.
     *
     * @stability stable
     */
    readonly step?: EmrClusterStep[] | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#step_concurrency_level EmrCluster#step_concurrency_level}.
     *
     * @stability stable
     */
    readonly stepConcurrencyLevel?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#tags EmrCluster#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#tags_all EmrCluster#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#termination_protection EmrCluster#termination_protection}.
     *
     * @stability stable
     */
    readonly terminationProtection?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#visible_to_all_users EmrCluster#visible_to_all_users}.
     *
     * @stability stable
     */
    readonly visibleToAllUsers?: boolean | cdktf.IResolvable;
    /**
     * auto_termination_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#auto_termination_policy EmrCluster#auto_termination_policy}
     *
     * @stability stable
     */
    readonly autoTerminationPolicy?: EmrClusterAutoTerminationPolicy;
    /**
     * bootstrap_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#bootstrap_action EmrCluster#bootstrap_action}
     *
     * @stability stable
     */
    readonly bootstrapAction?: EmrClusterBootstrapAction[] | cdktf.IResolvable;
    /**
     * core_instance_fleet block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#core_instance_fleet EmrCluster#core_instance_fleet}
     *
     * @stability stable
     */
    readonly coreInstanceFleet?: EmrClusterCoreInstanceFleet;
    /**
     * core_instance_group block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#core_instance_group EmrCluster#core_instance_group}
     *
     * @stability stable
     */
    readonly coreInstanceGroup?: EmrClusterCoreInstanceGroup;
    /**
     * ec2_attributes block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#ec2_attributes EmrCluster#ec2_attributes}
     *
     * @stability stable
     */
    readonly ec2Attributes?: EmrClusterEc2Attributes;
    /**
     * kerberos_attributes block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#kerberos_attributes EmrCluster#kerberos_attributes}
     *
     * @stability stable
     */
    readonly kerberosAttributes?: EmrClusterKerberosAttributes;
    /**
     * master_instance_fleet block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#master_instance_fleet EmrCluster#master_instance_fleet}
     *
     * @stability stable
     */
    readonly masterInstanceFleet?: EmrClusterMasterInstanceFleet;
    /**
     * master_instance_group block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#master_instance_group EmrCluster#master_instance_group}
     *
     * @stability stable
     */
    readonly masterInstanceGroup?: EmrClusterMasterInstanceGroup;
}
/**
 * @stability stable
 */
export interface EmrClusterStepHadoopJarStep {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#args EmrCluster#args}.
     *
     * @stability stable
     */
    readonly args?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#jar EmrCluster#jar}.
     *
     * @stability stable
     */
    readonly jar?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#main_class EmrCluster#main_class}.
     *
     * @stability stable
     */
    readonly mainClass?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#properties EmrCluster#properties}.
     *
     * @stability stable
     */
    readonly properties?: {
        [key: string]: string;
    };
}
export declare function emrClusterStepHadoopJarStepToTerraform(struct?: EmrClusterStepHadoopJarStep | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface EmrClusterStep {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#action_on_failure EmrCluster#action_on_failure}.
     *
     * @stability stable
     */
    readonly actionOnFailure?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#hadoop_jar_step EmrCluster#hadoop_jar_step}.
     *
     * @stability stable
     */
    readonly hadoopJarStep?: EmrClusterStepHadoopJarStep[] | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#name EmrCluster#name}.
     *
     * @stability stable
     */
    readonly name?: string;
}
export declare function emrClusterStepToTerraform(struct?: EmrClusterStep | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface EmrClusterAutoTerminationPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#idle_timeout EmrCluster#idle_timeout}.
     *
     * @stability stable
     */
    readonly idleTimeout?: number;
}
export declare function emrClusterAutoTerminationPolicyToTerraform(struct?: EmrClusterAutoTerminationPolicyOutputReference | EmrClusterAutoTerminationPolicy): any;
/**
 * @stability stable
 */
export declare class EmrClusterAutoTerminationPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): EmrClusterAutoTerminationPolicy | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: EmrClusterAutoTerminationPolicy | undefined);
    private _idleTimeout?;
    /**
     * @stability stable
     */
    get idleTimeout(): number;
    /**
     * @stability stable
     */
    set idleTimeout(value: number);
    /**
     * @stability stable
     */
    resetIdleTimeout(): void;
    /**
     * @stability stable
     */
    get idleTimeoutInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface EmrClusterBootstrapAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#args EmrCluster#args}.
     *
     * @stability stable
     */
    readonly args?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#name EmrCluster#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#path EmrCluster#path}.
     *
     * @stability stable
     */
    readonly path: string;
}
export declare function emrClusterBootstrapActionToTerraform(struct?: EmrClusterBootstrapAction | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceFleetInstanceTypeConfigsConfigurations {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#classification EmrCluster#classification}.
     *
     * @stability stable
     */
    readonly classification?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#properties EmrCluster#properties}.
     *
     * @stability stable
     */
    readonly properties?: {
        [key: string]: string;
    };
}
export declare function emrClusterCoreInstanceFleetInstanceTypeConfigsConfigurationsToTerraform(struct?: EmrClusterCoreInstanceFleetInstanceTypeConfigsConfigurations | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceFleetInstanceTypeConfigsEbsConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#iops EmrCluster#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#size EmrCluster#size}.
     *
     * @stability stable
     */
    readonly size: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#type EmrCluster#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#volumes_per_instance EmrCluster#volumes_per_instance}.
     *
     * @stability stable
     */
    readonly volumesPerInstance?: number;
}
export declare function emrClusterCoreInstanceFleetInstanceTypeConfigsEbsConfigToTerraform(struct?: EmrClusterCoreInstanceFleetInstanceTypeConfigsEbsConfig | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceFleetInstanceTypeConfigs {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#bid_price EmrCluster#bid_price}.
     *
     * @stability stable
     */
    readonly bidPrice?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#bid_price_as_percentage_of_on_demand_price EmrCluster#bid_price_as_percentage_of_on_demand_price}.
     *
     * @stability stable
     */
    readonly bidPriceAsPercentageOfOnDemandPrice?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#instance_type EmrCluster#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#weighted_capacity EmrCluster#weighted_capacity}.
     *
     * @stability stable
     */
    readonly weightedCapacity?: number;
    /**
     * configurations block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#configurations EmrCluster#configurations}
     *
     * @stability stable
     */
    readonly configurations?: EmrClusterCoreInstanceFleetInstanceTypeConfigsConfigurations[] | cdktf.IResolvable;
    /**
     * ebs_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#ebs_config EmrCluster#ebs_config}
     *
     * @stability stable
     */
    readonly ebsConfig?: EmrClusterCoreInstanceFleetInstanceTypeConfigsEbsConfig[] | cdktf.IResolvable;
}
export declare function emrClusterCoreInstanceFleetInstanceTypeConfigsToTerraform(struct?: EmrClusterCoreInstanceFleetInstanceTypeConfigs | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceFleetLaunchSpecificationsOnDemandSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#allocation_strategy EmrCluster#allocation_strategy}.
     *
     * @stability stable
     */
    readonly allocationStrategy: string;
}
export declare function emrClusterCoreInstanceFleetLaunchSpecificationsOnDemandSpecificationToTerraform(struct?: EmrClusterCoreInstanceFleetLaunchSpecificationsOnDemandSpecification | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceFleetLaunchSpecificationsSpotSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#allocation_strategy EmrCluster#allocation_strategy}.
     *
     * @stability stable
     */
    readonly allocationStrategy: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#block_duration_minutes EmrCluster#block_duration_minutes}.
     *
     * @stability stable
     */
    readonly blockDurationMinutes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#timeout_action EmrCluster#timeout_action}.
     *
     * @stability stable
     */
    readonly timeoutAction: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#timeout_duration_minutes EmrCluster#timeout_duration_minutes}.
     *
     * @stability stable
     */
    readonly timeoutDurationMinutes: number;
}
export declare function emrClusterCoreInstanceFleetLaunchSpecificationsSpotSpecificationToTerraform(struct?: EmrClusterCoreInstanceFleetLaunchSpecificationsSpotSpecification | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceFleetLaunchSpecifications {
    /**
     * on_demand_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#on_demand_specification EmrCluster#on_demand_specification}
     *
     * @stability stable
     */
    readonly onDemandSpecification?: EmrClusterCoreInstanceFleetLaunchSpecificationsOnDemandSpecification[] | cdktf.IResolvable;
    /**
     * spot_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#spot_specification EmrCluster#spot_specification}
     *
     * @stability stable
     */
    readonly spotSpecification?: EmrClusterCoreInstanceFleetLaunchSpecificationsSpotSpecification[] | cdktf.IResolvable;
}
export declare function emrClusterCoreInstanceFleetLaunchSpecificationsToTerraform(struct?: EmrClusterCoreInstanceFleetLaunchSpecificationsOutputReference | EmrClusterCoreInstanceFleetLaunchSpecifications): any;
/**
 * @stability stable
 */
export declare class EmrClusterCoreInstanceFleetLaunchSpecificationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): EmrClusterCoreInstanceFleetLaunchSpecifications | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: EmrClusterCoreInstanceFleetLaunchSpecifications | undefined);
    private _onDemandSpecification?;
    /**
     * @stability stable
     */
    get onDemandSpecification(): EmrClusterCoreInstanceFleetLaunchSpecificationsOnDemandSpecification[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set onDemandSpecification(value: EmrClusterCoreInstanceFleetLaunchSpecificationsOnDemandSpecification[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetOnDemandSpecification(): void;
    /**
     * @stability stable
     */
    get onDemandSpecificationInput(): cdktf.IResolvable | EmrClusterCoreInstanceFleetLaunchSpecificationsOnDemandSpecification[] | undefined;
    private _spotSpecification?;
    /**
     * @stability stable
     */
    get spotSpecification(): EmrClusterCoreInstanceFleetLaunchSpecificationsSpotSpecification[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set spotSpecification(value: EmrClusterCoreInstanceFleetLaunchSpecificationsSpotSpecification[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSpotSpecification(): void;
    /**
     * @stability stable
     */
    get spotSpecificationInput(): cdktf.IResolvable | EmrClusterCoreInstanceFleetLaunchSpecificationsSpotSpecification[] | undefined;
}
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceFleet {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#name EmrCluster#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#target_on_demand_capacity EmrCluster#target_on_demand_capacity}.
     *
     * @stability stable
     */
    readonly targetOnDemandCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#target_spot_capacity EmrCluster#target_spot_capacity}.
     *
     * @stability stable
     */
    readonly targetSpotCapacity?: number;
    /**
     * instance_type_configs block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#instance_type_configs EmrCluster#instance_type_configs}
     *
     * @stability stable
     */
    readonly instanceTypeConfigs?: EmrClusterCoreInstanceFleetInstanceTypeConfigs[] | cdktf.IResolvable;
    /**
     * launch_specifications block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#launch_specifications EmrCluster#launch_specifications}
     *
     * @stability stable
     */
    readonly launchSpecifications?: EmrClusterCoreInstanceFleetLaunchSpecifications;
}
export declare function emrClusterCoreInstanceFleetToTerraform(struct?: EmrClusterCoreInstanceFleetOutputReference | EmrClusterCoreInstanceFleet): any;
/**
 * @stability stable
 */
export declare class EmrClusterCoreInstanceFleetOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): EmrClusterCoreInstanceFleet | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: EmrClusterCoreInstanceFleet | undefined);
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get provisionedOnDemandCapacity(): number;
    /**
     * @stability stable
     */
    get provisionedSpotCapacity(): number;
    private _targetOnDemandCapacity?;
    /**
     * @stability stable
     */
    get targetOnDemandCapacity(): number;
    /**
     * @stability stable
     */
    set targetOnDemandCapacity(value: number);
    /**
     * @stability stable
     */
    resetTargetOnDemandCapacity(): void;
    /**
     * @stability stable
     */
    get targetOnDemandCapacityInput(): number | undefined;
    private _targetSpotCapacity?;
    /**
     * @stability stable
     */
    get targetSpotCapacity(): number;
    /**
     * @stability stable
     */
    set targetSpotCapacity(value: number);
    /**
     * @stability stable
     */
    resetTargetSpotCapacity(): void;
    /**
     * @stability stable
     */
    get targetSpotCapacityInput(): number | undefined;
    private _instanceTypeConfigs?;
    /**
     * @stability stable
     */
    get instanceTypeConfigs(): EmrClusterCoreInstanceFleetInstanceTypeConfigs[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set instanceTypeConfigs(value: EmrClusterCoreInstanceFleetInstanceTypeConfigs[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetInstanceTypeConfigs(): void;
    /**
     * @stability stable
     */
    get instanceTypeConfigsInput(): cdktf.IResolvable | EmrClusterCoreInstanceFleetInstanceTypeConfigs[] | undefined;
    private _launchSpecifications;
    /**
     * @stability stable
     */
    get launchSpecifications(): EmrClusterCoreInstanceFleetLaunchSpecificationsOutputReference;
    /**
     * @stability stable
     */
    putLaunchSpecifications(value: EmrClusterCoreInstanceFleetLaunchSpecifications): void;
    /**
     * @stability stable
     */
    resetLaunchSpecifications(): void;
    /**
     * @stability stable
     */
    get launchSpecificationsInput(): EmrClusterCoreInstanceFleetLaunchSpecifications | undefined;
}
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceGroupEbsConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#iops EmrCluster#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#size EmrCluster#size}.
     *
     * @stability stable
     */
    readonly size: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#type EmrCluster#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#volumes_per_instance EmrCluster#volumes_per_instance}.
     *
     * @stability stable
     */
    readonly volumesPerInstance?: number;
}
export declare function emrClusterCoreInstanceGroupEbsConfigToTerraform(struct?: EmrClusterCoreInstanceGroupEbsConfig | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceGroup {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#autoscaling_policy EmrCluster#autoscaling_policy}.
     *
     * @stability stable
     */
    readonly autoscalingPolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#bid_price EmrCluster#bid_price}.
     *
     * @stability stable
     */
    readonly bidPrice?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#instance_count EmrCluster#instance_count}.
     *
     * @stability stable
     */
    readonly instanceCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#instance_type EmrCluster#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#name EmrCluster#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * ebs_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#ebs_config EmrCluster#ebs_config}
     *
     * @stability stable
     */
    readonly ebsConfig?: EmrClusterCoreInstanceGroupEbsConfig[] | cdktf.IResolvable;
}
export declare function emrClusterCoreInstanceGroupToTerraform(struct?: EmrClusterCoreInstanceGroupOutputReference | EmrClusterCoreInstanceGroup): any;
/**
 * @stability stable
 */
export declare class EmrClusterCoreInstanceGroupOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): EmrClusterCoreInstanceGroup | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: EmrClusterCoreInstanceGroup | undefined);
    private _autoscalingPolicy?;
    /**
     * @stability stable
     */
    get autoscalingPolicy(): string;
    /**
     * @stability stable
     */
    set autoscalingPolicy(value: string);
    /**
     * @stability stable
     */
    resetAutoscalingPolicy(): void;
    /**
     * @stability stable
     */
    get autoscalingPolicyInput(): string | undefined;
    private _bidPrice?;
    /**
     * @stability stable
     */
    get bidPrice(): string;
    /**
     * @stability stable
     */
    set bidPrice(value: string);
    /**
     * @stability stable
     */
    resetBidPrice(): void;
    /**
     * @stability stable
     */
    get bidPriceInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceCount?;
    /**
     * @stability stable
     */
    get instanceCount(): number;
    /**
     * @stability stable
     */
    set instanceCount(value: number);
    /**
     * @stability stable
     */
    resetInstanceCount(): void;
    /**
     * @stability stable
     */
    get instanceCountInput(): number | undefined;
    private _instanceType?;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    set instanceType(value: string);
    /**
     * @stability stable
     */
    get instanceTypeInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _ebsConfig?;
    /**
     * @stability stable
     */
    get ebsConfig(): EmrClusterCoreInstanceGroupEbsConfig[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set ebsConfig(value: EmrClusterCoreInstanceGroupEbsConfig[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEbsConfig(): void;
    /**
     * @stability stable
     */
    get ebsConfigInput(): cdktf.IResolvable | EmrClusterCoreInstanceGroupEbsConfig[] | undefined;
}
/**
 * @stability stable
 */
export interface EmrClusterEc2Attributes {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#additional_master_security_groups EmrCluster#additional_master_security_groups}.
     *
     * @stability stable
     */
    readonly additionalMasterSecurityGroups?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#additional_slave_security_groups EmrCluster#additional_slave_security_groups}.
     *
     * @stability stable
     */
    readonly additionalSlaveSecurityGroups?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#emr_managed_master_security_group EmrCluster#emr_managed_master_security_group}.
     *
     * @stability stable
     */
    readonly emrManagedMasterSecurityGroup?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#emr_managed_slave_security_group EmrCluster#emr_managed_slave_security_group}.
     *
     * @stability stable
     */
    readonly emrManagedSlaveSecurityGroup?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#instance_profile EmrCluster#instance_profile}.
     *
     * @stability stable
     */
    readonly instanceProfile: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#key_name EmrCluster#key_name}.
     *
     * @stability stable
     */
    readonly keyName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#service_access_security_group EmrCluster#service_access_security_group}.
     *
     * @stability stable
     */
    readonly serviceAccessSecurityGroup?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#subnet_id EmrCluster#subnet_id}.
     *
     * @stability stable
     */
    readonly subnetId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#subnet_ids EmrCluster#subnet_ids}.
     *
     * @stability stable
     */
    readonly subnetIds?: string[];
}
export declare function emrClusterEc2AttributesToTerraform(struct?: EmrClusterEc2AttributesOutputReference | EmrClusterEc2Attributes): any;
/**
 * @stability stable
 */
export declare class EmrClusterEc2AttributesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): EmrClusterEc2Attributes | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: EmrClusterEc2Attributes | undefined);
    private _additionalMasterSecurityGroups?;
    /**
     * @stability stable
     */
    get additionalMasterSecurityGroups(): string;
    /**
     * @stability stable
     */
    set additionalMasterSecurityGroups(value: string);
    /**
     * @stability stable
     */
    resetAdditionalMasterSecurityGroups(): void;
    /**
     * @stability stable
     */
    get additionalMasterSecurityGroupsInput(): string | undefined;
    private _additionalSlaveSecurityGroups?;
    /**
     * @stability stable
     */
    get additionalSlaveSecurityGroups(): string;
    /**
     * @stability stable
     */
    set additionalSlaveSecurityGroups(value: string);
    /**
     * @stability stable
     */
    resetAdditionalSlaveSecurityGroups(): void;
    /**
     * @stability stable
     */
    get additionalSlaveSecurityGroupsInput(): string | undefined;
    private _emrManagedMasterSecurityGroup?;
    /**
     * @stability stable
     */
    get emrManagedMasterSecurityGroup(): string;
    /**
     * @stability stable
     */
    set emrManagedMasterSecurityGroup(value: string);
    /**
     * @stability stable
     */
    resetEmrManagedMasterSecurityGroup(): void;
    /**
     * @stability stable
     */
    get emrManagedMasterSecurityGroupInput(): string | undefined;
    private _emrManagedSlaveSecurityGroup?;
    /**
     * @stability stable
     */
    get emrManagedSlaveSecurityGroup(): string;
    /**
     * @stability stable
     */
    set emrManagedSlaveSecurityGroup(value: string);
    /**
     * @stability stable
     */
    resetEmrManagedSlaveSecurityGroup(): void;
    /**
     * @stability stable
     */
    get emrManagedSlaveSecurityGroupInput(): string | undefined;
    private _instanceProfile?;
    /**
     * @stability stable
     */
    get instanceProfile(): string;
    /**
     * @stability stable
     */
    set instanceProfile(value: string);
    /**
     * @stability stable
     */
    get instanceProfileInput(): string | undefined;
    private _keyName?;
    /**
     * @stability stable
     */
    get keyName(): string;
    /**
     * @stability stable
     */
    set keyName(value: string);
    /**
     * @stability stable
     */
    resetKeyName(): void;
    /**
     * @stability stable
     */
    get keyNameInput(): string | undefined;
    private _serviceAccessSecurityGroup?;
    /**
     * @stability stable
     */
    get serviceAccessSecurityGroup(): string;
    /**
     * @stability stable
     */
    set serviceAccessSecurityGroup(value: string);
    /**
     * @stability stable
     */
    resetServiceAccessSecurityGroup(): void;
    /**
     * @stability stable
     */
    get serviceAccessSecurityGroupInput(): string | undefined;
    private _subnetId?;
    /**
     * @stability stable
     */
    get subnetId(): string;
    /**
     * @stability stable
     */
    set subnetId(value: string);
    /**
     * @stability stable
     */
    resetSubnetId(): void;
    /**
     * @stability stable
     */
    get subnetIdInput(): string | undefined;
    private _subnetIds?;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    set subnetIds(value: string[]);
    /**
     * @stability stable
     */
    resetSubnetIds(): void;
    /**
     * @stability stable
     */
    get subnetIdsInput(): string[] | undefined;
}
/**
 * @stability stable
 */
export interface EmrClusterKerberosAttributes {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#ad_domain_join_password EmrCluster#ad_domain_join_password}.
     *
     * @stability stable
     */
    readonly adDomainJoinPassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#ad_domain_join_user EmrCluster#ad_domain_join_user}.
     *
     * @stability stable
     */
    readonly adDomainJoinUser?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#cross_realm_trust_principal_password EmrCluster#cross_realm_trust_principal_password}.
     *
     * @stability stable
     */
    readonly crossRealmTrustPrincipalPassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#kdc_admin_password EmrCluster#kdc_admin_password}.
     *
     * @stability stable
     */
    readonly kdcAdminPassword: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#realm EmrCluster#realm}.
     *
     * @stability stable
     */
    readonly realm: string;
}
export declare function emrClusterKerberosAttributesToTerraform(struct?: EmrClusterKerberosAttributesOutputReference | EmrClusterKerberosAttributes): any;
/**
 * @stability stable
 */
export declare class EmrClusterKerberosAttributesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): EmrClusterKerberosAttributes | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: EmrClusterKerberosAttributes | undefined);
    private _adDomainJoinPassword?;
    /**
     * @stability stable
     */
    get adDomainJoinPassword(): string;
    /**
     * @stability stable
     */
    set adDomainJoinPassword(value: string);
    /**
     * @stability stable
     */
    resetAdDomainJoinPassword(): void;
    /**
     * @stability stable
     */
    get adDomainJoinPasswordInput(): string | undefined;
    private _adDomainJoinUser?;
    /**
     * @stability stable
     */
    get adDomainJoinUser(): string;
    /**
     * @stability stable
     */
    set adDomainJoinUser(value: string);
    /**
     * @stability stable
     */
    resetAdDomainJoinUser(): void;
    /**
     * @stability stable
     */
    get adDomainJoinUserInput(): string | undefined;
    private _crossRealmTrustPrincipalPassword?;
    /**
     * @stability stable
     */
    get crossRealmTrustPrincipalPassword(): string;
    /**
     * @stability stable
     */
    set crossRealmTrustPrincipalPassword(value: string);
    /**
     * @stability stable
     */
    resetCrossRealmTrustPrincipalPassword(): void;
    /**
     * @stability stable
     */
    get crossRealmTrustPrincipalPasswordInput(): string | undefined;
    private _kdcAdminPassword?;
    /**
     * @stability stable
     */
    get kdcAdminPassword(): string;
    /**
     * @stability stable
     */
    set kdcAdminPassword(value: string);
    /**
     * @stability stable
     */
    get kdcAdminPasswordInput(): string | undefined;
    private _realm?;
    /**
     * @stability stable
     */
    get realm(): string;
    /**
     * @stability stable
     */
    set realm(value: string);
    /**
     * @stability stable
     */
    get realmInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceFleetInstanceTypeConfigsConfigurations {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#classification EmrCluster#classification}.
     *
     * @stability stable
     */
    readonly classification?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#properties EmrCluster#properties}.
     *
     * @stability stable
     */
    readonly properties?: {
        [key: string]: string;
    };
}
export declare function emrClusterMasterInstanceFleetInstanceTypeConfigsConfigurationsToTerraform(struct?: EmrClusterMasterInstanceFleetInstanceTypeConfigsConfigurations | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceFleetInstanceTypeConfigsEbsConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#iops EmrCluster#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#size EmrCluster#size}.
     *
     * @stability stable
     */
    readonly size: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#type EmrCluster#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#volumes_per_instance EmrCluster#volumes_per_instance}.
     *
     * @stability stable
     */
    readonly volumesPerInstance?: number;
}
export declare function emrClusterMasterInstanceFleetInstanceTypeConfigsEbsConfigToTerraform(struct?: EmrClusterMasterInstanceFleetInstanceTypeConfigsEbsConfig | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceFleetInstanceTypeConfigs {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#bid_price EmrCluster#bid_price}.
     *
     * @stability stable
     */
    readonly bidPrice?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#bid_price_as_percentage_of_on_demand_price EmrCluster#bid_price_as_percentage_of_on_demand_price}.
     *
     * @stability stable
     */
    readonly bidPriceAsPercentageOfOnDemandPrice?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#instance_type EmrCluster#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#weighted_capacity EmrCluster#weighted_capacity}.
     *
     * @stability stable
     */
    readonly weightedCapacity?: number;
    /**
     * configurations block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#configurations EmrCluster#configurations}
     *
     * @stability stable
     */
    readonly configurations?: EmrClusterMasterInstanceFleetInstanceTypeConfigsConfigurations[] | cdktf.IResolvable;
    /**
     * ebs_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#ebs_config EmrCluster#ebs_config}
     *
     * @stability stable
     */
    readonly ebsConfig?: EmrClusterMasterInstanceFleetInstanceTypeConfigsEbsConfig[] | cdktf.IResolvable;
}
export declare function emrClusterMasterInstanceFleetInstanceTypeConfigsToTerraform(struct?: EmrClusterMasterInstanceFleetInstanceTypeConfigs | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceFleetLaunchSpecificationsOnDemandSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#allocation_strategy EmrCluster#allocation_strategy}.
     *
     * @stability stable
     */
    readonly allocationStrategy: string;
}
export declare function emrClusterMasterInstanceFleetLaunchSpecificationsOnDemandSpecificationToTerraform(struct?: EmrClusterMasterInstanceFleetLaunchSpecificationsOnDemandSpecification | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceFleetLaunchSpecificationsSpotSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#allocation_strategy EmrCluster#allocation_strategy}.
     *
     * @stability stable
     */
    readonly allocationStrategy: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#block_duration_minutes EmrCluster#block_duration_minutes}.
     *
     * @stability stable
     */
    readonly blockDurationMinutes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#timeout_action EmrCluster#timeout_action}.
     *
     * @stability stable
     */
    readonly timeoutAction: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#timeout_duration_minutes EmrCluster#timeout_duration_minutes}.
     *
     * @stability stable
     */
    readonly timeoutDurationMinutes: number;
}
export declare function emrClusterMasterInstanceFleetLaunchSpecificationsSpotSpecificationToTerraform(struct?: EmrClusterMasterInstanceFleetLaunchSpecificationsSpotSpecification | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceFleetLaunchSpecifications {
    /**
     * on_demand_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#on_demand_specification EmrCluster#on_demand_specification}
     *
     * @stability stable
     */
    readonly onDemandSpecification?: EmrClusterMasterInstanceFleetLaunchSpecificationsOnDemandSpecification[] | cdktf.IResolvable;
    /**
     * spot_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#spot_specification EmrCluster#spot_specification}
     *
     * @stability stable
     */
    readonly spotSpecification?: EmrClusterMasterInstanceFleetLaunchSpecificationsSpotSpecification[] | cdktf.IResolvable;
}
export declare function emrClusterMasterInstanceFleetLaunchSpecificationsToTerraform(struct?: EmrClusterMasterInstanceFleetLaunchSpecificationsOutputReference | EmrClusterMasterInstanceFleetLaunchSpecifications): any;
/**
 * @stability stable
 */
export declare class EmrClusterMasterInstanceFleetLaunchSpecificationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): EmrClusterMasterInstanceFleetLaunchSpecifications | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: EmrClusterMasterInstanceFleetLaunchSpecifications | undefined);
    private _onDemandSpecification?;
    /**
     * @stability stable
     */
    get onDemandSpecification(): EmrClusterMasterInstanceFleetLaunchSpecificationsOnDemandSpecification[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set onDemandSpecification(value: EmrClusterMasterInstanceFleetLaunchSpecificationsOnDemandSpecification[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetOnDemandSpecification(): void;
    /**
     * @stability stable
     */
    get onDemandSpecificationInput(): cdktf.IResolvable | EmrClusterMasterInstanceFleetLaunchSpecificationsOnDemandSpecification[] | undefined;
    private _spotSpecification?;
    /**
     * @stability stable
     */
    get spotSpecification(): EmrClusterMasterInstanceFleetLaunchSpecificationsSpotSpecification[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set spotSpecification(value: EmrClusterMasterInstanceFleetLaunchSpecificationsSpotSpecification[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSpotSpecification(): void;
    /**
     * @stability stable
     */
    get spotSpecificationInput(): cdktf.IResolvable | EmrClusterMasterInstanceFleetLaunchSpecificationsSpotSpecification[] | undefined;
}
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceFleet {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#name EmrCluster#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#target_on_demand_capacity EmrCluster#target_on_demand_capacity}.
     *
     * @stability stable
     */
    readonly targetOnDemandCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#target_spot_capacity EmrCluster#target_spot_capacity}.
     *
     * @stability stable
     */
    readonly targetSpotCapacity?: number;
    /**
     * instance_type_configs block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#instance_type_configs EmrCluster#instance_type_configs}
     *
     * @stability stable
     */
    readonly instanceTypeConfigs?: EmrClusterMasterInstanceFleetInstanceTypeConfigs[] | cdktf.IResolvable;
    /**
     * launch_specifications block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#launch_specifications EmrCluster#launch_specifications}
     *
     * @stability stable
     */
    readonly launchSpecifications?: EmrClusterMasterInstanceFleetLaunchSpecifications;
}
export declare function emrClusterMasterInstanceFleetToTerraform(struct?: EmrClusterMasterInstanceFleetOutputReference | EmrClusterMasterInstanceFleet): any;
/**
 * @stability stable
 */
export declare class EmrClusterMasterInstanceFleetOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): EmrClusterMasterInstanceFleet | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: EmrClusterMasterInstanceFleet | undefined);
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get provisionedOnDemandCapacity(): number;
    /**
     * @stability stable
     */
    get provisionedSpotCapacity(): number;
    private _targetOnDemandCapacity?;
    /**
     * @stability stable
     */
    get targetOnDemandCapacity(): number;
    /**
     * @stability stable
     */
    set targetOnDemandCapacity(value: number);
    /**
     * @stability stable
     */
    resetTargetOnDemandCapacity(): void;
    /**
     * @stability stable
     */
    get targetOnDemandCapacityInput(): number | undefined;
    private _targetSpotCapacity?;
    /**
     * @stability stable
     */
    get targetSpotCapacity(): number;
    /**
     * @stability stable
     */
    set targetSpotCapacity(value: number);
    /**
     * @stability stable
     */
    resetTargetSpotCapacity(): void;
    /**
     * @stability stable
     */
    get targetSpotCapacityInput(): number | undefined;
    private _instanceTypeConfigs?;
    /**
     * @stability stable
     */
    get instanceTypeConfigs(): EmrClusterMasterInstanceFleetInstanceTypeConfigs[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set instanceTypeConfigs(value: EmrClusterMasterInstanceFleetInstanceTypeConfigs[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetInstanceTypeConfigs(): void;
    /**
     * @stability stable
     */
    get instanceTypeConfigsInput(): cdktf.IResolvable | EmrClusterMasterInstanceFleetInstanceTypeConfigs[] | undefined;
    private _launchSpecifications;
    /**
     * @stability stable
     */
    get launchSpecifications(): EmrClusterMasterInstanceFleetLaunchSpecificationsOutputReference;
    /**
     * @stability stable
     */
    putLaunchSpecifications(value: EmrClusterMasterInstanceFleetLaunchSpecifications): void;
    /**
     * @stability stable
     */
    resetLaunchSpecifications(): void;
    /**
     * @stability stable
     */
    get launchSpecificationsInput(): EmrClusterMasterInstanceFleetLaunchSpecifications | undefined;
}
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceGroupEbsConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#iops EmrCluster#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#size EmrCluster#size}.
     *
     * @stability stable
     */
    readonly size: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#type EmrCluster#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#volumes_per_instance EmrCluster#volumes_per_instance}.
     *
     * @stability stable
     */
    readonly volumesPerInstance?: number;
}
export declare function emrClusterMasterInstanceGroupEbsConfigToTerraform(struct?: EmrClusterMasterInstanceGroupEbsConfig | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceGroup {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#bid_price EmrCluster#bid_price}.
     *
     * @stability stable
     */
    readonly bidPrice?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#instance_count EmrCluster#instance_count}.
     *
     * @stability stable
     */
    readonly instanceCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#instance_type EmrCluster#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#name EmrCluster#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * ebs_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster#ebs_config EmrCluster#ebs_config}
     *
     * @stability stable
     */
    readonly ebsConfig?: EmrClusterMasterInstanceGroupEbsConfig[] | cdktf.IResolvable;
}
export declare function emrClusterMasterInstanceGroupToTerraform(struct?: EmrClusterMasterInstanceGroupOutputReference | EmrClusterMasterInstanceGroup): any;
/**
 * @stability stable
 */
export declare class EmrClusterMasterInstanceGroupOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): EmrClusterMasterInstanceGroup | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: EmrClusterMasterInstanceGroup | undefined);
    private _bidPrice?;
    /**
     * @stability stable
     */
    get bidPrice(): string;
    /**
     * @stability stable
     */
    set bidPrice(value: string);
    /**
     * @stability stable
     */
    resetBidPrice(): void;
    /**
     * @stability stable
     */
    get bidPriceInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceCount?;
    /**
     * @stability stable
     */
    get instanceCount(): number;
    /**
     * @stability stable
     */
    set instanceCount(value: number);
    /**
     * @stability stable
     */
    resetInstanceCount(): void;
    /**
     * @stability stable
     */
    get instanceCountInput(): number | undefined;
    private _instanceType?;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    set instanceType(value: string);
    /**
     * @stability stable
     */
    get instanceTypeInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _ebsConfig?;
    /**
     * @stability stable
     */
    get ebsConfig(): EmrClusterMasterInstanceGroupEbsConfig[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set ebsConfig(value: EmrClusterMasterInstanceGroupEbsConfig[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEbsConfig(): void;
    /**
     * @stability stable
     */
    get ebsConfigInput(): cdktf.IResolvable | EmrClusterMasterInstanceGroupEbsConfig[] | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster aws_emr_cluster}.
 *
 * @stability stable
 */
export declare class EmrCluster extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/emr_cluster aws_emr_cluster} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: EmrClusterConfig);
    private _additionalInfo?;
    /**
     * @stability stable
     */
    get additionalInfo(): string;
    /**
     * @stability stable
     */
    set additionalInfo(value: string);
    /**
     * @stability stable
     */
    resetAdditionalInfo(): void;
    /**
     * @stability stable
     */
    get additionalInfoInput(): string | undefined;
    private _applications?;
    /**
     * @stability stable
     */
    get applications(): string[];
    /**
     * @stability stable
     */
    set applications(value: string[]);
    /**
     * @stability stable
     */
    resetApplications(): void;
    /**
     * @stability stable
     */
    get applicationsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoscalingRole?;
    /**
     * @stability stable
     */
    get autoscalingRole(): string;
    /**
     * @stability stable
     */
    set autoscalingRole(value: string);
    /**
     * @stability stable
     */
    resetAutoscalingRole(): void;
    /**
     * @stability stable
     */
    get autoscalingRoleInput(): string | undefined;
    /**
     * @stability stable
     */
    get clusterState(): string;
    private _configurations?;
    /**
     * @stability stable
     */
    get configurations(): string;
    /**
     * @stability stable
     */
    set configurations(value: string);
    /**
     * @stability stable
     */
    resetConfigurations(): void;
    /**
     * @stability stable
     */
    get configurationsInput(): string | undefined;
    private _configurationsJson?;
    /**
     * @stability stable
     */
    get configurationsJson(): string;
    /**
     * @stability stable
     */
    set configurationsJson(value: string);
    /**
     * @stability stable
     */
    resetConfigurationsJson(): void;
    /**
     * @stability stable
     */
    get configurationsJsonInput(): string | undefined;
    private _customAmiId?;
    /**
     * @stability stable
     */
    get customAmiId(): string;
    /**
     * @stability stable
     */
    set customAmiId(value: string);
    /**
     * @stability stable
     */
    resetCustomAmiId(): void;
    /**
     * @stability stable
     */
    get customAmiIdInput(): string | undefined;
    private _ebsRootVolumeSize?;
    /**
     * @stability stable
     */
    get ebsRootVolumeSize(): number;
    /**
     * @stability stable
     */
    set ebsRootVolumeSize(value: number);
    /**
     * @stability stable
     */
    resetEbsRootVolumeSize(): void;
    /**
     * @stability stable
     */
    get ebsRootVolumeSizeInput(): number | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _keepJobFlowAliveWhenNoSteps?;
    /**
     * @stability stable
     */
    get keepJobFlowAliveWhenNoSteps(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set keepJobFlowAliveWhenNoSteps(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetKeepJobFlowAliveWhenNoSteps(): void;
    /**
     * @stability stable
     */
    get keepJobFlowAliveWhenNoStepsInput(): boolean | cdktf.IResolvable | undefined;
    private _logEncryptionKmsKeyId?;
    /**
     * @stability stable
     */
    get logEncryptionKmsKeyId(): string;
    /**
     * @stability stable
     */
    set logEncryptionKmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetLogEncryptionKmsKeyId(): void;
    /**
     * @stability stable
     */
    get logEncryptionKmsKeyIdInput(): string | undefined;
    private _logUri?;
    /**
     * @stability stable
     */
    get logUri(): string;
    /**
     * @stability stable
     */
    set logUri(value: string);
    /**
     * @stability stable
     */
    resetLogUri(): void;
    /**
     * @stability stable
     */
    get logUriInput(): string | undefined;
    /**
     * @stability stable
     */
    get masterPublicDns(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _releaseLabel?;
    /**
     * @stability stable
     */
    get releaseLabel(): string;
    /**
     * @stability stable
     */
    set releaseLabel(value: string);
    /**
     * @stability stable
     */
    get releaseLabelInput(): string | undefined;
    private _scaleDownBehavior?;
    /**
     * @stability stable
     */
    get scaleDownBehavior(): string;
    /**
     * @stability stable
     */
    set scaleDownBehavior(value: string);
    /**
     * @stability stable
     */
    resetScaleDownBehavior(): void;
    /**
     * @stability stable
     */
    get scaleDownBehaviorInput(): string | undefined;
    private _securityConfiguration?;
    /**
     * @stability stable
     */
    get securityConfiguration(): string;
    /**
     * @stability stable
     */
    set securityConfiguration(value: string);
    /**
     * @stability stable
     */
    resetSecurityConfiguration(): void;
    /**
     * @stability stable
     */
    get securityConfigurationInput(): string | undefined;
    private _serviceRole?;
    /**
     * @stability stable
     */
    get serviceRole(): string;
    /**
     * @stability stable
     */
    set serviceRole(value: string);
    /**
     * @stability stable
     */
    get serviceRoleInput(): string | undefined;
    private _step?;
    /**
     * @stability stable
     */
    get step(): EmrClusterStep[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set step(value: EmrClusterStep[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetStep(): void;
    /**
     * @stability stable
     */
    get stepInput(): cdktf.IResolvable | EmrClusterStep[] | undefined;
    private _stepConcurrencyLevel?;
    /**
     * @stability stable
     */
    get stepConcurrencyLevel(): number;
    /**
     * @stability stable
     */
    set stepConcurrencyLevel(value: number);
    /**
     * @stability stable
     */
    resetStepConcurrencyLevel(): void;
    /**
     * @stability stable
     */
    get stepConcurrencyLevelInput(): number | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _terminationProtection?;
    /**
     * @stability stable
     */
    get terminationProtection(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set terminationProtection(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTerminationProtection(): void;
    /**
     * @stability stable
     */
    get terminationProtectionInput(): boolean | cdktf.IResolvable | undefined;
    private _visibleToAllUsers?;
    /**
     * @stability stable
     */
    get visibleToAllUsers(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set visibleToAllUsers(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetVisibleToAllUsers(): void;
    /**
     * @stability stable
     */
    get visibleToAllUsersInput(): boolean | cdktf.IResolvable | undefined;
    private _autoTerminationPolicy;
    /**
     * @stability stable
     */
    get autoTerminationPolicy(): EmrClusterAutoTerminationPolicyOutputReference;
    /**
     * @stability stable
     */
    putAutoTerminationPolicy(value: EmrClusterAutoTerminationPolicy): void;
    /**
     * @stability stable
     */
    resetAutoTerminationPolicy(): void;
    /**
     * @stability stable
     */
    get autoTerminationPolicyInput(): EmrClusterAutoTerminationPolicy | undefined;
    private _bootstrapAction?;
    /**
     * @stability stable
     */
    get bootstrapAction(): EmrClusterBootstrapAction[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set bootstrapAction(value: EmrClusterBootstrapAction[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetBootstrapAction(): void;
    /**
     * @stability stable
     */
    get bootstrapActionInput(): cdktf.IResolvable | EmrClusterBootstrapAction[] | undefined;
    private _coreInstanceFleet;
    /**
     * @stability stable
     */
    get coreInstanceFleet(): EmrClusterCoreInstanceFleetOutputReference;
    /**
     * @stability stable
     */
    putCoreInstanceFleet(value: EmrClusterCoreInstanceFleet): void;
    /**
     * @stability stable
     */
    resetCoreInstanceFleet(): void;
    /**
     * @stability stable
     */
    get coreInstanceFleetInput(): EmrClusterCoreInstanceFleet | undefined;
    private _coreInstanceGroup;
    /**
     * @stability stable
     */
    get coreInstanceGroup(): EmrClusterCoreInstanceGroupOutputReference;
    /**
     * @stability stable
     */
    putCoreInstanceGroup(value: EmrClusterCoreInstanceGroup): void;
    /**
     * @stability stable
     */
    resetCoreInstanceGroup(): void;
    /**
     * @stability stable
     */
    get coreInstanceGroupInput(): EmrClusterCoreInstanceGroup | undefined;
    private _ec2Attributes;
    /**
     * @stability stable
     */
    get ec2Attributes(): EmrClusterEc2AttributesOutputReference;
    /**
     * @stability stable
     */
    putEc2Attributes(value: EmrClusterEc2Attributes): void;
    /**
     * @stability stable
     */
    resetEc2Attributes(): void;
    /**
     * @stability stable
     */
    get ec2AttributesInput(): EmrClusterEc2Attributes | undefined;
    private _kerberosAttributes;
    /**
     * @stability stable
     */
    get kerberosAttributes(): EmrClusterKerberosAttributesOutputReference;
    /**
     * @stability stable
     */
    putKerberosAttributes(value: EmrClusterKerberosAttributes): void;
    /**
     * @stability stable
     */
    resetKerberosAttributes(): void;
    /**
     * @stability stable
     */
    get kerberosAttributesInput(): EmrClusterKerberosAttributes | undefined;
    private _masterInstanceFleet;
    /**
     * @stability stable
     */
    get masterInstanceFleet(): EmrClusterMasterInstanceFleetOutputReference;
    /**
     * @stability stable
     */
    putMasterInstanceFleet(value: EmrClusterMasterInstanceFleet): void;
    /**
     * @stability stable
     */
    resetMasterInstanceFleet(): void;
    /**
     * @stability stable
     */
    get masterInstanceFleetInput(): EmrClusterMasterInstanceFleet | undefined;
    private _masterInstanceGroup;
    /**
     * @stability stable
     */
    get masterInstanceGroup(): EmrClusterMasterInstanceGroupOutputReference;
    /**
     * @stability stable
     */
    putMasterInstanceGroup(value: EmrClusterMasterInstanceGroup): void;
    /**
     * @stability stable
     */
    resetMasterInstanceGroup(): void;
    /**
     * @stability stable
     */
    get masterInstanceGroupInput(): EmrClusterMasterInstanceGroup | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
