import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Elastic MapReduce.
 *
 * @stability stable
 */
export interface EmrInstanceFleetConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet#cluster_id EmrInstanceFleet#cluster_id}.
     *
     * @stability stable
     */
    readonly clusterId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet#name EmrInstanceFleet#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet#target_on_demand_capacity EmrInstanceFleet#target_on_demand_capacity}.
     *
     * @stability stable
     */
    readonly targetOnDemandCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet#target_spot_capacity EmrInstanceFleet#target_spot_capacity}.
     *
     * @stability stable
     */
    readonly targetSpotCapacity?: number;
    /**
     * instance_type_configs block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet#instance_type_configs EmrInstanceFleet#instance_type_configs}
     *
     * @stability stable
     */
    readonly instanceTypeConfigs?: EmrInstanceFleetInstanceTypeConfigs[] | cdktf.IResolvable;
    /**
     * launch_specifications block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet#launch_specifications EmrInstanceFleet#launch_specifications}
     *
     * @stability stable
     */
    readonly launchSpecifications?: EmrInstanceFleetLaunchSpecifications;
}
/**
 * @stability stable
 */
export interface EmrInstanceFleetInstanceTypeConfigsConfigurations {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet#classification EmrInstanceFleet#classification}.
     *
     * @stability stable
     */
    readonly classification?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet#properties EmrInstanceFleet#properties}.
     *
     * @stability stable
     */
    readonly properties?: {
        [key: string]: string;
    };
}
export declare function emrInstanceFleetInstanceTypeConfigsConfigurationsToTerraform(struct?: EmrInstanceFleetInstanceTypeConfigsConfigurations | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface EmrInstanceFleetInstanceTypeConfigsEbsConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet#iops EmrInstanceFleet#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet#size EmrInstanceFleet#size}.
     *
     * @stability stable
     */
    readonly size: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet#type EmrInstanceFleet#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet#volumes_per_instance EmrInstanceFleet#volumes_per_instance}.
     *
     * @stability stable
     */
    readonly volumesPerInstance?: number;
}
export declare function emrInstanceFleetInstanceTypeConfigsEbsConfigToTerraform(struct?: EmrInstanceFleetInstanceTypeConfigsEbsConfig | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface EmrInstanceFleetInstanceTypeConfigs {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet#bid_price EmrInstanceFleet#bid_price}.
     *
     * @stability stable
     */
    readonly bidPrice?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet#bid_price_as_percentage_of_on_demand_price EmrInstanceFleet#bid_price_as_percentage_of_on_demand_price}.
     *
     * @stability stable
     */
    readonly bidPriceAsPercentageOfOnDemandPrice?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet#instance_type EmrInstanceFleet#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet#weighted_capacity EmrInstanceFleet#weighted_capacity}.
     *
     * @stability stable
     */
    readonly weightedCapacity?: number;
    /**
     * configurations block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet#configurations EmrInstanceFleet#configurations}
     *
     * @stability stable
     */
    readonly configurations?: EmrInstanceFleetInstanceTypeConfigsConfigurations[] | cdktf.IResolvable;
    /**
     * ebs_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet#ebs_config EmrInstanceFleet#ebs_config}
     *
     * @stability stable
     */
    readonly ebsConfig?: EmrInstanceFleetInstanceTypeConfigsEbsConfig[] | cdktf.IResolvable;
}
export declare function emrInstanceFleetInstanceTypeConfigsToTerraform(struct?: EmrInstanceFleetInstanceTypeConfigs | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface EmrInstanceFleetLaunchSpecificationsOnDemandSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet#allocation_strategy EmrInstanceFleet#allocation_strategy}.
     *
     * @stability stable
     */
    readonly allocationStrategy: string;
}
export declare function emrInstanceFleetLaunchSpecificationsOnDemandSpecificationToTerraform(struct?: EmrInstanceFleetLaunchSpecificationsOnDemandSpecification | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface EmrInstanceFleetLaunchSpecificationsSpotSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet#allocation_strategy EmrInstanceFleet#allocation_strategy}.
     *
     * @stability stable
     */
    readonly allocationStrategy: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet#block_duration_minutes EmrInstanceFleet#block_duration_minutes}.
     *
     * @stability stable
     */
    readonly blockDurationMinutes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet#timeout_action EmrInstanceFleet#timeout_action}.
     *
     * @stability stable
     */
    readonly timeoutAction: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet#timeout_duration_minutes EmrInstanceFleet#timeout_duration_minutes}.
     *
     * @stability stable
     */
    readonly timeoutDurationMinutes: number;
}
export declare function emrInstanceFleetLaunchSpecificationsSpotSpecificationToTerraform(struct?: EmrInstanceFleetLaunchSpecificationsSpotSpecification | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface EmrInstanceFleetLaunchSpecifications {
    /**
     * on_demand_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet#on_demand_specification EmrInstanceFleet#on_demand_specification}
     *
     * @stability stable
     */
    readonly onDemandSpecification?: EmrInstanceFleetLaunchSpecificationsOnDemandSpecification[] | cdktf.IResolvable;
    /**
     * spot_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet#spot_specification EmrInstanceFleet#spot_specification}
     *
     * @stability stable
     */
    readonly spotSpecification?: EmrInstanceFleetLaunchSpecificationsSpotSpecification[] | cdktf.IResolvable;
}
export declare function emrInstanceFleetLaunchSpecificationsToTerraform(struct?: EmrInstanceFleetLaunchSpecificationsOutputReference | EmrInstanceFleetLaunchSpecifications): any;
/**
 * @stability stable
 */
export declare class EmrInstanceFleetLaunchSpecificationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): EmrInstanceFleetLaunchSpecifications | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: EmrInstanceFleetLaunchSpecifications | undefined);
    private _onDemandSpecification?;
    /**
     * @stability stable
     */
    get onDemandSpecification(): EmrInstanceFleetLaunchSpecificationsOnDemandSpecification[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set onDemandSpecification(value: EmrInstanceFleetLaunchSpecificationsOnDemandSpecification[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetOnDemandSpecification(): void;
    /**
     * @stability stable
     */
    get onDemandSpecificationInput(): cdktf.IResolvable | EmrInstanceFleetLaunchSpecificationsOnDemandSpecification[] | undefined;
    private _spotSpecification?;
    /**
     * @stability stable
     */
    get spotSpecification(): EmrInstanceFleetLaunchSpecificationsSpotSpecification[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set spotSpecification(value: EmrInstanceFleetLaunchSpecificationsSpotSpecification[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSpotSpecification(): void;
    /**
     * @stability stable
     */
    get spotSpecificationInput(): cdktf.IResolvable | EmrInstanceFleetLaunchSpecificationsSpotSpecification[] | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet aws_emr_instance_fleet}.
 *
 * @stability stable
 */
export declare class EmrInstanceFleet extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/emr_instance_fleet aws_emr_instance_fleet} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: EmrInstanceFleetConfig);
    private _clusterId?;
    /**
     * @stability stable
     */
    get clusterId(): string;
    /**
     * @stability stable
     */
    set clusterId(value: string);
    /**
     * @stability stable
     */
    get clusterIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get provisionedOnDemandCapacity(): number;
    /**
     * @stability stable
     */
    get provisionedSpotCapacity(): number;
    private _targetOnDemandCapacity?;
    /**
     * @stability stable
     */
    get targetOnDemandCapacity(): number;
    /**
     * @stability stable
     */
    set targetOnDemandCapacity(value: number);
    /**
     * @stability stable
     */
    resetTargetOnDemandCapacity(): void;
    /**
     * @stability stable
     */
    get targetOnDemandCapacityInput(): number | undefined;
    private _targetSpotCapacity?;
    /**
     * @stability stable
     */
    get targetSpotCapacity(): number;
    /**
     * @stability stable
     */
    set targetSpotCapacity(value: number);
    /**
     * @stability stable
     */
    resetTargetSpotCapacity(): void;
    /**
     * @stability stable
     */
    get targetSpotCapacityInput(): number | undefined;
    private _instanceTypeConfigs?;
    /**
     * @stability stable
     */
    get instanceTypeConfigs(): EmrInstanceFleetInstanceTypeConfigs[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set instanceTypeConfigs(value: EmrInstanceFleetInstanceTypeConfigs[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetInstanceTypeConfigs(): void;
    /**
     * @stability stable
     */
    get instanceTypeConfigsInput(): cdktf.IResolvable | EmrInstanceFleetInstanceTypeConfigs[] | undefined;
    private _launchSpecifications;
    /**
     * @stability stable
     */
    get launchSpecifications(): EmrInstanceFleetLaunchSpecificationsOutputReference;
    /**
     * @stability stable
     */
    putLaunchSpecifications(value: EmrInstanceFleetLaunchSpecifications): void;
    /**
     * @stability stable
     */
    resetLaunchSpecifications(): void;
    /**
     * @stability stable
     */
    get launchSpecificationsInput(): EmrInstanceFleetLaunchSpecifications | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
