import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Firewall Management Service.
 *
 * @stability stable
 */
export interface FmsPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy#delete_all_policy_resources FmsPolicy#delete_all_policy_resources}.
     *
     * @stability stable
     */
    readonly deleteAllPolicyResources?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy#exclude_resource_tags FmsPolicy#exclude_resource_tags}.
     *
     * @stability stable
     */
    readonly excludeResourceTags: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy#name FmsPolicy#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy#remediation_enabled FmsPolicy#remediation_enabled}.
     *
     * @stability stable
     */
    readonly remediationEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy#resource_tags FmsPolicy#resource_tags}.
     *
     * @stability stable
     */
    readonly resourceTags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy#resource_type FmsPolicy#resource_type}.
     *
     * @stability stable
     */
    readonly resourceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy#resource_type_list FmsPolicy#resource_type_list}.
     *
     * @stability stable
     */
    readonly resourceTypeList?: string[];
    /**
     * exclude_map block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy#exclude_map FmsPolicy#exclude_map}
     *
     * @stability stable
     */
    readonly excludeMap?: FmsPolicyExcludeMap;
    /**
     * include_map block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy#include_map FmsPolicy#include_map}
     *
     * @stability stable
     */
    readonly includeMap?: FmsPolicyIncludeMap;
    /**
     * security_service_policy_data block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy#security_service_policy_data FmsPolicy#security_service_policy_data}
     *
     * @stability stable
     */
    readonly securityServicePolicyData: FmsPolicySecurityServicePolicyData;
}
/**
 * @stability stable
 */
export interface FmsPolicyExcludeMap {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy#account FmsPolicy#account}.
     *
     * @stability stable
     */
    readonly account?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy#orgunit FmsPolicy#orgunit}.
     *
     * @stability stable
     */
    readonly orgunit?: string[];
}
export declare function fmsPolicyExcludeMapToTerraform(struct?: FmsPolicyExcludeMapOutputReference | FmsPolicyExcludeMap): any;
/**
 * @stability stable
 */
export declare class FmsPolicyExcludeMapOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): FmsPolicyExcludeMap | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: FmsPolicyExcludeMap | undefined);
    private _account?;
    /**
     * @stability stable
     */
    get account(): string[];
    /**
     * @stability stable
     */
    set account(value: string[]);
    /**
     * @stability stable
     */
    resetAccount(): void;
    /**
     * @stability stable
     */
    get accountInput(): string[] | undefined;
    private _orgunit?;
    /**
     * @stability stable
     */
    get orgunit(): string[];
    /**
     * @stability stable
     */
    set orgunit(value: string[]);
    /**
     * @stability stable
     */
    resetOrgunit(): void;
    /**
     * @stability stable
     */
    get orgunitInput(): string[] | undefined;
}
/**
 * @stability stable
 */
export interface FmsPolicyIncludeMap {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy#account FmsPolicy#account}.
     *
     * @stability stable
     */
    readonly account?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy#orgunit FmsPolicy#orgunit}.
     *
     * @stability stable
     */
    readonly orgunit?: string[];
}
export declare function fmsPolicyIncludeMapToTerraform(struct?: FmsPolicyIncludeMapOutputReference | FmsPolicyIncludeMap): any;
/**
 * @stability stable
 */
export declare class FmsPolicyIncludeMapOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): FmsPolicyIncludeMap | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: FmsPolicyIncludeMap | undefined);
    private _account?;
    /**
     * @stability stable
     */
    get account(): string[];
    /**
     * @stability stable
     */
    set account(value: string[]);
    /**
     * @stability stable
     */
    resetAccount(): void;
    /**
     * @stability stable
     */
    get accountInput(): string[] | undefined;
    private _orgunit?;
    /**
     * @stability stable
     */
    get orgunit(): string[];
    /**
     * @stability stable
     */
    set orgunit(value: string[]);
    /**
     * @stability stable
     */
    resetOrgunit(): void;
    /**
     * @stability stable
     */
    get orgunitInput(): string[] | undefined;
}
/**
 * @stability stable
 */
export interface FmsPolicySecurityServicePolicyData {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy#managed_service_data FmsPolicy#managed_service_data}.
     *
     * @stability stable
     */
    readonly managedServiceData?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fms_policy#type FmsPolicy#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
export declare function fmsPolicySecurityServicePolicyDataToTerraform(struct?: FmsPolicySecurityServicePolicyDataOutputReference | FmsPolicySecurityServicePolicyData): any;
/**
 * @stability stable
 */
export declare class FmsPolicySecurityServicePolicyDataOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): FmsPolicySecurityServicePolicyData | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: FmsPolicySecurityServicePolicyData | undefined);
    private _managedServiceData?;
    /**
     * @stability stable
     */
    get managedServiceData(): string;
    /**
     * @stability stable
     */
    set managedServiceData(value: string);
    /**
     * @stability stable
     */
    resetManagedServiceData(): void;
    /**
     * @stability stable
     */
    get managedServiceDataInput(): string | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/fms_policy aws_fms_policy}.
 *
 * @stability stable
 */
export declare class FmsPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/fms_policy aws_fms_policy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: FmsPolicyConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _deleteAllPolicyResources?;
    /**
     * @stability stable
     */
    get deleteAllPolicyResources(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set deleteAllPolicyResources(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDeleteAllPolicyResources(): void;
    /**
     * @stability stable
     */
    get deleteAllPolicyResourcesInput(): boolean | cdktf.IResolvable | undefined;
    private _excludeResourceTags?;
    /**
     * @stability stable
     */
    get excludeResourceTags(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set excludeResourceTags(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get excludeResourceTagsInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get policyUpdateToken(): string;
    private _remediationEnabled?;
    /**
     * @stability stable
     */
    get remediationEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set remediationEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetRemediationEnabled(): void;
    /**
     * @stability stable
     */
    get remediationEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _resourceTags?;
    /**
     * @stability stable
     */
    get resourceTags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set resourceTags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetResourceTags(): void;
    /**
     * @stability stable
     */
    get resourceTagsInput(): {
        [key: string]: string;
    } | undefined;
    private _resourceType?;
    /**
     * @stability stable
     */
    get resourceType(): string;
    /**
     * @stability stable
     */
    set resourceType(value: string);
    /**
     * @stability stable
     */
    resetResourceType(): void;
    /**
     * @stability stable
     */
    get resourceTypeInput(): string | undefined;
    private _resourceTypeList?;
    /**
     * @stability stable
     */
    get resourceTypeList(): string[];
    /**
     * @stability stable
     */
    set resourceTypeList(value: string[]);
    /**
     * @stability stable
     */
    resetResourceTypeList(): void;
    /**
     * @stability stable
     */
    get resourceTypeListInput(): string[] | undefined;
    private _excludeMap;
    /**
     * @stability stable
     */
    get excludeMap(): FmsPolicyExcludeMapOutputReference;
    /**
     * @stability stable
     */
    putExcludeMap(value: FmsPolicyExcludeMap): void;
    /**
     * @stability stable
     */
    resetExcludeMap(): void;
    /**
     * @stability stable
     */
    get excludeMapInput(): FmsPolicyExcludeMap | undefined;
    private _includeMap;
    /**
     * @stability stable
     */
    get includeMap(): FmsPolicyIncludeMapOutputReference;
    /**
     * @stability stable
     */
    putIncludeMap(value: FmsPolicyIncludeMap): void;
    /**
     * @stability stable
     */
    resetIncludeMap(): void;
    /**
     * @stability stable
     */
    get includeMapInput(): FmsPolicyIncludeMap | undefined;
    private _securityServicePolicyData;
    /**
     * @stability stable
     */
    get securityServicePolicyData(): FmsPolicySecurityServicePolicyDataOutputReference;
    /**
     * @stability stable
     */
    putSecurityServicePolicyData(value: FmsPolicySecurityServicePolicyData): void;
    /**
     * @stability stable
     */
    get securityServicePolicyDataInput(): FmsPolicySecurityServicePolicyData | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
