import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS File System FSx.
 *
 * @stability stable
 */
export interface FsxDataRepositoryAssociationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_data_repository_association#batch_import_meta_data_on_create FsxDataRepositoryAssociation#batch_import_meta_data_on_create}.
     *
     * @stability stable
     */
    readonly batchImportMetaDataOnCreate?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_data_repository_association#data_repository_path FsxDataRepositoryAssociation#data_repository_path}.
     *
     * @stability stable
     */
    readonly dataRepositoryPath: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_data_repository_association#delete_data_in_filesystem FsxDataRepositoryAssociation#delete_data_in_filesystem}.
     *
     * @stability stable
     */
    readonly deleteDataInFilesystem?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_data_repository_association#file_system_id FsxDataRepositoryAssociation#file_system_id}.
     *
     * @stability stable
     */
    readonly fileSystemId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_data_repository_association#file_system_path FsxDataRepositoryAssociation#file_system_path}.
     *
     * @stability stable
     */
    readonly fileSystemPath: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_data_repository_association#imported_file_chunk_size FsxDataRepositoryAssociation#imported_file_chunk_size}.
     *
     * @stability stable
     */
    readonly importedFileChunkSize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_data_repository_association#tags FsxDataRepositoryAssociation#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_data_repository_association#tags_all FsxDataRepositoryAssociation#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * s3 block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_data_repository_association#s3 FsxDataRepositoryAssociation#s3}
     *
     * @stability stable
     */
    readonly s3?: FsxDataRepositoryAssociationS3;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_data_repository_association#timeouts FsxDataRepositoryAssociation#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: FsxDataRepositoryAssociationTimeouts;
}
/**
 * @stability stable
 */
export interface FsxDataRepositoryAssociationS3AutoExportPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_data_repository_association#events FsxDataRepositoryAssociation#events}.
     *
     * @stability stable
     */
    readonly events?: string[];
}
export declare function fsxDataRepositoryAssociationS3AutoExportPolicyToTerraform(struct?: FsxDataRepositoryAssociationS3AutoExportPolicyOutputReference | FsxDataRepositoryAssociationS3AutoExportPolicy): any;
/**
 * @stability stable
 */
export declare class FsxDataRepositoryAssociationS3AutoExportPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): FsxDataRepositoryAssociationS3AutoExportPolicy | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: FsxDataRepositoryAssociationS3AutoExportPolicy | undefined);
    private _events?;
    /**
     * @stability stable
     */
    get events(): string[];
    /**
     * @stability stable
     */
    set events(value: string[]);
    /**
     * @stability stable
     */
    resetEvents(): void;
    /**
     * @stability stable
     */
    get eventsInput(): string[] | undefined;
}
/**
 * @stability stable
 */
export interface FsxDataRepositoryAssociationS3AutoImportPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_data_repository_association#events FsxDataRepositoryAssociation#events}.
     *
     * @stability stable
     */
    readonly events?: string[];
}
export declare function fsxDataRepositoryAssociationS3AutoImportPolicyToTerraform(struct?: FsxDataRepositoryAssociationS3AutoImportPolicyOutputReference | FsxDataRepositoryAssociationS3AutoImportPolicy): any;
/**
 * @stability stable
 */
export declare class FsxDataRepositoryAssociationS3AutoImportPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): FsxDataRepositoryAssociationS3AutoImportPolicy | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: FsxDataRepositoryAssociationS3AutoImportPolicy | undefined);
    private _events?;
    /**
     * @stability stable
     */
    get events(): string[];
    /**
     * @stability stable
     */
    set events(value: string[]);
    /**
     * @stability stable
     */
    resetEvents(): void;
    /**
     * @stability stable
     */
    get eventsInput(): string[] | undefined;
}
/**
 * @stability stable
 */
export interface FsxDataRepositoryAssociationS3 {
    /**
     * auto_export_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_data_repository_association#auto_export_policy FsxDataRepositoryAssociation#auto_export_policy}
     *
     * @stability stable
     */
    readonly autoExportPolicy?: FsxDataRepositoryAssociationS3AutoExportPolicy;
    /**
     * auto_import_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_data_repository_association#auto_import_policy FsxDataRepositoryAssociation#auto_import_policy}
     *
     * @stability stable
     */
    readonly autoImportPolicy?: FsxDataRepositoryAssociationS3AutoImportPolicy;
}
export declare function fsxDataRepositoryAssociationS3ToTerraform(struct?: FsxDataRepositoryAssociationS3OutputReference | FsxDataRepositoryAssociationS3): any;
/**
 * @stability stable
 */
export declare class FsxDataRepositoryAssociationS3OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): FsxDataRepositoryAssociationS3 | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: FsxDataRepositoryAssociationS3 | undefined);
    private _autoExportPolicy;
    /**
     * @stability stable
     */
    get autoExportPolicy(): FsxDataRepositoryAssociationS3AutoExportPolicyOutputReference;
    /**
     * @stability stable
     */
    putAutoExportPolicy(value: FsxDataRepositoryAssociationS3AutoExportPolicy): void;
    /**
     * @stability stable
     */
    resetAutoExportPolicy(): void;
    /**
     * @stability stable
     */
    get autoExportPolicyInput(): FsxDataRepositoryAssociationS3AutoExportPolicy | undefined;
    private _autoImportPolicy;
    /**
     * @stability stable
     */
    get autoImportPolicy(): FsxDataRepositoryAssociationS3AutoImportPolicyOutputReference;
    /**
     * @stability stable
     */
    putAutoImportPolicy(value: FsxDataRepositoryAssociationS3AutoImportPolicy): void;
    /**
     * @stability stable
     */
    resetAutoImportPolicy(): void;
    /**
     * @stability stable
     */
    get autoImportPolicyInput(): FsxDataRepositoryAssociationS3AutoImportPolicy | undefined;
}
/**
 * @stability stable
 */
export interface FsxDataRepositoryAssociationTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_data_repository_association#create FsxDataRepositoryAssociation#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_data_repository_association#delete FsxDataRepositoryAssociation#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_data_repository_association#update FsxDataRepositoryAssociation#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function fsxDataRepositoryAssociationTimeoutsToTerraform(struct?: FsxDataRepositoryAssociationTimeoutsOutputReference | FsxDataRepositoryAssociationTimeouts | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export declare class FsxDataRepositoryAssociationTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): FsxDataRepositoryAssociationTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: FsxDataRepositoryAssociationTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/fsx_data_repository_association aws_fsx_data_repository_association}.
 *
 * @stability stable
 */
export declare class FsxDataRepositoryAssociation extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/fsx_data_repository_association aws_fsx_data_repository_association} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: FsxDataRepositoryAssociationConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get associationId(): string;
    private _batchImportMetaDataOnCreate?;
    /**
     * @stability stable
     */
    get batchImportMetaDataOnCreate(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set batchImportMetaDataOnCreate(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetBatchImportMetaDataOnCreate(): void;
    /**
     * @stability stable
     */
    get batchImportMetaDataOnCreateInput(): boolean | cdktf.IResolvable | undefined;
    private _dataRepositoryPath?;
    /**
     * @stability stable
     */
    get dataRepositoryPath(): string;
    /**
     * @stability stable
     */
    set dataRepositoryPath(value: string);
    /**
     * @stability stable
     */
    get dataRepositoryPathInput(): string | undefined;
    private _deleteDataInFilesystem?;
    /**
     * @stability stable
     */
    get deleteDataInFilesystem(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set deleteDataInFilesystem(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDeleteDataInFilesystem(): void;
    /**
     * @stability stable
     */
    get deleteDataInFilesystemInput(): boolean | cdktf.IResolvable | undefined;
    private _fileSystemId?;
    /**
     * @stability stable
     */
    get fileSystemId(): string;
    /**
     * @stability stable
     */
    set fileSystemId(value: string);
    /**
     * @stability stable
     */
    get fileSystemIdInput(): string | undefined;
    private _fileSystemPath?;
    /**
     * @stability stable
     */
    get fileSystemPath(): string;
    /**
     * @stability stable
     */
    set fileSystemPath(value: string);
    /**
     * @stability stable
     */
    get fileSystemPathInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _importedFileChunkSize?;
    /**
     * @stability stable
     */
    get importedFileChunkSize(): number;
    /**
     * @stability stable
     */
    set importedFileChunkSize(value: number);
    /**
     * @stability stable
     */
    resetImportedFileChunkSize(): void;
    /**
     * @stability stable
     */
    get importedFileChunkSizeInput(): number | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _s3;
    /**
     * @stability stable
     */
    get s3(): FsxDataRepositoryAssociationS3OutputReference;
    /**
     * @stability stable
     */
    putS3(value: FsxDataRepositoryAssociationS3): void;
    /**
     * @stability stable
     */
    resetS3(): void;
    /**
     * @stability stable
     */
    get s3Input(): FsxDataRepositoryAssociationS3 | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): FsxDataRepositoryAssociationTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: FsxDataRepositoryAssociationTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): FsxDataRepositoryAssociationTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
