import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS File System FSx.
 *
 * @stability stable
 */
export interface FsxOntapFileSystemConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system#automatic_backup_retention_days FsxOntapFileSystem#automatic_backup_retention_days}.
     *
     * @stability stable
     */
    readonly automaticBackupRetentionDays?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system#daily_automatic_backup_start_time FsxOntapFileSystem#daily_automatic_backup_start_time}.
     *
     * @stability stable
     */
    readonly dailyAutomaticBackupStartTime?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system#deployment_type FsxOntapFileSystem#deployment_type}.
     *
     * @stability stable
     */
    readonly deploymentType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system#endpoint_ip_address_range FsxOntapFileSystem#endpoint_ip_address_range}.
     *
     * @stability stable
     */
    readonly endpointIpAddressRange?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system#fsx_admin_password FsxOntapFileSystem#fsx_admin_password}.
     *
     * @stability stable
     */
    readonly fsxAdminPassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system#kms_key_id FsxOntapFileSystem#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system#preferred_subnet_id FsxOntapFileSystem#preferred_subnet_id}.
     *
     * @stability stable
     */
    readonly preferredSubnetId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system#route_table_ids FsxOntapFileSystem#route_table_ids}.
     *
     * @stability stable
     */
    readonly routeTableIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system#security_group_ids FsxOntapFileSystem#security_group_ids}.
     *
     * @stability stable
     */
    readonly securityGroupIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system#storage_capacity FsxOntapFileSystem#storage_capacity}.
     *
     * @stability stable
     */
    readonly storageCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system#storage_type FsxOntapFileSystem#storage_type}.
     *
     * @stability stable
     */
    readonly storageType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system#subnet_ids FsxOntapFileSystem#subnet_ids}.
     *
     * @stability stable
     */
    readonly subnetIds: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system#tags FsxOntapFileSystem#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system#tags_all FsxOntapFileSystem#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system#throughput_capacity FsxOntapFileSystem#throughput_capacity}.
     *
     * @stability stable
     */
    readonly throughputCapacity: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system#weekly_maintenance_start_time FsxOntapFileSystem#weekly_maintenance_start_time}.
     *
     * @stability stable
     */
    readonly weeklyMaintenanceStartTime?: string;
    /**
     * disk_iops_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system#disk_iops_configuration FsxOntapFileSystem#disk_iops_configuration}
     *
     * @stability stable
     */
    readonly diskIopsConfiguration?: FsxOntapFileSystemDiskIopsConfiguration;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system#timeouts FsxOntapFileSystem#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: FsxOntapFileSystemTimeouts;
}
/**
 * @stability stable
 */
export declare class FsxOntapFileSystemEndpointsIntercluster extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get dnsName(): string;
    /**
     * @stability stable
     */
    get ipAddresses(): string[];
}
/**
 * @stability stable
 */
export declare class FsxOntapFileSystemEndpointsManagement extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get dnsName(): string;
    /**
     * @stability stable
     */
    get ipAddresses(): string[];
}
/**
 * @stability stable
 */
export declare class FsxOntapFileSystemEndpoints extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get intercluster(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get management(): cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface FsxOntapFileSystemDiskIopsConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system#iops FsxOntapFileSystem#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system#mode FsxOntapFileSystem#mode}.
     *
     * @stability stable
     */
    readonly mode?: string;
}
export declare function fsxOntapFileSystemDiskIopsConfigurationToTerraform(struct?: FsxOntapFileSystemDiskIopsConfigurationOutputReference | FsxOntapFileSystemDiskIopsConfiguration): any;
/**
 * @stability stable
 */
export declare class FsxOntapFileSystemDiskIopsConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): FsxOntapFileSystemDiskIopsConfiguration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: FsxOntapFileSystemDiskIopsConfiguration | undefined);
    private _iops?;
    /**
     * @stability stable
     */
    get iops(): number;
    /**
     * @stability stable
     */
    set iops(value: number);
    /**
     * @stability stable
     */
    resetIops(): void;
    /**
     * @stability stable
     */
    get iopsInput(): number | undefined;
    private _mode?;
    /**
     * @stability stable
     */
    get mode(): string;
    /**
     * @stability stable
     */
    set mode(value: string);
    /**
     * @stability stable
     */
    resetMode(): void;
    /**
     * @stability stable
     */
    get modeInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface FsxOntapFileSystemTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system#create FsxOntapFileSystem#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system#delete FsxOntapFileSystem#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system#update FsxOntapFileSystem#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function fsxOntapFileSystemTimeoutsToTerraform(struct?: FsxOntapFileSystemTimeoutsOutputReference | FsxOntapFileSystemTimeouts | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export declare class FsxOntapFileSystemTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): FsxOntapFileSystemTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: FsxOntapFileSystemTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system aws_fsx_ontap_file_system}.
 *
 * @stability stable
 */
export declare class FsxOntapFileSystem extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_file_system aws_fsx_ontap_file_system} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: FsxOntapFileSystemConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _automaticBackupRetentionDays?;
    /**
     * @stability stable
     */
    get automaticBackupRetentionDays(): number;
    /**
     * @stability stable
     */
    set automaticBackupRetentionDays(value: number);
    /**
     * @stability stable
     */
    resetAutomaticBackupRetentionDays(): void;
    /**
     * @stability stable
     */
    get automaticBackupRetentionDaysInput(): number | undefined;
    private _dailyAutomaticBackupStartTime?;
    /**
     * @stability stable
     */
    get dailyAutomaticBackupStartTime(): string;
    /**
     * @stability stable
     */
    set dailyAutomaticBackupStartTime(value: string);
    /**
     * @stability stable
     */
    resetDailyAutomaticBackupStartTime(): void;
    /**
     * @stability stable
     */
    get dailyAutomaticBackupStartTimeInput(): string | undefined;
    private _deploymentType?;
    /**
     * @stability stable
     */
    get deploymentType(): string;
    /**
     * @stability stable
     */
    set deploymentType(value: string);
    /**
     * @stability stable
     */
    get deploymentTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get dnsName(): string;
    private _endpointIpAddressRange?;
    /**
     * @stability stable
     */
    get endpointIpAddressRange(): string;
    /**
     * @stability stable
     */
    set endpointIpAddressRange(value: string);
    /**
     * @stability stable
     */
    resetEndpointIpAddressRange(): void;
    /**
     * @stability stable
     */
    get endpointIpAddressRangeInput(): string | undefined;
    /**
     * @stability stable
     */
    endpoints(index: string): FsxOntapFileSystemEndpoints;
    private _fsxAdminPassword?;
    /**
     * @stability stable
     */
    get fsxAdminPassword(): string;
    /**
     * @stability stable
     */
    set fsxAdminPassword(value: string);
    /**
     * @stability stable
     */
    resetFsxAdminPassword(): void;
    /**
     * @stability stable
     */
    get fsxAdminPasswordInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get networkInterfaceIds(): string[];
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _preferredSubnetId?;
    /**
     * @stability stable
     */
    get preferredSubnetId(): string;
    /**
     * @stability stable
     */
    set preferredSubnetId(value: string);
    /**
     * @stability stable
     */
    get preferredSubnetIdInput(): string | undefined;
    private _routeTableIds?;
    /**
     * @stability stable
     */
    get routeTableIds(): string[];
    /**
     * @stability stable
     */
    set routeTableIds(value: string[]);
    /**
     * @stability stable
     */
    resetRouteTableIds(): void;
    /**
     * @stability stable
     */
    get routeTableIdsInput(): string[] | undefined;
    private _securityGroupIds?;
    /**
     * @stability stable
     */
    get securityGroupIds(): string[];
    /**
     * @stability stable
     */
    set securityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get securityGroupIdsInput(): string[] | undefined;
    private _storageCapacity?;
    /**
     * @stability stable
     */
    get storageCapacity(): number;
    /**
     * @stability stable
     */
    set storageCapacity(value: number);
    /**
     * @stability stable
     */
    resetStorageCapacity(): void;
    /**
     * @stability stable
     */
    get storageCapacityInput(): number | undefined;
    private _storageType?;
    /**
     * @stability stable
     */
    get storageType(): string;
    /**
     * @stability stable
     */
    set storageType(value: string);
    /**
     * @stability stable
     */
    resetStorageType(): void;
    /**
     * @stability stable
     */
    get storageTypeInput(): string | undefined;
    private _subnetIds?;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    set subnetIds(value: string[]);
    /**
     * @stability stable
     */
    get subnetIdsInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _throughputCapacity?;
    /**
     * @stability stable
     */
    get throughputCapacity(): number;
    /**
     * @stability stable
     */
    set throughputCapacity(value: number);
    /**
     * @stability stable
     */
    get throughputCapacityInput(): number | undefined;
    /**
     * @stability stable
     */
    get vpcId(): string;
    private _weeklyMaintenanceStartTime?;
    /**
     * @stability stable
     */
    get weeklyMaintenanceStartTime(): string;
    /**
     * @stability stable
     */
    set weeklyMaintenanceStartTime(value: string);
    /**
     * @stability stable
     */
    resetWeeklyMaintenanceStartTime(): void;
    /**
     * @stability stable
     */
    get weeklyMaintenanceStartTimeInput(): string | undefined;
    private _diskIopsConfiguration;
    /**
     * @stability stable
     */
    get diskIopsConfiguration(): FsxOntapFileSystemDiskIopsConfigurationOutputReference;
    /**
     * @stability stable
     */
    putDiskIopsConfiguration(value: FsxOntapFileSystemDiskIopsConfiguration): void;
    /**
     * @stability stable
     */
    resetDiskIopsConfiguration(): void;
    /**
     * @stability stable
     */
    get diskIopsConfigurationInput(): FsxOntapFileSystemDiskIopsConfiguration | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): FsxOntapFileSystemTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: FsxOntapFileSystemTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): FsxOntapFileSystemTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
