import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS File System FSx.
 *
 * @stability stable
 */
export interface FsxOntapVolumeConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_volume#junction_path FsxOntapVolume#junction_path}.
     *
     * @stability stable
     */
    readonly junctionPath: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_volume#name FsxOntapVolume#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_volume#security_style FsxOntapVolume#security_style}.
     *
     * @stability stable
     */
    readonly securityStyle?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_volume#size_in_megabytes FsxOntapVolume#size_in_megabytes}.
     *
     * @stability stable
     */
    readonly sizeInMegabytes: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_volume#storage_efficiency_enabled FsxOntapVolume#storage_efficiency_enabled}.
     *
     * @stability stable
     */
    readonly storageEfficiencyEnabled: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_volume#storage_virtual_machine_id FsxOntapVolume#storage_virtual_machine_id}.
     *
     * @stability stable
     */
    readonly storageVirtualMachineId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_volume#tags FsxOntapVolume#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_volume#tags_all FsxOntapVolume#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_volume#volume_type FsxOntapVolume#volume_type}.
     *
     * @stability stable
     */
    readonly volumeType?: string;
    /**
     * tiering_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_volume#tiering_policy FsxOntapVolume#tiering_policy}
     *
     * @stability stable
     */
    readonly tieringPolicy?: FsxOntapVolumeTieringPolicy;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_volume#timeouts FsxOntapVolume#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: FsxOntapVolumeTimeouts;
}
/**
 * @stability stable
 */
export interface FsxOntapVolumeTieringPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_volume#cooling_period FsxOntapVolume#cooling_period}.
     *
     * @stability stable
     */
    readonly coolingPeriod?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_volume#name FsxOntapVolume#name}.
     *
     * @stability stable
     */
    readonly name?: string;
}
export declare function fsxOntapVolumeTieringPolicyToTerraform(struct?: FsxOntapVolumeTieringPolicyOutputReference | FsxOntapVolumeTieringPolicy): any;
/**
 * @stability stable
 */
export declare class FsxOntapVolumeTieringPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): FsxOntapVolumeTieringPolicy | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: FsxOntapVolumeTieringPolicy | undefined);
    private _coolingPeriod?;
    /**
     * @stability stable
     */
    get coolingPeriod(): number;
    /**
     * @stability stable
     */
    set coolingPeriod(value: number);
    /**
     * @stability stable
     */
    resetCoolingPeriod(): void;
    /**
     * @stability stable
     */
    get coolingPeriodInput(): number | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface FsxOntapVolumeTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_volume#create FsxOntapVolume#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_volume#delete FsxOntapVolume#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_volume#update FsxOntapVolume#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function fsxOntapVolumeTimeoutsToTerraform(struct?: FsxOntapVolumeTimeoutsOutputReference | FsxOntapVolumeTimeouts | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export declare class FsxOntapVolumeTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): FsxOntapVolumeTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: FsxOntapVolumeTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_volume aws_fsx_ontap_volume}.
 *
 * @stability stable
 */
export declare class FsxOntapVolume extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/fsx_ontap_volume aws_fsx_ontap_volume} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: FsxOntapVolumeConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get fileSystemId(): string;
    /**
     * @stability stable
     */
    get flexcacheEndpointType(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _junctionPath?;
    /**
     * @stability stable
     */
    get junctionPath(): string;
    /**
     * @stability stable
     */
    set junctionPath(value: string);
    /**
     * @stability stable
     */
    get junctionPathInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get ontapVolumeType(): string;
    private _securityStyle?;
    /**
     * @stability stable
     */
    get securityStyle(): string;
    /**
     * @stability stable
     */
    set securityStyle(value: string);
    /**
     * @stability stable
     */
    resetSecurityStyle(): void;
    /**
     * @stability stable
     */
    get securityStyleInput(): string | undefined;
    private _sizeInMegabytes?;
    /**
     * @stability stable
     */
    get sizeInMegabytes(): number;
    /**
     * @stability stable
     */
    set sizeInMegabytes(value: number);
    /**
     * @stability stable
     */
    get sizeInMegabytesInput(): number | undefined;
    private _storageEfficiencyEnabled?;
    /**
     * @stability stable
     */
    get storageEfficiencyEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set storageEfficiencyEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get storageEfficiencyEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _storageVirtualMachineId?;
    /**
     * @stability stable
     */
    get storageVirtualMachineId(): string;
    /**
     * @stability stable
     */
    set storageVirtualMachineId(value: string);
    /**
     * @stability stable
     */
    get storageVirtualMachineIdInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get uuid(): string;
    private _volumeType?;
    /**
     * @stability stable
     */
    get volumeType(): string;
    /**
     * @stability stable
     */
    set volumeType(value: string);
    /**
     * @stability stable
     */
    resetVolumeType(): void;
    /**
     * @stability stable
     */
    get volumeTypeInput(): string | undefined;
    private _tieringPolicy;
    /**
     * @stability stable
     */
    get tieringPolicy(): FsxOntapVolumeTieringPolicyOutputReference;
    /**
     * @stability stable
     */
    putTieringPolicy(value: FsxOntapVolumeTieringPolicy): void;
    /**
     * @stability stable
     */
    resetTieringPolicy(): void;
    /**
     * @stability stable
     */
    get tieringPolicyInput(): FsxOntapVolumeTieringPolicy | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): FsxOntapVolumeTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: FsxOntapVolumeTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): FsxOntapVolumeTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
