import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS GameLift.
 *
 * @stability stable
 */
export interface GameliftFleetConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#build_id GameliftFleet#build_id}.
     *
     * @stability stable
     */
    readonly buildId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#description GameliftFleet#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#ec2_instance_type GameliftFleet#ec2_instance_type}.
     *
     * @stability stable
     */
    readonly ec2InstanceType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#fleet_type GameliftFleet#fleet_type}.
     *
     * @stability stable
     */
    readonly fleetType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#instance_role_arn GameliftFleet#instance_role_arn}.
     *
     * @stability stable
     */
    readonly instanceRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#metric_groups GameliftFleet#metric_groups}.
     *
     * @stability stable
     */
    readonly metricGroups?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#name GameliftFleet#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#new_game_session_protection_policy GameliftFleet#new_game_session_protection_policy}.
     *
     * @stability stable
     */
    readonly newGameSessionProtectionPolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#tags GameliftFleet#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#tags_all GameliftFleet#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * ec2_inbound_permission block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#ec2_inbound_permission GameliftFleet#ec2_inbound_permission}
     *
     * @stability stable
     */
    readonly ec2InboundPermission?: GameliftFleetEc2InboundPermission[] | cdktf.IResolvable;
    /**
     * resource_creation_limit_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#resource_creation_limit_policy GameliftFleet#resource_creation_limit_policy}
     *
     * @stability stable
     */
    readonly resourceCreationLimitPolicy?: GameliftFleetResourceCreationLimitPolicy;
    /**
     * runtime_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#runtime_configuration GameliftFleet#runtime_configuration}
     *
     * @stability stable
     */
    readonly runtimeConfiguration?: GameliftFleetRuntimeConfiguration;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#timeouts GameliftFleet#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: GameliftFleetTimeouts;
}
/**
 * @stability stable
 */
export interface GameliftFleetEc2InboundPermission {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#from_port GameliftFleet#from_port}.
     *
     * @stability stable
     */
    readonly fromPort: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#ip_range GameliftFleet#ip_range}.
     *
     * @stability stable
     */
    readonly ipRange: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#protocol GameliftFleet#protocol}.
     *
     * @stability stable
     */
    readonly protocol: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#to_port GameliftFleet#to_port}.
     *
     * @stability stable
     */
    readonly toPort: number;
}
export declare function gameliftFleetEc2InboundPermissionToTerraform(struct?: GameliftFleetEc2InboundPermission | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface GameliftFleetResourceCreationLimitPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#new_game_sessions_per_creator GameliftFleet#new_game_sessions_per_creator}.
     *
     * @stability stable
     */
    readonly newGameSessionsPerCreator?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#policy_period_in_minutes GameliftFleet#policy_period_in_minutes}.
     *
     * @stability stable
     */
    readonly policyPeriodInMinutes?: number;
}
export declare function gameliftFleetResourceCreationLimitPolicyToTerraform(struct?: GameliftFleetResourceCreationLimitPolicyOutputReference | GameliftFleetResourceCreationLimitPolicy): any;
/**
 * @stability stable
 */
export declare class GameliftFleetResourceCreationLimitPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): GameliftFleetResourceCreationLimitPolicy | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: GameliftFleetResourceCreationLimitPolicy | undefined);
    private _newGameSessionsPerCreator?;
    /**
     * @stability stable
     */
    get newGameSessionsPerCreator(): number;
    /**
     * @stability stable
     */
    set newGameSessionsPerCreator(value: number);
    /**
     * @stability stable
     */
    resetNewGameSessionsPerCreator(): void;
    /**
     * @stability stable
     */
    get newGameSessionsPerCreatorInput(): number | undefined;
    private _policyPeriodInMinutes?;
    /**
     * @stability stable
     */
    get policyPeriodInMinutes(): number;
    /**
     * @stability stable
     */
    set policyPeriodInMinutes(value: number);
    /**
     * @stability stable
     */
    resetPolicyPeriodInMinutes(): void;
    /**
     * @stability stable
     */
    get policyPeriodInMinutesInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface GameliftFleetRuntimeConfigurationServerProcess {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#concurrent_executions GameliftFleet#concurrent_executions}.
     *
     * @stability stable
     */
    readonly concurrentExecutions: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#launch_path GameliftFleet#launch_path}.
     *
     * @stability stable
     */
    readonly launchPath: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#parameters GameliftFleet#parameters}.
     *
     * @stability stable
     */
    readonly parameters?: string;
}
export declare function gameliftFleetRuntimeConfigurationServerProcessToTerraform(struct?: GameliftFleetRuntimeConfigurationServerProcess | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface GameliftFleetRuntimeConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#game_session_activation_timeout_seconds GameliftFleet#game_session_activation_timeout_seconds}.
     *
     * @stability stable
     */
    readonly gameSessionActivationTimeoutSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#max_concurrent_game_session_activations GameliftFleet#max_concurrent_game_session_activations}.
     *
     * @stability stable
     */
    readonly maxConcurrentGameSessionActivations?: number;
    /**
     * server_process block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#server_process GameliftFleet#server_process}
     *
     * @stability stable
     */
    readonly serverProcess?: GameliftFleetRuntimeConfigurationServerProcess[] | cdktf.IResolvable;
}
export declare function gameliftFleetRuntimeConfigurationToTerraform(struct?: GameliftFleetRuntimeConfigurationOutputReference | GameliftFleetRuntimeConfiguration): any;
/**
 * @stability stable
 */
export declare class GameliftFleetRuntimeConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): GameliftFleetRuntimeConfiguration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: GameliftFleetRuntimeConfiguration | undefined);
    private _gameSessionActivationTimeoutSeconds?;
    /**
     * @stability stable
     */
    get gameSessionActivationTimeoutSeconds(): number;
    /**
     * @stability stable
     */
    set gameSessionActivationTimeoutSeconds(value: number);
    /**
     * @stability stable
     */
    resetGameSessionActivationTimeoutSeconds(): void;
    /**
     * @stability stable
     */
    get gameSessionActivationTimeoutSecondsInput(): number | undefined;
    private _maxConcurrentGameSessionActivations?;
    /**
     * @stability stable
     */
    get maxConcurrentGameSessionActivations(): number;
    /**
     * @stability stable
     */
    set maxConcurrentGameSessionActivations(value: number);
    /**
     * @stability stable
     */
    resetMaxConcurrentGameSessionActivations(): void;
    /**
     * @stability stable
     */
    get maxConcurrentGameSessionActivationsInput(): number | undefined;
    private _serverProcess?;
    /**
     * @stability stable
     */
    get serverProcess(): GameliftFleetRuntimeConfigurationServerProcess[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set serverProcess(value: GameliftFleetRuntimeConfigurationServerProcess[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetServerProcess(): void;
    /**
     * @stability stable
     */
    get serverProcessInput(): cdktf.IResolvable | GameliftFleetRuntimeConfigurationServerProcess[] | undefined;
}
/**
 * @stability stable
 */
export interface GameliftFleetTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#create GameliftFleet#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet#delete GameliftFleet#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
}
export declare function gameliftFleetTimeoutsToTerraform(struct?: GameliftFleetTimeoutsOutputReference | GameliftFleetTimeouts | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export declare class GameliftFleetTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): GameliftFleetTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: GameliftFleetTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet aws_gamelift_fleet}.
 *
 * @stability stable
 */
export declare class GameliftFleet extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/gamelift_fleet aws_gamelift_fleet} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GameliftFleetConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _buildId?;
    /**
     * @stability stable
     */
    get buildId(): string;
    /**
     * @stability stable
     */
    set buildId(value: string);
    /**
     * @stability stable
     */
    get buildIdInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _ec2InstanceType?;
    /**
     * @stability stable
     */
    get ec2InstanceType(): string;
    /**
     * @stability stable
     */
    set ec2InstanceType(value: string);
    /**
     * @stability stable
     */
    get ec2InstanceTypeInput(): string | undefined;
    private _fleetType?;
    /**
     * @stability stable
     */
    get fleetType(): string;
    /**
     * @stability stable
     */
    set fleetType(value: string);
    /**
     * @stability stable
     */
    resetFleetType(): void;
    /**
     * @stability stable
     */
    get fleetTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceRoleArn?;
    /**
     * @stability stable
     */
    get instanceRoleArn(): string;
    /**
     * @stability stable
     */
    set instanceRoleArn(value: string);
    /**
     * @stability stable
     */
    resetInstanceRoleArn(): void;
    /**
     * @stability stable
     */
    get instanceRoleArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get logPaths(): string[];
    private _metricGroups?;
    /**
     * @stability stable
     */
    get metricGroups(): string[];
    /**
     * @stability stable
     */
    set metricGroups(value: string[]);
    /**
     * @stability stable
     */
    resetMetricGroups(): void;
    /**
     * @stability stable
     */
    get metricGroupsInput(): string[] | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _newGameSessionProtectionPolicy?;
    /**
     * @stability stable
     */
    get newGameSessionProtectionPolicy(): string;
    /**
     * @stability stable
     */
    set newGameSessionProtectionPolicy(value: string);
    /**
     * @stability stable
     */
    resetNewGameSessionProtectionPolicy(): void;
    /**
     * @stability stable
     */
    get newGameSessionProtectionPolicyInput(): string | undefined;
    /**
     * @stability stable
     */
    get operatingSystem(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _ec2InboundPermission?;
    /**
     * @stability stable
     */
    get ec2InboundPermission(): GameliftFleetEc2InboundPermission[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set ec2InboundPermission(value: GameliftFleetEc2InboundPermission[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEc2InboundPermission(): void;
    /**
     * @stability stable
     */
    get ec2InboundPermissionInput(): cdktf.IResolvable | GameliftFleetEc2InboundPermission[] | undefined;
    private _resourceCreationLimitPolicy;
    /**
     * @stability stable
     */
    get resourceCreationLimitPolicy(): GameliftFleetResourceCreationLimitPolicyOutputReference;
    /**
     * @stability stable
     */
    putResourceCreationLimitPolicy(value: GameliftFleetResourceCreationLimitPolicy): void;
    /**
     * @stability stable
     */
    resetResourceCreationLimitPolicy(): void;
    /**
     * @stability stable
     */
    get resourceCreationLimitPolicyInput(): GameliftFleetResourceCreationLimitPolicy | undefined;
    private _runtimeConfiguration;
    /**
     * @stability stable
     */
    get runtimeConfiguration(): GameliftFleetRuntimeConfigurationOutputReference;
    /**
     * @stability stable
     */
    putRuntimeConfiguration(value: GameliftFleetRuntimeConfiguration): void;
    /**
     * @stability stable
     */
    resetRuntimeConfiguration(): void;
    /**
     * @stability stable
     */
    get runtimeConfigurationInput(): GameliftFleetRuntimeConfiguration | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): GameliftFleetTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: GameliftFleetTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): GameliftFleetTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
