import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Global Accelerator.
 *
 * @stability stable
 */
export interface GlobalacceleratorEndpointGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group#endpoint_group_region GlobalacceleratorEndpointGroup#endpoint_group_region}.
     *
     * @stability stable
     */
    readonly endpointGroupRegion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group#health_check_interval_seconds GlobalacceleratorEndpointGroup#health_check_interval_seconds}.
     *
     * @stability stable
     */
    readonly healthCheckIntervalSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group#health_check_path GlobalacceleratorEndpointGroup#health_check_path}.
     *
     * @stability stable
     */
    readonly healthCheckPath?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group#health_check_port GlobalacceleratorEndpointGroup#health_check_port}.
     *
     * @stability stable
     */
    readonly healthCheckPort?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group#health_check_protocol GlobalacceleratorEndpointGroup#health_check_protocol}.
     *
     * @stability stable
     */
    readonly healthCheckProtocol?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group#listener_arn GlobalacceleratorEndpointGroup#listener_arn}.
     *
     * @stability stable
     */
    readonly listenerArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group#threshold_count GlobalacceleratorEndpointGroup#threshold_count}.
     *
     * @stability stable
     */
    readonly thresholdCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group#traffic_dial_percentage GlobalacceleratorEndpointGroup#traffic_dial_percentage}.
     *
     * @stability stable
     */
    readonly trafficDialPercentage?: number;
    /**
     * endpoint_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group#endpoint_configuration GlobalacceleratorEndpointGroup#endpoint_configuration}
     *
     * @stability stable
     */
    readonly endpointConfiguration?: GlobalacceleratorEndpointGroupEndpointConfiguration[] | cdktf.IResolvable;
    /**
     * port_override block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group#port_override GlobalacceleratorEndpointGroup#port_override}
     *
     * @stability stable
     */
    readonly portOverride?: GlobalacceleratorEndpointGroupPortOverride[] | cdktf.IResolvable;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group#timeouts GlobalacceleratorEndpointGroup#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: GlobalacceleratorEndpointGroupTimeouts;
}
/**
 * @stability stable
 */
export interface GlobalacceleratorEndpointGroupEndpointConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group#client_ip_preservation_enabled GlobalacceleratorEndpointGroup#client_ip_preservation_enabled}.
     *
     * @stability stable
     */
    readonly clientIpPreservationEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group#endpoint_id GlobalacceleratorEndpointGroup#endpoint_id}.
     *
     * @stability stable
     */
    readonly endpointId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group#weight GlobalacceleratorEndpointGroup#weight}.
     *
     * @stability stable
     */
    readonly weight?: number;
}
export declare function globalacceleratorEndpointGroupEndpointConfigurationToTerraform(struct?: GlobalacceleratorEndpointGroupEndpointConfiguration | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface GlobalacceleratorEndpointGroupPortOverride {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group#endpoint_port GlobalacceleratorEndpointGroup#endpoint_port}.
     *
     * @stability stable
     */
    readonly endpointPort: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group#listener_port GlobalacceleratorEndpointGroup#listener_port}.
     *
     * @stability stable
     */
    readonly listenerPort: number;
}
export declare function globalacceleratorEndpointGroupPortOverrideToTerraform(struct?: GlobalacceleratorEndpointGroupPortOverride | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface GlobalacceleratorEndpointGroupTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group#create GlobalacceleratorEndpointGroup#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group#delete GlobalacceleratorEndpointGroup#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group#update GlobalacceleratorEndpointGroup#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function globalacceleratorEndpointGroupTimeoutsToTerraform(struct?: GlobalacceleratorEndpointGroupTimeoutsOutputReference | GlobalacceleratorEndpointGroupTimeouts | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export declare class GlobalacceleratorEndpointGroupTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): GlobalacceleratorEndpointGroupTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: GlobalacceleratorEndpointGroupTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group aws_globalaccelerator_endpoint_group}.
 *
 * @stability stable
 */
export declare class GlobalacceleratorEndpointGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_endpoint_group aws_globalaccelerator_endpoint_group} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlobalacceleratorEndpointGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _endpointGroupRegion?;
    /**
     * @stability stable
     */
    get endpointGroupRegion(): string;
    /**
     * @stability stable
     */
    set endpointGroupRegion(value: string);
    /**
     * @stability stable
     */
    resetEndpointGroupRegion(): void;
    /**
     * @stability stable
     */
    get endpointGroupRegionInput(): string | undefined;
    private _healthCheckIntervalSeconds?;
    /**
     * @stability stable
     */
    get healthCheckIntervalSeconds(): number;
    /**
     * @stability stable
     */
    set healthCheckIntervalSeconds(value: number);
    /**
     * @stability stable
     */
    resetHealthCheckIntervalSeconds(): void;
    /**
     * @stability stable
     */
    get healthCheckIntervalSecondsInput(): number | undefined;
    private _healthCheckPath?;
    /**
     * @stability stable
     */
    get healthCheckPath(): string;
    /**
     * @stability stable
     */
    set healthCheckPath(value: string);
    /**
     * @stability stable
     */
    resetHealthCheckPath(): void;
    /**
     * @stability stable
     */
    get healthCheckPathInput(): string | undefined;
    private _healthCheckPort?;
    /**
     * @stability stable
     */
    get healthCheckPort(): number;
    /**
     * @stability stable
     */
    set healthCheckPort(value: number);
    /**
     * @stability stable
     */
    resetHealthCheckPort(): void;
    /**
     * @stability stable
     */
    get healthCheckPortInput(): number | undefined;
    private _healthCheckProtocol?;
    /**
     * @stability stable
     */
    get healthCheckProtocol(): string;
    /**
     * @stability stable
     */
    set healthCheckProtocol(value: string);
    /**
     * @stability stable
     */
    resetHealthCheckProtocol(): void;
    /**
     * @stability stable
     */
    get healthCheckProtocolInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _listenerArn?;
    /**
     * @stability stable
     */
    get listenerArn(): string;
    /**
     * @stability stable
     */
    set listenerArn(value: string);
    /**
     * @stability stable
     */
    get listenerArnInput(): string | undefined;
    private _thresholdCount?;
    /**
     * @stability stable
     */
    get thresholdCount(): number;
    /**
     * @stability stable
     */
    set thresholdCount(value: number);
    /**
     * @stability stable
     */
    resetThresholdCount(): void;
    /**
     * @stability stable
     */
    get thresholdCountInput(): number | undefined;
    private _trafficDialPercentage?;
    /**
     * @stability stable
     */
    get trafficDialPercentage(): number;
    /**
     * @stability stable
     */
    set trafficDialPercentage(value: number);
    /**
     * @stability stable
     */
    resetTrafficDialPercentage(): void;
    /**
     * @stability stable
     */
    get trafficDialPercentageInput(): number | undefined;
    private _endpointConfiguration?;
    /**
     * @stability stable
     */
    get endpointConfiguration(): GlobalacceleratorEndpointGroupEndpointConfiguration[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set endpointConfiguration(value: GlobalacceleratorEndpointGroupEndpointConfiguration[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEndpointConfiguration(): void;
    /**
     * @stability stable
     */
    get endpointConfigurationInput(): cdktf.IResolvable | GlobalacceleratorEndpointGroupEndpointConfiguration[] | undefined;
    private _portOverride?;
    /**
     * @stability stable
     */
    get portOverride(): GlobalacceleratorEndpointGroupPortOverride[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set portOverride(value: GlobalacceleratorEndpointGroupPortOverride[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetPortOverride(): void;
    /**
     * @stability stable
     */
    get portOverrideInput(): cdktf.IResolvable | GlobalacceleratorEndpointGroupPortOverride[] | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): GlobalacceleratorEndpointGroupTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: GlobalacceleratorEndpointGroupTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): GlobalacceleratorEndpointGroupTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
