import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Global Accelerator.
 *
 * @stability stable
 */
export interface GlobalacceleratorListenerConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener#accelerator_arn GlobalacceleratorListener#accelerator_arn}.
     *
     * @stability stable
     */
    readonly acceleratorArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener#client_affinity GlobalacceleratorListener#client_affinity}.
     *
     * @stability stable
     */
    readonly clientAffinity?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener#protocol GlobalacceleratorListener#protocol}.
     *
     * @stability stable
     */
    readonly protocol: string;
    /**
     * port_range block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener#port_range GlobalacceleratorListener#port_range}
     *
     * @stability stable
     */
    readonly portRange: GlobalacceleratorListenerPortRange[] | cdktf.IResolvable;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener#timeouts GlobalacceleratorListener#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: GlobalacceleratorListenerTimeouts;
}
/**
 * @stability stable
 */
export interface GlobalacceleratorListenerPortRange {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener#from_port GlobalacceleratorListener#from_port}.
     *
     * @stability stable
     */
    readonly fromPort?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener#to_port GlobalacceleratorListener#to_port}.
     *
     * @stability stable
     */
    readonly toPort?: number;
}
export declare function globalacceleratorListenerPortRangeToTerraform(struct?: GlobalacceleratorListenerPortRange | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface GlobalacceleratorListenerTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener#create GlobalacceleratorListener#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener#delete GlobalacceleratorListener#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener#update GlobalacceleratorListener#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function globalacceleratorListenerTimeoutsToTerraform(struct?: GlobalacceleratorListenerTimeoutsOutputReference | GlobalacceleratorListenerTimeouts | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export declare class GlobalacceleratorListenerTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): GlobalacceleratorListenerTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: GlobalacceleratorListenerTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener aws_globalaccelerator_listener}.
 *
 * @stability stable
 */
export declare class GlobalacceleratorListener extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_listener aws_globalaccelerator_listener} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlobalacceleratorListenerConfig);
    private _acceleratorArn?;
    /**
     * @stability stable
     */
    get acceleratorArn(): string;
    /**
     * @stability stable
     */
    set acceleratorArn(value: string);
    /**
     * @stability stable
     */
    get acceleratorArnInput(): string | undefined;
    private _clientAffinity?;
    /**
     * @stability stable
     */
    get clientAffinity(): string;
    /**
     * @stability stable
     */
    set clientAffinity(value: string);
    /**
     * @stability stable
     */
    resetClientAffinity(): void;
    /**
     * @stability stable
     */
    get clientAffinityInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _protocol?;
    /**
     * @stability stable
     */
    get protocol(): string;
    /**
     * @stability stable
     */
    set protocol(value: string);
    /**
     * @stability stable
     */
    get protocolInput(): string | undefined;
    private _portRange?;
    /**
     * @stability stable
     */
    get portRange(): GlobalacceleratorListenerPortRange[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set portRange(value: GlobalacceleratorListenerPortRange[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get portRangeInput(): cdktf.IResolvable | GlobalacceleratorListenerPortRange[] | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): GlobalacceleratorListenerTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: GlobalacceleratorListenerTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): GlobalacceleratorListenerTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
