import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Glue.
 *
 * @stability stable
 */
export interface DataAwsGlueScriptConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script#language DataAwsGlueScript#language}.
     *
     * @stability stable
     */
    readonly language?: string;
    /**
     * dag_edge block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script#dag_edge DataAwsGlueScript#dag_edge}
     *
     * @stability stable
     */
    readonly dagEdge: DataAwsGlueScriptDagEdge[] | cdktf.IResolvable;
    /**
     * dag_node block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script#dag_node DataAwsGlueScript#dag_node}
     *
     * @stability stable
     */
    readonly dagNode: DataAwsGlueScriptDagNode[] | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface DataAwsGlueScriptDagEdge {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script#source DataAwsGlueScript#source}.
     *
     * @stability stable
     */
    readonly source: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script#target DataAwsGlueScript#target}.
     *
     * @stability stable
     */
    readonly target: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script#target_parameter DataAwsGlueScript#target_parameter}.
     *
     * @stability stable
     */
    readonly targetParameter?: string;
}
export declare function dataAwsGlueScriptDagEdgeToTerraform(struct?: DataAwsGlueScriptDagEdge | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface DataAwsGlueScriptDagNodeArgs {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script#name DataAwsGlueScript#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script#param DataAwsGlueScript#param}.
     *
     * @stability stable
     */
    readonly param?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script#value DataAwsGlueScript#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function dataAwsGlueScriptDagNodeArgsToTerraform(struct?: DataAwsGlueScriptDagNodeArgs | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface DataAwsGlueScriptDagNode {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script#id DataAwsGlueScript#id}.
     *
     * @stability stable
     */
    readonly id: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script#line_number DataAwsGlueScript#line_number}.
     *
     * @stability stable
     */
    readonly lineNumber?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script#node_type DataAwsGlueScript#node_type}.
     *
     * @stability stable
     */
    readonly nodeType: string;
    /**
     * args block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/glue_script#args DataAwsGlueScript#args}
     *
     * @stability stable
     */
    readonly args: DataAwsGlueScriptDagNodeArgs[] | cdktf.IResolvable;
}
export declare function dataAwsGlueScriptDagNodeToTerraform(struct?: DataAwsGlueScriptDagNode | cdktf.IResolvable): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/glue_script aws_glue_script}.
 *
 * @stability stable
 */
export declare class DataAwsGlueScript extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/glue_script aws_glue_script} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsGlueScriptConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _language?;
    /**
     * @stability stable
     */
    get language(): string;
    /**
     * @stability stable
     */
    set language(value: string);
    /**
     * @stability stable
     */
    resetLanguage(): void;
    /**
     * @stability stable
     */
    get languageInput(): string | undefined;
    /**
     * @stability stable
     */
    get pythonScript(): string;
    /**
     * @stability stable
     */
    get scalaCode(): string;
    private _dagEdge?;
    /**
     * @stability stable
     */
    get dagEdge(): DataAwsGlueScriptDagEdge[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set dagEdge(value: DataAwsGlueScriptDagEdge[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get dagEdgeInput(): cdktf.IResolvable | DataAwsGlueScriptDagEdge[] | undefined;
    private _dagNode?;
    /**
     * @stability stable
     */
    get dagNode(): DataAwsGlueScriptDagNode[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set dagNode(value: DataAwsGlueScriptDagNode[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get dagNodeInput(): cdktf.IResolvable | DataAwsGlueScriptDagNode[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
