import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Glue.
 *
 * @stability stable
 */
export interface GlueClassifierConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_classifier#name GlueClassifier#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * csv_classifier block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_classifier#csv_classifier GlueClassifier#csv_classifier}
     *
     * @stability stable
     */
    readonly csvClassifier?: GlueClassifierCsvClassifier;
    /**
     * grok_classifier block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_classifier#grok_classifier GlueClassifier#grok_classifier}
     *
     * @stability stable
     */
    readonly grokClassifier?: GlueClassifierGrokClassifier;
    /**
     * json_classifier block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_classifier#json_classifier GlueClassifier#json_classifier}
     *
     * @stability stable
     */
    readonly jsonClassifier?: GlueClassifierJsonClassifier;
    /**
     * xml_classifier block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_classifier#xml_classifier GlueClassifier#xml_classifier}
     *
     * @stability stable
     */
    readonly xmlClassifier?: GlueClassifierXmlClassifier;
}
/**
 * @stability stable
 */
export interface GlueClassifierCsvClassifier {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_classifier#allow_single_column GlueClassifier#allow_single_column}.
     *
     * @stability stable
     */
    readonly allowSingleColumn?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_classifier#contains_header GlueClassifier#contains_header}.
     *
     * @stability stable
     */
    readonly containsHeader?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_classifier#delimiter GlueClassifier#delimiter}.
     *
     * @stability stable
     */
    readonly delimiter?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_classifier#disable_value_trimming GlueClassifier#disable_value_trimming}.
     *
     * @stability stable
     */
    readonly disableValueTrimming?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_classifier#header GlueClassifier#header}.
     *
     * @stability stable
     */
    readonly header?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_classifier#quote_symbol GlueClassifier#quote_symbol}.
     *
     * @stability stable
     */
    readonly quoteSymbol?: string;
}
export declare function glueClassifierCsvClassifierToTerraform(struct?: GlueClassifierCsvClassifierOutputReference | GlueClassifierCsvClassifier): any;
/**
 * @stability stable
 */
export declare class GlueClassifierCsvClassifierOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): GlueClassifierCsvClassifier | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: GlueClassifierCsvClassifier | undefined);
    private _allowSingleColumn?;
    /**
     * @stability stable
     */
    get allowSingleColumn(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set allowSingleColumn(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAllowSingleColumn(): void;
    /**
     * @stability stable
     */
    get allowSingleColumnInput(): boolean | cdktf.IResolvable | undefined;
    private _containsHeader?;
    /**
     * @stability stable
     */
    get containsHeader(): string;
    /**
     * @stability stable
     */
    set containsHeader(value: string);
    /**
     * @stability stable
     */
    resetContainsHeader(): void;
    /**
     * @stability stable
     */
    get containsHeaderInput(): string | undefined;
    private _delimiter?;
    /**
     * @stability stable
     */
    get delimiter(): string;
    /**
     * @stability stable
     */
    set delimiter(value: string);
    /**
     * @stability stable
     */
    resetDelimiter(): void;
    /**
     * @stability stable
     */
    get delimiterInput(): string | undefined;
    private _disableValueTrimming?;
    /**
     * @stability stable
     */
    get disableValueTrimming(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set disableValueTrimming(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDisableValueTrimming(): void;
    /**
     * @stability stable
     */
    get disableValueTrimmingInput(): boolean | cdktf.IResolvable | undefined;
    private _header?;
    /**
     * @stability stable
     */
    get header(): string[];
    /**
     * @stability stable
     */
    set header(value: string[]);
    /**
     * @stability stable
     */
    resetHeader(): void;
    /**
     * @stability stable
     */
    get headerInput(): string[] | undefined;
    private _quoteSymbol?;
    /**
     * @stability stable
     */
    get quoteSymbol(): string;
    /**
     * @stability stable
     */
    set quoteSymbol(value: string);
    /**
     * @stability stable
     */
    resetQuoteSymbol(): void;
    /**
     * @stability stable
     */
    get quoteSymbolInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface GlueClassifierGrokClassifier {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_classifier#classification GlueClassifier#classification}.
     *
     * @stability stable
     */
    readonly classification: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_classifier#custom_patterns GlueClassifier#custom_patterns}.
     *
     * @stability stable
     */
    readonly customPatterns?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_classifier#grok_pattern GlueClassifier#grok_pattern}.
     *
     * @stability stable
     */
    readonly grokPattern: string;
}
export declare function glueClassifierGrokClassifierToTerraform(struct?: GlueClassifierGrokClassifierOutputReference | GlueClassifierGrokClassifier): any;
/**
 * @stability stable
 */
export declare class GlueClassifierGrokClassifierOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): GlueClassifierGrokClassifier | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: GlueClassifierGrokClassifier | undefined);
    private _classification?;
    /**
     * @stability stable
     */
    get classification(): string;
    /**
     * @stability stable
     */
    set classification(value: string);
    /**
     * @stability stable
     */
    get classificationInput(): string | undefined;
    private _customPatterns?;
    /**
     * @stability stable
     */
    get customPatterns(): string;
    /**
     * @stability stable
     */
    set customPatterns(value: string);
    /**
     * @stability stable
     */
    resetCustomPatterns(): void;
    /**
     * @stability stable
     */
    get customPatternsInput(): string | undefined;
    private _grokPattern?;
    /**
     * @stability stable
     */
    get grokPattern(): string;
    /**
     * @stability stable
     */
    set grokPattern(value: string);
    /**
     * @stability stable
     */
    get grokPatternInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface GlueClassifierJsonClassifier {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_classifier#json_path GlueClassifier#json_path}.
     *
     * @stability stable
     */
    readonly jsonPath: string;
}
export declare function glueClassifierJsonClassifierToTerraform(struct?: GlueClassifierJsonClassifierOutputReference | GlueClassifierJsonClassifier): any;
/**
 * @stability stable
 */
export declare class GlueClassifierJsonClassifierOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): GlueClassifierJsonClassifier | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: GlueClassifierJsonClassifier | undefined);
    private _jsonPath?;
    /**
     * @stability stable
     */
    get jsonPath(): string;
    /**
     * @stability stable
     */
    set jsonPath(value: string);
    /**
     * @stability stable
     */
    get jsonPathInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface GlueClassifierXmlClassifier {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_classifier#classification GlueClassifier#classification}.
     *
     * @stability stable
     */
    readonly classification: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_classifier#row_tag GlueClassifier#row_tag}.
     *
     * @stability stable
     */
    readonly rowTag: string;
}
export declare function glueClassifierXmlClassifierToTerraform(struct?: GlueClassifierXmlClassifierOutputReference | GlueClassifierXmlClassifier): any;
/**
 * @stability stable
 */
export declare class GlueClassifierXmlClassifierOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): GlueClassifierXmlClassifier | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: GlueClassifierXmlClassifier | undefined);
    private _classification?;
    /**
     * @stability stable
     */
    get classification(): string;
    /**
     * @stability stable
     */
    set classification(value: string);
    /**
     * @stability stable
     */
    get classificationInput(): string | undefined;
    private _rowTag?;
    /**
     * @stability stable
     */
    get rowTag(): string;
    /**
     * @stability stable
     */
    set rowTag(value: string);
    /**
     * @stability stable
     */
    get rowTagInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/glue_classifier aws_glue_classifier}.
 *
 * @stability stable
 */
export declare class GlueClassifier extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/glue_classifier aws_glue_classifier} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlueClassifierConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _csvClassifier;
    /**
     * @stability stable
     */
    get csvClassifier(): GlueClassifierCsvClassifierOutputReference;
    /**
     * @stability stable
     */
    putCsvClassifier(value: GlueClassifierCsvClassifier): void;
    /**
     * @stability stable
     */
    resetCsvClassifier(): void;
    /**
     * @stability stable
     */
    get csvClassifierInput(): GlueClassifierCsvClassifier | undefined;
    private _grokClassifier;
    /**
     * @stability stable
     */
    get grokClassifier(): GlueClassifierGrokClassifierOutputReference;
    /**
     * @stability stable
     */
    putGrokClassifier(value: GlueClassifierGrokClassifier): void;
    /**
     * @stability stable
     */
    resetGrokClassifier(): void;
    /**
     * @stability stable
     */
    get grokClassifierInput(): GlueClassifierGrokClassifier | undefined;
    private _jsonClassifier;
    /**
     * @stability stable
     */
    get jsonClassifier(): GlueClassifierJsonClassifierOutputReference;
    /**
     * @stability stable
     */
    putJsonClassifier(value: GlueClassifierJsonClassifier): void;
    /**
     * @stability stable
     */
    resetJsonClassifier(): void;
    /**
     * @stability stable
     */
    get jsonClassifierInput(): GlueClassifierJsonClassifier | undefined;
    private _xmlClassifier;
    /**
     * @stability stable
     */
    get xmlClassifier(): GlueClassifierXmlClassifierOutputReference;
    /**
     * @stability stable
     */
    putXmlClassifier(value: GlueClassifierXmlClassifier): void;
    /**
     * @stability stable
     */
    resetXmlClassifier(): void;
    /**
     * @stability stable
     */
    get xmlClassifierInput(): GlueClassifierXmlClassifier | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
