import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Glue.
 *
 * @stability stable
 */
export interface GlueCrawlerConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#classifiers GlueCrawler#classifiers}.
     *
     * @stability stable
     */
    readonly classifiers?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#configuration GlueCrawler#configuration}.
     *
     * @stability stable
     */
    readonly configuration?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#database_name GlueCrawler#database_name}.
     *
     * @stability stable
     */
    readonly databaseName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#description GlueCrawler#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#name GlueCrawler#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#role GlueCrawler#role}.
     *
     * @stability stable
     */
    readonly role: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#schedule GlueCrawler#schedule}.
     *
     * @stability stable
     */
    readonly schedule?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#security_configuration GlueCrawler#security_configuration}.
     *
     * @stability stable
     */
    readonly securityConfiguration?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#table_prefix GlueCrawler#table_prefix}.
     *
     * @stability stable
     */
    readonly tablePrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#tags GlueCrawler#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#tags_all GlueCrawler#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * catalog_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#catalog_target GlueCrawler#catalog_target}
     *
     * @stability stable
     */
    readonly catalogTarget?: GlueCrawlerCatalogTarget[] | cdktf.IResolvable;
    /**
     * delta_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#delta_target GlueCrawler#delta_target}
     *
     * @stability stable
     */
    readonly deltaTarget?: GlueCrawlerDeltaTarget[] | cdktf.IResolvable;
    /**
     * dynamodb_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#dynamodb_target GlueCrawler#dynamodb_target}
     *
     * @stability stable
     */
    readonly dynamodbTarget?: GlueCrawlerDynamodbTarget[] | cdktf.IResolvable;
    /**
     * jdbc_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#jdbc_target GlueCrawler#jdbc_target}
     *
     * @stability stable
     */
    readonly jdbcTarget?: GlueCrawlerJdbcTarget[] | cdktf.IResolvable;
    /**
     * lineage_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#lineage_configuration GlueCrawler#lineage_configuration}
     *
     * @stability stable
     */
    readonly lineageConfiguration?: GlueCrawlerLineageConfiguration;
    /**
     * mongodb_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#mongodb_target GlueCrawler#mongodb_target}
     *
     * @stability stable
     */
    readonly mongodbTarget?: GlueCrawlerMongodbTarget[] | cdktf.IResolvable;
    /**
     * recrawl_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#recrawl_policy GlueCrawler#recrawl_policy}
     *
     * @stability stable
     */
    readonly recrawlPolicy?: GlueCrawlerRecrawlPolicy;
    /**
     * s3_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#s3_target GlueCrawler#s3_target}
     *
     * @stability stable
     */
    readonly s3Target?: GlueCrawlerS3Target[] | cdktf.IResolvable;
    /**
     * schema_change_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#schema_change_policy GlueCrawler#schema_change_policy}
     *
     * @stability stable
     */
    readonly schemaChangePolicy?: GlueCrawlerSchemaChangePolicy;
}
/**
 * @stability stable
 */
export interface GlueCrawlerCatalogTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#database_name GlueCrawler#database_name}.
     *
     * @stability stable
     */
    readonly databaseName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#tables GlueCrawler#tables}.
     *
     * @stability stable
     */
    readonly tables: string[];
}
export declare function glueCrawlerCatalogTargetToTerraform(struct?: GlueCrawlerCatalogTarget | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface GlueCrawlerDeltaTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#connection_name GlueCrawler#connection_name}.
     *
     * @stability stable
     */
    readonly connectionName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#delta_tables GlueCrawler#delta_tables}.
     *
     * @stability stable
     */
    readonly deltaTables: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#write_manifest GlueCrawler#write_manifest}.
     *
     * @stability stable
     */
    readonly writeManifest: boolean | cdktf.IResolvable;
}
export declare function glueCrawlerDeltaTargetToTerraform(struct?: GlueCrawlerDeltaTarget | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface GlueCrawlerDynamodbTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#path GlueCrawler#path}.
     *
     * @stability stable
     */
    readonly path: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#scan_all GlueCrawler#scan_all}.
     *
     * @stability stable
     */
    readonly scanAll?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#scan_rate GlueCrawler#scan_rate}.
     *
     * @stability stable
     */
    readonly scanRate?: number;
}
export declare function glueCrawlerDynamodbTargetToTerraform(struct?: GlueCrawlerDynamodbTarget | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface GlueCrawlerJdbcTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#connection_name GlueCrawler#connection_name}.
     *
     * @stability stable
     */
    readonly connectionName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#exclusions GlueCrawler#exclusions}.
     *
     * @stability stable
     */
    readonly exclusions?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#path GlueCrawler#path}.
     *
     * @stability stable
     */
    readonly path: string;
}
export declare function glueCrawlerJdbcTargetToTerraform(struct?: GlueCrawlerJdbcTarget | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface GlueCrawlerLineageConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#crawler_lineage_settings GlueCrawler#crawler_lineage_settings}.
     *
     * @stability stable
     */
    readonly crawlerLineageSettings?: string;
}
export declare function glueCrawlerLineageConfigurationToTerraform(struct?: GlueCrawlerLineageConfigurationOutputReference | GlueCrawlerLineageConfiguration): any;
/**
 * @stability stable
 */
export declare class GlueCrawlerLineageConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): GlueCrawlerLineageConfiguration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: GlueCrawlerLineageConfiguration | undefined);
    private _crawlerLineageSettings?;
    /**
     * @stability stable
     */
    get crawlerLineageSettings(): string;
    /**
     * @stability stable
     */
    set crawlerLineageSettings(value: string);
    /**
     * @stability stable
     */
    resetCrawlerLineageSettings(): void;
    /**
     * @stability stable
     */
    get crawlerLineageSettingsInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface GlueCrawlerMongodbTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#connection_name GlueCrawler#connection_name}.
     *
     * @stability stable
     */
    readonly connectionName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#path GlueCrawler#path}.
     *
     * @stability stable
     */
    readonly path: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#scan_all GlueCrawler#scan_all}.
     *
     * @stability stable
     */
    readonly scanAll?: boolean | cdktf.IResolvable;
}
export declare function glueCrawlerMongodbTargetToTerraform(struct?: GlueCrawlerMongodbTarget | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface GlueCrawlerRecrawlPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#recrawl_behavior GlueCrawler#recrawl_behavior}.
     *
     * @stability stable
     */
    readonly recrawlBehavior?: string;
}
export declare function glueCrawlerRecrawlPolicyToTerraform(struct?: GlueCrawlerRecrawlPolicyOutputReference | GlueCrawlerRecrawlPolicy): any;
/**
 * @stability stable
 */
export declare class GlueCrawlerRecrawlPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): GlueCrawlerRecrawlPolicy | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: GlueCrawlerRecrawlPolicy | undefined);
    private _recrawlBehavior?;
    /**
     * @stability stable
     */
    get recrawlBehavior(): string;
    /**
     * @stability stable
     */
    set recrawlBehavior(value: string);
    /**
     * @stability stable
     */
    resetRecrawlBehavior(): void;
    /**
     * @stability stable
     */
    get recrawlBehaviorInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface GlueCrawlerS3Target {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#connection_name GlueCrawler#connection_name}.
     *
     * @stability stable
     */
    readonly connectionName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#dlq_event_queue_arn GlueCrawler#dlq_event_queue_arn}.
     *
     * @stability stable
     */
    readonly dlqEventQueueArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#event_queue_arn GlueCrawler#event_queue_arn}.
     *
     * @stability stable
     */
    readonly eventQueueArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#exclusions GlueCrawler#exclusions}.
     *
     * @stability stable
     */
    readonly exclusions?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#path GlueCrawler#path}.
     *
     * @stability stable
     */
    readonly path: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#sample_size GlueCrawler#sample_size}.
     *
     * @stability stable
     */
    readonly sampleSize?: number;
}
export declare function glueCrawlerS3TargetToTerraform(struct?: GlueCrawlerS3Target | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface GlueCrawlerSchemaChangePolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#delete_behavior GlueCrawler#delete_behavior}.
     *
     * @stability stable
     */
    readonly deleteBehavior?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler#update_behavior GlueCrawler#update_behavior}.
     *
     * @stability stable
     */
    readonly updateBehavior?: string;
}
export declare function glueCrawlerSchemaChangePolicyToTerraform(struct?: GlueCrawlerSchemaChangePolicyOutputReference | GlueCrawlerSchemaChangePolicy): any;
/**
 * @stability stable
 */
export declare class GlueCrawlerSchemaChangePolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): GlueCrawlerSchemaChangePolicy | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: GlueCrawlerSchemaChangePolicy | undefined);
    private _deleteBehavior?;
    /**
     * @stability stable
     */
    get deleteBehavior(): string;
    /**
     * @stability stable
     */
    set deleteBehavior(value: string);
    /**
     * @stability stable
     */
    resetDeleteBehavior(): void;
    /**
     * @stability stable
     */
    get deleteBehaviorInput(): string | undefined;
    private _updateBehavior?;
    /**
     * @stability stable
     */
    get updateBehavior(): string;
    /**
     * @stability stable
     */
    set updateBehavior(value: string);
    /**
     * @stability stable
     */
    resetUpdateBehavior(): void;
    /**
     * @stability stable
     */
    get updateBehaviorInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler aws_glue_crawler}.
 *
 * @stability stable
 */
export declare class GlueCrawler extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/glue_crawler aws_glue_crawler} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlueCrawlerConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _classifiers?;
    /**
     * @stability stable
     */
    get classifiers(): string[];
    /**
     * @stability stable
     */
    set classifiers(value: string[]);
    /**
     * @stability stable
     */
    resetClassifiers(): void;
    /**
     * @stability stable
     */
    get classifiersInput(): string[] | undefined;
    private _configuration?;
    /**
     * @stability stable
     */
    get configuration(): string;
    /**
     * @stability stable
     */
    set configuration(value: string);
    /**
     * @stability stable
     */
    resetConfiguration(): void;
    /**
     * @stability stable
     */
    get configurationInput(): string | undefined;
    private _databaseName?;
    /**
     * @stability stable
     */
    get databaseName(): string;
    /**
     * @stability stable
     */
    set databaseName(value: string);
    /**
     * @stability stable
     */
    get databaseNameInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _role?;
    /**
     * @stability stable
     */
    get role(): string;
    /**
     * @stability stable
     */
    set role(value: string);
    /**
     * @stability stable
     */
    get roleInput(): string | undefined;
    private _schedule?;
    /**
     * @stability stable
     */
    get schedule(): string;
    /**
     * @stability stable
     */
    set schedule(value: string);
    /**
     * @stability stable
     */
    resetSchedule(): void;
    /**
     * @stability stable
     */
    get scheduleInput(): string | undefined;
    private _securityConfiguration?;
    /**
     * @stability stable
     */
    get securityConfiguration(): string;
    /**
     * @stability stable
     */
    set securityConfiguration(value: string);
    /**
     * @stability stable
     */
    resetSecurityConfiguration(): void;
    /**
     * @stability stable
     */
    get securityConfigurationInput(): string | undefined;
    private _tablePrefix?;
    /**
     * @stability stable
     */
    get tablePrefix(): string;
    /**
     * @stability stable
     */
    set tablePrefix(value: string);
    /**
     * @stability stable
     */
    resetTablePrefix(): void;
    /**
     * @stability stable
     */
    get tablePrefixInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _catalogTarget?;
    /**
     * @stability stable
     */
    get catalogTarget(): GlueCrawlerCatalogTarget[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set catalogTarget(value: GlueCrawlerCatalogTarget[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetCatalogTarget(): void;
    /**
     * @stability stable
     */
    get catalogTargetInput(): cdktf.IResolvable | GlueCrawlerCatalogTarget[] | undefined;
    private _deltaTarget?;
    /**
     * @stability stable
     */
    get deltaTarget(): GlueCrawlerDeltaTarget[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set deltaTarget(value: GlueCrawlerDeltaTarget[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDeltaTarget(): void;
    /**
     * @stability stable
     */
    get deltaTargetInput(): cdktf.IResolvable | GlueCrawlerDeltaTarget[] | undefined;
    private _dynamodbTarget?;
    /**
     * @stability stable
     */
    get dynamodbTarget(): GlueCrawlerDynamodbTarget[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set dynamodbTarget(value: GlueCrawlerDynamodbTarget[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDynamodbTarget(): void;
    /**
     * @stability stable
     */
    get dynamodbTargetInput(): cdktf.IResolvable | GlueCrawlerDynamodbTarget[] | undefined;
    private _jdbcTarget?;
    /**
     * @stability stable
     */
    get jdbcTarget(): GlueCrawlerJdbcTarget[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set jdbcTarget(value: GlueCrawlerJdbcTarget[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetJdbcTarget(): void;
    /**
     * @stability stable
     */
    get jdbcTargetInput(): cdktf.IResolvable | GlueCrawlerJdbcTarget[] | undefined;
    private _lineageConfiguration;
    /**
     * @stability stable
     */
    get lineageConfiguration(): GlueCrawlerLineageConfigurationOutputReference;
    /**
     * @stability stable
     */
    putLineageConfiguration(value: GlueCrawlerLineageConfiguration): void;
    /**
     * @stability stable
     */
    resetLineageConfiguration(): void;
    /**
     * @stability stable
     */
    get lineageConfigurationInput(): GlueCrawlerLineageConfiguration | undefined;
    private _mongodbTarget?;
    /**
     * @stability stable
     */
    get mongodbTarget(): GlueCrawlerMongodbTarget[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set mongodbTarget(value: GlueCrawlerMongodbTarget[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetMongodbTarget(): void;
    /**
     * @stability stable
     */
    get mongodbTargetInput(): cdktf.IResolvable | GlueCrawlerMongodbTarget[] | undefined;
    private _recrawlPolicy;
    /**
     * @stability stable
     */
    get recrawlPolicy(): GlueCrawlerRecrawlPolicyOutputReference;
    /**
     * @stability stable
     */
    putRecrawlPolicy(value: GlueCrawlerRecrawlPolicy): void;
    /**
     * @stability stable
     */
    resetRecrawlPolicy(): void;
    /**
     * @stability stable
     */
    get recrawlPolicyInput(): GlueCrawlerRecrawlPolicy | undefined;
    private _s3Target?;
    /**
     * @stability stable
     */
    get s3Target(): GlueCrawlerS3Target[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set s3Target(value: GlueCrawlerS3Target[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetS3Target(): void;
    /**
     * @stability stable
     */
    get s3TargetInput(): cdktf.IResolvable | GlueCrawlerS3Target[] | undefined;
    private _schemaChangePolicy;
    /**
     * @stability stable
     */
    get schemaChangePolicy(): GlueCrawlerSchemaChangePolicyOutputReference;
    /**
     * @stability stable
     */
    putSchemaChangePolicy(value: GlueCrawlerSchemaChangePolicy): void;
    /**
     * @stability stable
     */
    resetSchemaChangePolicy(): void;
    /**
     * @stability stable
     */
    get schemaChangePolicyInput(): GlueCrawlerSchemaChangePolicy | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
