import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Glue.
 *
 * @stability stable
 */
export interface GlueTriggerConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#description GlueTrigger#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#enabled GlueTrigger#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#name GlueTrigger#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#schedule GlueTrigger#schedule}.
     *
     * @stability stable
     */
    readonly schedule?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#start_on_creation GlueTrigger#start_on_creation}.
     *
     * @stability stable
     */
    readonly startOnCreation?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#tags GlueTrigger#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#tags_all GlueTrigger#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#type GlueTrigger#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#workflow_name GlueTrigger#workflow_name}.
     *
     * @stability stable
     */
    readonly workflowName?: string;
    /**
     * actions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#actions GlueTrigger#actions}
     *
     * @stability stable
     */
    readonly actions: GlueTriggerActions[] | cdktf.IResolvable;
    /**
     * predicate block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#predicate GlueTrigger#predicate}
     *
     * @stability stable
     */
    readonly predicate?: GlueTriggerPredicate;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#timeouts GlueTrigger#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: GlueTriggerTimeouts;
}
/**
 * @stability stable
 */
export interface GlueTriggerActionsNotificationProperty {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#notify_delay_after GlueTrigger#notify_delay_after}.
     *
     * @stability stable
     */
    readonly notifyDelayAfter?: number;
}
export declare function glueTriggerActionsNotificationPropertyToTerraform(struct?: GlueTriggerActionsNotificationPropertyOutputReference | GlueTriggerActionsNotificationProperty): any;
/**
 * @stability stable
 */
export declare class GlueTriggerActionsNotificationPropertyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): GlueTriggerActionsNotificationProperty | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: GlueTriggerActionsNotificationProperty | undefined);
    private _notifyDelayAfter?;
    /**
     * @stability stable
     */
    get notifyDelayAfter(): number;
    /**
     * @stability stable
     */
    set notifyDelayAfter(value: number);
    /**
     * @stability stable
     */
    resetNotifyDelayAfter(): void;
    /**
     * @stability stable
     */
    get notifyDelayAfterInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface GlueTriggerActions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#arguments GlueTrigger#arguments}.
     *
     * @stability stable
     */
    readonly arguments?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#crawler_name GlueTrigger#crawler_name}.
     *
     * @stability stable
     */
    readonly crawlerName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#job_name GlueTrigger#job_name}.
     *
     * @stability stable
     */
    readonly jobName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#security_configuration GlueTrigger#security_configuration}.
     *
     * @stability stable
     */
    readonly securityConfiguration?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#timeout GlueTrigger#timeout}.
     *
     * @stability stable
     */
    readonly timeout?: number;
    /**
     * notification_property block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#notification_property GlueTrigger#notification_property}
     *
     * @stability stable
     */
    readonly notificationProperty?: GlueTriggerActionsNotificationProperty;
}
export declare function glueTriggerActionsToTerraform(struct?: GlueTriggerActions | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface GlueTriggerPredicateConditions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#crawl_state GlueTrigger#crawl_state}.
     *
     * @stability stable
     */
    readonly crawlState?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#crawler_name GlueTrigger#crawler_name}.
     *
     * @stability stable
     */
    readonly crawlerName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#job_name GlueTrigger#job_name}.
     *
     * @stability stable
     */
    readonly jobName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#logical_operator GlueTrigger#logical_operator}.
     *
     * @stability stable
     */
    readonly logicalOperator?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#state GlueTrigger#state}.
     *
     * @stability stable
     */
    readonly state?: string;
}
export declare function glueTriggerPredicateConditionsToTerraform(struct?: GlueTriggerPredicateConditions | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface GlueTriggerPredicate {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#logical GlueTrigger#logical}.
     *
     * @stability stable
     */
    readonly logical?: string;
    /**
     * conditions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#conditions GlueTrigger#conditions}
     *
     * @stability stable
     */
    readonly conditions: GlueTriggerPredicateConditions[] | cdktf.IResolvable;
}
export declare function glueTriggerPredicateToTerraform(struct?: GlueTriggerPredicateOutputReference | GlueTriggerPredicate): any;
/**
 * @stability stable
 */
export declare class GlueTriggerPredicateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): GlueTriggerPredicate | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: GlueTriggerPredicate | undefined);
    private _logical?;
    /**
     * @stability stable
     */
    get logical(): string;
    /**
     * @stability stable
     */
    set logical(value: string);
    /**
     * @stability stable
     */
    resetLogical(): void;
    /**
     * @stability stable
     */
    get logicalInput(): string | undefined;
    private _conditions?;
    /**
     * @stability stable
     */
    get conditions(): GlueTriggerPredicateConditions[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set conditions(value: GlueTriggerPredicateConditions[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get conditionsInput(): cdktf.IResolvable | GlueTriggerPredicateConditions[] | undefined;
}
/**
 * @stability stable
 */
export interface GlueTriggerTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#create GlueTrigger#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger#delete GlueTrigger#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
}
export declare function glueTriggerTimeoutsToTerraform(struct?: GlueTriggerTimeoutsOutputReference | GlueTriggerTimeouts | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export declare class GlueTriggerTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): GlueTriggerTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: GlueTriggerTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger aws_glue_trigger}.
 *
 * @stability stable
 */
export declare class GlueTrigger extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/glue_trigger aws_glue_trigger} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlueTriggerConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _schedule?;
    /**
     * @stability stable
     */
    get schedule(): string;
    /**
     * @stability stable
     */
    set schedule(value: string);
    /**
     * @stability stable
     */
    resetSchedule(): void;
    /**
     * @stability stable
     */
    get scheduleInput(): string | undefined;
    private _startOnCreation?;
    /**
     * @stability stable
     */
    get startOnCreation(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set startOnCreation(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetStartOnCreation(): void;
    /**
     * @stability stable
     */
    get startOnCreationInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get state(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _workflowName?;
    /**
     * @stability stable
     */
    get workflowName(): string;
    /**
     * @stability stable
     */
    set workflowName(value: string);
    /**
     * @stability stable
     */
    resetWorkflowName(): void;
    /**
     * @stability stable
     */
    get workflowNameInput(): string | undefined;
    private _actions?;
    /**
     * @stability stable
     */
    get actions(): GlueTriggerActions[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set actions(value: GlueTriggerActions[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get actionsInput(): cdktf.IResolvable | GlueTriggerActions[] | undefined;
    private _predicate;
    /**
     * @stability stable
     */
    get predicate(): GlueTriggerPredicateOutputReference;
    /**
     * @stability stable
     */
    putPredicate(value: GlueTriggerPredicate): void;
    /**
     * @stability stable
     */
    resetPredicate(): void;
    /**
     * @stability stable
     */
    get predicateInput(): GlueTriggerPredicate | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): GlueTriggerTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: GlueTriggerTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): GlueTriggerTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
