import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Key Management Service.
 *
 * @stability stable
 */
export interface DataAwsKmsKeyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/kms_key#grant_tokens DataAwsKmsKey#grant_tokens}.
     *
     * @stability stable
     */
    readonly grantTokens?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/kms_key#key_id DataAwsKmsKey#key_id}.
     *
     * @stability stable
     */
    readonly keyId: string;
}
/**
 * @stability stable
 */
export declare class DataAwsKmsKeyMultiRegionConfigurationPrimaryKey extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get region(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsKmsKeyMultiRegionConfigurationReplicaKeys extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get region(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsKmsKeyMultiRegionConfiguration extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get multiRegionKeyType(): string;
    /**
     * @stability stable
     */
    get primaryKey(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get replicaKeys(): cdktf.IResolvable;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/kms_key aws_kms_key}.
 *
 * @stability stable
 */
export declare class DataAwsKmsKey extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/kms_key aws_kms_key} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsKmsKeyConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get awsAccountId(): string;
    /**
     * @stability stable
     */
    get creationDate(): string;
    /**
     * @stability stable
     */
    get customerMasterKeySpec(): string;
    /**
     * @stability stable
     */
    get deletionDate(): string;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get enabled(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get expirationModel(): string;
    private _grantTokens?;
    /**
     * @stability stable
     */
    get grantTokens(): string[];
    /**
     * @stability stable
     */
    set grantTokens(value: string[]);
    /**
     * @stability stable
     */
    resetGrantTokens(): void;
    /**
     * @stability stable
     */
    get grantTokensInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _keyId?;
    /**
     * @stability stable
     */
    get keyId(): string;
    /**
     * @stability stable
     */
    set keyId(value: string);
    /**
     * @stability stable
     */
    get keyIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get keyManager(): string;
    /**
     * @stability stable
     */
    get keyState(): string;
    /**
     * @stability stable
     */
    get keyUsage(): string;
    /**
     * @stability stable
     */
    get multiRegion(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    multiRegionConfiguration(index: string): DataAwsKmsKeyMultiRegionConfiguration;
    /**
     * @stability stable
     */
    get origin(): string;
    /**
     * @stability stable
     */
    get validTo(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
