import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Lambda.
 *
 * @stability stable
 */
export interface DataAwsLambdaLayerVersionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lambda_layer_version#compatible_architecture DataAwsLambdaLayerVersion#compatible_architecture}.
     *
     * @stability stable
     */
    readonly compatibleArchitecture?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lambda_layer_version#compatible_runtime DataAwsLambdaLayerVersion#compatible_runtime}.
     *
     * @stability stable
     */
    readonly compatibleRuntime?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lambda_layer_version#layer_name DataAwsLambdaLayerVersion#layer_name}.
     *
     * @stability stable
     */
    readonly layerName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lambda_layer_version#version DataAwsLambdaLayerVersion#version}.
     *
     * @stability stable
     */
    readonly version?: number;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/lambda_layer_version aws_lambda_layer_version}.
 *
 * @stability stable
 */
export declare class DataAwsLambdaLayerVersion extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/lambda_layer_version aws_lambda_layer_version} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsLambdaLayerVersionConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _compatibleArchitecture?;
    /**
     * @stability stable
     */
    get compatibleArchitecture(): string;
    /**
     * @stability stable
     */
    set compatibleArchitecture(value: string);
    /**
     * @stability stable
     */
    resetCompatibleArchitecture(): void;
    /**
     * @stability stable
     */
    get compatibleArchitectureInput(): string | undefined;
    /**
     * @stability stable
     */
    get compatibleArchitectures(): string[];
    private _compatibleRuntime?;
    /**
     * @stability stable
     */
    get compatibleRuntime(): string;
    /**
     * @stability stable
     */
    set compatibleRuntime(value: string);
    /**
     * @stability stable
     */
    resetCompatibleRuntime(): void;
    /**
     * @stability stable
     */
    get compatibleRuntimeInput(): string | undefined;
    /**
     * @stability stable
     */
    get compatibleRuntimes(): string[];
    /**
     * @stability stable
     */
    get createdDate(): string;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get layerArn(): string;
    private _layerName?;
    /**
     * @stability stable
     */
    get layerName(): string;
    /**
     * @stability stable
     */
    set layerName(value: string);
    /**
     * @stability stable
     */
    get layerNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get licenseInfo(): string;
    /**
     * @stability stable
     */
    get signingJobArn(): string;
    /**
     * @stability stable
     */
    get signingProfileVersionArn(): string;
    /**
     * @stability stable
     */
    get sourceCodeHash(): string;
    /**
     * @stability stable
     */
    get sourceCodeSize(): number;
    private _version?;
    /**
     * @stability stable
     */
    get version(): number;
    /**
     * @stability stable
     */
    set version(value: number);
    /**
     * @stability stable
     */
    resetVersion(): void;
    /**
     * @stability stable
     */
    get versionInput(): number | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
