import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Lambda.
 *
 * @stability stable
 */
export interface LambdaFunctionEventInvokeConfigConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function_event_invoke_config#function_name LambdaFunctionEventInvokeConfig#function_name}.
     *
     * @stability stable
     */
    readonly functionName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function_event_invoke_config#maximum_event_age_in_seconds LambdaFunctionEventInvokeConfig#maximum_event_age_in_seconds}.
     *
     * @stability stable
     */
    readonly maximumEventAgeInSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function_event_invoke_config#maximum_retry_attempts LambdaFunctionEventInvokeConfig#maximum_retry_attempts}.
     *
     * @stability stable
     */
    readonly maximumRetryAttempts?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function_event_invoke_config#qualifier LambdaFunctionEventInvokeConfig#qualifier}.
     *
     * @stability stable
     */
    readonly qualifier?: string;
    /**
     * destination_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function_event_invoke_config#destination_config LambdaFunctionEventInvokeConfig#destination_config}
     *
     * @stability stable
     */
    readonly destinationConfig?: LambdaFunctionEventInvokeConfigDestinationConfig;
}
/**
 * @stability stable
 */
export interface LambdaFunctionEventInvokeConfigDestinationConfigOnFailure {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function_event_invoke_config#destination LambdaFunctionEventInvokeConfig#destination}.
     *
     * @stability stable
     */
    readonly destination: string;
}
export declare function lambdaFunctionEventInvokeConfigDestinationConfigOnFailureToTerraform(struct?: LambdaFunctionEventInvokeConfigDestinationConfigOnFailureOutputReference | LambdaFunctionEventInvokeConfigDestinationConfigOnFailure): any;
/**
 * @stability stable
 */
export declare class LambdaFunctionEventInvokeConfigDestinationConfigOnFailureOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LambdaFunctionEventInvokeConfigDestinationConfigOnFailure | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LambdaFunctionEventInvokeConfigDestinationConfigOnFailure | undefined);
    private _destination?;
    /**
     * @stability stable
     */
    get destination(): string;
    /**
     * @stability stable
     */
    set destination(value: string);
    /**
     * @stability stable
     */
    get destinationInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface LambdaFunctionEventInvokeConfigDestinationConfigOnSuccess {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function_event_invoke_config#destination LambdaFunctionEventInvokeConfig#destination}.
     *
     * @stability stable
     */
    readonly destination: string;
}
export declare function lambdaFunctionEventInvokeConfigDestinationConfigOnSuccessToTerraform(struct?: LambdaFunctionEventInvokeConfigDestinationConfigOnSuccessOutputReference | LambdaFunctionEventInvokeConfigDestinationConfigOnSuccess): any;
/**
 * @stability stable
 */
export declare class LambdaFunctionEventInvokeConfigDestinationConfigOnSuccessOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LambdaFunctionEventInvokeConfigDestinationConfigOnSuccess | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LambdaFunctionEventInvokeConfigDestinationConfigOnSuccess | undefined);
    private _destination?;
    /**
     * @stability stable
     */
    get destination(): string;
    /**
     * @stability stable
     */
    set destination(value: string);
    /**
     * @stability stable
     */
    get destinationInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface LambdaFunctionEventInvokeConfigDestinationConfig {
    /**
     * on_failure block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function_event_invoke_config#on_failure LambdaFunctionEventInvokeConfig#on_failure}
     *
     * @stability stable
     */
    readonly onFailure?: LambdaFunctionEventInvokeConfigDestinationConfigOnFailure;
    /**
     * on_success block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function_event_invoke_config#on_success LambdaFunctionEventInvokeConfig#on_success}
     *
     * @stability stable
     */
    readonly onSuccess?: LambdaFunctionEventInvokeConfigDestinationConfigOnSuccess;
}
export declare function lambdaFunctionEventInvokeConfigDestinationConfigToTerraform(struct?: LambdaFunctionEventInvokeConfigDestinationConfigOutputReference | LambdaFunctionEventInvokeConfigDestinationConfig): any;
/**
 * @stability stable
 */
export declare class LambdaFunctionEventInvokeConfigDestinationConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LambdaFunctionEventInvokeConfigDestinationConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LambdaFunctionEventInvokeConfigDestinationConfig | undefined);
    private _onFailure;
    /**
     * @stability stable
     */
    get onFailure(): LambdaFunctionEventInvokeConfigDestinationConfigOnFailureOutputReference;
    /**
     * @stability stable
     */
    putOnFailure(value: LambdaFunctionEventInvokeConfigDestinationConfigOnFailure): void;
    /**
     * @stability stable
     */
    resetOnFailure(): void;
    /**
     * @stability stable
     */
    get onFailureInput(): LambdaFunctionEventInvokeConfigDestinationConfigOnFailure | undefined;
    private _onSuccess;
    /**
     * @stability stable
     */
    get onSuccess(): LambdaFunctionEventInvokeConfigDestinationConfigOnSuccessOutputReference;
    /**
     * @stability stable
     */
    putOnSuccess(value: LambdaFunctionEventInvokeConfigDestinationConfigOnSuccess): void;
    /**
     * @stability stable
     */
    resetOnSuccess(): void;
    /**
     * @stability stable
     */
    get onSuccessInput(): LambdaFunctionEventInvokeConfigDestinationConfigOnSuccess | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/lambda_function_event_invoke_config aws_lambda_function_event_invoke_config}.
 *
 * @stability stable
 */
export declare class LambdaFunctionEventInvokeConfig extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/lambda_function_event_invoke_config aws_lambda_function_event_invoke_config} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LambdaFunctionEventInvokeConfigConfig);
    private _functionName?;
    /**
     * @stability stable
     */
    get functionName(): string;
    /**
     * @stability stable
     */
    set functionName(value: string);
    /**
     * @stability stable
     */
    get functionNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _maximumEventAgeInSeconds?;
    /**
     * @stability stable
     */
    get maximumEventAgeInSeconds(): number;
    /**
     * @stability stable
     */
    set maximumEventAgeInSeconds(value: number);
    /**
     * @stability stable
     */
    resetMaximumEventAgeInSeconds(): void;
    /**
     * @stability stable
     */
    get maximumEventAgeInSecondsInput(): number | undefined;
    private _maximumRetryAttempts?;
    /**
     * @stability stable
     */
    get maximumRetryAttempts(): number;
    /**
     * @stability stable
     */
    set maximumRetryAttempts(value: number);
    /**
     * @stability stable
     */
    resetMaximumRetryAttempts(): void;
    /**
     * @stability stable
     */
    get maximumRetryAttemptsInput(): number | undefined;
    private _qualifier?;
    /**
     * @stability stable
     */
    get qualifier(): string;
    /**
     * @stability stable
     */
    set qualifier(value: string);
    /**
     * @stability stable
     */
    resetQualifier(): void;
    /**
     * @stability stable
     */
    get qualifierInput(): string | undefined;
    private _destinationConfig;
    /**
     * @stability stable
     */
    get destinationConfig(): LambdaFunctionEventInvokeConfigDestinationConfigOutputReference;
    /**
     * @stability stable
     */
    putDestinationConfig(value: LambdaFunctionEventInvokeConfigDestinationConfig): void;
    /**
     * @stability stable
     */
    resetDestinationConfig(): void;
    /**
     * @stability stable
     */
    get destinationConfigInput(): LambdaFunctionEventInvokeConfigDestinationConfig | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
