import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Lambda.
 *
 * @stability stable
 */
export interface LambdaFunctionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#architectures LambdaFunction#architectures}.
     *
     * @stability stable
     */
    readonly architectures?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#code_signing_config_arn LambdaFunction#code_signing_config_arn}.
     *
     * @stability stable
     */
    readonly codeSigningConfigArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#description LambdaFunction#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#filename LambdaFunction#filename}.
     *
     * @stability stable
     */
    readonly filename?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#function_name LambdaFunction#function_name}.
     *
     * @stability stable
     */
    readonly functionName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#handler LambdaFunction#handler}.
     *
     * @stability stable
     */
    readonly handler?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#image_uri LambdaFunction#image_uri}.
     *
     * @stability stable
     */
    readonly imageUri?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#kms_key_arn LambdaFunction#kms_key_arn}.
     *
     * @stability stable
     */
    readonly kmsKeyArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#layers LambdaFunction#layers}.
     *
     * @stability stable
     */
    readonly layers?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#memory_size LambdaFunction#memory_size}.
     *
     * @stability stable
     */
    readonly memorySize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#package_type LambdaFunction#package_type}.
     *
     * @stability stable
     */
    readonly packageType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#publish LambdaFunction#publish}.
     *
     * @stability stable
     */
    readonly publish?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#reserved_concurrent_executions LambdaFunction#reserved_concurrent_executions}.
     *
     * @stability stable
     */
    readonly reservedConcurrentExecutions?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#role LambdaFunction#role}.
     *
     * @stability stable
     */
    readonly role: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#runtime LambdaFunction#runtime}.
     *
     * @stability stable
     */
    readonly runtime?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#s3_bucket LambdaFunction#s3_bucket}.
     *
     * @stability stable
     */
    readonly s3Bucket?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#s3_key LambdaFunction#s3_key}.
     *
     * @stability stable
     */
    readonly s3Key?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#s3_object_version LambdaFunction#s3_object_version}.
     *
     * @stability stable
     */
    readonly s3ObjectVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#source_code_hash LambdaFunction#source_code_hash}.
     *
     * @stability stable
     */
    readonly sourceCodeHash?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#tags LambdaFunction#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#tags_all LambdaFunction#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#timeout LambdaFunction#timeout}.
     *
     * @stability stable
     */
    readonly timeout?: number;
    /**
     * dead_letter_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#dead_letter_config LambdaFunction#dead_letter_config}
     *
     * @stability stable
     */
    readonly deadLetterConfig?: LambdaFunctionDeadLetterConfig;
    /**
     * environment block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#environment LambdaFunction#environment}
     *
     * @stability stable
     */
    readonly environment?: LambdaFunctionEnvironment;
    /**
     * file_system_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#file_system_config LambdaFunction#file_system_config}
     *
     * @stability stable
     */
    readonly fileSystemConfig?: LambdaFunctionFileSystemConfig;
    /**
     * image_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#image_config LambdaFunction#image_config}
     *
     * @stability stable
     */
    readonly imageConfig?: LambdaFunctionImageConfig;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#timeouts LambdaFunction#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: LambdaFunctionTimeouts;
    /**
     * tracing_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#tracing_config LambdaFunction#tracing_config}
     *
     * @stability stable
     */
    readonly tracingConfig?: LambdaFunctionTracingConfig;
    /**
     * vpc_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#vpc_config LambdaFunction#vpc_config}
     *
     * @stability stable
     */
    readonly vpcConfig?: LambdaFunctionVpcConfig;
}
/**
 * @stability stable
 */
export interface LambdaFunctionDeadLetterConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#target_arn LambdaFunction#target_arn}.
     *
     * @stability stable
     */
    readonly targetArn: string;
}
export declare function lambdaFunctionDeadLetterConfigToTerraform(struct?: LambdaFunctionDeadLetterConfigOutputReference | LambdaFunctionDeadLetterConfig): any;
/**
 * @stability stable
 */
export declare class LambdaFunctionDeadLetterConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LambdaFunctionDeadLetterConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LambdaFunctionDeadLetterConfig | undefined);
    private _targetArn?;
    /**
     * @stability stable
     */
    get targetArn(): string;
    /**
     * @stability stable
     */
    set targetArn(value: string);
    /**
     * @stability stable
     */
    get targetArnInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface LambdaFunctionEnvironment {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#variables LambdaFunction#variables}.
     *
     * @stability stable
     */
    readonly variables?: {
        [key: string]: string;
    };
}
export declare function lambdaFunctionEnvironmentToTerraform(struct?: LambdaFunctionEnvironmentOutputReference | LambdaFunctionEnvironment): any;
/**
 * @stability stable
 */
export declare class LambdaFunctionEnvironmentOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LambdaFunctionEnvironment | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LambdaFunctionEnvironment | undefined);
    private _variables?;
    /**
     * @stability stable
     */
    get variables(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set variables(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetVariables(): void;
    /**
     * @stability stable
     */
    get variablesInput(): {
        [key: string]: string;
    } | undefined;
}
/**
 * @stability stable
 */
export interface LambdaFunctionFileSystemConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#arn LambdaFunction#arn}.
     *
     * @stability stable
     */
    readonly arn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#local_mount_path LambdaFunction#local_mount_path}.
     *
     * @stability stable
     */
    readonly localMountPath: string;
}
export declare function lambdaFunctionFileSystemConfigToTerraform(struct?: LambdaFunctionFileSystemConfigOutputReference | LambdaFunctionFileSystemConfig): any;
/**
 * @stability stable
 */
export declare class LambdaFunctionFileSystemConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LambdaFunctionFileSystemConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LambdaFunctionFileSystemConfig | undefined);
    private _arn?;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    set arn(value: string);
    /**
     * @stability stable
     */
    get arnInput(): string | undefined;
    private _localMountPath?;
    /**
     * @stability stable
     */
    get localMountPath(): string;
    /**
     * @stability stable
     */
    set localMountPath(value: string);
    /**
     * @stability stable
     */
    get localMountPathInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface LambdaFunctionImageConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#command LambdaFunction#command}.
     *
     * @stability stable
     */
    readonly command?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#entry_point LambdaFunction#entry_point}.
     *
     * @stability stable
     */
    readonly entryPoint?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#working_directory LambdaFunction#working_directory}.
     *
     * @stability stable
     */
    readonly workingDirectory?: string;
}
export declare function lambdaFunctionImageConfigToTerraform(struct?: LambdaFunctionImageConfigOutputReference | LambdaFunctionImageConfig): any;
/**
 * @stability stable
 */
export declare class LambdaFunctionImageConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LambdaFunctionImageConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LambdaFunctionImageConfig | undefined);
    private _command?;
    /**
     * @stability stable
     */
    get command(): string[];
    /**
     * @stability stable
     */
    set command(value: string[]);
    /**
     * @stability stable
     */
    resetCommand(): void;
    /**
     * @stability stable
     */
    get commandInput(): string[] | undefined;
    private _entryPoint?;
    /**
     * @stability stable
     */
    get entryPoint(): string[];
    /**
     * @stability stable
     */
    set entryPoint(value: string[]);
    /**
     * @stability stable
     */
    resetEntryPoint(): void;
    /**
     * @stability stable
     */
    get entryPointInput(): string[] | undefined;
    private _workingDirectory?;
    /**
     * @stability stable
     */
    get workingDirectory(): string;
    /**
     * @stability stable
     */
    set workingDirectory(value: string);
    /**
     * @stability stable
     */
    resetWorkingDirectory(): void;
    /**
     * @stability stable
     */
    get workingDirectoryInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface LambdaFunctionTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#create LambdaFunction#create}.
     *
     * @stability stable
     */
    readonly create?: string;
}
export declare function lambdaFunctionTimeoutsToTerraform(struct?: LambdaFunctionTimeoutsOutputReference | LambdaFunctionTimeouts | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export declare class LambdaFunctionTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LambdaFunctionTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LambdaFunctionTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface LambdaFunctionTracingConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#mode LambdaFunction#mode}.
     *
     * @stability stable
     */
    readonly mode: string;
}
export declare function lambdaFunctionTracingConfigToTerraform(struct?: LambdaFunctionTracingConfigOutputReference | LambdaFunctionTracingConfig): any;
/**
 * @stability stable
 */
export declare class LambdaFunctionTracingConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LambdaFunctionTracingConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LambdaFunctionTracingConfig | undefined);
    private _mode?;
    /**
     * @stability stable
     */
    get mode(): string;
    /**
     * @stability stable
     */
    set mode(value: string);
    /**
     * @stability stable
     */
    get modeInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface LambdaFunctionVpcConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#security_group_ids LambdaFunction#security_group_ids}.
     *
     * @stability stable
     */
    readonly securityGroupIds: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_function#subnet_ids LambdaFunction#subnet_ids}.
     *
     * @stability stable
     */
    readonly subnetIds: string[];
}
export declare function lambdaFunctionVpcConfigToTerraform(struct?: LambdaFunctionVpcConfigOutputReference | LambdaFunctionVpcConfig): any;
/**
 * @stability stable
 */
export declare class LambdaFunctionVpcConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LambdaFunctionVpcConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LambdaFunctionVpcConfig | undefined);
    private _securityGroupIds?;
    /**
     * @stability stable
     */
    get securityGroupIds(): string[];
    /**
     * @stability stable
     */
    set securityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    get securityGroupIdsInput(): string[] | undefined;
    private _subnetIds?;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    set subnetIds(value: string[]);
    /**
     * @stability stable
     */
    get subnetIdsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get vpcId(): string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/lambda_function aws_lambda_function}.
 *
 * @stability stable
 */
export declare class LambdaFunction extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/lambda_function aws_lambda_function} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LambdaFunctionConfig);
    private _architectures?;
    /**
     * @stability stable
     */
    get architectures(): string[];
    /**
     * @stability stable
     */
    set architectures(value: string[]);
    /**
     * @stability stable
     */
    resetArchitectures(): void;
    /**
     * @stability stable
     */
    get architecturesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _codeSigningConfigArn?;
    /**
     * @stability stable
     */
    get codeSigningConfigArn(): string;
    /**
     * @stability stable
     */
    set codeSigningConfigArn(value: string);
    /**
     * @stability stable
     */
    resetCodeSigningConfigArn(): void;
    /**
     * @stability stable
     */
    get codeSigningConfigArnInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _filename?;
    /**
     * @stability stable
     */
    get filename(): string;
    /**
     * @stability stable
     */
    set filename(value: string);
    /**
     * @stability stable
     */
    resetFilename(): void;
    /**
     * @stability stable
     */
    get filenameInput(): string | undefined;
    private _functionName?;
    /**
     * @stability stable
     */
    get functionName(): string;
    /**
     * @stability stable
     */
    set functionName(value: string);
    /**
     * @stability stable
     */
    get functionNameInput(): string | undefined;
    private _handler?;
    /**
     * @stability stable
     */
    get handler(): string;
    /**
     * @stability stable
     */
    set handler(value: string);
    /**
     * @stability stable
     */
    resetHandler(): void;
    /**
     * @stability stable
     */
    get handlerInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _imageUri?;
    /**
     * @stability stable
     */
    get imageUri(): string;
    /**
     * @stability stable
     */
    set imageUri(value: string);
    /**
     * @stability stable
     */
    resetImageUri(): void;
    /**
     * @stability stable
     */
    get imageUriInput(): string | undefined;
    /**
     * @stability stable
     */
    get invokeArn(): string;
    private _kmsKeyArn?;
    /**
     * @stability stable
     */
    get kmsKeyArn(): string;
    /**
     * @stability stable
     */
    set kmsKeyArn(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyArn(): void;
    /**
     * @stability stable
     */
    get kmsKeyArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get lastModified(): string;
    private _layers?;
    /**
     * @stability stable
     */
    get layers(): string[];
    /**
     * @stability stable
     */
    set layers(value: string[]);
    /**
     * @stability stable
     */
    resetLayers(): void;
    /**
     * @stability stable
     */
    get layersInput(): string[] | undefined;
    private _memorySize?;
    /**
     * @stability stable
     */
    get memorySize(): number;
    /**
     * @stability stable
     */
    set memorySize(value: number);
    /**
     * @stability stable
     */
    resetMemorySize(): void;
    /**
     * @stability stable
     */
    get memorySizeInput(): number | undefined;
    private _packageType?;
    /**
     * @stability stable
     */
    get packageType(): string;
    /**
     * @stability stable
     */
    set packageType(value: string);
    /**
     * @stability stable
     */
    resetPackageType(): void;
    /**
     * @stability stable
     */
    get packageTypeInput(): string | undefined;
    private _publish?;
    /**
     * @stability stable
     */
    get publish(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set publish(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetPublish(): void;
    /**
     * @stability stable
     */
    get publishInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get qualifiedArn(): string;
    private _reservedConcurrentExecutions?;
    /**
     * @stability stable
     */
    get reservedConcurrentExecutions(): number;
    /**
     * @stability stable
     */
    set reservedConcurrentExecutions(value: number);
    /**
     * @stability stable
     */
    resetReservedConcurrentExecutions(): void;
    /**
     * @stability stable
     */
    get reservedConcurrentExecutionsInput(): number | undefined;
    private _role?;
    /**
     * @stability stable
     */
    get role(): string;
    /**
     * @stability stable
     */
    set role(value: string);
    /**
     * @stability stable
     */
    get roleInput(): string | undefined;
    private _runtime?;
    /**
     * @stability stable
     */
    get runtime(): string;
    /**
     * @stability stable
     */
    set runtime(value: string);
    /**
     * @stability stable
     */
    resetRuntime(): void;
    /**
     * @stability stable
     */
    get runtimeInput(): string | undefined;
    private _s3Bucket?;
    /**
     * @stability stable
     */
    get s3Bucket(): string;
    /**
     * @stability stable
     */
    set s3Bucket(value: string);
    /**
     * @stability stable
     */
    resetS3Bucket(): void;
    /**
     * @stability stable
     */
    get s3BucketInput(): string | undefined;
    private _s3Key?;
    /**
     * @stability stable
     */
    get s3Key(): string;
    /**
     * @stability stable
     */
    set s3Key(value: string);
    /**
     * @stability stable
     */
    resetS3Key(): void;
    /**
     * @stability stable
     */
    get s3KeyInput(): string | undefined;
    private _s3ObjectVersion?;
    /**
     * @stability stable
     */
    get s3ObjectVersion(): string;
    /**
     * @stability stable
     */
    set s3ObjectVersion(value: string);
    /**
     * @stability stable
     */
    resetS3ObjectVersion(): void;
    /**
     * @stability stable
     */
    get s3ObjectVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get signingJobArn(): string;
    /**
     * @stability stable
     */
    get signingProfileVersionArn(): string;
    private _sourceCodeHash?;
    /**
     * @stability stable
     */
    get sourceCodeHash(): string;
    /**
     * @stability stable
     */
    set sourceCodeHash(value: string);
    /**
     * @stability stable
     */
    resetSourceCodeHash(): void;
    /**
     * @stability stable
     */
    get sourceCodeHashInput(): string | undefined;
    /**
     * @stability stable
     */
    get sourceCodeSize(): number;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _timeout?;
    /**
     * @stability stable
     */
    get timeout(): number;
    /**
     * @stability stable
     */
    set timeout(value: number);
    /**
     * @stability stable
     */
    resetTimeout(): void;
    /**
     * @stability stable
     */
    get timeoutInput(): number | undefined;
    /**
     * @stability stable
     */
    get version(): string;
    private _deadLetterConfig;
    /**
     * @stability stable
     */
    get deadLetterConfig(): LambdaFunctionDeadLetterConfigOutputReference;
    /**
     * @stability stable
     */
    putDeadLetterConfig(value: LambdaFunctionDeadLetterConfig): void;
    /**
     * @stability stable
     */
    resetDeadLetterConfig(): void;
    /**
     * @stability stable
     */
    get deadLetterConfigInput(): LambdaFunctionDeadLetterConfig | undefined;
    private _environment;
    /**
     * @stability stable
     */
    get environment(): LambdaFunctionEnvironmentOutputReference;
    /**
     * @stability stable
     */
    putEnvironment(value: LambdaFunctionEnvironment): void;
    /**
     * @stability stable
     */
    resetEnvironment(): void;
    /**
     * @stability stable
     */
    get environmentInput(): LambdaFunctionEnvironment | undefined;
    private _fileSystemConfig;
    /**
     * @stability stable
     */
    get fileSystemConfig(): LambdaFunctionFileSystemConfigOutputReference;
    /**
     * @stability stable
     */
    putFileSystemConfig(value: LambdaFunctionFileSystemConfig): void;
    /**
     * @stability stable
     */
    resetFileSystemConfig(): void;
    /**
     * @stability stable
     */
    get fileSystemConfigInput(): LambdaFunctionFileSystemConfig | undefined;
    private _imageConfig;
    /**
     * @stability stable
     */
    get imageConfig(): LambdaFunctionImageConfigOutputReference;
    /**
     * @stability stable
     */
    putImageConfig(value: LambdaFunctionImageConfig): void;
    /**
     * @stability stable
     */
    resetImageConfig(): void;
    /**
     * @stability stable
     */
    get imageConfigInput(): LambdaFunctionImageConfig | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): LambdaFunctionTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: LambdaFunctionTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): LambdaFunctionTimeouts | undefined;
    private _tracingConfig;
    /**
     * @stability stable
     */
    get tracingConfig(): LambdaFunctionTracingConfigOutputReference;
    /**
     * @stability stable
     */
    putTracingConfig(value: LambdaFunctionTracingConfig): void;
    /**
     * @stability stable
     */
    resetTracingConfig(): void;
    /**
     * @stability stable
     */
    get tracingConfigInput(): LambdaFunctionTracingConfig | undefined;
    private _vpcConfig;
    /**
     * @stability stable
     */
    get vpcConfig(): LambdaFunctionVpcConfigOutputReference;
    /**
     * @stability stable
     */
    putVpcConfig(value: LambdaFunctionVpcConfig): void;
    /**
     * @stability stable
     */
    resetVpcConfig(): void;
    /**
     * @stability stable
     */
    get vpcConfigInput(): LambdaFunctionVpcConfig | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
