import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Lambda.
 *
 * @stability stable
 */
export interface LambdaInvocationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_invocation#function_name LambdaInvocation#function_name}.
     *
     * @stability stable
     */
    readonly functionName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_invocation#input LambdaInvocation#input}.
     *
     * @stability stable
     */
    readonly input: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_invocation#qualifier LambdaInvocation#qualifier}.
     *
     * @stability stable
     */
    readonly qualifier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_invocation#triggers LambdaInvocation#triggers}.
     *
     * @stability stable
     */
    readonly triggers?: {
        [key: string]: string;
    };
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/lambda_invocation aws_lambda_invocation}.
 *
 * @stability stable
 */
export declare class LambdaInvocation extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/lambda_invocation aws_lambda_invocation} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LambdaInvocationConfig);
    private _functionName?;
    /**
     * @stability stable
     */
    get functionName(): string;
    /**
     * @stability stable
     */
    set functionName(value: string);
    /**
     * @stability stable
     */
    get functionNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _input?;
    /**
     * @stability stable
     */
    get input(): string;
    /**
     * @stability stable
     */
    set input(value: string);
    /**
     * @stability stable
     */
    get inputInput(): string | undefined;
    private _qualifier?;
    /**
     * @stability stable
     */
    get qualifier(): string;
    /**
     * @stability stable
     */
    set qualifier(value: string);
    /**
     * @stability stable
     */
    resetQualifier(): void;
    /**
     * @stability stable
     */
    get qualifierInput(): string | undefined;
    /**
     * @stability stable
     */
    get result(): string;
    private _triggers?;
    /**
     * @stability stable
     */
    get triggers(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set triggers(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTriggers(): void;
    /**
     * @stability stable
     */
    get triggersInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
