import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Lex.
 *
 * @stability stable
 */
export interface LexIntentConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#create_version LexIntent#create_version}.
     *
     * @stability stable
     */
    readonly createVersion?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#description LexIntent#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#name LexIntent#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#parent_intent_signature LexIntent#parent_intent_signature}.
     *
     * @stability stable
     */
    readonly parentIntentSignature?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#sample_utterances LexIntent#sample_utterances}.
     *
     * @stability stable
     */
    readonly sampleUtterances?: string[];
    /**
     * conclusion_statement block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#conclusion_statement LexIntent#conclusion_statement}
     *
     * @stability stable
     */
    readonly conclusionStatement?: LexIntentConclusionStatement;
    /**
     * confirmation_prompt block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#confirmation_prompt LexIntent#confirmation_prompt}
     *
     * @stability stable
     */
    readonly confirmationPrompt?: LexIntentConfirmationPrompt;
    /**
     * dialog_code_hook block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#dialog_code_hook LexIntent#dialog_code_hook}
     *
     * @stability stable
     */
    readonly dialogCodeHook?: LexIntentDialogCodeHook;
    /**
     * follow_up_prompt block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#follow_up_prompt LexIntent#follow_up_prompt}
     *
     * @stability stable
     */
    readonly followUpPrompt?: LexIntentFollowUpPrompt;
    /**
     * fulfillment_activity block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#fulfillment_activity LexIntent#fulfillment_activity}
     *
     * @stability stable
     */
    readonly fulfillmentActivity: LexIntentFulfillmentActivity;
    /**
     * rejection_statement block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#rejection_statement LexIntent#rejection_statement}
     *
     * @stability stable
     */
    readonly rejectionStatement?: LexIntentRejectionStatement;
    /**
     * slot block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#slot LexIntent#slot}
     *
     * @stability stable
     */
    readonly slot?: LexIntentSlot[] | cdktf.IResolvable;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#timeouts LexIntent#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: LexIntentTimeouts;
}
/**
 * @stability stable
 */
export interface LexIntentConclusionStatementMessage {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#content LexIntent#content}.
     *
     * @stability stable
     */
    readonly content: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#content_type LexIntent#content_type}.
     *
     * @stability stable
     */
    readonly contentType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#group_number LexIntent#group_number}.
     *
     * @stability stable
     */
    readonly groupNumber?: number;
}
export declare function lexIntentConclusionStatementMessageToTerraform(struct?: LexIntentConclusionStatementMessage | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface LexIntentConclusionStatement {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#response_card LexIntent#response_card}.
     *
     * @stability stable
     */
    readonly responseCard?: string;
    /**
     * message block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#message LexIntent#message}
     *
     * @stability stable
     */
    readonly message: LexIntentConclusionStatementMessage[] | cdktf.IResolvable;
}
export declare function lexIntentConclusionStatementToTerraform(struct?: LexIntentConclusionStatementOutputReference | LexIntentConclusionStatement): any;
/**
 * @stability stable
 */
export declare class LexIntentConclusionStatementOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LexIntentConclusionStatement | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LexIntentConclusionStatement | undefined);
    private _responseCard?;
    /**
     * @stability stable
     */
    get responseCard(): string;
    /**
     * @stability stable
     */
    set responseCard(value: string);
    /**
     * @stability stable
     */
    resetResponseCard(): void;
    /**
     * @stability stable
     */
    get responseCardInput(): string | undefined;
    private _message?;
    /**
     * @stability stable
     */
    get message(): LexIntentConclusionStatementMessage[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set message(value: LexIntentConclusionStatementMessage[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get messageInput(): cdktf.IResolvable | LexIntentConclusionStatementMessage[] | undefined;
}
/**
 * @stability stable
 */
export interface LexIntentConfirmationPromptMessage {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#content LexIntent#content}.
     *
     * @stability stable
     */
    readonly content: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#content_type LexIntent#content_type}.
     *
     * @stability stable
     */
    readonly contentType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#group_number LexIntent#group_number}.
     *
     * @stability stable
     */
    readonly groupNumber?: number;
}
export declare function lexIntentConfirmationPromptMessageToTerraform(struct?: LexIntentConfirmationPromptMessage | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface LexIntentConfirmationPrompt {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#max_attempts LexIntent#max_attempts}.
     *
     * @stability stable
     */
    readonly maxAttempts: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#response_card LexIntent#response_card}.
     *
     * @stability stable
     */
    readonly responseCard?: string;
    /**
     * message block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#message LexIntent#message}
     *
     * @stability stable
     */
    readonly message: LexIntentConfirmationPromptMessage[] | cdktf.IResolvable;
}
export declare function lexIntentConfirmationPromptToTerraform(struct?: LexIntentConfirmationPromptOutputReference | LexIntentConfirmationPrompt): any;
/**
 * @stability stable
 */
export declare class LexIntentConfirmationPromptOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LexIntentConfirmationPrompt | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LexIntentConfirmationPrompt | undefined);
    private _maxAttempts?;
    /**
     * @stability stable
     */
    get maxAttempts(): number;
    /**
     * @stability stable
     */
    set maxAttempts(value: number);
    /**
     * @stability stable
     */
    get maxAttemptsInput(): number | undefined;
    private _responseCard?;
    /**
     * @stability stable
     */
    get responseCard(): string;
    /**
     * @stability stable
     */
    set responseCard(value: string);
    /**
     * @stability stable
     */
    resetResponseCard(): void;
    /**
     * @stability stable
     */
    get responseCardInput(): string | undefined;
    private _message?;
    /**
     * @stability stable
     */
    get message(): LexIntentConfirmationPromptMessage[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set message(value: LexIntentConfirmationPromptMessage[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get messageInput(): cdktf.IResolvable | LexIntentConfirmationPromptMessage[] | undefined;
}
/**
 * @stability stable
 */
export interface LexIntentDialogCodeHook {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#message_version LexIntent#message_version}.
     *
     * @stability stable
     */
    readonly messageVersion: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#uri LexIntent#uri}.
     *
     * @stability stable
     */
    readonly uri: string;
}
export declare function lexIntentDialogCodeHookToTerraform(struct?: LexIntentDialogCodeHookOutputReference | LexIntentDialogCodeHook): any;
/**
 * @stability stable
 */
export declare class LexIntentDialogCodeHookOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LexIntentDialogCodeHook | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LexIntentDialogCodeHook | undefined);
    private _messageVersion?;
    /**
     * @stability stable
     */
    get messageVersion(): string;
    /**
     * @stability stable
     */
    set messageVersion(value: string);
    /**
     * @stability stable
     */
    get messageVersionInput(): string | undefined;
    private _uri?;
    /**
     * @stability stable
     */
    get uri(): string;
    /**
     * @stability stable
     */
    set uri(value: string);
    /**
     * @stability stable
     */
    get uriInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface LexIntentFollowUpPromptPromptMessage {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#content LexIntent#content}.
     *
     * @stability stable
     */
    readonly content: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#content_type LexIntent#content_type}.
     *
     * @stability stable
     */
    readonly contentType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#group_number LexIntent#group_number}.
     *
     * @stability stable
     */
    readonly groupNumber?: number;
}
export declare function lexIntentFollowUpPromptPromptMessageToTerraform(struct?: LexIntentFollowUpPromptPromptMessage | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface LexIntentFollowUpPromptPrompt {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#max_attempts LexIntent#max_attempts}.
     *
     * @stability stable
     */
    readonly maxAttempts: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#response_card LexIntent#response_card}.
     *
     * @stability stable
     */
    readonly responseCard?: string;
    /**
     * message block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#message LexIntent#message}
     *
     * @stability stable
     */
    readonly message: LexIntentFollowUpPromptPromptMessage[] | cdktf.IResolvable;
}
export declare function lexIntentFollowUpPromptPromptToTerraform(struct?: LexIntentFollowUpPromptPromptOutputReference | LexIntentFollowUpPromptPrompt): any;
/**
 * @stability stable
 */
export declare class LexIntentFollowUpPromptPromptOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LexIntentFollowUpPromptPrompt | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LexIntentFollowUpPromptPrompt | undefined);
    private _maxAttempts?;
    /**
     * @stability stable
     */
    get maxAttempts(): number;
    /**
     * @stability stable
     */
    set maxAttempts(value: number);
    /**
     * @stability stable
     */
    get maxAttemptsInput(): number | undefined;
    private _responseCard?;
    /**
     * @stability stable
     */
    get responseCard(): string;
    /**
     * @stability stable
     */
    set responseCard(value: string);
    /**
     * @stability stable
     */
    resetResponseCard(): void;
    /**
     * @stability stable
     */
    get responseCardInput(): string | undefined;
    private _message?;
    /**
     * @stability stable
     */
    get message(): LexIntentFollowUpPromptPromptMessage[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set message(value: LexIntentFollowUpPromptPromptMessage[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get messageInput(): cdktf.IResolvable | LexIntentFollowUpPromptPromptMessage[] | undefined;
}
/**
 * @stability stable
 */
export interface LexIntentFollowUpPromptRejectionStatementMessage {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#content LexIntent#content}.
     *
     * @stability stable
     */
    readonly content: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#content_type LexIntent#content_type}.
     *
     * @stability stable
     */
    readonly contentType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#group_number LexIntent#group_number}.
     *
     * @stability stable
     */
    readonly groupNumber?: number;
}
export declare function lexIntentFollowUpPromptRejectionStatementMessageToTerraform(struct?: LexIntentFollowUpPromptRejectionStatementMessage | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface LexIntentFollowUpPromptRejectionStatement {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#response_card LexIntent#response_card}.
     *
     * @stability stable
     */
    readonly responseCard?: string;
    /**
     * message block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#message LexIntent#message}
     *
     * @stability stable
     */
    readonly message: LexIntentFollowUpPromptRejectionStatementMessage[] | cdktf.IResolvable;
}
export declare function lexIntentFollowUpPromptRejectionStatementToTerraform(struct?: LexIntentFollowUpPromptRejectionStatementOutputReference | LexIntentFollowUpPromptRejectionStatement): any;
/**
 * @stability stable
 */
export declare class LexIntentFollowUpPromptRejectionStatementOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LexIntentFollowUpPromptRejectionStatement | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LexIntentFollowUpPromptRejectionStatement | undefined);
    private _responseCard?;
    /**
     * @stability stable
     */
    get responseCard(): string;
    /**
     * @stability stable
     */
    set responseCard(value: string);
    /**
     * @stability stable
     */
    resetResponseCard(): void;
    /**
     * @stability stable
     */
    get responseCardInput(): string | undefined;
    private _message?;
    /**
     * @stability stable
     */
    get message(): LexIntentFollowUpPromptRejectionStatementMessage[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set message(value: LexIntentFollowUpPromptRejectionStatementMessage[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get messageInput(): cdktf.IResolvable | LexIntentFollowUpPromptRejectionStatementMessage[] | undefined;
}
/**
 * @stability stable
 */
export interface LexIntentFollowUpPrompt {
    /**
     * prompt block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#prompt LexIntent#prompt}
     *
     * @stability stable
     */
    readonly prompt: LexIntentFollowUpPromptPrompt;
    /**
     * rejection_statement block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#rejection_statement LexIntent#rejection_statement}
     *
     * @stability stable
     */
    readonly rejectionStatement: LexIntentFollowUpPromptRejectionStatement;
}
export declare function lexIntentFollowUpPromptToTerraform(struct?: LexIntentFollowUpPromptOutputReference | LexIntentFollowUpPrompt): any;
/**
 * @stability stable
 */
export declare class LexIntentFollowUpPromptOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LexIntentFollowUpPrompt | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LexIntentFollowUpPrompt | undefined);
    private _prompt;
    /**
     * @stability stable
     */
    get prompt(): LexIntentFollowUpPromptPromptOutputReference;
    /**
     * @stability stable
     */
    putPrompt(value: LexIntentFollowUpPromptPrompt): void;
    /**
     * @stability stable
     */
    get promptInput(): LexIntentFollowUpPromptPrompt | undefined;
    private _rejectionStatement;
    /**
     * @stability stable
     */
    get rejectionStatement(): LexIntentFollowUpPromptRejectionStatementOutputReference;
    /**
     * @stability stable
     */
    putRejectionStatement(value: LexIntentFollowUpPromptRejectionStatement): void;
    /**
     * @stability stable
     */
    get rejectionStatementInput(): LexIntentFollowUpPromptRejectionStatement | undefined;
}
/**
 * @stability stable
 */
export interface LexIntentFulfillmentActivityCodeHook {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#message_version LexIntent#message_version}.
     *
     * @stability stable
     */
    readonly messageVersion: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#uri LexIntent#uri}.
     *
     * @stability stable
     */
    readonly uri: string;
}
export declare function lexIntentFulfillmentActivityCodeHookToTerraform(struct?: LexIntentFulfillmentActivityCodeHookOutputReference | LexIntentFulfillmentActivityCodeHook): any;
/**
 * @stability stable
 */
export declare class LexIntentFulfillmentActivityCodeHookOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LexIntentFulfillmentActivityCodeHook | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LexIntentFulfillmentActivityCodeHook | undefined);
    private _messageVersion?;
    /**
     * @stability stable
     */
    get messageVersion(): string;
    /**
     * @stability stable
     */
    set messageVersion(value: string);
    /**
     * @stability stable
     */
    get messageVersionInput(): string | undefined;
    private _uri?;
    /**
     * @stability stable
     */
    get uri(): string;
    /**
     * @stability stable
     */
    set uri(value: string);
    /**
     * @stability stable
     */
    get uriInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface LexIntentFulfillmentActivity {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#type LexIntent#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * code_hook block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#code_hook LexIntent#code_hook}
     *
     * @stability stable
     */
    readonly codeHook?: LexIntentFulfillmentActivityCodeHook;
}
export declare function lexIntentFulfillmentActivityToTerraform(struct?: LexIntentFulfillmentActivityOutputReference | LexIntentFulfillmentActivity): any;
/**
 * @stability stable
 */
export declare class LexIntentFulfillmentActivityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LexIntentFulfillmentActivity | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LexIntentFulfillmentActivity | undefined);
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _codeHook;
    /**
     * @stability stable
     */
    get codeHook(): LexIntentFulfillmentActivityCodeHookOutputReference;
    /**
     * @stability stable
     */
    putCodeHook(value: LexIntentFulfillmentActivityCodeHook): void;
    /**
     * @stability stable
     */
    resetCodeHook(): void;
    /**
     * @stability stable
     */
    get codeHookInput(): LexIntentFulfillmentActivityCodeHook | undefined;
}
/**
 * @stability stable
 */
export interface LexIntentRejectionStatementMessage {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#content LexIntent#content}.
     *
     * @stability stable
     */
    readonly content: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#content_type LexIntent#content_type}.
     *
     * @stability stable
     */
    readonly contentType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#group_number LexIntent#group_number}.
     *
     * @stability stable
     */
    readonly groupNumber?: number;
}
export declare function lexIntentRejectionStatementMessageToTerraform(struct?: LexIntentRejectionStatementMessage | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface LexIntentRejectionStatement {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#response_card LexIntent#response_card}.
     *
     * @stability stable
     */
    readonly responseCard?: string;
    /**
     * message block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#message LexIntent#message}
     *
     * @stability stable
     */
    readonly message: LexIntentRejectionStatementMessage[] | cdktf.IResolvable;
}
export declare function lexIntentRejectionStatementToTerraform(struct?: LexIntentRejectionStatementOutputReference | LexIntentRejectionStatement): any;
/**
 * @stability stable
 */
export declare class LexIntentRejectionStatementOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LexIntentRejectionStatement | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LexIntentRejectionStatement | undefined);
    private _responseCard?;
    /**
     * @stability stable
     */
    get responseCard(): string;
    /**
     * @stability stable
     */
    set responseCard(value: string);
    /**
     * @stability stable
     */
    resetResponseCard(): void;
    /**
     * @stability stable
     */
    get responseCardInput(): string | undefined;
    private _message?;
    /**
     * @stability stable
     */
    get message(): LexIntentRejectionStatementMessage[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set message(value: LexIntentRejectionStatementMessage[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get messageInput(): cdktf.IResolvable | LexIntentRejectionStatementMessage[] | undefined;
}
/**
 * @stability stable
 */
export interface LexIntentSlotValueElicitationPromptMessage {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#content LexIntent#content}.
     *
     * @stability stable
     */
    readonly content: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#content_type LexIntent#content_type}.
     *
     * @stability stable
     */
    readonly contentType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#group_number LexIntent#group_number}.
     *
     * @stability stable
     */
    readonly groupNumber?: number;
}
export declare function lexIntentSlotValueElicitationPromptMessageToTerraform(struct?: LexIntentSlotValueElicitationPromptMessage | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface LexIntentSlotValueElicitationPrompt {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#max_attempts LexIntent#max_attempts}.
     *
     * @stability stable
     */
    readonly maxAttempts: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#response_card LexIntent#response_card}.
     *
     * @stability stable
     */
    readonly responseCard?: string;
    /**
     * message block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#message LexIntent#message}
     *
     * @stability stable
     */
    readonly message: LexIntentSlotValueElicitationPromptMessage[] | cdktf.IResolvable;
}
export declare function lexIntentSlotValueElicitationPromptToTerraform(struct?: LexIntentSlotValueElicitationPromptOutputReference | LexIntentSlotValueElicitationPrompt): any;
/**
 * @stability stable
 */
export declare class LexIntentSlotValueElicitationPromptOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LexIntentSlotValueElicitationPrompt | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LexIntentSlotValueElicitationPrompt | undefined);
    private _maxAttempts?;
    /**
     * @stability stable
     */
    get maxAttempts(): number;
    /**
     * @stability stable
     */
    set maxAttempts(value: number);
    /**
     * @stability stable
     */
    get maxAttemptsInput(): number | undefined;
    private _responseCard?;
    /**
     * @stability stable
     */
    get responseCard(): string;
    /**
     * @stability stable
     */
    set responseCard(value: string);
    /**
     * @stability stable
     */
    resetResponseCard(): void;
    /**
     * @stability stable
     */
    get responseCardInput(): string | undefined;
    private _message?;
    /**
     * @stability stable
     */
    get message(): LexIntentSlotValueElicitationPromptMessage[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set message(value: LexIntentSlotValueElicitationPromptMessage[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get messageInput(): cdktf.IResolvable | LexIntentSlotValueElicitationPromptMessage[] | undefined;
}
/**
 * @stability stable
 */
export interface LexIntentSlot {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#description LexIntent#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#name LexIntent#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#priority LexIntent#priority}.
     *
     * @stability stable
     */
    readonly priority?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#response_card LexIntent#response_card}.
     *
     * @stability stable
     */
    readonly responseCard?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#sample_utterances LexIntent#sample_utterances}.
     *
     * @stability stable
     */
    readonly sampleUtterances?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#slot_constraint LexIntent#slot_constraint}.
     *
     * @stability stable
     */
    readonly slotConstraint: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#slot_type LexIntent#slot_type}.
     *
     * @stability stable
     */
    readonly slotType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#slot_type_version LexIntent#slot_type_version}.
     *
     * @stability stable
     */
    readonly slotTypeVersion?: string;
    /**
     * value_elicitation_prompt block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#value_elicitation_prompt LexIntent#value_elicitation_prompt}
     *
     * @stability stable
     */
    readonly valueElicitationPrompt?: LexIntentSlotValueElicitationPrompt;
}
export declare function lexIntentSlotToTerraform(struct?: LexIntentSlot | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface LexIntentTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#create LexIntent#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#delete LexIntent#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_intent#update LexIntent#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function lexIntentTimeoutsToTerraform(struct?: LexIntentTimeoutsOutputReference | LexIntentTimeouts | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export declare class LexIntentTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LexIntentTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LexIntentTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/lex_intent aws_lex_intent}.
 *
 * @stability stable
 */
export declare class LexIntent extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/lex_intent aws_lex_intent} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LexIntentConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get checksum(): string;
    private _createVersion?;
    /**
     * @stability stable
     */
    get createVersion(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set createVersion(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetCreateVersion(): void;
    /**
     * @stability stable
     */
    get createVersionInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get createdDate(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastUpdatedDate(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _parentIntentSignature?;
    /**
     * @stability stable
     */
    get parentIntentSignature(): string;
    /**
     * @stability stable
     */
    set parentIntentSignature(value: string);
    /**
     * @stability stable
     */
    resetParentIntentSignature(): void;
    /**
     * @stability stable
     */
    get parentIntentSignatureInput(): string | undefined;
    private _sampleUtterances?;
    /**
     * @stability stable
     */
    get sampleUtterances(): string[];
    /**
     * @stability stable
     */
    set sampleUtterances(value: string[]);
    /**
     * @stability stable
     */
    resetSampleUtterances(): void;
    /**
     * @stability stable
     */
    get sampleUtterancesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get version(): string;
    private _conclusionStatement;
    /**
     * @stability stable
     */
    get conclusionStatement(): LexIntentConclusionStatementOutputReference;
    /**
     * @stability stable
     */
    putConclusionStatement(value: LexIntentConclusionStatement): void;
    /**
     * @stability stable
     */
    resetConclusionStatement(): void;
    /**
     * @stability stable
     */
    get conclusionStatementInput(): LexIntentConclusionStatement | undefined;
    private _confirmationPrompt;
    /**
     * @stability stable
     */
    get confirmationPrompt(): LexIntentConfirmationPromptOutputReference;
    /**
     * @stability stable
     */
    putConfirmationPrompt(value: LexIntentConfirmationPrompt): void;
    /**
     * @stability stable
     */
    resetConfirmationPrompt(): void;
    /**
     * @stability stable
     */
    get confirmationPromptInput(): LexIntentConfirmationPrompt | undefined;
    private _dialogCodeHook;
    /**
     * @stability stable
     */
    get dialogCodeHook(): LexIntentDialogCodeHookOutputReference;
    /**
     * @stability stable
     */
    putDialogCodeHook(value: LexIntentDialogCodeHook): void;
    /**
     * @stability stable
     */
    resetDialogCodeHook(): void;
    /**
     * @stability stable
     */
    get dialogCodeHookInput(): LexIntentDialogCodeHook | undefined;
    private _followUpPrompt;
    /**
     * @stability stable
     */
    get followUpPrompt(): LexIntentFollowUpPromptOutputReference;
    /**
     * @stability stable
     */
    putFollowUpPrompt(value: LexIntentFollowUpPrompt): void;
    /**
     * @stability stable
     */
    resetFollowUpPrompt(): void;
    /**
     * @stability stable
     */
    get followUpPromptInput(): LexIntentFollowUpPrompt | undefined;
    private _fulfillmentActivity;
    /**
     * @stability stable
     */
    get fulfillmentActivity(): LexIntentFulfillmentActivityOutputReference;
    /**
     * @stability stable
     */
    putFulfillmentActivity(value: LexIntentFulfillmentActivity): void;
    /**
     * @stability stable
     */
    get fulfillmentActivityInput(): LexIntentFulfillmentActivity | undefined;
    private _rejectionStatement;
    /**
     * @stability stable
     */
    get rejectionStatement(): LexIntentRejectionStatementOutputReference;
    /**
     * @stability stable
     */
    putRejectionStatement(value: LexIntentRejectionStatement): void;
    /**
     * @stability stable
     */
    resetRejectionStatement(): void;
    /**
     * @stability stable
     */
    get rejectionStatementInput(): LexIntentRejectionStatement | undefined;
    private _slot?;
    /**
     * @stability stable
     */
    get slot(): LexIntentSlot[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set slot(value: LexIntentSlot[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSlot(): void;
    /**
     * @stability stable
     */
    get slotInput(): cdktf.IResolvable | LexIntentSlot[] | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): LexIntentTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: LexIntentTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): LexIntentTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
