import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Lex.
 *
 * @stability stable
 */
export interface LexSlotTypeConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type#create_version LexSlotType#create_version}.
     *
     * @stability stable
     */
    readonly createVersion?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type#description LexSlotType#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type#name LexSlotType#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type#value_selection_strategy LexSlotType#value_selection_strategy}.
     *
     * @stability stable
     */
    readonly valueSelectionStrategy?: string;
    /**
     * enumeration_value block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type#enumeration_value LexSlotType#enumeration_value}
     *
     * @stability stable
     */
    readonly enumerationValue: LexSlotTypeEnumerationValue[] | cdktf.IResolvable;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type#timeouts LexSlotType#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: LexSlotTypeTimeouts;
}
/**
 * @stability stable
 */
export interface LexSlotTypeEnumerationValue {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type#synonyms LexSlotType#synonyms}.
     *
     * @stability stable
     */
    readonly synonyms?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type#value LexSlotType#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function lexSlotTypeEnumerationValueToTerraform(struct?: LexSlotTypeEnumerationValue | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface LexSlotTypeTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type#create LexSlotType#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type#delete LexSlotType#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type#update LexSlotType#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function lexSlotTypeTimeoutsToTerraform(struct?: LexSlotTypeTimeoutsOutputReference | LexSlotTypeTimeouts | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export declare class LexSlotTypeTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LexSlotTypeTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LexSlotTypeTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type aws_lex_slot_type}.
 *
 * @stability stable
 */
export declare class LexSlotType extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/lex_slot_type aws_lex_slot_type} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LexSlotTypeConfig);
    /**
     * @stability stable
     */
    get checksum(): string;
    private _createVersion?;
    /**
     * @stability stable
     */
    get createVersion(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set createVersion(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetCreateVersion(): void;
    /**
     * @stability stable
     */
    get createVersionInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get createdDate(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastUpdatedDate(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _valueSelectionStrategy?;
    /**
     * @stability stable
     */
    get valueSelectionStrategy(): string;
    /**
     * @stability stable
     */
    set valueSelectionStrategy(value: string);
    /**
     * @stability stable
     */
    resetValueSelectionStrategy(): void;
    /**
     * @stability stable
     */
    get valueSelectionStrategyInput(): string | undefined;
    /**
     * @stability stable
     */
    get version(): string;
    private _enumerationValue?;
    /**
     * @stability stable
     */
    get enumerationValue(): LexSlotTypeEnumerationValue[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enumerationValue(value: LexSlotTypeEnumerationValue[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get enumerationValueInput(): cdktf.IResolvable | LexSlotTypeEnumerationValue[] | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): LexSlotTypeTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: LexSlotTypeTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): LexSlotTypeTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
