import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Lightsail.
 *
 * @stability stable
 */
export interface LightsailInstancePublicPortsConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lightsail_instance_public_ports#instance_name LightsailInstancePublicPorts#instance_name}.
     *
     * @stability stable
     */
    readonly instanceName: string;
    /**
     * port_info block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lightsail_instance_public_ports#port_info LightsailInstancePublicPorts#port_info}
     *
     * @stability stable
     */
    readonly portInfo: LightsailInstancePublicPortsPortInfo[] | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface LightsailInstancePublicPortsPortInfo {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lightsail_instance_public_ports#cidrs LightsailInstancePublicPorts#cidrs}.
     *
     * @stability stable
     */
    readonly cidrs?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lightsail_instance_public_ports#from_port LightsailInstancePublicPorts#from_port}.
     *
     * @stability stable
     */
    readonly fromPort: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lightsail_instance_public_ports#protocol LightsailInstancePublicPorts#protocol}.
     *
     * @stability stable
     */
    readonly protocol: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lightsail_instance_public_ports#to_port LightsailInstancePublicPorts#to_port}.
     *
     * @stability stable
     */
    readonly toPort: number;
}
export declare function lightsailInstancePublicPortsPortInfoToTerraform(struct?: LightsailInstancePublicPortsPortInfo | cdktf.IResolvable): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/lightsail_instance_public_ports aws_lightsail_instance_public_ports}.
 *
 * @stability stable
 */
export declare class LightsailInstancePublicPorts extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/lightsail_instance_public_ports aws_lightsail_instance_public_ports} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LightsailInstancePublicPortsConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceName?;
    /**
     * @stability stable
     */
    get instanceName(): string;
    /**
     * @stability stable
     */
    set instanceName(value: string);
    /**
     * @stability stable
     */
    get instanceNameInput(): string | undefined;
    private _portInfo?;
    /**
     * @stability stable
     */
    get portInfo(): LightsailInstancePublicPortsPortInfo[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set portInfo(value: LightsailInstancePublicPortsPortInfo[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get portInfoInput(): cdktf.IResolvable | LightsailInstancePublicPortsPortInfo[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
