import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Macie 2.
 *
 * @stability stable
 */
export interface Macie2OrganizationAdminAccountConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_organization_admin_account#admin_account_id Macie2OrganizationAdminAccount#admin_account_id}.
     *
     * @stability stable
     */
    readonly adminAccountId: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/macie2_organization_admin_account aws_macie2_organization_admin_account}.
 *
 * @stability stable
 */
export declare class Macie2OrganizationAdminAccount extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/macie2_organization_admin_account aws_macie2_organization_admin_account} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Macie2OrganizationAdminAccountConfig);
    private _adminAccountId?;
    /**
     * @stability stable
     */
    get adminAccountId(): string;
    /**
     * @stability stable
     */
    set adminAccountId(value: string);
    /**
     * @stability stable
     */
    get adminAccountIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
