import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Managed Streaming for Kafka.
 *
 * @stability stable
 */
export interface DataAwsMskBrokerNodesConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/msk_broker_nodes#cluster_arn DataAwsMskBrokerNodes#cluster_arn}.
     *
     * @stability stable
     */
    readonly clusterArn: string;
}
/**
 * @stability stable
 */
export declare class DataAwsMskBrokerNodesNodeInfoList extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get attachedEniId(): string;
    /**
     * @stability stable
     */
    get brokerId(): number;
    /**
     * @stability stable
     */
    get clientSubnet(): string;
    /**
     * @stability stable
     */
    get clientVpcIpAddress(): string;
    /**
     * @stability stable
     */
    get endpoints(): string[];
    /**
     * @stability stable
     */
    get nodeArn(): string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/msk_broker_nodes aws_msk_broker_nodes}.
 *
 * @stability stable
 */
export declare class DataAwsMskBrokerNodes extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/msk_broker_nodes aws_msk_broker_nodes} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsMskBrokerNodesConfig);
    private _clusterArn?;
    /**
     * @stability stable
     */
    get clusterArn(): string;
    /**
     * @stability stable
     */
    set clusterArn(value: string);
    /**
     * @stability stable
     */
    get clusterArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    nodeInfoList(index: string): DataAwsMskBrokerNodesNodeInfoList;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
