import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Network Firewall.
 *
 * @stability stable
 */
export interface NetworkfirewallFirewallConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall#delete_protection NetworkfirewallFirewall#delete_protection}.
     *
     * @stability stable
     */
    readonly deleteProtection?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall#description NetworkfirewallFirewall#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall#firewall_policy_arn NetworkfirewallFirewall#firewall_policy_arn}.
     *
     * @stability stable
     */
    readonly firewallPolicyArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall#firewall_policy_change_protection NetworkfirewallFirewall#firewall_policy_change_protection}.
     *
     * @stability stable
     */
    readonly firewallPolicyChangeProtection?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall#name NetworkfirewallFirewall#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall#subnet_change_protection NetworkfirewallFirewall#subnet_change_protection}.
     *
     * @stability stable
     */
    readonly subnetChangeProtection?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall#tags NetworkfirewallFirewall#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall#tags_all NetworkfirewallFirewall#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall#vpc_id NetworkfirewallFirewall#vpc_id}.
     *
     * @stability stable
     */
    readonly vpcId: string;
    /**
     * subnet_mapping block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall#subnet_mapping NetworkfirewallFirewall#subnet_mapping}
     *
     * @stability stable
     */
    readonly subnetMapping: NetworkfirewallFirewallSubnetMapping[] | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export declare class NetworkfirewallFirewallFirewallStatusSyncStatesAttachment extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get endpointId(): string;
    /**
     * @stability stable
     */
    get subnetId(): string;
}
/**
 * @stability stable
 */
export declare class NetworkfirewallFirewallFirewallStatusSyncStates extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get attachment(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
}
/**
 * @stability stable
 */
export declare class NetworkfirewallFirewallFirewallStatus extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get syncStates(): cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface NetworkfirewallFirewallSubnetMapping {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall#subnet_id NetworkfirewallFirewall#subnet_id}.
     *
     * @stability stable
     */
    readonly subnetId: string;
}
export declare function networkfirewallFirewallSubnetMappingToTerraform(struct?: NetworkfirewallFirewallSubnetMapping | cdktf.IResolvable): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall aws_networkfirewall_firewall}.
 *
 * @stability stable
 */
export declare class NetworkfirewallFirewall extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_firewall aws_networkfirewall_firewall} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: NetworkfirewallFirewallConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _deleteProtection?;
    /**
     * @stability stable
     */
    get deleteProtection(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set deleteProtection(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDeleteProtection(): void;
    /**
     * @stability stable
     */
    get deleteProtectionInput(): boolean | cdktf.IResolvable | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _firewallPolicyArn?;
    /**
     * @stability stable
     */
    get firewallPolicyArn(): string;
    /**
     * @stability stable
     */
    set firewallPolicyArn(value: string);
    /**
     * @stability stable
     */
    get firewallPolicyArnInput(): string | undefined;
    private _firewallPolicyChangeProtection?;
    /**
     * @stability stable
     */
    get firewallPolicyChangeProtection(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set firewallPolicyChangeProtection(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetFirewallPolicyChangeProtection(): void;
    /**
     * @stability stable
     */
    get firewallPolicyChangeProtectionInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    firewallStatus(index: string): NetworkfirewallFirewallFirewallStatus;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _subnetChangeProtection?;
    /**
     * @stability stable
     */
    get subnetChangeProtection(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set subnetChangeProtection(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSubnetChangeProtection(): void;
    /**
     * @stability stable
     */
    get subnetChangeProtectionInput(): boolean | cdktf.IResolvable | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get updateToken(): string;
    private _vpcId?;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    get vpcIdInput(): string | undefined;
    private _subnetMapping?;
    /**
     * @stability stable
     */
    get subnetMapping(): NetworkfirewallFirewallSubnetMapping[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set subnetMapping(value: NetworkfirewallFirewallSubnetMapping[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get subnetMappingInput(): cdktf.IResolvable | NetworkfirewallFirewallSubnetMapping[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
