import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Network Firewall.
 *
 * @stability stable
 */
export interface NetworkfirewallLoggingConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_logging_configuration#firewall_arn NetworkfirewallLoggingConfiguration#firewall_arn}.
     *
     * @stability stable
     */
    readonly firewallArn: string;
    /**
     * logging_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_logging_configuration#logging_configuration NetworkfirewallLoggingConfiguration#logging_configuration}
     *
     * @stability stable
     */
    readonly loggingConfiguration: NetworkfirewallLoggingConfigurationLoggingConfiguration;
}
/**
 * @stability stable
 */
export interface NetworkfirewallLoggingConfigurationLoggingConfigurationLogDestinationConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_logging_configuration#log_destination NetworkfirewallLoggingConfiguration#log_destination}.
     *
     * @stability stable
     */
    readonly logDestination: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_logging_configuration#log_destination_type NetworkfirewallLoggingConfiguration#log_destination_type}.
     *
     * @stability stable
     */
    readonly logDestinationType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_logging_configuration#log_type NetworkfirewallLoggingConfiguration#log_type}.
     *
     * @stability stable
     */
    readonly logType: string;
}
export declare function networkfirewallLoggingConfigurationLoggingConfigurationLogDestinationConfigToTerraform(struct?: NetworkfirewallLoggingConfigurationLoggingConfigurationLogDestinationConfig | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface NetworkfirewallLoggingConfigurationLoggingConfiguration {
    /**
     * log_destination_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_logging_configuration#log_destination_config NetworkfirewallLoggingConfiguration#log_destination_config}
     *
     * @stability stable
     */
    readonly logDestinationConfig: NetworkfirewallLoggingConfigurationLoggingConfigurationLogDestinationConfig[] | cdktf.IResolvable;
}
export declare function networkfirewallLoggingConfigurationLoggingConfigurationToTerraform(struct?: NetworkfirewallLoggingConfigurationLoggingConfigurationOutputReference | NetworkfirewallLoggingConfigurationLoggingConfiguration): any;
/**
 * @stability stable
 */
export declare class NetworkfirewallLoggingConfigurationLoggingConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): NetworkfirewallLoggingConfigurationLoggingConfiguration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: NetworkfirewallLoggingConfigurationLoggingConfiguration | undefined);
    private _logDestinationConfig?;
    /**
     * @stability stable
     */
    get logDestinationConfig(): NetworkfirewallLoggingConfigurationLoggingConfigurationLogDestinationConfig[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set logDestinationConfig(value: NetworkfirewallLoggingConfigurationLoggingConfigurationLogDestinationConfig[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get logDestinationConfigInput(): cdktf.IResolvable | NetworkfirewallLoggingConfigurationLoggingConfigurationLogDestinationConfig[] | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_logging_configuration aws_networkfirewall_logging_configuration}.
 *
 * @stability stable
 */
export declare class NetworkfirewallLoggingConfiguration extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/networkfirewall_logging_configuration aws_networkfirewall_logging_configuration} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: NetworkfirewallLoggingConfigurationConfig);
    private _firewallArn?;
    /**
     * @stability stable
     */
    get firewallArn(): string;
    /**
     * @stability stable
     */
    set firewallArn(value: string);
    /**
     * @stability stable
     */
    get firewallArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _loggingConfiguration;
    /**
     * @stability stable
     */
    get loggingConfiguration(): NetworkfirewallLoggingConfigurationLoggingConfigurationOutputReference;
    /**
     * @stability stable
     */
    putLoggingConfiguration(value: NetworkfirewallLoggingConfigurationLoggingConfiguration): void;
    /**
     * @stability stable
     */
    get loggingConfigurationInput(): NetworkfirewallLoggingConfigurationLoggingConfiguration | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
