import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS OpsWorks.
 *
 * @stability stable
 */
export interface OpsworksApplicationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#auto_bundle_on_deploy OpsworksApplication#auto_bundle_on_deploy}.
     *
     * @stability stable
     */
    readonly autoBundleOnDeploy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#aws_flow_ruby_settings OpsworksApplication#aws_flow_ruby_settings}.
     *
     * @stability stable
     */
    readonly awsFlowRubySettings?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#data_source_arn OpsworksApplication#data_source_arn}.
     *
     * @stability stable
     */
    readonly dataSourceArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#data_source_database_name OpsworksApplication#data_source_database_name}.
     *
     * @stability stable
     */
    readonly dataSourceDatabaseName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#data_source_type OpsworksApplication#data_source_type}.
     *
     * @stability stable
     */
    readonly dataSourceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#description OpsworksApplication#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#document_root OpsworksApplication#document_root}.
     *
     * @stability stable
     */
    readonly documentRoot?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#domains OpsworksApplication#domains}.
     *
     * @stability stable
     */
    readonly domains?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#enable_ssl OpsworksApplication#enable_ssl}.
     *
     * @stability stable
     */
    readonly enableSsl?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#name OpsworksApplication#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#rails_env OpsworksApplication#rails_env}.
     *
     * @stability stable
     */
    readonly railsEnv?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#short_name OpsworksApplication#short_name}.
     *
     * @stability stable
     */
    readonly shortName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#stack_id OpsworksApplication#stack_id}.
     *
     * @stability stable
     */
    readonly stackId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#type OpsworksApplication#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * app_source block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#app_source OpsworksApplication#app_source}
     *
     * @stability stable
     */
    readonly appSource?: OpsworksApplicationAppSource[] | cdktf.IResolvable;
    /**
     * environment block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#environment OpsworksApplication#environment}
     *
     * @stability stable
     */
    readonly environment?: OpsworksApplicationEnvironment[] | cdktf.IResolvable;
    /**
     * ssl_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#ssl_configuration OpsworksApplication#ssl_configuration}
     *
     * @stability stable
     */
    readonly sslConfiguration?: OpsworksApplicationSslConfiguration[] | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface OpsworksApplicationAppSource {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#password OpsworksApplication#password}.
     *
     * @stability stable
     */
    readonly password?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#revision OpsworksApplication#revision}.
     *
     * @stability stable
     */
    readonly revision?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#ssh_key OpsworksApplication#ssh_key}.
     *
     * @stability stable
     */
    readonly sshKey?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#type OpsworksApplication#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#url OpsworksApplication#url}.
     *
     * @stability stable
     */
    readonly url?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#username OpsworksApplication#username}.
     *
     * @stability stable
     */
    readonly username?: string;
}
export declare function opsworksApplicationAppSourceToTerraform(struct?: OpsworksApplicationAppSource | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface OpsworksApplicationEnvironment {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#key OpsworksApplication#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#secure OpsworksApplication#secure}.
     *
     * @stability stable
     */
    readonly secure?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#value OpsworksApplication#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function opsworksApplicationEnvironmentToTerraform(struct?: OpsworksApplicationEnvironment | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface OpsworksApplicationSslConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#certificate OpsworksApplication#certificate}.
     *
     * @stability stable
     */
    readonly certificate: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#chain OpsworksApplication#chain}.
     *
     * @stability stable
     */
    readonly chain?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application#private_key OpsworksApplication#private_key}.
     *
     * @stability stable
     */
    readonly privateKey: string;
}
export declare function opsworksApplicationSslConfigurationToTerraform(struct?: OpsworksApplicationSslConfiguration | cdktf.IResolvable): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application aws_opsworks_application}.
 *
 * @stability stable
 */
export declare class OpsworksApplication extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/opsworks_application aws_opsworks_application} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: OpsworksApplicationConfig);
    private _autoBundleOnDeploy?;
    /**
     * @stability stable
     */
    get autoBundleOnDeploy(): string;
    /**
     * @stability stable
     */
    set autoBundleOnDeploy(value: string);
    /**
     * @stability stable
     */
    resetAutoBundleOnDeploy(): void;
    /**
     * @stability stable
     */
    get autoBundleOnDeployInput(): string | undefined;
    private _awsFlowRubySettings?;
    /**
     * @stability stable
     */
    get awsFlowRubySettings(): string;
    /**
     * @stability stable
     */
    set awsFlowRubySettings(value: string);
    /**
     * @stability stable
     */
    resetAwsFlowRubySettings(): void;
    /**
     * @stability stable
     */
    get awsFlowRubySettingsInput(): string | undefined;
    private _dataSourceArn?;
    /**
     * @stability stable
     */
    get dataSourceArn(): string;
    /**
     * @stability stable
     */
    set dataSourceArn(value: string);
    /**
     * @stability stable
     */
    resetDataSourceArn(): void;
    /**
     * @stability stable
     */
    get dataSourceArnInput(): string | undefined;
    private _dataSourceDatabaseName?;
    /**
     * @stability stable
     */
    get dataSourceDatabaseName(): string;
    /**
     * @stability stable
     */
    set dataSourceDatabaseName(value: string);
    /**
     * @stability stable
     */
    resetDataSourceDatabaseName(): void;
    /**
     * @stability stable
     */
    get dataSourceDatabaseNameInput(): string | undefined;
    private _dataSourceType?;
    /**
     * @stability stable
     */
    get dataSourceType(): string;
    /**
     * @stability stable
     */
    set dataSourceType(value: string);
    /**
     * @stability stable
     */
    resetDataSourceType(): void;
    /**
     * @stability stable
     */
    get dataSourceTypeInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _documentRoot?;
    /**
     * @stability stable
     */
    get documentRoot(): string;
    /**
     * @stability stable
     */
    set documentRoot(value: string);
    /**
     * @stability stable
     */
    resetDocumentRoot(): void;
    /**
     * @stability stable
     */
    get documentRootInput(): string | undefined;
    private _domains?;
    /**
     * @stability stable
     */
    get domains(): string[];
    /**
     * @stability stable
     */
    set domains(value: string[]);
    /**
     * @stability stable
     */
    resetDomains(): void;
    /**
     * @stability stable
     */
    get domainsInput(): string[] | undefined;
    private _enableSsl?;
    /**
     * @stability stable
     */
    get enableSsl(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enableSsl(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnableSsl(): void;
    /**
     * @stability stable
     */
    get enableSslInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _railsEnv?;
    /**
     * @stability stable
     */
    get railsEnv(): string;
    /**
     * @stability stable
     */
    set railsEnv(value: string);
    /**
     * @stability stable
     */
    resetRailsEnv(): void;
    /**
     * @stability stable
     */
    get railsEnvInput(): string | undefined;
    private _shortName?;
    /**
     * @stability stable
     */
    get shortName(): string;
    /**
     * @stability stable
     */
    set shortName(value: string);
    /**
     * @stability stable
     */
    resetShortName(): void;
    /**
     * @stability stable
     */
    get shortNameInput(): string | undefined;
    private _stackId?;
    /**
     * @stability stable
     */
    get stackId(): string;
    /**
     * @stability stable
     */
    set stackId(value: string);
    /**
     * @stability stable
     */
    get stackIdInput(): string | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _appSource?;
    /**
     * @stability stable
     */
    get appSource(): OpsworksApplicationAppSource[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set appSource(value: OpsworksApplicationAppSource[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAppSource(): void;
    /**
     * @stability stable
     */
    get appSourceInput(): cdktf.IResolvable | OpsworksApplicationAppSource[] | undefined;
    private _environment?;
    /**
     * @stability stable
     */
    get environment(): OpsworksApplicationEnvironment[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set environment(value: OpsworksApplicationEnvironment[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnvironment(): void;
    /**
     * @stability stable
     */
    get environmentInput(): cdktf.IResolvable | OpsworksApplicationEnvironment[] | undefined;
    private _sslConfiguration?;
    /**
     * @stability stable
     */
    get sslConfiguration(): OpsworksApplicationSslConfiguration[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set sslConfiguration(value: OpsworksApplicationSslConfiguration[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSslConfiguration(): void;
    /**
     * @stability stable
     */
    get sslConfigurationInput(): cdktf.IResolvable | OpsworksApplicationSslConfiguration[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
