import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS OpsWorks.
 *
 * @stability stable
 */
export interface OpsworksHaproxyLayerConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#auto_assign_elastic_ips OpsworksHaproxyLayer#auto_assign_elastic_ips}.
     *
     * @stability stable
     */
    readonly autoAssignElasticIps?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#auto_assign_public_ips OpsworksHaproxyLayer#auto_assign_public_ips}.
     *
     * @stability stable
     */
    readonly autoAssignPublicIps?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#auto_healing OpsworksHaproxyLayer#auto_healing}.
     *
     * @stability stable
     */
    readonly autoHealing?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#custom_configure_recipes OpsworksHaproxyLayer#custom_configure_recipes}.
     *
     * @stability stable
     */
    readonly customConfigureRecipes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#custom_deploy_recipes OpsworksHaproxyLayer#custom_deploy_recipes}.
     *
     * @stability stable
     */
    readonly customDeployRecipes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#custom_instance_profile_arn OpsworksHaproxyLayer#custom_instance_profile_arn}.
     *
     * @stability stable
     */
    readonly customInstanceProfileArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#custom_json OpsworksHaproxyLayer#custom_json}.
     *
     * @stability stable
     */
    readonly customJson?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#custom_security_group_ids OpsworksHaproxyLayer#custom_security_group_ids}.
     *
     * @stability stable
     */
    readonly customSecurityGroupIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#custom_setup_recipes OpsworksHaproxyLayer#custom_setup_recipes}.
     *
     * @stability stable
     */
    readonly customSetupRecipes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#custom_shutdown_recipes OpsworksHaproxyLayer#custom_shutdown_recipes}.
     *
     * @stability stable
     */
    readonly customShutdownRecipes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#custom_undeploy_recipes OpsworksHaproxyLayer#custom_undeploy_recipes}.
     *
     * @stability stable
     */
    readonly customUndeployRecipes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#drain_elb_on_shutdown OpsworksHaproxyLayer#drain_elb_on_shutdown}.
     *
     * @stability stable
     */
    readonly drainElbOnShutdown?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#elastic_load_balancer OpsworksHaproxyLayer#elastic_load_balancer}.
     *
     * @stability stable
     */
    readonly elasticLoadBalancer?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#healthcheck_method OpsworksHaproxyLayer#healthcheck_method}.
     *
     * @stability stable
     */
    readonly healthcheckMethod?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#healthcheck_url OpsworksHaproxyLayer#healthcheck_url}.
     *
     * @stability stable
     */
    readonly healthcheckUrl?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#install_updates_on_boot OpsworksHaproxyLayer#install_updates_on_boot}.
     *
     * @stability stable
     */
    readonly installUpdatesOnBoot?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#instance_shutdown_timeout OpsworksHaproxyLayer#instance_shutdown_timeout}.
     *
     * @stability stable
     */
    readonly instanceShutdownTimeout?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#name OpsworksHaproxyLayer#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#stack_id OpsworksHaproxyLayer#stack_id}.
     *
     * @stability stable
     */
    readonly stackId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#stats_enabled OpsworksHaproxyLayer#stats_enabled}.
     *
     * @stability stable
     */
    readonly statsEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#stats_password OpsworksHaproxyLayer#stats_password}.
     *
     * @stability stable
     */
    readonly statsPassword: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#stats_url OpsworksHaproxyLayer#stats_url}.
     *
     * @stability stable
     */
    readonly statsUrl?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#stats_user OpsworksHaproxyLayer#stats_user}.
     *
     * @stability stable
     */
    readonly statsUser?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#system_packages OpsworksHaproxyLayer#system_packages}.
     *
     * @stability stable
     */
    readonly systemPackages?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#tags OpsworksHaproxyLayer#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#tags_all OpsworksHaproxyLayer#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#use_ebs_optimized_instances OpsworksHaproxyLayer#use_ebs_optimized_instances}.
     *
     * @stability stable
     */
    readonly useEbsOptimizedInstances?: boolean | cdktf.IResolvable;
    /**
     * cloudwatch_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#cloudwatch_configuration OpsworksHaproxyLayer#cloudwatch_configuration}
     *
     * @stability stable
     */
    readonly cloudwatchConfiguration?: OpsworksHaproxyLayerCloudwatchConfiguration;
    /**
     * ebs_volume block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#ebs_volume OpsworksHaproxyLayer#ebs_volume}
     *
     * @stability stable
     */
    readonly ebsVolume?: OpsworksHaproxyLayerEbsVolume[] | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface OpsworksHaproxyLayerCloudwatchConfigurationLogStreams {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#batch_count OpsworksHaproxyLayer#batch_count}.
     *
     * @stability stable
     */
    readonly batchCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#batch_size OpsworksHaproxyLayer#batch_size}.
     *
     * @stability stable
     */
    readonly batchSize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#buffer_duration OpsworksHaproxyLayer#buffer_duration}.
     *
     * @stability stable
     */
    readonly bufferDuration?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#datetime_format OpsworksHaproxyLayer#datetime_format}.
     *
     * @stability stable
     */
    readonly datetimeFormat?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#encoding OpsworksHaproxyLayer#encoding}.
     *
     * @stability stable
     */
    readonly encoding?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#file OpsworksHaproxyLayer#file}.
     *
     * @stability stable
     */
    readonly file: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#file_fingerprint_lines OpsworksHaproxyLayer#file_fingerprint_lines}.
     *
     * @stability stable
     */
    readonly fileFingerprintLines?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#initial_position OpsworksHaproxyLayer#initial_position}.
     *
     * @stability stable
     */
    readonly initialPosition?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#log_group_name OpsworksHaproxyLayer#log_group_name}.
     *
     * @stability stable
     */
    readonly logGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#multiline_start_pattern OpsworksHaproxyLayer#multiline_start_pattern}.
     *
     * @stability stable
     */
    readonly multilineStartPattern?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#time_zone OpsworksHaproxyLayer#time_zone}.
     *
     * @stability stable
     */
    readonly timeZone?: string;
}
export declare function opsworksHaproxyLayerCloudwatchConfigurationLogStreamsToTerraform(struct?: OpsworksHaproxyLayerCloudwatchConfigurationLogStreams | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface OpsworksHaproxyLayerCloudwatchConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#enabled OpsworksHaproxyLayer#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
     * log_streams block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#log_streams OpsworksHaproxyLayer#log_streams}
     *
     * @stability stable
     */
    readonly logStreams?: OpsworksHaproxyLayerCloudwatchConfigurationLogStreams[] | cdktf.IResolvable;
}
export declare function opsworksHaproxyLayerCloudwatchConfigurationToTerraform(struct?: OpsworksHaproxyLayerCloudwatchConfigurationOutputReference | OpsworksHaproxyLayerCloudwatchConfiguration): any;
/**
 * @stability stable
 */
export declare class OpsworksHaproxyLayerCloudwatchConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): OpsworksHaproxyLayerCloudwatchConfiguration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: OpsworksHaproxyLayerCloudwatchConfiguration | undefined);
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _logStreams?;
    /**
     * @stability stable
     */
    get logStreams(): OpsworksHaproxyLayerCloudwatchConfigurationLogStreams[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set logStreams(value: OpsworksHaproxyLayerCloudwatchConfigurationLogStreams[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetLogStreams(): void;
    /**
     * @stability stable
     */
    get logStreamsInput(): cdktf.IResolvable | OpsworksHaproxyLayerCloudwatchConfigurationLogStreams[] | undefined;
}
/**
 * @stability stable
 */
export interface OpsworksHaproxyLayerEbsVolume {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#encrypted OpsworksHaproxyLayer#encrypted}.
     *
     * @stability stable
     */
    readonly encrypted?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#iops OpsworksHaproxyLayer#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#mount_point OpsworksHaproxyLayer#mount_point}.
     *
     * @stability stable
     */
    readonly mountPoint: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#number_of_disks OpsworksHaproxyLayer#number_of_disks}.
     *
     * @stability stable
     */
    readonly numberOfDisks: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#raid_level OpsworksHaproxyLayer#raid_level}.
     *
     * @stability stable
     */
    readonly raidLevel?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#size OpsworksHaproxyLayer#size}.
     *
     * @stability stable
     */
    readonly size: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer#type OpsworksHaproxyLayer#type}.
     *
     * @stability stable
     */
    readonly type?: string;
}
export declare function opsworksHaproxyLayerEbsVolumeToTerraform(struct?: OpsworksHaproxyLayerEbsVolume | cdktf.IResolvable): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer aws_opsworks_haproxy_layer}.
 *
 * @stability stable
 */
export declare class OpsworksHaproxyLayer extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/opsworks_haproxy_layer aws_opsworks_haproxy_layer} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: OpsworksHaproxyLayerConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoAssignElasticIps?;
    /**
     * @stability stable
     */
    get autoAssignElasticIps(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set autoAssignElasticIps(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAutoAssignElasticIps(): void;
    /**
     * @stability stable
     */
    get autoAssignElasticIpsInput(): boolean | cdktf.IResolvable | undefined;
    private _autoAssignPublicIps?;
    /**
     * @stability stable
     */
    get autoAssignPublicIps(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set autoAssignPublicIps(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAutoAssignPublicIps(): void;
    /**
     * @stability stable
     */
    get autoAssignPublicIpsInput(): boolean | cdktf.IResolvable | undefined;
    private _autoHealing?;
    /**
     * @stability stable
     */
    get autoHealing(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set autoHealing(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAutoHealing(): void;
    /**
     * @stability stable
     */
    get autoHealingInput(): boolean | cdktf.IResolvable | undefined;
    private _customConfigureRecipes?;
    /**
     * @stability stable
     */
    get customConfigureRecipes(): string[];
    /**
     * @stability stable
     */
    set customConfigureRecipes(value: string[]);
    /**
     * @stability stable
     */
    resetCustomConfigureRecipes(): void;
    /**
     * @stability stable
     */
    get customConfigureRecipesInput(): string[] | undefined;
    private _customDeployRecipes?;
    /**
     * @stability stable
     */
    get customDeployRecipes(): string[];
    /**
     * @stability stable
     */
    set customDeployRecipes(value: string[]);
    /**
     * @stability stable
     */
    resetCustomDeployRecipes(): void;
    /**
     * @stability stable
     */
    get customDeployRecipesInput(): string[] | undefined;
    private _customInstanceProfileArn?;
    /**
     * @stability stable
     */
    get customInstanceProfileArn(): string;
    /**
     * @stability stable
     */
    set customInstanceProfileArn(value: string);
    /**
     * @stability stable
     */
    resetCustomInstanceProfileArn(): void;
    /**
     * @stability stable
     */
    get customInstanceProfileArnInput(): string | undefined;
    private _customJson?;
    /**
     * @stability stable
     */
    get customJson(): string;
    /**
     * @stability stable
     */
    set customJson(value: string);
    /**
     * @stability stable
     */
    resetCustomJson(): void;
    /**
     * @stability stable
     */
    get customJsonInput(): string | undefined;
    private _customSecurityGroupIds?;
    /**
     * @stability stable
     */
    get customSecurityGroupIds(): string[];
    /**
     * @stability stable
     */
    set customSecurityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetCustomSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get customSecurityGroupIdsInput(): string[] | undefined;
    private _customSetupRecipes?;
    /**
     * @stability stable
     */
    get customSetupRecipes(): string[];
    /**
     * @stability stable
     */
    set customSetupRecipes(value: string[]);
    /**
     * @stability stable
     */
    resetCustomSetupRecipes(): void;
    /**
     * @stability stable
     */
    get customSetupRecipesInput(): string[] | undefined;
    private _customShutdownRecipes?;
    /**
     * @stability stable
     */
    get customShutdownRecipes(): string[];
    /**
     * @stability stable
     */
    set customShutdownRecipes(value: string[]);
    /**
     * @stability stable
     */
    resetCustomShutdownRecipes(): void;
    /**
     * @stability stable
     */
    get customShutdownRecipesInput(): string[] | undefined;
    private _customUndeployRecipes?;
    /**
     * @stability stable
     */
    get customUndeployRecipes(): string[];
    /**
     * @stability stable
     */
    set customUndeployRecipes(value: string[]);
    /**
     * @stability stable
     */
    resetCustomUndeployRecipes(): void;
    /**
     * @stability stable
     */
    get customUndeployRecipesInput(): string[] | undefined;
    private _drainElbOnShutdown?;
    /**
     * @stability stable
     */
    get drainElbOnShutdown(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set drainElbOnShutdown(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDrainElbOnShutdown(): void;
    /**
     * @stability stable
     */
    get drainElbOnShutdownInput(): boolean | cdktf.IResolvable | undefined;
    private _elasticLoadBalancer?;
    /**
     * @stability stable
     */
    get elasticLoadBalancer(): string;
    /**
     * @stability stable
     */
    set elasticLoadBalancer(value: string);
    /**
     * @stability stable
     */
    resetElasticLoadBalancer(): void;
    /**
     * @stability stable
     */
    get elasticLoadBalancerInput(): string | undefined;
    private _healthcheckMethod?;
    /**
     * @stability stable
     */
    get healthcheckMethod(): string;
    /**
     * @stability stable
     */
    set healthcheckMethod(value: string);
    /**
     * @stability stable
     */
    resetHealthcheckMethod(): void;
    /**
     * @stability stable
     */
    get healthcheckMethodInput(): string | undefined;
    private _healthcheckUrl?;
    /**
     * @stability stable
     */
    get healthcheckUrl(): string;
    /**
     * @stability stable
     */
    set healthcheckUrl(value: string);
    /**
     * @stability stable
     */
    resetHealthcheckUrl(): void;
    /**
     * @stability stable
     */
    get healthcheckUrlInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _installUpdatesOnBoot?;
    /**
     * @stability stable
     */
    get installUpdatesOnBoot(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set installUpdatesOnBoot(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetInstallUpdatesOnBoot(): void;
    /**
     * @stability stable
     */
    get installUpdatesOnBootInput(): boolean | cdktf.IResolvable | undefined;
    private _instanceShutdownTimeout?;
    /**
     * @stability stable
     */
    get instanceShutdownTimeout(): number;
    /**
     * @stability stable
     */
    set instanceShutdownTimeout(value: number);
    /**
     * @stability stable
     */
    resetInstanceShutdownTimeout(): void;
    /**
     * @stability stable
     */
    get instanceShutdownTimeoutInput(): number | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _stackId?;
    /**
     * @stability stable
     */
    get stackId(): string;
    /**
     * @stability stable
     */
    set stackId(value: string);
    /**
     * @stability stable
     */
    get stackIdInput(): string | undefined;
    private _statsEnabled?;
    /**
     * @stability stable
     */
    get statsEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set statsEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetStatsEnabled(): void;
    /**
     * @stability stable
     */
    get statsEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _statsPassword?;
    /**
     * @stability stable
     */
    get statsPassword(): string;
    /**
     * @stability stable
     */
    set statsPassword(value: string);
    /**
     * @stability stable
     */
    get statsPasswordInput(): string | undefined;
    private _statsUrl?;
    /**
     * @stability stable
     */
    get statsUrl(): string;
    /**
     * @stability stable
     */
    set statsUrl(value: string);
    /**
     * @stability stable
     */
    resetStatsUrl(): void;
    /**
     * @stability stable
     */
    get statsUrlInput(): string | undefined;
    private _statsUser?;
    /**
     * @stability stable
     */
    get statsUser(): string;
    /**
     * @stability stable
     */
    set statsUser(value: string);
    /**
     * @stability stable
     */
    resetStatsUser(): void;
    /**
     * @stability stable
     */
    get statsUserInput(): string | undefined;
    private _systemPackages?;
    /**
     * @stability stable
     */
    get systemPackages(): string[];
    /**
     * @stability stable
     */
    set systemPackages(value: string[]);
    /**
     * @stability stable
     */
    resetSystemPackages(): void;
    /**
     * @stability stable
     */
    get systemPackagesInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _useEbsOptimizedInstances?;
    /**
     * @stability stable
     */
    get useEbsOptimizedInstances(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set useEbsOptimizedInstances(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetUseEbsOptimizedInstances(): void;
    /**
     * @stability stable
     */
    get useEbsOptimizedInstancesInput(): boolean | cdktf.IResolvable | undefined;
    private _cloudwatchConfiguration;
    /**
     * @stability stable
     */
    get cloudwatchConfiguration(): OpsworksHaproxyLayerCloudwatchConfigurationOutputReference;
    /**
     * @stability stable
     */
    putCloudwatchConfiguration(value: OpsworksHaproxyLayerCloudwatchConfiguration): void;
    /**
     * @stability stable
     */
    resetCloudwatchConfiguration(): void;
    /**
     * @stability stable
     */
    get cloudwatchConfigurationInput(): OpsworksHaproxyLayerCloudwatchConfiguration | undefined;
    private _ebsVolume?;
    /**
     * @stability stable
     */
    get ebsVolume(): OpsworksHaproxyLayerEbsVolume[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set ebsVolume(value: OpsworksHaproxyLayerEbsVolume[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEbsVolume(): void;
    /**
     * @stability stable
     */
    get ebsVolumeInput(): cdktf.IResolvable | OpsworksHaproxyLayerEbsVolume[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
