import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS OpsWorks.
 *
 * @stability stable
 */
export interface OpsworksMysqlLayerConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#auto_assign_elastic_ips OpsworksMysqlLayer#auto_assign_elastic_ips}.
     *
     * @stability stable
     */
    readonly autoAssignElasticIps?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#auto_assign_public_ips OpsworksMysqlLayer#auto_assign_public_ips}.
     *
     * @stability stable
     */
    readonly autoAssignPublicIps?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#auto_healing OpsworksMysqlLayer#auto_healing}.
     *
     * @stability stable
     */
    readonly autoHealing?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#custom_configure_recipes OpsworksMysqlLayer#custom_configure_recipes}.
     *
     * @stability stable
     */
    readonly customConfigureRecipes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#custom_deploy_recipes OpsworksMysqlLayer#custom_deploy_recipes}.
     *
     * @stability stable
     */
    readonly customDeployRecipes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#custom_instance_profile_arn OpsworksMysqlLayer#custom_instance_profile_arn}.
     *
     * @stability stable
     */
    readonly customInstanceProfileArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#custom_json OpsworksMysqlLayer#custom_json}.
     *
     * @stability stable
     */
    readonly customJson?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#custom_security_group_ids OpsworksMysqlLayer#custom_security_group_ids}.
     *
     * @stability stable
     */
    readonly customSecurityGroupIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#custom_setup_recipes OpsworksMysqlLayer#custom_setup_recipes}.
     *
     * @stability stable
     */
    readonly customSetupRecipes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#custom_shutdown_recipes OpsworksMysqlLayer#custom_shutdown_recipes}.
     *
     * @stability stable
     */
    readonly customShutdownRecipes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#custom_undeploy_recipes OpsworksMysqlLayer#custom_undeploy_recipes}.
     *
     * @stability stable
     */
    readonly customUndeployRecipes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#drain_elb_on_shutdown OpsworksMysqlLayer#drain_elb_on_shutdown}.
     *
     * @stability stable
     */
    readonly drainElbOnShutdown?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#elastic_load_balancer OpsworksMysqlLayer#elastic_load_balancer}.
     *
     * @stability stable
     */
    readonly elasticLoadBalancer?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#install_updates_on_boot OpsworksMysqlLayer#install_updates_on_boot}.
     *
     * @stability stable
     */
    readonly installUpdatesOnBoot?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#instance_shutdown_timeout OpsworksMysqlLayer#instance_shutdown_timeout}.
     *
     * @stability stable
     */
    readonly instanceShutdownTimeout?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#name OpsworksMysqlLayer#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#root_password OpsworksMysqlLayer#root_password}.
     *
     * @stability stable
     */
    readonly rootPassword?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#root_password_on_all_instances OpsworksMysqlLayer#root_password_on_all_instances}.
     *
     * @stability stable
     */
    readonly rootPasswordOnAllInstances?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#stack_id OpsworksMysqlLayer#stack_id}.
     *
     * @stability stable
     */
    readonly stackId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#system_packages OpsworksMysqlLayer#system_packages}.
     *
     * @stability stable
     */
    readonly systemPackages?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#tags OpsworksMysqlLayer#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#tags_all OpsworksMysqlLayer#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#use_ebs_optimized_instances OpsworksMysqlLayer#use_ebs_optimized_instances}.
     *
     * @stability stable
     */
    readonly useEbsOptimizedInstances?: boolean | cdktf.IResolvable;
    /**
     * cloudwatch_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#cloudwatch_configuration OpsworksMysqlLayer#cloudwatch_configuration}
     *
     * @stability stable
     */
    readonly cloudwatchConfiguration?: OpsworksMysqlLayerCloudwatchConfiguration;
    /**
     * ebs_volume block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#ebs_volume OpsworksMysqlLayer#ebs_volume}
     *
     * @stability stable
     */
    readonly ebsVolume?: OpsworksMysqlLayerEbsVolume[] | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface OpsworksMysqlLayerCloudwatchConfigurationLogStreams {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#batch_count OpsworksMysqlLayer#batch_count}.
     *
     * @stability stable
     */
    readonly batchCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#batch_size OpsworksMysqlLayer#batch_size}.
     *
     * @stability stable
     */
    readonly batchSize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#buffer_duration OpsworksMysqlLayer#buffer_duration}.
     *
     * @stability stable
     */
    readonly bufferDuration?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#datetime_format OpsworksMysqlLayer#datetime_format}.
     *
     * @stability stable
     */
    readonly datetimeFormat?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#encoding OpsworksMysqlLayer#encoding}.
     *
     * @stability stable
     */
    readonly encoding?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#file OpsworksMysqlLayer#file}.
     *
     * @stability stable
     */
    readonly file: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#file_fingerprint_lines OpsworksMysqlLayer#file_fingerprint_lines}.
     *
     * @stability stable
     */
    readonly fileFingerprintLines?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#initial_position OpsworksMysqlLayer#initial_position}.
     *
     * @stability stable
     */
    readonly initialPosition?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#log_group_name OpsworksMysqlLayer#log_group_name}.
     *
     * @stability stable
     */
    readonly logGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#multiline_start_pattern OpsworksMysqlLayer#multiline_start_pattern}.
     *
     * @stability stable
     */
    readonly multilineStartPattern?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#time_zone OpsworksMysqlLayer#time_zone}.
     *
     * @stability stable
     */
    readonly timeZone?: string;
}
export declare function opsworksMysqlLayerCloudwatchConfigurationLogStreamsToTerraform(struct?: OpsworksMysqlLayerCloudwatchConfigurationLogStreams | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface OpsworksMysqlLayerCloudwatchConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#enabled OpsworksMysqlLayer#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
     * log_streams block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#log_streams OpsworksMysqlLayer#log_streams}
     *
     * @stability stable
     */
    readonly logStreams?: OpsworksMysqlLayerCloudwatchConfigurationLogStreams[] | cdktf.IResolvable;
}
export declare function opsworksMysqlLayerCloudwatchConfigurationToTerraform(struct?: OpsworksMysqlLayerCloudwatchConfigurationOutputReference | OpsworksMysqlLayerCloudwatchConfiguration): any;
/**
 * @stability stable
 */
export declare class OpsworksMysqlLayerCloudwatchConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): OpsworksMysqlLayerCloudwatchConfiguration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: OpsworksMysqlLayerCloudwatchConfiguration | undefined);
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _logStreams?;
    /**
     * @stability stable
     */
    get logStreams(): OpsworksMysqlLayerCloudwatchConfigurationLogStreams[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set logStreams(value: OpsworksMysqlLayerCloudwatchConfigurationLogStreams[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetLogStreams(): void;
    /**
     * @stability stable
     */
    get logStreamsInput(): cdktf.IResolvable | OpsworksMysqlLayerCloudwatchConfigurationLogStreams[] | undefined;
}
/**
 * @stability stable
 */
export interface OpsworksMysqlLayerEbsVolume {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#encrypted OpsworksMysqlLayer#encrypted}.
     *
     * @stability stable
     */
    readonly encrypted?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#iops OpsworksMysqlLayer#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#mount_point OpsworksMysqlLayer#mount_point}.
     *
     * @stability stable
     */
    readonly mountPoint: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#number_of_disks OpsworksMysqlLayer#number_of_disks}.
     *
     * @stability stable
     */
    readonly numberOfDisks: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#raid_level OpsworksMysqlLayer#raid_level}.
     *
     * @stability stable
     */
    readonly raidLevel?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#size OpsworksMysqlLayer#size}.
     *
     * @stability stable
     */
    readonly size: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer#type OpsworksMysqlLayer#type}.
     *
     * @stability stable
     */
    readonly type?: string;
}
export declare function opsworksMysqlLayerEbsVolumeToTerraform(struct?: OpsworksMysqlLayerEbsVolume | cdktf.IResolvable): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer aws_opsworks_mysql_layer}.
 *
 * @stability stable
 */
export declare class OpsworksMysqlLayer extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/opsworks_mysql_layer aws_opsworks_mysql_layer} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: OpsworksMysqlLayerConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoAssignElasticIps?;
    /**
     * @stability stable
     */
    get autoAssignElasticIps(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set autoAssignElasticIps(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAutoAssignElasticIps(): void;
    /**
     * @stability stable
     */
    get autoAssignElasticIpsInput(): boolean | cdktf.IResolvable | undefined;
    private _autoAssignPublicIps?;
    /**
     * @stability stable
     */
    get autoAssignPublicIps(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set autoAssignPublicIps(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAutoAssignPublicIps(): void;
    /**
     * @stability stable
     */
    get autoAssignPublicIpsInput(): boolean | cdktf.IResolvable | undefined;
    private _autoHealing?;
    /**
     * @stability stable
     */
    get autoHealing(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set autoHealing(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAutoHealing(): void;
    /**
     * @stability stable
     */
    get autoHealingInput(): boolean | cdktf.IResolvable | undefined;
    private _customConfigureRecipes?;
    /**
     * @stability stable
     */
    get customConfigureRecipes(): string[];
    /**
     * @stability stable
     */
    set customConfigureRecipes(value: string[]);
    /**
     * @stability stable
     */
    resetCustomConfigureRecipes(): void;
    /**
     * @stability stable
     */
    get customConfigureRecipesInput(): string[] | undefined;
    private _customDeployRecipes?;
    /**
     * @stability stable
     */
    get customDeployRecipes(): string[];
    /**
     * @stability stable
     */
    set customDeployRecipes(value: string[]);
    /**
     * @stability stable
     */
    resetCustomDeployRecipes(): void;
    /**
     * @stability stable
     */
    get customDeployRecipesInput(): string[] | undefined;
    private _customInstanceProfileArn?;
    /**
     * @stability stable
     */
    get customInstanceProfileArn(): string;
    /**
     * @stability stable
     */
    set customInstanceProfileArn(value: string);
    /**
     * @stability stable
     */
    resetCustomInstanceProfileArn(): void;
    /**
     * @stability stable
     */
    get customInstanceProfileArnInput(): string | undefined;
    private _customJson?;
    /**
     * @stability stable
     */
    get customJson(): string;
    /**
     * @stability stable
     */
    set customJson(value: string);
    /**
     * @stability stable
     */
    resetCustomJson(): void;
    /**
     * @stability stable
     */
    get customJsonInput(): string | undefined;
    private _customSecurityGroupIds?;
    /**
     * @stability stable
     */
    get customSecurityGroupIds(): string[];
    /**
     * @stability stable
     */
    set customSecurityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetCustomSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get customSecurityGroupIdsInput(): string[] | undefined;
    private _customSetupRecipes?;
    /**
     * @stability stable
     */
    get customSetupRecipes(): string[];
    /**
     * @stability stable
     */
    set customSetupRecipes(value: string[]);
    /**
     * @stability stable
     */
    resetCustomSetupRecipes(): void;
    /**
     * @stability stable
     */
    get customSetupRecipesInput(): string[] | undefined;
    private _customShutdownRecipes?;
    /**
     * @stability stable
     */
    get customShutdownRecipes(): string[];
    /**
     * @stability stable
     */
    set customShutdownRecipes(value: string[]);
    /**
     * @stability stable
     */
    resetCustomShutdownRecipes(): void;
    /**
     * @stability stable
     */
    get customShutdownRecipesInput(): string[] | undefined;
    private _customUndeployRecipes?;
    /**
     * @stability stable
     */
    get customUndeployRecipes(): string[];
    /**
     * @stability stable
     */
    set customUndeployRecipes(value: string[]);
    /**
     * @stability stable
     */
    resetCustomUndeployRecipes(): void;
    /**
     * @stability stable
     */
    get customUndeployRecipesInput(): string[] | undefined;
    private _drainElbOnShutdown?;
    /**
     * @stability stable
     */
    get drainElbOnShutdown(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set drainElbOnShutdown(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDrainElbOnShutdown(): void;
    /**
     * @stability stable
     */
    get drainElbOnShutdownInput(): boolean | cdktf.IResolvable | undefined;
    private _elasticLoadBalancer?;
    /**
     * @stability stable
     */
    get elasticLoadBalancer(): string;
    /**
     * @stability stable
     */
    set elasticLoadBalancer(value: string);
    /**
     * @stability stable
     */
    resetElasticLoadBalancer(): void;
    /**
     * @stability stable
     */
    get elasticLoadBalancerInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _installUpdatesOnBoot?;
    /**
     * @stability stable
     */
    get installUpdatesOnBoot(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set installUpdatesOnBoot(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetInstallUpdatesOnBoot(): void;
    /**
     * @stability stable
     */
    get installUpdatesOnBootInput(): boolean | cdktf.IResolvable | undefined;
    private _instanceShutdownTimeout?;
    /**
     * @stability stable
     */
    get instanceShutdownTimeout(): number;
    /**
     * @stability stable
     */
    set instanceShutdownTimeout(value: number);
    /**
     * @stability stable
     */
    resetInstanceShutdownTimeout(): void;
    /**
     * @stability stable
     */
    get instanceShutdownTimeoutInput(): number | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _rootPassword?;
    /**
     * @stability stable
     */
    get rootPassword(): string;
    /**
     * @stability stable
     */
    set rootPassword(value: string);
    /**
     * @stability stable
     */
    resetRootPassword(): void;
    /**
     * @stability stable
     */
    get rootPasswordInput(): string | undefined;
    private _rootPasswordOnAllInstances?;
    /**
     * @stability stable
     */
    get rootPasswordOnAllInstances(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set rootPasswordOnAllInstances(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetRootPasswordOnAllInstances(): void;
    /**
     * @stability stable
     */
    get rootPasswordOnAllInstancesInput(): boolean | cdktf.IResolvable | undefined;
    private _stackId?;
    /**
     * @stability stable
     */
    get stackId(): string;
    /**
     * @stability stable
     */
    set stackId(value: string);
    /**
     * @stability stable
     */
    get stackIdInput(): string | undefined;
    private _systemPackages?;
    /**
     * @stability stable
     */
    get systemPackages(): string[];
    /**
     * @stability stable
     */
    set systemPackages(value: string[]);
    /**
     * @stability stable
     */
    resetSystemPackages(): void;
    /**
     * @stability stable
     */
    get systemPackagesInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _useEbsOptimizedInstances?;
    /**
     * @stability stable
     */
    get useEbsOptimizedInstances(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set useEbsOptimizedInstances(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetUseEbsOptimizedInstances(): void;
    /**
     * @stability stable
     */
    get useEbsOptimizedInstancesInput(): boolean | cdktf.IResolvable | undefined;
    private _cloudwatchConfiguration;
    /**
     * @stability stable
     */
    get cloudwatchConfiguration(): OpsworksMysqlLayerCloudwatchConfigurationOutputReference;
    /**
     * @stability stable
     */
    putCloudwatchConfiguration(value: OpsworksMysqlLayerCloudwatchConfiguration): void;
    /**
     * @stability stable
     */
    resetCloudwatchConfiguration(): void;
    /**
     * @stability stable
     */
    get cloudwatchConfigurationInput(): OpsworksMysqlLayerCloudwatchConfiguration | undefined;
    private _ebsVolume?;
    /**
     * @stability stable
     */
    get ebsVolume(): OpsworksMysqlLayerEbsVolume[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set ebsVolume(value: OpsworksMysqlLayerEbsVolume[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEbsVolume(): void;
    /**
     * @stability stable
     */
    get ebsVolumeInput(): cdktf.IResolvable | OpsworksMysqlLayerEbsVolume[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
