import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS OpsWorks.
 *
 * @stability stable
 */
export interface OpsworksPhpAppLayerConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#auto_assign_elastic_ips OpsworksPhpAppLayer#auto_assign_elastic_ips}.
     *
     * @stability stable
     */
    readonly autoAssignElasticIps?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#auto_assign_public_ips OpsworksPhpAppLayer#auto_assign_public_ips}.
     *
     * @stability stable
     */
    readonly autoAssignPublicIps?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#auto_healing OpsworksPhpAppLayer#auto_healing}.
     *
     * @stability stable
     */
    readonly autoHealing?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#custom_configure_recipes OpsworksPhpAppLayer#custom_configure_recipes}.
     *
     * @stability stable
     */
    readonly customConfigureRecipes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#custom_deploy_recipes OpsworksPhpAppLayer#custom_deploy_recipes}.
     *
     * @stability stable
     */
    readonly customDeployRecipes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#custom_instance_profile_arn OpsworksPhpAppLayer#custom_instance_profile_arn}.
     *
     * @stability stable
     */
    readonly customInstanceProfileArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#custom_json OpsworksPhpAppLayer#custom_json}.
     *
     * @stability stable
     */
    readonly customJson?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#custom_security_group_ids OpsworksPhpAppLayer#custom_security_group_ids}.
     *
     * @stability stable
     */
    readonly customSecurityGroupIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#custom_setup_recipes OpsworksPhpAppLayer#custom_setup_recipes}.
     *
     * @stability stable
     */
    readonly customSetupRecipes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#custom_shutdown_recipes OpsworksPhpAppLayer#custom_shutdown_recipes}.
     *
     * @stability stable
     */
    readonly customShutdownRecipes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#custom_undeploy_recipes OpsworksPhpAppLayer#custom_undeploy_recipes}.
     *
     * @stability stable
     */
    readonly customUndeployRecipes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#drain_elb_on_shutdown OpsworksPhpAppLayer#drain_elb_on_shutdown}.
     *
     * @stability stable
     */
    readonly drainElbOnShutdown?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#elastic_load_balancer OpsworksPhpAppLayer#elastic_load_balancer}.
     *
     * @stability stable
     */
    readonly elasticLoadBalancer?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#install_updates_on_boot OpsworksPhpAppLayer#install_updates_on_boot}.
     *
     * @stability stable
     */
    readonly installUpdatesOnBoot?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#instance_shutdown_timeout OpsworksPhpAppLayer#instance_shutdown_timeout}.
     *
     * @stability stable
     */
    readonly instanceShutdownTimeout?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#name OpsworksPhpAppLayer#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#stack_id OpsworksPhpAppLayer#stack_id}.
     *
     * @stability stable
     */
    readonly stackId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#system_packages OpsworksPhpAppLayer#system_packages}.
     *
     * @stability stable
     */
    readonly systemPackages?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#tags OpsworksPhpAppLayer#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#tags_all OpsworksPhpAppLayer#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#use_ebs_optimized_instances OpsworksPhpAppLayer#use_ebs_optimized_instances}.
     *
     * @stability stable
     */
    readonly useEbsOptimizedInstances?: boolean | cdktf.IResolvable;
    /**
     * cloudwatch_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#cloudwatch_configuration OpsworksPhpAppLayer#cloudwatch_configuration}
     *
     * @stability stable
     */
    readonly cloudwatchConfiguration?: OpsworksPhpAppLayerCloudwatchConfiguration;
    /**
     * ebs_volume block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#ebs_volume OpsworksPhpAppLayer#ebs_volume}
     *
     * @stability stable
     */
    readonly ebsVolume?: OpsworksPhpAppLayerEbsVolume[] | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface OpsworksPhpAppLayerCloudwatchConfigurationLogStreams {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#batch_count OpsworksPhpAppLayer#batch_count}.
     *
     * @stability stable
     */
    readonly batchCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#batch_size OpsworksPhpAppLayer#batch_size}.
     *
     * @stability stable
     */
    readonly batchSize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#buffer_duration OpsworksPhpAppLayer#buffer_duration}.
     *
     * @stability stable
     */
    readonly bufferDuration?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#datetime_format OpsworksPhpAppLayer#datetime_format}.
     *
     * @stability stable
     */
    readonly datetimeFormat?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#encoding OpsworksPhpAppLayer#encoding}.
     *
     * @stability stable
     */
    readonly encoding?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#file OpsworksPhpAppLayer#file}.
     *
     * @stability stable
     */
    readonly file: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#file_fingerprint_lines OpsworksPhpAppLayer#file_fingerprint_lines}.
     *
     * @stability stable
     */
    readonly fileFingerprintLines?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#initial_position OpsworksPhpAppLayer#initial_position}.
     *
     * @stability stable
     */
    readonly initialPosition?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#log_group_name OpsworksPhpAppLayer#log_group_name}.
     *
     * @stability stable
     */
    readonly logGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#multiline_start_pattern OpsworksPhpAppLayer#multiline_start_pattern}.
     *
     * @stability stable
     */
    readonly multilineStartPattern?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#time_zone OpsworksPhpAppLayer#time_zone}.
     *
     * @stability stable
     */
    readonly timeZone?: string;
}
export declare function opsworksPhpAppLayerCloudwatchConfigurationLogStreamsToTerraform(struct?: OpsworksPhpAppLayerCloudwatchConfigurationLogStreams | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface OpsworksPhpAppLayerCloudwatchConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#enabled OpsworksPhpAppLayer#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
     * log_streams block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#log_streams OpsworksPhpAppLayer#log_streams}
     *
     * @stability stable
     */
    readonly logStreams?: OpsworksPhpAppLayerCloudwatchConfigurationLogStreams[] | cdktf.IResolvable;
}
export declare function opsworksPhpAppLayerCloudwatchConfigurationToTerraform(struct?: OpsworksPhpAppLayerCloudwatchConfigurationOutputReference | OpsworksPhpAppLayerCloudwatchConfiguration): any;
/**
 * @stability stable
 */
export declare class OpsworksPhpAppLayerCloudwatchConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): OpsworksPhpAppLayerCloudwatchConfiguration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: OpsworksPhpAppLayerCloudwatchConfiguration | undefined);
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _logStreams?;
    /**
     * @stability stable
     */
    get logStreams(): OpsworksPhpAppLayerCloudwatchConfigurationLogStreams[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set logStreams(value: OpsworksPhpAppLayerCloudwatchConfigurationLogStreams[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetLogStreams(): void;
    /**
     * @stability stable
     */
    get logStreamsInput(): cdktf.IResolvable | OpsworksPhpAppLayerCloudwatchConfigurationLogStreams[] | undefined;
}
/**
 * @stability stable
 */
export interface OpsworksPhpAppLayerEbsVolume {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#encrypted OpsworksPhpAppLayer#encrypted}.
     *
     * @stability stable
     */
    readonly encrypted?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#iops OpsworksPhpAppLayer#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#mount_point OpsworksPhpAppLayer#mount_point}.
     *
     * @stability stable
     */
    readonly mountPoint: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#number_of_disks OpsworksPhpAppLayer#number_of_disks}.
     *
     * @stability stable
     */
    readonly numberOfDisks: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#raid_level OpsworksPhpAppLayer#raid_level}.
     *
     * @stability stable
     */
    readonly raidLevel?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#size OpsworksPhpAppLayer#size}.
     *
     * @stability stable
     */
    readonly size: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer#type OpsworksPhpAppLayer#type}.
     *
     * @stability stable
     */
    readonly type?: string;
}
export declare function opsworksPhpAppLayerEbsVolumeToTerraform(struct?: OpsworksPhpAppLayerEbsVolume | cdktf.IResolvable): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer aws_opsworks_php_app_layer}.
 *
 * @stability stable
 */
export declare class OpsworksPhpAppLayer extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/opsworks_php_app_layer aws_opsworks_php_app_layer} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: OpsworksPhpAppLayerConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoAssignElasticIps?;
    /**
     * @stability stable
     */
    get autoAssignElasticIps(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set autoAssignElasticIps(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAutoAssignElasticIps(): void;
    /**
     * @stability stable
     */
    get autoAssignElasticIpsInput(): boolean | cdktf.IResolvable | undefined;
    private _autoAssignPublicIps?;
    /**
     * @stability stable
     */
    get autoAssignPublicIps(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set autoAssignPublicIps(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAutoAssignPublicIps(): void;
    /**
     * @stability stable
     */
    get autoAssignPublicIpsInput(): boolean | cdktf.IResolvable | undefined;
    private _autoHealing?;
    /**
     * @stability stable
     */
    get autoHealing(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set autoHealing(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAutoHealing(): void;
    /**
     * @stability stable
     */
    get autoHealingInput(): boolean | cdktf.IResolvable | undefined;
    private _customConfigureRecipes?;
    /**
     * @stability stable
     */
    get customConfigureRecipes(): string[];
    /**
     * @stability stable
     */
    set customConfigureRecipes(value: string[]);
    /**
     * @stability stable
     */
    resetCustomConfigureRecipes(): void;
    /**
     * @stability stable
     */
    get customConfigureRecipesInput(): string[] | undefined;
    private _customDeployRecipes?;
    /**
     * @stability stable
     */
    get customDeployRecipes(): string[];
    /**
     * @stability stable
     */
    set customDeployRecipes(value: string[]);
    /**
     * @stability stable
     */
    resetCustomDeployRecipes(): void;
    /**
     * @stability stable
     */
    get customDeployRecipesInput(): string[] | undefined;
    private _customInstanceProfileArn?;
    /**
     * @stability stable
     */
    get customInstanceProfileArn(): string;
    /**
     * @stability stable
     */
    set customInstanceProfileArn(value: string);
    /**
     * @stability stable
     */
    resetCustomInstanceProfileArn(): void;
    /**
     * @stability stable
     */
    get customInstanceProfileArnInput(): string | undefined;
    private _customJson?;
    /**
     * @stability stable
     */
    get customJson(): string;
    /**
     * @stability stable
     */
    set customJson(value: string);
    /**
     * @stability stable
     */
    resetCustomJson(): void;
    /**
     * @stability stable
     */
    get customJsonInput(): string | undefined;
    private _customSecurityGroupIds?;
    /**
     * @stability stable
     */
    get customSecurityGroupIds(): string[];
    /**
     * @stability stable
     */
    set customSecurityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetCustomSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get customSecurityGroupIdsInput(): string[] | undefined;
    private _customSetupRecipes?;
    /**
     * @stability stable
     */
    get customSetupRecipes(): string[];
    /**
     * @stability stable
     */
    set customSetupRecipes(value: string[]);
    /**
     * @stability stable
     */
    resetCustomSetupRecipes(): void;
    /**
     * @stability stable
     */
    get customSetupRecipesInput(): string[] | undefined;
    private _customShutdownRecipes?;
    /**
     * @stability stable
     */
    get customShutdownRecipes(): string[];
    /**
     * @stability stable
     */
    set customShutdownRecipes(value: string[]);
    /**
     * @stability stable
     */
    resetCustomShutdownRecipes(): void;
    /**
     * @stability stable
     */
    get customShutdownRecipesInput(): string[] | undefined;
    private _customUndeployRecipes?;
    /**
     * @stability stable
     */
    get customUndeployRecipes(): string[];
    /**
     * @stability stable
     */
    set customUndeployRecipes(value: string[]);
    /**
     * @stability stable
     */
    resetCustomUndeployRecipes(): void;
    /**
     * @stability stable
     */
    get customUndeployRecipesInput(): string[] | undefined;
    private _drainElbOnShutdown?;
    /**
     * @stability stable
     */
    get drainElbOnShutdown(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set drainElbOnShutdown(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDrainElbOnShutdown(): void;
    /**
     * @stability stable
     */
    get drainElbOnShutdownInput(): boolean | cdktf.IResolvable | undefined;
    private _elasticLoadBalancer?;
    /**
     * @stability stable
     */
    get elasticLoadBalancer(): string;
    /**
     * @stability stable
     */
    set elasticLoadBalancer(value: string);
    /**
     * @stability stable
     */
    resetElasticLoadBalancer(): void;
    /**
     * @stability stable
     */
    get elasticLoadBalancerInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _installUpdatesOnBoot?;
    /**
     * @stability stable
     */
    get installUpdatesOnBoot(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set installUpdatesOnBoot(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetInstallUpdatesOnBoot(): void;
    /**
     * @stability stable
     */
    get installUpdatesOnBootInput(): boolean | cdktf.IResolvable | undefined;
    private _instanceShutdownTimeout?;
    /**
     * @stability stable
     */
    get instanceShutdownTimeout(): number;
    /**
     * @stability stable
     */
    set instanceShutdownTimeout(value: number);
    /**
     * @stability stable
     */
    resetInstanceShutdownTimeout(): void;
    /**
     * @stability stable
     */
    get instanceShutdownTimeoutInput(): number | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _stackId?;
    /**
     * @stability stable
     */
    get stackId(): string;
    /**
     * @stability stable
     */
    set stackId(value: string);
    /**
     * @stability stable
     */
    get stackIdInput(): string | undefined;
    private _systemPackages?;
    /**
     * @stability stable
     */
    get systemPackages(): string[];
    /**
     * @stability stable
     */
    set systemPackages(value: string[]);
    /**
     * @stability stable
     */
    resetSystemPackages(): void;
    /**
     * @stability stable
     */
    get systemPackagesInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _useEbsOptimizedInstances?;
    /**
     * @stability stable
     */
    get useEbsOptimizedInstances(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set useEbsOptimizedInstances(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetUseEbsOptimizedInstances(): void;
    /**
     * @stability stable
     */
    get useEbsOptimizedInstancesInput(): boolean | cdktf.IResolvable | undefined;
    private _cloudwatchConfiguration;
    /**
     * @stability stable
     */
    get cloudwatchConfiguration(): OpsworksPhpAppLayerCloudwatchConfigurationOutputReference;
    /**
     * @stability stable
     */
    putCloudwatchConfiguration(value: OpsworksPhpAppLayerCloudwatchConfiguration): void;
    /**
     * @stability stable
     */
    resetCloudwatchConfiguration(): void;
    /**
     * @stability stable
     */
    get cloudwatchConfigurationInput(): OpsworksPhpAppLayerCloudwatchConfiguration | undefined;
    private _ebsVolume?;
    /**
     * @stability stable
     */
    get ebsVolume(): OpsworksPhpAppLayerEbsVolume[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set ebsVolume(value: OpsworksPhpAppLayerEbsVolume[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEbsVolume(): void;
    /**
     * @stability stable
     */
    get ebsVolumeInput(): cdktf.IResolvable | OpsworksPhpAppLayerEbsVolume[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
