import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS OpsWorks.
 *
 * @stability stable
 */
export interface OpsworksStackConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#agent_version OpsworksStack#agent_version}.
     *
     * @stability stable
     */
    readonly agentVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#berkshelf_version OpsworksStack#berkshelf_version}.
     *
     * @stability stable
     */
    readonly berkshelfVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#color OpsworksStack#color}.
     *
     * @stability stable
     */
    readonly color?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#configuration_manager_name OpsworksStack#configuration_manager_name}.
     *
     * @stability stable
     */
    readonly configurationManagerName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#configuration_manager_version OpsworksStack#configuration_manager_version}.
     *
     * @stability stable
     */
    readonly configurationManagerVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#custom_json OpsworksStack#custom_json}.
     *
     * @stability stable
     */
    readonly customJson?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#default_availability_zone OpsworksStack#default_availability_zone}.
     *
     * @stability stable
     */
    readonly defaultAvailabilityZone?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#default_instance_profile_arn OpsworksStack#default_instance_profile_arn}.
     *
     * @stability stable
     */
    readonly defaultInstanceProfileArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#default_os OpsworksStack#default_os}.
     *
     * @stability stable
     */
    readonly defaultOs?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#default_root_device_type OpsworksStack#default_root_device_type}.
     *
     * @stability stable
     */
    readonly defaultRootDeviceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#default_ssh_key_name OpsworksStack#default_ssh_key_name}.
     *
     * @stability stable
     */
    readonly defaultSshKeyName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#default_subnet_id OpsworksStack#default_subnet_id}.
     *
     * @stability stable
     */
    readonly defaultSubnetId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#hostname_theme OpsworksStack#hostname_theme}.
     *
     * @stability stable
     */
    readonly hostnameTheme?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#manage_berkshelf OpsworksStack#manage_berkshelf}.
     *
     * @stability stable
     */
    readonly manageBerkshelf?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#name OpsworksStack#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#region OpsworksStack#region}.
     *
     * @stability stable
     */
    readonly region: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#service_role_arn OpsworksStack#service_role_arn}.
     *
     * @stability stable
     */
    readonly serviceRoleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#tags OpsworksStack#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#tags_all OpsworksStack#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#use_custom_cookbooks OpsworksStack#use_custom_cookbooks}.
     *
     * @stability stable
     */
    readonly useCustomCookbooks?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#use_opsworks_security_groups OpsworksStack#use_opsworks_security_groups}.
     *
     * @stability stable
     */
    readonly useOpsworksSecurityGroups?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#vpc_id OpsworksStack#vpc_id}.
     *
     * @stability stable
     */
    readonly vpcId?: string;
    /**
     * custom_cookbooks_source block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#custom_cookbooks_source OpsworksStack#custom_cookbooks_source}
     *
     * @stability stable
     */
    readonly customCookbooksSource?: OpsworksStackCustomCookbooksSource[] | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface OpsworksStackCustomCookbooksSource {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#password OpsworksStack#password}.
     *
     * @stability stable
     */
    readonly password?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#revision OpsworksStack#revision}.
     *
     * @stability stable
     */
    readonly revision?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#ssh_key OpsworksStack#ssh_key}.
     *
     * @stability stable
     */
    readonly sshKey?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#type OpsworksStack#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#url OpsworksStack#url}.
     *
     * @stability stable
     */
    readonly url: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack#username OpsworksStack#username}.
     *
     * @stability stable
     */
    readonly username?: string;
}
export declare function opsworksStackCustomCookbooksSourceToTerraform(struct?: OpsworksStackCustomCookbooksSource | cdktf.IResolvable): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack aws_opsworks_stack}.
 *
 * @stability stable
 */
export declare class OpsworksStack extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/opsworks_stack aws_opsworks_stack} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: OpsworksStackConfig);
    private _agentVersion?;
    /**
     * @stability stable
     */
    get agentVersion(): string;
    /**
     * @stability stable
     */
    set agentVersion(value: string);
    /**
     * @stability stable
     */
    resetAgentVersion(): void;
    /**
     * @stability stable
     */
    get agentVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _berkshelfVersion?;
    /**
     * @stability stable
     */
    get berkshelfVersion(): string;
    /**
     * @stability stable
     */
    set berkshelfVersion(value: string);
    /**
     * @stability stable
     */
    resetBerkshelfVersion(): void;
    /**
     * @stability stable
     */
    get berkshelfVersionInput(): string | undefined;
    private _color?;
    /**
     * @stability stable
     */
    get color(): string;
    /**
     * @stability stable
     */
    set color(value: string);
    /**
     * @stability stable
     */
    resetColor(): void;
    /**
     * @stability stable
     */
    get colorInput(): string | undefined;
    private _configurationManagerName?;
    /**
     * @stability stable
     */
    get configurationManagerName(): string;
    /**
     * @stability stable
     */
    set configurationManagerName(value: string);
    /**
     * @stability stable
     */
    resetConfigurationManagerName(): void;
    /**
     * @stability stable
     */
    get configurationManagerNameInput(): string | undefined;
    private _configurationManagerVersion?;
    /**
     * @stability stable
     */
    get configurationManagerVersion(): string;
    /**
     * @stability stable
     */
    set configurationManagerVersion(value: string);
    /**
     * @stability stable
     */
    resetConfigurationManagerVersion(): void;
    /**
     * @stability stable
     */
    get configurationManagerVersionInput(): string | undefined;
    private _customJson?;
    /**
     * @stability stable
     */
    get customJson(): string;
    /**
     * @stability stable
     */
    set customJson(value: string);
    /**
     * @stability stable
     */
    resetCustomJson(): void;
    /**
     * @stability stable
     */
    get customJsonInput(): string | undefined;
    private _defaultAvailabilityZone?;
    /**
     * @stability stable
     */
    get defaultAvailabilityZone(): string;
    /**
     * @stability stable
     */
    set defaultAvailabilityZone(value: string);
    /**
     * @stability stable
     */
    resetDefaultAvailabilityZone(): void;
    /**
     * @stability stable
     */
    get defaultAvailabilityZoneInput(): string | undefined;
    private _defaultInstanceProfileArn?;
    /**
     * @stability stable
     */
    get defaultInstanceProfileArn(): string;
    /**
     * @stability stable
     */
    set defaultInstanceProfileArn(value: string);
    /**
     * @stability stable
     */
    get defaultInstanceProfileArnInput(): string | undefined;
    private _defaultOs?;
    /**
     * @stability stable
     */
    get defaultOs(): string;
    /**
     * @stability stable
     */
    set defaultOs(value: string);
    /**
     * @stability stable
     */
    resetDefaultOs(): void;
    /**
     * @stability stable
     */
    get defaultOsInput(): string | undefined;
    private _defaultRootDeviceType?;
    /**
     * @stability stable
     */
    get defaultRootDeviceType(): string;
    /**
     * @stability stable
     */
    set defaultRootDeviceType(value: string);
    /**
     * @stability stable
     */
    resetDefaultRootDeviceType(): void;
    /**
     * @stability stable
     */
    get defaultRootDeviceTypeInput(): string | undefined;
    private _defaultSshKeyName?;
    /**
     * @stability stable
     */
    get defaultSshKeyName(): string;
    /**
     * @stability stable
     */
    set defaultSshKeyName(value: string);
    /**
     * @stability stable
     */
    resetDefaultSshKeyName(): void;
    /**
     * @stability stable
     */
    get defaultSshKeyNameInput(): string | undefined;
    private _defaultSubnetId?;
    /**
     * @stability stable
     */
    get defaultSubnetId(): string;
    /**
     * @stability stable
     */
    set defaultSubnetId(value: string);
    /**
     * @stability stable
     */
    resetDefaultSubnetId(): void;
    /**
     * @stability stable
     */
    get defaultSubnetIdInput(): string | undefined;
    private _hostnameTheme?;
    /**
     * @stability stable
     */
    get hostnameTheme(): string;
    /**
     * @stability stable
     */
    set hostnameTheme(value: string);
    /**
     * @stability stable
     */
    resetHostnameTheme(): void;
    /**
     * @stability stable
     */
    get hostnameThemeInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _manageBerkshelf?;
    /**
     * @stability stable
     */
    get manageBerkshelf(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set manageBerkshelf(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetManageBerkshelf(): void;
    /**
     * @stability stable
     */
    get manageBerkshelfInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _region?;
    /**
     * @stability stable
     */
    get region(): string;
    /**
     * @stability stable
     */
    set region(value: string);
    /**
     * @stability stable
     */
    get regionInput(): string | undefined;
    private _serviceRoleArn?;
    /**
     * @stability stable
     */
    get serviceRoleArn(): string;
    /**
     * @stability stable
     */
    set serviceRoleArn(value: string);
    /**
     * @stability stable
     */
    get serviceRoleArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get stackEndpoint(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _useCustomCookbooks?;
    /**
     * @stability stable
     */
    get useCustomCookbooks(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set useCustomCookbooks(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetUseCustomCookbooks(): void;
    /**
     * @stability stable
     */
    get useCustomCookbooksInput(): boolean | cdktf.IResolvable | undefined;
    private _useOpsworksSecurityGroups?;
    /**
     * @stability stable
     */
    get useOpsworksSecurityGroups(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set useOpsworksSecurityGroups(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetUseOpsworksSecurityGroups(): void;
    /**
     * @stability stable
     */
    get useOpsworksSecurityGroupsInput(): boolean | cdktf.IResolvable | undefined;
    private _vpcId?;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    resetVpcId(): void;
    /**
     * @stability stable
     */
    get vpcIdInput(): string | undefined;
    private _customCookbooksSource?;
    /**
     * @stability stable
     */
    get customCookbooksSource(): OpsworksStackCustomCookbooksSource[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set customCookbooksSource(value: OpsworksStackCustomCookbooksSource[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetCustomCookbooksSource(): void;
    /**
     * @stability stable
     */
    get customCookbooksSourceInput(): cdktf.IResolvable | OpsworksStackCustomCookbooksSource[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
