import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Organizations.
 *
 * @stability stable
 */
export interface OrganizationsOrganizationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/organizations_organization#aws_service_access_principals OrganizationsOrganization#aws_service_access_principals}.
     *
     * @stability stable
     */
    readonly awsServiceAccessPrincipals?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/organizations_organization#enabled_policy_types OrganizationsOrganization#enabled_policy_types}.
     *
     * @stability stable
     */
    readonly enabledPolicyTypes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/organizations_organization#feature_set OrganizationsOrganization#feature_set}.
     *
     * @stability stable
     */
    readonly featureSet?: string;
}
/**
 * @stability stable
 */
export declare class OrganizationsOrganizationAccounts extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get email(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get status(): string;
}
/**
 * @stability stable
 */
export declare class OrganizationsOrganizationNonMasterAccounts extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get email(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get status(): string;
}
/**
 * @stability stable
 */
export declare class OrganizationsOrganizationRootsPolicyTypes extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    get type(): string;
}
/**
 * @stability stable
 */
export declare class OrganizationsOrganizationRoots extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get policyTypes(): cdktf.IResolvable;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/organizations_organization aws_organizations_organization}.
 *
 * @stability stable
 */
export declare class OrganizationsOrganization extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/organizations_organization aws_organizations_organization} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: OrganizationsOrganizationConfig);
    /**
     * @stability stable
     */
    accounts(index: string): OrganizationsOrganizationAccounts;
    /**
     * @stability stable
     */
    get arn(): string;
    private _awsServiceAccessPrincipals?;
    /**
     * @stability stable
     */
    get awsServiceAccessPrincipals(): string[];
    /**
     * @stability stable
     */
    set awsServiceAccessPrincipals(value: string[]);
    /**
     * @stability stable
     */
    resetAwsServiceAccessPrincipals(): void;
    /**
     * @stability stable
     */
    get awsServiceAccessPrincipalsInput(): string[] | undefined;
    private _enabledPolicyTypes?;
    /**
     * @stability stable
     */
    get enabledPolicyTypes(): string[];
    /**
     * @stability stable
     */
    set enabledPolicyTypes(value: string[]);
    /**
     * @stability stable
     */
    resetEnabledPolicyTypes(): void;
    /**
     * @stability stable
     */
    get enabledPolicyTypesInput(): string[] | undefined;
    private _featureSet?;
    /**
     * @stability stable
     */
    get featureSet(): string;
    /**
     * @stability stable
     */
    set featureSet(value: string);
    /**
     * @stability stable
     */
    resetFeatureSet(): void;
    /**
     * @stability stable
     */
    get featureSetInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get masterAccountArn(): string;
    /**
     * @stability stable
     */
    get masterAccountEmail(): string;
    /**
     * @stability stable
     */
    get masterAccountId(): string;
    /**
     * @stability stable
     */
    nonMasterAccounts(index: string): OrganizationsOrganizationNonMasterAccounts;
    /**
     * @stability stable
     */
    roots(index: string): OrganizationsOrganizationRoots;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
