import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Pinpoint.
 *
 * @stability stable
 */
export interface PinpointAppConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app#name PinpointApp#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app#name_prefix PinpointApp#name_prefix}.
     *
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app#tags PinpointApp#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app#tags_all PinpointApp#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * campaign_hook block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app#campaign_hook PinpointApp#campaign_hook}
     *
     * @stability stable
     */
    readonly campaignHook?: PinpointAppCampaignHook;
    /**
     * limits block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app#limits PinpointApp#limits}
     *
     * @stability stable
     */
    readonly limits?: PinpointAppLimits;
    /**
     * quiet_time block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app#quiet_time PinpointApp#quiet_time}
     *
     * @stability stable
     */
    readonly quietTime?: PinpointAppQuietTime;
}
/**
 * @stability stable
 */
export interface PinpointAppCampaignHook {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app#lambda_function_name PinpointApp#lambda_function_name}.
     *
     * @stability stable
     */
    readonly lambdaFunctionName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app#mode PinpointApp#mode}.
     *
     * @stability stable
     */
    readonly mode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app#web_url PinpointApp#web_url}.
     *
     * @stability stable
     */
    readonly webUrl?: string;
}
export declare function pinpointAppCampaignHookToTerraform(struct?: PinpointAppCampaignHookOutputReference | PinpointAppCampaignHook): any;
/**
 * @stability stable
 */
export declare class PinpointAppCampaignHookOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): PinpointAppCampaignHook | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: PinpointAppCampaignHook | undefined);
    private _lambdaFunctionName?;
    /**
     * @stability stable
     */
    get lambdaFunctionName(): string;
    /**
     * @stability stable
     */
    set lambdaFunctionName(value: string);
    /**
     * @stability stable
     */
    resetLambdaFunctionName(): void;
    /**
     * @stability stable
     */
    get lambdaFunctionNameInput(): string | undefined;
    private _mode?;
    /**
     * @stability stable
     */
    get mode(): string;
    /**
     * @stability stable
     */
    set mode(value: string);
    /**
     * @stability stable
     */
    resetMode(): void;
    /**
     * @stability stable
     */
    get modeInput(): string | undefined;
    private _webUrl?;
    /**
     * @stability stable
     */
    get webUrl(): string;
    /**
     * @stability stable
     */
    set webUrl(value: string);
    /**
     * @stability stable
     */
    resetWebUrl(): void;
    /**
     * @stability stable
     */
    get webUrlInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface PinpointAppLimits {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app#daily PinpointApp#daily}.
     *
     * @stability stable
     */
    readonly daily?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app#maximum_duration PinpointApp#maximum_duration}.
     *
     * @stability stable
     */
    readonly maximumDuration?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app#messages_per_second PinpointApp#messages_per_second}.
     *
     * @stability stable
     */
    readonly messagesPerSecond?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app#total PinpointApp#total}.
     *
     * @stability stable
     */
    readonly total?: number;
}
export declare function pinpointAppLimitsToTerraform(struct?: PinpointAppLimitsOutputReference | PinpointAppLimits): any;
/**
 * @stability stable
 */
export declare class PinpointAppLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): PinpointAppLimits | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: PinpointAppLimits | undefined);
    private _daily?;
    /**
     * @stability stable
     */
    get daily(): number;
    /**
     * @stability stable
     */
    set daily(value: number);
    /**
     * @stability stable
     */
    resetDaily(): void;
    /**
     * @stability stable
     */
    get dailyInput(): number | undefined;
    private _maximumDuration?;
    /**
     * @stability stable
     */
    get maximumDuration(): number;
    /**
     * @stability stable
     */
    set maximumDuration(value: number);
    /**
     * @stability stable
     */
    resetMaximumDuration(): void;
    /**
     * @stability stable
     */
    get maximumDurationInput(): number | undefined;
    private _messagesPerSecond?;
    /**
     * @stability stable
     */
    get messagesPerSecond(): number;
    /**
     * @stability stable
     */
    set messagesPerSecond(value: number);
    /**
     * @stability stable
     */
    resetMessagesPerSecond(): void;
    /**
     * @stability stable
     */
    get messagesPerSecondInput(): number | undefined;
    private _total?;
    /**
     * @stability stable
     */
    get total(): number;
    /**
     * @stability stable
     */
    set total(value: number);
    /**
     * @stability stable
     */
    resetTotal(): void;
    /**
     * @stability stable
     */
    get totalInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface PinpointAppQuietTime {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app#end PinpointApp#end}.
     *
     * @stability stable
     */
    readonly end?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app#start PinpointApp#start}.
     *
     * @stability stable
     */
    readonly start?: string;
}
export declare function pinpointAppQuietTimeToTerraform(struct?: PinpointAppQuietTimeOutputReference | PinpointAppQuietTime): any;
/**
 * @stability stable
 */
export declare class PinpointAppQuietTimeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): PinpointAppQuietTime | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: PinpointAppQuietTime | undefined);
    private _end?;
    /**
     * @stability stable
     */
    get end(): string;
    /**
     * @stability stable
     */
    set end(value: string);
    /**
     * @stability stable
     */
    resetEnd(): void;
    /**
     * @stability stable
     */
    get endInput(): string | undefined;
    private _start?;
    /**
     * @stability stable
     */
    get start(): string;
    /**
     * @stability stable
     */
    set start(value: string);
    /**
     * @stability stable
     */
    resetStart(): void;
    /**
     * @stability stable
     */
    get startInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app aws_pinpoint_app}.
 *
 * @stability stable
 */
export declare class PinpointApp extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_app aws_pinpoint_app} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: PinpointAppConfig);
    /**
     * @stability stable
     */
    get applicationId(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _campaignHook;
    /**
     * @stability stable
     */
    get campaignHook(): PinpointAppCampaignHookOutputReference;
    /**
     * @stability stable
     */
    putCampaignHook(value: PinpointAppCampaignHook): void;
    /**
     * @stability stable
     */
    resetCampaignHook(): void;
    /**
     * @stability stable
     */
    get campaignHookInput(): PinpointAppCampaignHook | undefined;
    private _limits;
    /**
     * @stability stable
     */
    get limits(): PinpointAppLimitsOutputReference;
    /**
     * @stability stable
     */
    putLimits(value: PinpointAppLimits): void;
    /**
     * @stability stable
     */
    resetLimits(): void;
    /**
     * @stability stable
     */
    get limitsInput(): PinpointAppLimits | undefined;
    private _quietTime;
    /**
     * @stability stable
     */
    get quietTime(): PinpointAppQuietTimeOutputReference;
    /**
     * @stability stable
     */
    putQuietTime(value: PinpointAppQuietTime): void;
    /**
     * @stability stable
     */
    resetQuietTime(): void;
    /**
     * @stability stable
     */
    get quietTimeInput(): PinpointAppQuietTime | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
