import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Pricing.
 *
 * @stability stable
 */
export interface DataAwsPricingProductConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/pricing_product#service_code DataAwsPricingProduct#service_code}.
     *
     * @stability stable
     */
    readonly serviceCode: string;
    /**
     * filters block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/pricing_product#filters DataAwsPricingProduct#filters}
     *
     * @stability stable
     */
    readonly filters: DataAwsPricingProductFilters[] | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface DataAwsPricingProductFilters {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/pricing_product#field DataAwsPricingProduct#field}.
     *
     * @stability stable
     */
    readonly field: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/pricing_product#value DataAwsPricingProduct#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function dataAwsPricingProductFiltersToTerraform(struct?: DataAwsPricingProductFilters | cdktf.IResolvable): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/pricing_product aws_pricing_product}.
 *
 * @stability stable
 */
export declare class DataAwsPricingProduct extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/pricing_product aws_pricing_product} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsPricingProductConfig);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get result(): string;
    private _serviceCode?;
    /**
     * @stability stable
     */
    get serviceCode(): string;
    /**
     * @stability stable
     */
    set serviceCode(value: string);
    /**
     * @stability stable
     */
    get serviceCodeInput(): string | undefined;
    private _filters?;
    /**
     * @stability stable
     */
    get filters(): DataAwsPricingProductFilters[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set filters(value: DataAwsPricingProductFilters[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get filtersInput(): cdktf.IResolvable | DataAwsPricingProductFilters[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
