import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Relational Database Service.
 *
 * @stability stable
 */
export interface DataAwsRdsEngineVersionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/rds_engine_version#engine DataAwsRdsEngineVersion#engine}.
     *
     * @stability stable
     */
    readonly engine: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/rds_engine_version#parameter_group_family DataAwsRdsEngineVersion#parameter_group_family}.
     *
     * @stability stable
     */
    readonly parameterGroupFamily?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/rds_engine_version#preferred_versions DataAwsRdsEngineVersion#preferred_versions}.
     *
     * @stability stable
     */
    readonly preferredVersions?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/rds_engine_version#version DataAwsRdsEngineVersion#version}.
     *
     * @stability stable
     */
    readonly version?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/rds_engine_version aws_rds_engine_version}.
 *
 * @stability stable
 */
export declare class DataAwsRdsEngineVersion extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/rds_engine_version aws_rds_engine_version} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsRdsEngineVersionConfig);
    /**
     * @stability stable
     */
    get defaultCharacterSet(): string;
    private _engine?;
    /**
     * @stability stable
     */
    get engine(): string;
    /**
     * @stability stable
     */
    set engine(value: string);
    /**
     * @stability stable
     */
    get engineInput(): string | undefined;
    /**
     * @stability stable
     */
    get engineDescription(): string;
    /**
     * @stability stable
     */
    get exportableLogTypes(): string[];
    /**
     * @stability stable
     */
    get id(): string;
    private _parameterGroupFamily?;
    /**
     * @stability stable
     */
    get parameterGroupFamily(): string;
    /**
     * @stability stable
     */
    set parameterGroupFamily(value: string);
    /**
     * @stability stable
     */
    resetParameterGroupFamily(): void;
    /**
     * @stability stable
     */
    get parameterGroupFamilyInput(): string | undefined;
    private _preferredVersions?;
    /**
     * @stability stable
     */
    get preferredVersions(): string[];
    /**
     * @stability stable
     */
    set preferredVersions(value: string[]);
    /**
     * @stability stable
     */
    resetPreferredVersions(): void;
    /**
     * @stability stable
     */
    get preferredVersionsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    get supportedCharacterSets(): string[];
    /**
     * @stability stable
     */
    get supportedFeatureNames(): string[];
    /**
     * @stability stable
     */
    get supportedModes(): string[];
    /**
     * @stability stable
     */
    get supportedTimezones(): string[];
    /**
     * @stability stable
     */
    get supportsGlobalDatabases(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get supportsLogExportsToCloudwatch(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get supportsParallelQuery(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get supportsReadReplica(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get validUpgradeTargets(): string[];
    private _version?;
    /**
     * @stability stable
     */
    get version(): string;
    /**
     * @stability stable
     */
    set version(value: string);
    /**
     * @stability stable
     */
    resetVersion(): void;
    /**
     * @stability stable
     */
    get versionInput(): string | undefined;
    /**
     * @stability stable
     */
    get versionDescription(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
