import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Relational Database Service.
 *
 * @stability stable
 */
export interface DbInstanceConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#allocated_storage DbInstance#allocated_storage}.
     *
     * @stability stable
     */
    readonly allocatedStorage?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#allow_major_version_upgrade DbInstance#allow_major_version_upgrade}.
     *
     * @stability stable
     */
    readonly allowMajorVersionUpgrade?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#apply_immediately DbInstance#apply_immediately}.
     *
     * @stability stable
     */
    readonly applyImmediately?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#auto_minor_version_upgrade DbInstance#auto_minor_version_upgrade}.
     *
     * @stability stable
     */
    readonly autoMinorVersionUpgrade?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#availability_zone DbInstance#availability_zone}.
     *
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#backup_retention_period DbInstance#backup_retention_period}.
     *
     * @stability stable
     */
    readonly backupRetentionPeriod?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#backup_window DbInstance#backup_window}.
     *
     * @stability stable
     */
    readonly backupWindow?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#ca_cert_identifier DbInstance#ca_cert_identifier}.
     *
     * @stability stable
     */
    readonly caCertIdentifier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#character_set_name DbInstance#character_set_name}.
     *
     * @stability stable
     */
    readonly characterSetName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#copy_tags_to_snapshot DbInstance#copy_tags_to_snapshot}.
     *
     * @stability stable
     */
    readonly copyTagsToSnapshot?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#customer_owned_ip_enabled DbInstance#customer_owned_ip_enabled}.
     *
     * @stability stable
     */
    readonly customerOwnedIpEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#db_subnet_group_name DbInstance#db_subnet_group_name}.
     *
     * @stability stable
     */
    readonly dbSubnetGroupName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#delete_automated_backups DbInstance#delete_automated_backups}.
     *
     * @stability stable
     */
    readonly deleteAutomatedBackups?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#deletion_protection DbInstance#deletion_protection}.
     *
     * @stability stable
     */
    readonly deletionProtection?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#domain DbInstance#domain}.
     *
     * @stability stable
     */
    readonly domain?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#domain_iam_role_name DbInstance#domain_iam_role_name}.
     *
     * @stability stable
     */
    readonly domainIamRoleName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#enabled_cloudwatch_logs_exports DbInstance#enabled_cloudwatch_logs_exports}.
     *
     * @stability stable
     */
    readonly enabledCloudwatchLogsExports?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#engine DbInstance#engine}.
     *
     * @stability stable
     */
    readonly engine?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#engine_version DbInstance#engine_version}.
     *
     * @stability stable
     */
    readonly engineVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#final_snapshot_identifier DbInstance#final_snapshot_identifier}.
     *
     * @stability stable
     */
    readonly finalSnapshotIdentifier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#iam_database_authentication_enabled DbInstance#iam_database_authentication_enabled}.
     *
     * @stability stable
     */
    readonly iamDatabaseAuthenticationEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#identifier DbInstance#identifier}.
     *
     * @stability stable
     */
    readonly identifier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#identifier_prefix DbInstance#identifier_prefix}.
     *
     * @stability stable
     */
    readonly identifierPrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#instance_class DbInstance#instance_class}.
     *
     * @stability stable
     */
    readonly instanceClass: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#iops DbInstance#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#kms_key_id DbInstance#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#license_model DbInstance#license_model}.
     *
     * @stability stable
     */
    readonly licenseModel?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#maintenance_window DbInstance#maintenance_window}.
     *
     * @stability stable
     */
    readonly maintenanceWindow?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#max_allocated_storage DbInstance#max_allocated_storage}.
     *
     * @stability stable
     */
    readonly maxAllocatedStorage?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#monitoring_interval DbInstance#monitoring_interval}.
     *
     * @stability stable
     */
    readonly monitoringInterval?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#monitoring_role_arn DbInstance#monitoring_role_arn}.
     *
     * @stability stable
     */
    readonly monitoringRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#multi_az DbInstance#multi_az}.
     *
     * @stability stable
     */
    readonly multiAz?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#name DbInstance#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#nchar_character_set_name DbInstance#nchar_character_set_name}.
     *
     * @stability stable
     */
    readonly ncharCharacterSetName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#option_group_name DbInstance#option_group_name}.
     *
     * @stability stable
     */
    readonly optionGroupName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#parameter_group_name DbInstance#parameter_group_name}.
     *
     * @stability stable
     */
    readonly parameterGroupName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#password DbInstance#password}.
     *
     * @stability stable
     */
    readonly password?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#performance_insights_enabled DbInstance#performance_insights_enabled}.
     *
     * @stability stable
     */
    readonly performanceInsightsEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#performance_insights_kms_key_id DbInstance#performance_insights_kms_key_id}.
     *
     * @stability stable
     */
    readonly performanceInsightsKmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#performance_insights_retention_period DbInstance#performance_insights_retention_period}.
     *
     * @stability stable
     */
    readonly performanceInsightsRetentionPeriod?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#port DbInstance#port}.
     *
     * @stability stable
     */
    readonly port?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#publicly_accessible DbInstance#publicly_accessible}.
     *
     * @stability stable
     */
    readonly publiclyAccessible?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#replica_mode DbInstance#replica_mode}.
     *
     * @stability stable
     */
    readonly replicaMode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#replicate_source_db DbInstance#replicate_source_db}.
     *
     * @stability stable
     */
    readonly replicateSourceDb?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#security_group_names DbInstance#security_group_names}.
     *
     * @stability stable
     */
    readonly securityGroupNames?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#skip_final_snapshot DbInstance#skip_final_snapshot}.
     *
     * @stability stable
     */
    readonly skipFinalSnapshot?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#snapshot_identifier DbInstance#snapshot_identifier}.
     *
     * @stability stable
     */
    readonly snapshotIdentifier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#storage_encrypted DbInstance#storage_encrypted}.
     *
     * @stability stable
     */
    readonly storageEncrypted?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#storage_type DbInstance#storage_type}.
     *
     * @stability stable
     */
    readonly storageType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#tags DbInstance#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#tags_all DbInstance#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#timezone DbInstance#timezone}.
     *
     * @stability stable
     */
    readonly timezone?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#username DbInstance#username}.
     *
     * @stability stable
     */
    readonly username?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#vpc_security_group_ids DbInstance#vpc_security_group_ids}.
     *
     * @stability stable
     */
    readonly vpcSecurityGroupIds?: string[];
    /**
     * restore_to_point_in_time block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#restore_to_point_in_time DbInstance#restore_to_point_in_time}
     *
     * @stability stable
     */
    readonly restoreToPointInTime?: DbInstanceRestoreToPointInTime;
    /**
     * s3_import block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#s3_import DbInstance#s3_import}
     *
     * @stability stable
     */
    readonly s3Import?: DbInstanceS3Import;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#timeouts DbInstance#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: DbInstanceTimeouts;
}
/**
 * @stability stable
 */
export interface DbInstanceRestoreToPointInTime {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#restore_time DbInstance#restore_time}.
     *
     * @stability stable
     */
    readonly restoreTime?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#source_db_instance_identifier DbInstance#source_db_instance_identifier}.
     *
     * @stability stable
     */
    readonly sourceDbInstanceIdentifier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#source_dbi_resource_id DbInstance#source_dbi_resource_id}.
     *
     * @stability stable
     */
    readonly sourceDbiResourceId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#use_latest_restorable_time DbInstance#use_latest_restorable_time}.
     *
     * @stability stable
     */
    readonly useLatestRestorableTime?: boolean | cdktf.IResolvable;
}
export declare function dbInstanceRestoreToPointInTimeToTerraform(struct?: DbInstanceRestoreToPointInTimeOutputReference | DbInstanceRestoreToPointInTime): any;
/**
 * @stability stable
 */
export declare class DbInstanceRestoreToPointInTimeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DbInstanceRestoreToPointInTime | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DbInstanceRestoreToPointInTime | undefined);
    private _restoreTime?;
    /**
     * @stability stable
     */
    get restoreTime(): string;
    /**
     * @stability stable
     */
    set restoreTime(value: string);
    /**
     * @stability stable
     */
    resetRestoreTime(): void;
    /**
     * @stability stable
     */
    get restoreTimeInput(): string | undefined;
    private _sourceDbInstanceIdentifier?;
    /**
     * @stability stable
     */
    get sourceDbInstanceIdentifier(): string;
    /**
     * @stability stable
     */
    set sourceDbInstanceIdentifier(value: string);
    /**
     * @stability stable
     */
    resetSourceDbInstanceIdentifier(): void;
    /**
     * @stability stable
     */
    get sourceDbInstanceIdentifierInput(): string | undefined;
    private _sourceDbiResourceId?;
    /**
     * @stability stable
     */
    get sourceDbiResourceId(): string;
    /**
     * @stability stable
     */
    set sourceDbiResourceId(value: string);
    /**
     * @stability stable
     */
    resetSourceDbiResourceId(): void;
    /**
     * @stability stable
     */
    get sourceDbiResourceIdInput(): string | undefined;
    private _useLatestRestorableTime?;
    /**
     * @stability stable
     */
    get useLatestRestorableTime(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set useLatestRestorableTime(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetUseLatestRestorableTime(): void;
    /**
     * @stability stable
     */
    get useLatestRestorableTimeInput(): boolean | cdktf.IResolvable | undefined;
}
/**
 * @stability stable
 */
export interface DbInstanceS3Import {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#bucket_name DbInstance#bucket_name}.
     *
     * @stability stable
     */
    readonly bucketName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#bucket_prefix DbInstance#bucket_prefix}.
     *
     * @stability stable
     */
    readonly bucketPrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#ingestion_role DbInstance#ingestion_role}.
     *
     * @stability stable
     */
    readonly ingestionRole: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#source_engine DbInstance#source_engine}.
     *
     * @stability stable
     */
    readonly sourceEngine: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#source_engine_version DbInstance#source_engine_version}.
     *
     * @stability stable
     */
    readonly sourceEngineVersion: string;
}
export declare function dbInstanceS3ImportToTerraform(struct?: DbInstanceS3ImportOutputReference | DbInstanceS3Import): any;
/**
 * @stability stable
 */
export declare class DbInstanceS3ImportOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DbInstanceS3Import | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DbInstanceS3Import | undefined);
    private _bucketName?;
    /**
     * @stability stable
     */
    get bucketName(): string;
    /**
     * @stability stable
     */
    set bucketName(value: string);
    /**
     * @stability stable
     */
    get bucketNameInput(): string | undefined;
    private _bucketPrefix?;
    /**
     * @stability stable
     */
    get bucketPrefix(): string;
    /**
     * @stability stable
     */
    set bucketPrefix(value: string);
    /**
     * @stability stable
     */
    resetBucketPrefix(): void;
    /**
     * @stability stable
     */
    get bucketPrefixInput(): string | undefined;
    private _ingestionRole?;
    /**
     * @stability stable
     */
    get ingestionRole(): string;
    /**
     * @stability stable
     */
    set ingestionRole(value: string);
    /**
     * @stability stable
     */
    get ingestionRoleInput(): string | undefined;
    private _sourceEngine?;
    /**
     * @stability stable
     */
    get sourceEngine(): string;
    /**
     * @stability stable
     */
    set sourceEngine(value: string);
    /**
     * @stability stable
     */
    get sourceEngineInput(): string | undefined;
    private _sourceEngineVersion?;
    /**
     * @stability stable
     */
    get sourceEngineVersion(): string;
    /**
     * @stability stable
     */
    set sourceEngineVersion(value: string);
    /**
     * @stability stable
     */
    get sourceEngineVersionInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DbInstanceTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#create DbInstance#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#delete DbInstance#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_instance#update DbInstance#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function dbInstanceTimeoutsToTerraform(struct?: DbInstanceTimeoutsOutputReference | DbInstanceTimeouts | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export declare class DbInstanceTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DbInstanceTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DbInstanceTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/db_instance aws_db_instance}.
 *
 * @stability stable
 */
export declare class DbInstance extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/db_instance aws_db_instance} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DbInstanceConfig);
    /**
     * @stability stable
     */
    get address(): string;
    private _allocatedStorage?;
    /**
     * @stability stable
     */
    get allocatedStorage(): number;
    /**
     * @stability stable
     */
    set allocatedStorage(value: number);
    /**
     * @stability stable
     */
    resetAllocatedStorage(): void;
    /**
     * @stability stable
     */
    get allocatedStorageInput(): number | undefined;
    private _allowMajorVersionUpgrade?;
    /**
     * @stability stable
     */
    get allowMajorVersionUpgrade(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set allowMajorVersionUpgrade(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAllowMajorVersionUpgrade(): void;
    /**
     * @stability stable
     */
    get allowMajorVersionUpgradeInput(): boolean | cdktf.IResolvable | undefined;
    private _applyImmediately?;
    /**
     * @stability stable
     */
    get applyImmediately(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set applyImmediately(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetApplyImmediately(): void;
    /**
     * @stability stable
     */
    get applyImmediatelyInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoMinorVersionUpgrade?;
    /**
     * @stability stable
     */
    get autoMinorVersionUpgrade(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set autoMinorVersionUpgrade(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAutoMinorVersionUpgrade(): void;
    /**
     * @stability stable
     */
    get autoMinorVersionUpgradeInput(): boolean | cdktf.IResolvable | undefined;
    private _availabilityZone?;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    /**
     * @stability stable
     */
    set availabilityZone(value: string);
    /**
     * @stability stable
     */
    resetAvailabilityZone(): void;
    /**
     * @stability stable
     */
    get availabilityZoneInput(): string | undefined;
    private _backupRetentionPeriod?;
    /**
     * @stability stable
     */
    get backupRetentionPeriod(): number;
    /**
     * @stability stable
     */
    set backupRetentionPeriod(value: number);
    /**
     * @stability stable
     */
    resetBackupRetentionPeriod(): void;
    /**
     * @stability stable
     */
    get backupRetentionPeriodInput(): number | undefined;
    private _backupWindow?;
    /**
     * @stability stable
     */
    get backupWindow(): string;
    /**
     * @stability stable
     */
    set backupWindow(value: string);
    /**
     * @stability stable
     */
    resetBackupWindow(): void;
    /**
     * @stability stable
     */
    get backupWindowInput(): string | undefined;
    private _caCertIdentifier?;
    /**
     * @stability stable
     */
    get caCertIdentifier(): string;
    /**
     * @stability stable
     */
    set caCertIdentifier(value: string);
    /**
     * @stability stable
     */
    resetCaCertIdentifier(): void;
    /**
     * @stability stable
     */
    get caCertIdentifierInput(): string | undefined;
    private _characterSetName?;
    /**
     * @stability stable
     */
    get characterSetName(): string;
    /**
     * @stability stable
     */
    set characterSetName(value: string);
    /**
     * @stability stable
     */
    resetCharacterSetName(): void;
    /**
     * @stability stable
     */
    get characterSetNameInput(): string | undefined;
    private _copyTagsToSnapshot?;
    /**
     * @stability stable
     */
    get copyTagsToSnapshot(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set copyTagsToSnapshot(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetCopyTagsToSnapshot(): void;
    /**
     * @stability stable
     */
    get copyTagsToSnapshotInput(): boolean | cdktf.IResolvable | undefined;
    private _customerOwnedIpEnabled?;
    /**
     * @stability stable
     */
    get customerOwnedIpEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set customerOwnedIpEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetCustomerOwnedIpEnabled(): void;
    /**
     * @stability stable
     */
    get customerOwnedIpEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _dbSubnetGroupName?;
    /**
     * @stability stable
     */
    get dbSubnetGroupName(): string;
    /**
     * @stability stable
     */
    set dbSubnetGroupName(value: string);
    /**
     * @stability stable
     */
    resetDbSubnetGroupName(): void;
    /**
     * @stability stable
     */
    get dbSubnetGroupNameInput(): string | undefined;
    private _deleteAutomatedBackups?;
    /**
     * @stability stable
     */
    get deleteAutomatedBackups(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set deleteAutomatedBackups(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDeleteAutomatedBackups(): void;
    /**
     * @stability stable
     */
    get deleteAutomatedBackupsInput(): boolean | cdktf.IResolvable | undefined;
    private _deletionProtection?;
    /**
     * @stability stable
     */
    get deletionProtection(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set deletionProtection(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDeletionProtection(): void;
    /**
     * @stability stable
     */
    get deletionProtectionInput(): boolean | cdktf.IResolvable | undefined;
    private _domain?;
    /**
     * @stability stable
     */
    get domain(): string;
    /**
     * @stability stable
     */
    set domain(value: string);
    /**
     * @stability stable
     */
    resetDomain(): void;
    /**
     * @stability stable
     */
    get domainInput(): string | undefined;
    private _domainIamRoleName?;
    /**
     * @stability stable
     */
    get domainIamRoleName(): string;
    /**
     * @stability stable
     */
    set domainIamRoleName(value: string);
    /**
     * @stability stable
     */
    resetDomainIamRoleName(): void;
    /**
     * @stability stable
     */
    get domainIamRoleNameInput(): string | undefined;
    private _enabledCloudwatchLogsExports?;
    /**
     * @stability stable
     */
    get enabledCloudwatchLogsExports(): string[];
    /**
     * @stability stable
     */
    set enabledCloudwatchLogsExports(value: string[]);
    /**
     * @stability stable
     */
    resetEnabledCloudwatchLogsExports(): void;
    /**
     * @stability stable
     */
    get enabledCloudwatchLogsExportsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get endpoint(): string;
    private _engine?;
    /**
     * @stability stable
     */
    get engine(): string;
    /**
     * @stability stable
     */
    set engine(value: string);
    /**
     * @stability stable
     */
    resetEngine(): void;
    /**
     * @stability stable
     */
    get engineInput(): string | undefined;
    private _engineVersion?;
    /**
     * @stability stable
     */
    get engineVersion(): string;
    /**
     * @stability stable
     */
    set engineVersion(value: string);
    /**
     * @stability stable
     */
    resetEngineVersion(): void;
    /**
     * @stability stable
     */
    get engineVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get engineVersionActual(): string;
    private _finalSnapshotIdentifier?;
    /**
     * @stability stable
     */
    get finalSnapshotIdentifier(): string;
    /**
     * @stability stable
     */
    set finalSnapshotIdentifier(value: string);
    /**
     * @stability stable
     */
    resetFinalSnapshotIdentifier(): void;
    /**
     * @stability stable
     */
    get finalSnapshotIdentifierInput(): string | undefined;
    /**
     * @stability stable
     */
    get hostedZoneId(): string;
    private _iamDatabaseAuthenticationEnabled?;
    /**
     * @stability stable
     */
    get iamDatabaseAuthenticationEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set iamDatabaseAuthenticationEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIamDatabaseAuthenticationEnabled(): void;
    /**
     * @stability stable
     */
    get iamDatabaseAuthenticationEnabledInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _identifier?;
    /**
     * @stability stable
     */
    get identifier(): string;
    /**
     * @stability stable
     */
    set identifier(value: string);
    /**
     * @stability stable
     */
    resetIdentifier(): void;
    /**
     * @stability stable
     */
    get identifierInput(): string | undefined;
    private _identifierPrefix?;
    /**
     * @stability stable
     */
    get identifierPrefix(): string;
    /**
     * @stability stable
     */
    set identifierPrefix(value: string);
    /**
     * @stability stable
     */
    resetIdentifierPrefix(): void;
    /**
     * @stability stable
     */
    get identifierPrefixInput(): string | undefined;
    private _instanceClass?;
    /**
     * @stability stable
     */
    get instanceClass(): string;
    /**
     * @stability stable
     */
    set instanceClass(value: string);
    /**
     * @stability stable
     */
    get instanceClassInput(): string | undefined;
    private _iops?;
    /**
     * @stability stable
     */
    get iops(): number;
    /**
     * @stability stable
     */
    set iops(value: number);
    /**
     * @stability stable
     */
    resetIops(): void;
    /**
     * @stability stable
     */
    get iopsInput(): number | undefined;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get latestRestorableTime(): string;
    private _licenseModel?;
    /**
     * @stability stable
     */
    get licenseModel(): string;
    /**
     * @stability stable
     */
    set licenseModel(value: string);
    /**
     * @stability stable
     */
    resetLicenseModel(): void;
    /**
     * @stability stable
     */
    get licenseModelInput(): string | undefined;
    private _maintenanceWindow?;
    /**
     * @stability stable
     */
    get maintenanceWindow(): string;
    /**
     * @stability stable
     */
    set maintenanceWindow(value: string);
    /**
     * @stability stable
     */
    resetMaintenanceWindow(): void;
    /**
     * @stability stable
     */
    get maintenanceWindowInput(): string | undefined;
    private _maxAllocatedStorage?;
    /**
     * @stability stable
     */
    get maxAllocatedStorage(): number;
    /**
     * @stability stable
     */
    set maxAllocatedStorage(value: number);
    /**
     * @stability stable
     */
    resetMaxAllocatedStorage(): void;
    /**
     * @stability stable
     */
    get maxAllocatedStorageInput(): number | undefined;
    private _monitoringInterval?;
    /**
     * @stability stable
     */
    get monitoringInterval(): number;
    /**
     * @stability stable
     */
    set monitoringInterval(value: number);
    /**
     * @stability stable
     */
    resetMonitoringInterval(): void;
    /**
     * @stability stable
     */
    get monitoringIntervalInput(): number | undefined;
    private _monitoringRoleArn?;
    /**
     * @stability stable
     */
    get monitoringRoleArn(): string;
    /**
     * @stability stable
     */
    set monitoringRoleArn(value: string);
    /**
     * @stability stable
     */
    resetMonitoringRoleArn(): void;
    /**
     * @stability stable
     */
    get monitoringRoleArnInput(): string | undefined;
    private _multiAz?;
    /**
     * @stability stable
     */
    get multiAz(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set multiAz(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetMultiAz(): void;
    /**
     * @stability stable
     */
    get multiAzInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _ncharCharacterSetName?;
    /**
     * @stability stable
     */
    get ncharCharacterSetName(): string;
    /**
     * @stability stable
     */
    set ncharCharacterSetName(value: string);
    /**
     * @stability stable
     */
    resetNcharCharacterSetName(): void;
    /**
     * @stability stable
     */
    get ncharCharacterSetNameInput(): string | undefined;
    private _optionGroupName?;
    /**
     * @stability stable
     */
    get optionGroupName(): string;
    /**
     * @stability stable
     */
    set optionGroupName(value: string);
    /**
     * @stability stable
     */
    resetOptionGroupName(): void;
    /**
     * @stability stable
     */
    get optionGroupNameInput(): string | undefined;
    private _parameterGroupName?;
    /**
     * @stability stable
     */
    get parameterGroupName(): string;
    /**
     * @stability stable
     */
    set parameterGroupName(value: string);
    /**
     * @stability stable
     */
    resetParameterGroupName(): void;
    /**
     * @stability stable
     */
    get parameterGroupNameInput(): string | undefined;
    private _password?;
    /**
     * @stability stable
     */
    get password(): string;
    /**
     * @stability stable
     */
    set password(value: string);
    /**
     * @stability stable
     */
    resetPassword(): void;
    /**
     * @stability stable
     */
    get passwordInput(): string | undefined;
    private _performanceInsightsEnabled?;
    /**
     * @stability stable
     */
    get performanceInsightsEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set performanceInsightsEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetPerformanceInsightsEnabled(): void;
    /**
     * @stability stable
     */
    get performanceInsightsEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _performanceInsightsKmsKeyId?;
    /**
     * @stability stable
     */
    get performanceInsightsKmsKeyId(): string;
    /**
     * @stability stable
     */
    set performanceInsightsKmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetPerformanceInsightsKmsKeyId(): void;
    /**
     * @stability stable
     */
    get performanceInsightsKmsKeyIdInput(): string | undefined;
    private _performanceInsightsRetentionPeriod?;
    /**
     * @stability stable
     */
    get performanceInsightsRetentionPeriod(): number;
    /**
     * @stability stable
     */
    set performanceInsightsRetentionPeriod(value: number);
    /**
     * @stability stable
     */
    resetPerformanceInsightsRetentionPeriod(): void;
    /**
     * @stability stable
     */
    get performanceInsightsRetentionPeriodInput(): number | undefined;
    private _port?;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    set port(value: number);
    /**
     * @stability stable
     */
    resetPort(): void;
    /**
     * @stability stable
     */
    get portInput(): number | undefined;
    private _publiclyAccessible?;
    /**
     * @stability stable
     */
    get publiclyAccessible(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set publiclyAccessible(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetPubliclyAccessible(): void;
    /**
     * @stability stable
     */
    get publiclyAccessibleInput(): boolean | cdktf.IResolvable | undefined;
    private _replicaMode?;
    /**
     * @stability stable
     */
    get replicaMode(): string;
    /**
     * @stability stable
     */
    set replicaMode(value: string);
    /**
     * @stability stable
     */
    resetReplicaMode(): void;
    /**
     * @stability stable
     */
    get replicaModeInput(): string | undefined;
    /**
     * @stability stable
     */
    get replicas(): string[];
    private _replicateSourceDb?;
    /**
     * @stability stable
     */
    get replicateSourceDb(): string;
    /**
     * @stability stable
     */
    set replicateSourceDb(value: string);
    /**
     * @stability stable
     */
    resetReplicateSourceDb(): void;
    /**
     * @stability stable
     */
    get replicateSourceDbInput(): string | undefined;
    /**
     * @stability stable
     */
    get resourceId(): string;
    private _securityGroupNames?;
    /**
     * @stability stable
     */
    get securityGroupNames(): string[];
    /**
     * @stability stable
     */
    set securityGroupNames(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroupNames(): void;
    /**
     * @stability stable
     */
    get securityGroupNamesInput(): string[] | undefined;
    private _skipFinalSnapshot?;
    /**
     * @stability stable
     */
    get skipFinalSnapshot(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set skipFinalSnapshot(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSkipFinalSnapshot(): void;
    /**
     * @stability stable
     */
    get skipFinalSnapshotInput(): boolean | cdktf.IResolvable | undefined;
    private _snapshotIdentifier?;
    /**
     * @stability stable
     */
    get snapshotIdentifier(): string;
    /**
     * @stability stable
     */
    set snapshotIdentifier(value: string);
    /**
     * @stability stable
     */
    resetSnapshotIdentifier(): void;
    /**
     * @stability stable
     */
    get snapshotIdentifierInput(): string | undefined;
    /**
     * @stability stable
     */
    get status(): string;
    private _storageEncrypted?;
    /**
     * @stability stable
     */
    get storageEncrypted(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set storageEncrypted(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetStorageEncrypted(): void;
    /**
     * @stability stable
     */
    get storageEncryptedInput(): boolean | cdktf.IResolvable | undefined;
    private _storageType?;
    /**
     * @stability stable
     */
    get storageType(): string;
    /**
     * @stability stable
     */
    set storageType(value: string);
    /**
     * @stability stable
     */
    resetStorageType(): void;
    /**
     * @stability stable
     */
    get storageTypeInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _timezone?;
    /**
     * @stability stable
     */
    get timezone(): string;
    /**
     * @stability stable
     */
    set timezone(value: string);
    /**
     * @stability stable
     */
    resetTimezone(): void;
    /**
     * @stability stable
     */
    get timezoneInput(): string | undefined;
    private _username?;
    /**
     * @stability stable
     */
    get username(): string;
    /**
     * @stability stable
     */
    set username(value: string);
    /**
     * @stability stable
     */
    resetUsername(): void;
    /**
     * @stability stable
     */
    get usernameInput(): string | undefined;
    private _vpcSecurityGroupIds?;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIds(): string[];
    /**
     * @stability stable
     */
    set vpcSecurityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetVpcSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIdsInput(): string[] | undefined;
    private _restoreToPointInTime;
    /**
     * @stability stable
     */
    get restoreToPointInTime(): DbInstanceRestoreToPointInTimeOutputReference;
    /**
     * @stability stable
     */
    putRestoreToPointInTime(value: DbInstanceRestoreToPointInTime): void;
    /**
     * @stability stable
     */
    resetRestoreToPointInTime(): void;
    /**
     * @stability stable
     */
    get restoreToPointInTimeInput(): DbInstanceRestoreToPointInTime | undefined;
    private _s3Import;
    /**
     * @stability stable
     */
    get s3Import(): DbInstanceS3ImportOutputReference;
    /**
     * @stability stable
     */
    putS3Import(value: DbInstanceS3Import): void;
    /**
     * @stability stable
     */
    resetS3Import(): void;
    /**
     * @stability stable
     */
    get s3ImportInput(): DbInstanceS3Import | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): DbInstanceTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: DbInstanceTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DbInstanceTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
