import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Relational Database Service.
 *
 * @stability stable
 */
export interface RdsClusterEndpointConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/rds_cluster_endpoint#cluster_endpoint_identifier RdsClusterEndpoint#cluster_endpoint_identifier}.
     *
     * @stability stable
     */
    readonly clusterEndpointIdentifier: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/rds_cluster_endpoint#cluster_identifier RdsClusterEndpoint#cluster_identifier}.
     *
     * @stability stable
     */
    readonly clusterIdentifier: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/rds_cluster_endpoint#custom_endpoint_type RdsClusterEndpoint#custom_endpoint_type}.
     *
     * @stability stable
     */
    readonly customEndpointType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/rds_cluster_endpoint#excluded_members RdsClusterEndpoint#excluded_members}.
     *
     * @stability stable
     */
    readonly excludedMembers?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/rds_cluster_endpoint#static_members RdsClusterEndpoint#static_members}.
     *
     * @stability stable
     */
    readonly staticMembers?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/rds_cluster_endpoint#tags RdsClusterEndpoint#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/rds_cluster_endpoint#tags_all RdsClusterEndpoint#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/rds_cluster_endpoint aws_rds_cluster_endpoint}.
 *
 * @stability stable
 */
export declare class RdsClusterEndpoint extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/rds_cluster_endpoint aws_rds_cluster_endpoint} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: RdsClusterEndpointConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _clusterEndpointIdentifier?;
    /**
     * @stability stable
     */
    get clusterEndpointIdentifier(): string;
    /**
     * @stability stable
     */
    set clusterEndpointIdentifier(value: string);
    /**
     * @stability stable
     */
    get clusterEndpointIdentifierInput(): string | undefined;
    private _clusterIdentifier?;
    /**
     * @stability stable
     */
    get clusterIdentifier(): string;
    /**
     * @stability stable
     */
    set clusterIdentifier(value: string);
    /**
     * @stability stable
     */
    get clusterIdentifierInput(): string | undefined;
    private _customEndpointType?;
    /**
     * @stability stable
     */
    get customEndpointType(): string;
    /**
     * @stability stable
     */
    set customEndpointType(value: string);
    /**
     * @stability stable
     */
    get customEndpointTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get endpoint(): string;
    private _excludedMembers?;
    /**
     * @stability stable
     */
    get excludedMembers(): string[];
    /**
     * @stability stable
     */
    set excludedMembers(value: string[]);
    /**
     * @stability stable
     */
    resetExcludedMembers(): void;
    /**
     * @stability stable
     */
    get excludedMembersInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _staticMembers?;
    /**
     * @stability stable
     */
    get staticMembers(): string[];
    /**
     * @stability stable
     */
    set staticMembers(value: string[]);
    /**
     * @stability stable
     */
    resetStaticMembers(): void;
    /**
     * @stability stable
     */
    get staticMembersInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
