import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Route 53.
 *
 * @stability stable
 */
export interface Route53RecordConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record#allow_overwrite Route53Record#allow_overwrite}.
     *
     * @stability stable
     */
    readonly allowOverwrite?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record#health_check_id Route53Record#health_check_id}.
     *
     * @stability stable
     */
    readonly healthCheckId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record#multivalue_answer_routing_policy Route53Record#multivalue_answer_routing_policy}.
     *
     * @stability stable
     */
    readonly multivalueAnswerRoutingPolicy?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record#name Route53Record#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record#records Route53Record#records}.
     *
     * @stability stable
     */
    readonly records?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record#set_identifier Route53Record#set_identifier}.
     *
     * @stability stable
     */
    readonly setIdentifier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record#ttl Route53Record#ttl}.
     *
     * @stability stable
     */
    readonly ttl?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record#type Route53Record#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record#zone_id Route53Record#zone_id}.
     *
     * @stability stable
     */
    readonly zoneId: string;
    /**
     * alias block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record#alias Route53Record#alias}
     *
     * @stability stable
     */
    readonly alias?: Route53RecordAlias[] | cdktf.IResolvable;
    /**
     * failover_routing_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record#failover_routing_policy Route53Record#failover_routing_policy}
     *
     * @stability stable
     */
    readonly failoverRoutingPolicy?: Route53RecordFailoverRoutingPolicy[] | cdktf.IResolvable;
    /**
     * geolocation_routing_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record#geolocation_routing_policy Route53Record#geolocation_routing_policy}
     *
     * @stability stable
     */
    readonly geolocationRoutingPolicy?: Route53RecordGeolocationRoutingPolicy[] | cdktf.IResolvable;
    /**
     * latency_routing_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record#latency_routing_policy Route53Record#latency_routing_policy}
     *
     * @stability stable
     */
    readonly latencyRoutingPolicy?: Route53RecordLatencyRoutingPolicy[] | cdktf.IResolvable;
    /**
     * weighted_routing_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record#weighted_routing_policy Route53Record#weighted_routing_policy}
     *
     * @stability stable
     */
    readonly weightedRoutingPolicy?: Route53RecordWeightedRoutingPolicy[] | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface Route53RecordAlias {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record#evaluate_target_health Route53Record#evaluate_target_health}.
     *
     * @stability stable
     */
    readonly evaluateTargetHealth: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record#name Route53Record#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record#zone_id Route53Record#zone_id}.
     *
     * @stability stable
     */
    readonly zoneId: string;
}
export declare function route53RecordAliasToTerraform(struct?: Route53RecordAlias | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface Route53RecordFailoverRoutingPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record#type Route53Record#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
export declare function route53RecordFailoverRoutingPolicyToTerraform(struct?: Route53RecordFailoverRoutingPolicy | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface Route53RecordGeolocationRoutingPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record#continent Route53Record#continent}.
     *
     * @stability stable
     */
    readonly continent?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record#country Route53Record#country}.
     *
     * @stability stable
     */
    readonly country?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record#subdivision Route53Record#subdivision}.
     *
     * @stability stable
     */
    readonly subdivision?: string;
}
export declare function route53RecordGeolocationRoutingPolicyToTerraform(struct?: Route53RecordGeolocationRoutingPolicy | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface Route53RecordLatencyRoutingPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record#region Route53Record#region}.
     *
     * @stability stable
     */
    readonly region: string;
}
export declare function route53RecordLatencyRoutingPolicyToTerraform(struct?: Route53RecordLatencyRoutingPolicy | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface Route53RecordWeightedRoutingPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_record#weight Route53Record#weight}.
     *
     * @stability stable
     */
    readonly weight: number;
}
export declare function route53RecordWeightedRoutingPolicyToTerraform(struct?: Route53RecordWeightedRoutingPolicy | cdktf.IResolvable): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53_record aws_route53_record}.
 *
 * @stability stable
 */
export declare class Route53Record extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53_record aws_route53_record} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Route53RecordConfig);
    private _allowOverwrite?;
    /**
     * @stability stable
     */
    get allowOverwrite(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set allowOverwrite(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAllowOverwrite(): void;
    /**
     * @stability stable
     */
    get allowOverwriteInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get fqdn(): string;
    private _healthCheckId?;
    /**
     * @stability stable
     */
    get healthCheckId(): string;
    /**
     * @stability stable
     */
    set healthCheckId(value: string);
    /**
     * @stability stable
     */
    resetHealthCheckId(): void;
    /**
     * @stability stable
     */
    get healthCheckIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _multivalueAnswerRoutingPolicy?;
    /**
     * @stability stable
     */
    get multivalueAnswerRoutingPolicy(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set multivalueAnswerRoutingPolicy(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetMultivalueAnswerRoutingPolicy(): void;
    /**
     * @stability stable
     */
    get multivalueAnswerRoutingPolicyInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _records?;
    /**
     * @stability stable
     */
    get records(): string[];
    /**
     * @stability stable
     */
    set records(value: string[]);
    /**
     * @stability stable
     */
    resetRecords(): void;
    /**
     * @stability stable
     */
    get recordsInput(): string[] | undefined;
    private _setIdentifier?;
    /**
     * @stability stable
     */
    get setIdentifier(): string;
    /**
     * @stability stable
     */
    set setIdentifier(value: string);
    /**
     * @stability stable
     */
    resetSetIdentifier(): void;
    /**
     * @stability stable
     */
    get setIdentifierInput(): string | undefined;
    private _ttl?;
    /**
     * @stability stable
     */
    get ttl(): number;
    /**
     * @stability stable
     */
    set ttl(value: number);
    /**
     * @stability stable
     */
    resetTtl(): void;
    /**
     * @stability stable
     */
    get ttlInput(): number | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _zoneId?;
    /**
     * @stability stable
     */
    get zoneId(): string;
    /**
     * @stability stable
     */
    set zoneId(value: string);
    /**
     * @stability stable
     */
    get zoneIdInput(): string | undefined;
    private _alias?;
    /**
     * @stability stable
     */
    get alias(): Route53RecordAlias[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set alias(value: Route53RecordAlias[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAlias(): void;
    /**
     * @stability stable
     */
    get aliasInput(): cdktf.IResolvable | Route53RecordAlias[] | undefined;
    private _failoverRoutingPolicy?;
    /**
     * @stability stable
     */
    get failoverRoutingPolicy(): Route53RecordFailoverRoutingPolicy[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set failoverRoutingPolicy(value: Route53RecordFailoverRoutingPolicy[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetFailoverRoutingPolicy(): void;
    /**
     * @stability stable
     */
    get failoverRoutingPolicyInput(): cdktf.IResolvable | Route53RecordFailoverRoutingPolicy[] | undefined;
    private _geolocationRoutingPolicy?;
    /**
     * @stability stable
     */
    get geolocationRoutingPolicy(): Route53RecordGeolocationRoutingPolicy[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set geolocationRoutingPolicy(value: Route53RecordGeolocationRoutingPolicy[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetGeolocationRoutingPolicy(): void;
    /**
     * @stability stable
     */
    get geolocationRoutingPolicyInput(): cdktf.IResolvable | Route53RecordGeolocationRoutingPolicy[] | undefined;
    private _latencyRoutingPolicy?;
    /**
     * @stability stable
     */
    get latencyRoutingPolicy(): Route53RecordLatencyRoutingPolicy[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set latencyRoutingPolicy(value: Route53RecordLatencyRoutingPolicy[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetLatencyRoutingPolicy(): void;
    /**
     * @stability stable
     */
    get latencyRoutingPolicyInput(): cdktf.IResolvable | Route53RecordLatencyRoutingPolicy[] | undefined;
    private _weightedRoutingPolicy?;
    /**
     * @stability stable
     */
    get weightedRoutingPolicy(): Route53RecordWeightedRoutingPolicy[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set weightedRoutingPolicy(value: Route53RecordWeightedRoutingPolicy[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetWeightedRoutingPolicy(): void;
    /**
     * @stability stable
     */
    get weightedRoutingPolicyInput(): cdktf.IResolvable | Route53RecordWeightedRoutingPolicy[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
