import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Simple Storage Service.
 *
 * @stability stable
 */
export interface S3ControlMultiRegionAccessPointConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3control_multi_region_access_point#account_id S3ControlMultiRegionAccessPoint#account_id}.
     *
     * @stability stable
     */
    readonly accountId?: string;
    /**
     * details block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3control_multi_region_access_point#details S3ControlMultiRegionAccessPoint#details}
     *
     * @stability stable
     */
    readonly details: S3ControlMultiRegionAccessPointDetails;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3control_multi_region_access_point#timeouts S3ControlMultiRegionAccessPoint#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: S3ControlMultiRegionAccessPointTimeouts;
}
/**
 * @stability stable
 */
export interface S3ControlMultiRegionAccessPointDetailsPublicAccessBlock {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3control_multi_region_access_point#block_public_acls S3ControlMultiRegionAccessPoint#block_public_acls}.
     *
     * @stability stable
     */
    readonly blockPublicAcls?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3control_multi_region_access_point#block_public_policy S3ControlMultiRegionAccessPoint#block_public_policy}.
     *
     * @stability stable
     */
    readonly blockPublicPolicy?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3control_multi_region_access_point#ignore_public_acls S3ControlMultiRegionAccessPoint#ignore_public_acls}.
     *
     * @stability stable
     */
    readonly ignorePublicAcls?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3control_multi_region_access_point#restrict_public_buckets S3ControlMultiRegionAccessPoint#restrict_public_buckets}.
     *
     * @stability stable
     */
    readonly restrictPublicBuckets?: boolean | cdktf.IResolvable;
}
export declare function s3ControlMultiRegionAccessPointDetailsPublicAccessBlockToTerraform(struct?: S3ControlMultiRegionAccessPointDetailsPublicAccessBlockOutputReference | S3ControlMultiRegionAccessPointDetailsPublicAccessBlock): any;
/**
 * @stability stable
 */
export declare class S3ControlMultiRegionAccessPointDetailsPublicAccessBlockOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): S3ControlMultiRegionAccessPointDetailsPublicAccessBlock | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: S3ControlMultiRegionAccessPointDetailsPublicAccessBlock | undefined);
    private _blockPublicAcls?;
    /**
     * @stability stable
     */
    get blockPublicAcls(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set blockPublicAcls(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetBlockPublicAcls(): void;
    /**
     * @stability stable
     */
    get blockPublicAclsInput(): boolean | cdktf.IResolvable | undefined;
    private _blockPublicPolicy?;
    /**
     * @stability stable
     */
    get blockPublicPolicy(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set blockPublicPolicy(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetBlockPublicPolicy(): void;
    /**
     * @stability stable
     */
    get blockPublicPolicyInput(): boolean | cdktf.IResolvable | undefined;
    private _ignorePublicAcls?;
    /**
     * @stability stable
     */
    get ignorePublicAcls(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set ignorePublicAcls(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIgnorePublicAcls(): void;
    /**
     * @stability stable
     */
    get ignorePublicAclsInput(): boolean | cdktf.IResolvable | undefined;
    private _restrictPublicBuckets?;
    /**
     * @stability stable
     */
    get restrictPublicBuckets(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set restrictPublicBuckets(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetRestrictPublicBuckets(): void;
    /**
     * @stability stable
     */
    get restrictPublicBucketsInput(): boolean | cdktf.IResolvable | undefined;
}
/**
 * @stability stable
 */
export interface S3ControlMultiRegionAccessPointDetailsRegion {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3control_multi_region_access_point#bucket S3ControlMultiRegionAccessPoint#bucket}.
     *
     * @stability stable
     */
    readonly bucket: string;
}
export declare function s3ControlMultiRegionAccessPointDetailsRegionToTerraform(struct?: S3ControlMultiRegionAccessPointDetailsRegion | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface S3ControlMultiRegionAccessPointDetails {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3control_multi_region_access_point#name S3ControlMultiRegionAccessPoint#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * public_access_block block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3control_multi_region_access_point#public_access_block S3ControlMultiRegionAccessPoint#public_access_block}
     *
     * @stability stable
     */
    readonly publicAccessBlock?: S3ControlMultiRegionAccessPointDetailsPublicAccessBlock;
    /**
     * region block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3control_multi_region_access_point#region S3ControlMultiRegionAccessPoint#region}
     *
     * @stability stable
     */
    readonly region: S3ControlMultiRegionAccessPointDetailsRegion[] | cdktf.IResolvable;
}
export declare function s3ControlMultiRegionAccessPointDetailsToTerraform(struct?: S3ControlMultiRegionAccessPointDetailsOutputReference | S3ControlMultiRegionAccessPointDetails): any;
/**
 * @stability stable
 */
export declare class S3ControlMultiRegionAccessPointDetailsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): S3ControlMultiRegionAccessPointDetails | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: S3ControlMultiRegionAccessPointDetails | undefined);
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _publicAccessBlock;
    /**
     * @stability stable
     */
    get publicAccessBlock(): S3ControlMultiRegionAccessPointDetailsPublicAccessBlockOutputReference;
    /**
     * @stability stable
     */
    putPublicAccessBlock(value: S3ControlMultiRegionAccessPointDetailsPublicAccessBlock): void;
    /**
     * @stability stable
     */
    resetPublicAccessBlock(): void;
    /**
     * @stability stable
     */
    get publicAccessBlockInput(): S3ControlMultiRegionAccessPointDetailsPublicAccessBlock | undefined;
    private _region?;
    /**
     * @stability stable
     */
    get region(): S3ControlMultiRegionAccessPointDetailsRegion[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set region(value: S3ControlMultiRegionAccessPointDetailsRegion[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get regionInput(): cdktf.IResolvable | S3ControlMultiRegionAccessPointDetailsRegion[] | undefined;
}
/**
 * @stability stable
 */
export interface S3ControlMultiRegionAccessPointTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3control_multi_region_access_point#create S3ControlMultiRegionAccessPoint#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3control_multi_region_access_point#delete S3ControlMultiRegionAccessPoint#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
}
export declare function s3ControlMultiRegionAccessPointTimeoutsToTerraform(struct?: S3ControlMultiRegionAccessPointTimeoutsOutputReference | S3ControlMultiRegionAccessPointTimeouts | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export declare class S3ControlMultiRegionAccessPointTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): S3ControlMultiRegionAccessPointTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: S3ControlMultiRegionAccessPointTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/s3control_multi_region_access_point aws_s3control_multi_region_access_point}.
 *
 * @stability stable
 */
export declare class S3ControlMultiRegionAccessPoint extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/s3control_multi_region_access_point aws_s3control_multi_region_access_point} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: S3ControlMultiRegionAccessPointConfig);
    private _accountId?;
    /**
     * @stability stable
     */
    get accountId(): string;
    /**
     * @stability stable
     */
    set accountId(value: string);
    /**
     * @stability stable
     */
    resetAccountId(): void;
    /**
     * @stability stable
     */
    get accountIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get alias(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get domainName(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get status(): string;
    private _details;
    /**
     * @stability stable
     */
    get details(): S3ControlMultiRegionAccessPointDetailsOutputReference;
    /**
     * @stability stable
     */
    putDetails(value: S3ControlMultiRegionAccessPointDetails): void;
    /**
     * @stability stable
     */
    get detailsInput(): S3ControlMultiRegionAccessPointDetails | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): S3ControlMultiRegionAccessPointTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: S3ControlMultiRegionAccessPointTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): S3ControlMultiRegionAccessPointTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
