import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS SageMaker.
 *
 * @stability stable
 */
export interface SagemakerAppImageConfigConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_app_image_config#app_image_config_name SagemakerAppImageConfig#app_image_config_name}.
     *
     * @stability stable
     */
    readonly appImageConfigName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_app_image_config#tags SagemakerAppImageConfig#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_app_image_config#tags_all SagemakerAppImageConfig#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * kernel_gateway_image_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_app_image_config#kernel_gateway_image_config SagemakerAppImageConfig#kernel_gateway_image_config}
     *
     * @stability stable
     */
    readonly kernelGatewayImageConfig?: SagemakerAppImageConfigKernelGatewayImageConfig;
}
/**
 * @stability stable
 */
export interface SagemakerAppImageConfigKernelGatewayImageConfigFileSystemConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_app_image_config#default_gid SagemakerAppImageConfig#default_gid}.
     *
     * @stability stable
     */
    readonly defaultGid?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_app_image_config#default_uid SagemakerAppImageConfig#default_uid}.
     *
     * @stability stable
     */
    readonly defaultUid?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_app_image_config#mount_path SagemakerAppImageConfig#mount_path}.
     *
     * @stability stable
     */
    readonly mountPath?: string;
}
export declare function sagemakerAppImageConfigKernelGatewayImageConfigFileSystemConfigToTerraform(struct?: SagemakerAppImageConfigKernelGatewayImageConfigFileSystemConfigOutputReference | SagemakerAppImageConfigKernelGatewayImageConfigFileSystemConfig): any;
/**
 * @stability stable
 */
export declare class SagemakerAppImageConfigKernelGatewayImageConfigFileSystemConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerAppImageConfigKernelGatewayImageConfigFileSystemConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerAppImageConfigKernelGatewayImageConfigFileSystemConfig | undefined);
    private _defaultGid?;
    /**
     * @stability stable
     */
    get defaultGid(): number;
    /**
     * @stability stable
     */
    set defaultGid(value: number);
    /**
     * @stability stable
     */
    resetDefaultGid(): void;
    /**
     * @stability stable
     */
    get defaultGidInput(): number | undefined;
    private _defaultUid?;
    /**
     * @stability stable
     */
    get defaultUid(): number;
    /**
     * @stability stable
     */
    set defaultUid(value: number);
    /**
     * @stability stable
     */
    resetDefaultUid(): void;
    /**
     * @stability stable
     */
    get defaultUidInput(): number | undefined;
    private _mountPath?;
    /**
     * @stability stable
     */
    get mountPath(): string;
    /**
     * @stability stable
     */
    set mountPath(value: string);
    /**
     * @stability stable
     */
    resetMountPath(): void;
    /**
     * @stability stable
     */
    get mountPathInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface SagemakerAppImageConfigKernelGatewayImageConfigKernelSpec {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_app_image_config#display_name SagemakerAppImageConfig#display_name}.
     *
     * @stability stable
     */
    readonly displayName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_app_image_config#name SagemakerAppImageConfig#name}.
     *
     * @stability stable
     */
    readonly name: string;
}
export declare function sagemakerAppImageConfigKernelGatewayImageConfigKernelSpecToTerraform(struct?: SagemakerAppImageConfigKernelGatewayImageConfigKernelSpecOutputReference | SagemakerAppImageConfigKernelGatewayImageConfigKernelSpec): any;
/**
 * @stability stable
 */
export declare class SagemakerAppImageConfigKernelGatewayImageConfigKernelSpecOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerAppImageConfigKernelGatewayImageConfigKernelSpec | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerAppImageConfigKernelGatewayImageConfigKernelSpec | undefined);
    private _displayName?;
    /**
     * @stability stable
     */
    get displayName(): string;
    /**
     * @stability stable
     */
    set displayName(value: string);
    /**
     * @stability stable
     */
    resetDisplayName(): void;
    /**
     * @stability stable
     */
    get displayNameInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface SagemakerAppImageConfigKernelGatewayImageConfig {
    /**
     * file_system_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_app_image_config#file_system_config SagemakerAppImageConfig#file_system_config}
     *
     * @stability stable
     */
    readonly fileSystemConfig?: SagemakerAppImageConfigKernelGatewayImageConfigFileSystemConfig;
    /**
     * kernel_spec block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_app_image_config#kernel_spec SagemakerAppImageConfig#kernel_spec}
     *
     * @stability stable
     */
    readonly kernelSpec: SagemakerAppImageConfigKernelGatewayImageConfigKernelSpec;
}
export declare function sagemakerAppImageConfigKernelGatewayImageConfigToTerraform(struct?: SagemakerAppImageConfigKernelGatewayImageConfigOutputReference | SagemakerAppImageConfigKernelGatewayImageConfig): any;
/**
 * @stability stable
 */
export declare class SagemakerAppImageConfigKernelGatewayImageConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerAppImageConfigKernelGatewayImageConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerAppImageConfigKernelGatewayImageConfig | undefined);
    private _fileSystemConfig;
    /**
     * @stability stable
     */
    get fileSystemConfig(): SagemakerAppImageConfigKernelGatewayImageConfigFileSystemConfigOutputReference;
    /**
     * @stability stable
     */
    putFileSystemConfig(value: SagemakerAppImageConfigKernelGatewayImageConfigFileSystemConfig): void;
    /**
     * @stability stable
     */
    resetFileSystemConfig(): void;
    /**
     * @stability stable
     */
    get fileSystemConfigInput(): SagemakerAppImageConfigKernelGatewayImageConfigFileSystemConfig | undefined;
    private _kernelSpec;
    /**
     * @stability stable
     */
    get kernelSpec(): SagemakerAppImageConfigKernelGatewayImageConfigKernelSpecOutputReference;
    /**
     * @stability stable
     */
    putKernelSpec(value: SagemakerAppImageConfigKernelGatewayImageConfigKernelSpec): void;
    /**
     * @stability stable
     */
    get kernelSpecInput(): SagemakerAppImageConfigKernelGatewayImageConfigKernelSpec | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_app_image_config aws_sagemaker_app_image_config}.
 *
 * @stability stable
 */
export declare class SagemakerAppImageConfig extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_app_image_config aws_sagemaker_app_image_config} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SagemakerAppImageConfigConfig);
    private _appImageConfigName?;
    /**
     * @stability stable
     */
    get appImageConfigName(): string;
    /**
     * @stability stable
     */
    set appImageConfigName(value: string);
    /**
     * @stability stable
     */
    get appImageConfigNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _kernelGatewayImageConfig;
    /**
     * @stability stable
     */
    get kernelGatewayImageConfig(): SagemakerAppImageConfigKernelGatewayImageConfigOutputReference;
    /**
     * @stability stable
     */
    putKernelGatewayImageConfig(value: SagemakerAppImageConfigKernelGatewayImageConfig): void;
    /**
     * @stability stable
     */
    resetKernelGatewayImageConfig(): void;
    /**
     * @stability stable
     */
    get kernelGatewayImageConfigInput(): SagemakerAppImageConfigKernelGatewayImageConfig | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
