import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS SageMaker.
 *
 * @stability stable
 */
export interface SagemakerDeviceConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_device#device_fleet_name SagemakerDevice#device_fleet_name}.
     *
     * @stability stable
     */
    readonly deviceFleetName: string;
    /**
     * device block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_device#device SagemakerDevice#device}
     *
     * @stability stable
     */
    readonly device: SagemakerDeviceDevice;
}
/**
 * @stability stable
 */
export interface SagemakerDeviceDevice {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_device#description SagemakerDevice#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_device#device_name SagemakerDevice#device_name}.
     *
     * @stability stable
     */
    readonly deviceName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_device#iot_thing_name SagemakerDevice#iot_thing_name}.
     *
     * @stability stable
     */
    readonly iotThingName?: string;
}
export declare function sagemakerDeviceDeviceToTerraform(struct?: SagemakerDeviceDeviceOutputReference | SagemakerDeviceDevice): any;
/**
 * @stability stable
 */
export declare class SagemakerDeviceDeviceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerDeviceDevice | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerDeviceDevice | undefined);
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _deviceName?;
    /**
     * @stability stable
     */
    get deviceName(): string;
    /**
     * @stability stable
     */
    set deviceName(value: string);
    /**
     * @stability stable
     */
    get deviceNameInput(): string | undefined;
    private _iotThingName?;
    /**
     * @stability stable
     */
    get iotThingName(): string;
    /**
     * @stability stable
     */
    set iotThingName(value: string);
    /**
     * @stability stable
     */
    resetIotThingName(): void;
    /**
     * @stability stable
     */
    get iotThingNameInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_device aws_sagemaker_device}.
 *
 * @stability stable
 */
export declare class SagemakerDevice extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_device aws_sagemaker_device} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SagemakerDeviceConfig);
    /**
     * @stability stable
     */
    get agentVersion(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _deviceFleetName?;
    /**
     * @stability stable
     */
    get deviceFleetName(): string;
    /**
     * @stability stable
     */
    set deviceFleetName(value: string);
    /**
     * @stability stable
     */
    get deviceFleetNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _device;
    /**
     * @stability stable
     */
    get device(): SagemakerDeviceDeviceOutputReference;
    /**
     * @stability stable
     */
    putDevice(value: SagemakerDeviceDevice): void;
    /**
     * @stability stable
     */
    get deviceInput(): SagemakerDeviceDevice | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
