import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS SageMaker.
 *
 * @stability stable
 */
export interface SagemakerUserProfileConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#domain_id SagemakerUserProfile#domain_id}.
     *
     * @stability stable
     */
    readonly domainId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#single_sign_on_user_identifier SagemakerUserProfile#single_sign_on_user_identifier}.
     *
     * @stability stable
     */
    readonly singleSignOnUserIdentifier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#single_sign_on_user_value SagemakerUserProfile#single_sign_on_user_value}.
     *
     * @stability stable
     */
    readonly singleSignOnUserValue?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#tags SagemakerUserProfile#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#tags_all SagemakerUserProfile#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#user_profile_name SagemakerUserProfile#user_profile_name}.
     *
     * @stability stable
     */
    readonly userProfileName: string;
    /**
     * user_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#user_settings SagemakerUserProfile#user_settings}
     *
     * @stability stable
     */
    readonly userSettings?: SagemakerUserProfileUserSettings;
}
/**
 * @stability stable
 */
export interface SagemakerUserProfileUserSettingsJupyterServerAppSettingsDefaultResourceSpec {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#instance_type SagemakerUserProfile#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#lifecycle_config_arn SagemakerUserProfile#lifecycle_config_arn}.
     *
     * @stability stable
     */
    readonly lifecycleConfigArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#sagemaker_image_arn SagemakerUserProfile#sagemaker_image_arn}.
     *
     * @stability stable
     */
    readonly sagemakerImageArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#sagemaker_image_version_arn SagemakerUserProfile#sagemaker_image_version_arn}.
     *
     * @stability stable
     */
    readonly sagemakerImageVersionArn?: string;
}
export declare function sagemakerUserProfileUserSettingsJupyterServerAppSettingsDefaultResourceSpecToTerraform(struct?: SagemakerUserProfileUserSettingsJupyterServerAppSettingsDefaultResourceSpecOutputReference | SagemakerUserProfileUserSettingsJupyterServerAppSettingsDefaultResourceSpec): any;
/**
 * @stability stable
 */
export declare class SagemakerUserProfileUserSettingsJupyterServerAppSettingsDefaultResourceSpecOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerUserProfileUserSettingsJupyterServerAppSettingsDefaultResourceSpec | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerUserProfileUserSettingsJupyterServerAppSettingsDefaultResourceSpec | undefined);
    private _instanceType?;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    set instanceType(value: string);
    /**
     * @stability stable
     */
    resetInstanceType(): void;
    /**
     * @stability stable
     */
    get instanceTypeInput(): string | undefined;
    private _lifecycleConfigArn?;
    /**
     * @stability stable
     */
    get lifecycleConfigArn(): string;
    /**
     * @stability stable
     */
    set lifecycleConfigArn(value: string);
    /**
     * @stability stable
     */
    resetLifecycleConfigArn(): void;
    /**
     * @stability stable
     */
    get lifecycleConfigArnInput(): string | undefined;
    private _sagemakerImageArn?;
    /**
     * @stability stable
     */
    get sagemakerImageArn(): string;
    /**
     * @stability stable
     */
    set sagemakerImageArn(value: string);
    /**
     * @stability stable
     */
    resetSagemakerImageArn(): void;
    /**
     * @stability stable
     */
    get sagemakerImageArnInput(): string | undefined;
    private _sagemakerImageVersionArn?;
    /**
     * @stability stable
     */
    get sagemakerImageVersionArn(): string;
    /**
     * @stability stable
     */
    set sagemakerImageVersionArn(value: string);
    /**
     * @stability stable
     */
    resetSagemakerImageVersionArn(): void;
    /**
     * @stability stable
     */
    get sagemakerImageVersionArnInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface SagemakerUserProfileUserSettingsJupyterServerAppSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#lifecycle_config_arns SagemakerUserProfile#lifecycle_config_arns}.
     *
     * @stability stable
     */
    readonly lifecycleConfigArns?: string[];
    /**
     * default_resource_spec block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#default_resource_spec SagemakerUserProfile#default_resource_spec}
     *
     * @stability stable
     */
    readonly defaultResourceSpec: SagemakerUserProfileUserSettingsJupyterServerAppSettingsDefaultResourceSpec;
}
export declare function sagemakerUserProfileUserSettingsJupyterServerAppSettingsToTerraform(struct?: SagemakerUserProfileUserSettingsJupyterServerAppSettingsOutputReference | SagemakerUserProfileUserSettingsJupyterServerAppSettings): any;
/**
 * @stability stable
 */
export declare class SagemakerUserProfileUserSettingsJupyterServerAppSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerUserProfileUserSettingsJupyterServerAppSettings | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerUserProfileUserSettingsJupyterServerAppSettings | undefined);
    private _lifecycleConfigArns?;
    /**
     * @stability stable
     */
    get lifecycleConfigArns(): string[];
    /**
     * @stability stable
     */
    set lifecycleConfigArns(value: string[]);
    /**
     * @stability stable
     */
    resetLifecycleConfigArns(): void;
    /**
     * @stability stable
     */
    get lifecycleConfigArnsInput(): string[] | undefined;
    private _defaultResourceSpec;
    /**
     * @stability stable
     */
    get defaultResourceSpec(): SagemakerUserProfileUserSettingsJupyterServerAppSettingsDefaultResourceSpecOutputReference;
    /**
     * @stability stable
     */
    putDefaultResourceSpec(value: SagemakerUserProfileUserSettingsJupyterServerAppSettingsDefaultResourceSpec): void;
    /**
     * @stability stable
     */
    get defaultResourceSpecInput(): SagemakerUserProfileUserSettingsJupyterServerAppSettingsDefaultResourceSpec | undefined;
}
/**
 * @stability stable
 */
export interface SagemakerUserProfileUserSettingsKernelGatewayAppSettingsCustomImage {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#app_image_config_name SagemakerUserProfile#app_image_config_name}.
     *
     * @stability stable
     */
    readonly appImageConfigName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#image_name SagemakerUserProfile#image_name}.
     *
     * @stability stable
     */
    readonly imageName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#image_version_number SagemakerUserProfile#image_version_number}.
     *
     * @stability stable
     */
    readonly imageVersionNumber?: number;
}
export declare function sagemakerUserProfileUserSettingsKernelGatewayAppSettingsCustomImageToTerraform(struct?: SagemakerUserProfileUserSettingsKernelGatewayAppSettingsCustomImage | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface SagemakerUserProfileUserSettingsKernelGatewayAppSettingsDefaultResourceSpec {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#instance_type SagemakerUserProfile#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#lifecycle_config_arn SagemakerUserProfile#lifecycle_config_arn}.
     *
     * @stability stable
     */
    readonly lifecycleConfigArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#sagemaker_image_arn SagemakerUserProfile#sagemaker_image_arn}.
     *
     * @stability stable
     */
    readonly sagemakerImageArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#sagemaker_image_version_arn SagemakerUserProfile#sagemaker_image_version_arn}.
     *
     * @stability stable
     */
    readonly sagemakerImageVersionArn?: string;
}
export declare function sagemakerUserProfileUserSettingsKernelGatewayAppSettingsDefaultResourceSpecToTerraform(struct?: SagemakerUserProfileUserSettingsKernelGatewayAppSettingsDefaultResourceSpecOutputReference | SagemakerUserProfileUserSettingsKernelGatewayAppSettingsDefaultResourceSpec): any;
/**
 * @stability stable
 */
export declare class SagemakerUserProfileUserSettingsKernelGatewayAppSettingsDefaultResourceSpecOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerUserProfileUserSettingsKernelGatewayAppSettingsDefaultResourceSpec | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerUserProfileUserSettingsKernelGatewayAppSettingsDefaultResourceSpec | undefined);
    private _instanceType?;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    set instanceType(value: string);
    /**
     * @stability stable
     */
    resetInstanceType(): void;
    /**
     * @stability stable
     */
    get instanceTypeInput(): string | undefined;
    private _lifecycleConfigArn?;
    /**
     * @stability stable
     */
    get lifecycleConfigArn(): string;
    /**
     * @stability stable
     */
    set lifecycleConfigArn(value: string);
    /**
     * @stability stable
     */
    resetLifecycleConfigArn(): void;
    /**
     * @stability stable
     */
    get lifecycleConfigArnInput(): string | undefined;
    private _sagemakerImageArn?;
    /**
     * @stability stable
     */
    get sagemakerImageArn(): string;
    /**
     * @stability stable
     */
    set sagemakerImageArn(value: string);
    /**
     * @stability stable
     */
    resetSagemakerImageArn(): void;
    /**
     * @stability stable
     */
    get sagemakerImageArnInput(): string | undefined;
    private _sagemakerImageVersionArn?;
    /**
     * @stability stable
     */
    get sagemakerImageVersionArn(): string;
    /**
     * @stability stable
     */
    set sagemakerImageVersionArn(value: string);
    /**
     * @stability stable
     */
    resetSagemakerImageVersionArn(): void;
    /**
     * @stability stable
     */
    get sagemakerImageVersionArnInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface SagemakerUserProfileUserSettingsKernelGatewayAppSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#lifecycle_config_arns SagemakerUserProfile#lifecycle_config_arns}.
     *
     * @stability stable
     */
    readonly lifecycleConfigArns?: string[];
    /**
     * custom_image block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#custom_image SagemakerUserProfile#custom_image}
     *
     * @stability stable
     */
    readonly customImage?: SagemakerUserProfileUserSettingsKernelGatewayAppSettingsCustomImage[] | cdktf.IResolvable;
    /**
     * default_resource_spec block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#default_resource_spec SagemakerUserProfile#default_resource_spec}
     *
     * @stability stable
     */
    readonly defaultResourceSpec: SagemakerUserProfileUserSettingsKernelGatewayAppSettingsDefaultResourceSpec;
}
export declare function sagemakerUserProfileUserSettingsKernelGatewayAppSettingsToTerraform(struct?: SagemakerUserProfileUserSettingsKernelGatewayAppSettingsOutputReference | SagemakerUserProfileUserSettingsKernelGatewayAppSettings): any;
/**
 * @stability stable
 */
export declare class SagemakerUserProfileUserSettingsKernelGatewayAppSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerUserProfileUserSettingsKernelGatewayAppSettings | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerUserProfileUserSettingsKernelGatewayAppSettings | undefined);
    private _lifecycleConfigArns?;
    /**
     * @stability stable
     */
    get lifecycleConfigArns(): string[];
    /**
     * @stability stable
     */
    set lifecycleConfigArns(value: string[]);
    /**
     * @stability stable
     */
    resetLifecycleConfigArns(): void;
    /**
     * @stability stable
     */
    get lifecycleConfigArnsInput(): string[] | undefined;
    private _customImage?;
    /**
     * @stability stable
     */
    get customImage(): SagemakerUserProfileUserSettingsKernelGatewayAppSettingsCustomImage[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set customImage(value: SagemakerUserProfileUserSettingsKernelGatewayAppSettingsCustomImage[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetCustomImage(): void;
    /**
     * @stability stable
     */
    get customImageInput(): cdktf.IResolvable | SagemakerUserProfileUserSettingsKernelGatewayAppSettingsCustomImage[] | undefined;
    private _defaultResourceSpec;
    /**
     * @stability stable
     */
    get defaultResourceSpec(): SagemakerUserProfileUserSettingsKernelGatewayAppSettingsDefaultResourceSpecOutputReference;
    /**
     * @stability stable
     */
    putDefaultResourceSpec(value: SagemakerUserProfileUserSettingsKernelGatewayAppSettingsDefaultResourceSpec): void;
    /**
     * @stability stable
     */
    get defaultResourceSpecInput(): SagemakerUserProfileUserSettingsKernelGatewayAppSettingsDefaultResourceSpec | undefined;
}
/**
 * @stability stable
 */
export interface SagemakerUserProfileUserSettingsSharingSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#notebook_output_option SagemakerUserProfile#notebook_output_option}.
     *
     * @stability stable
     */
    readonly notebookOutputOption?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#s3_kms_key_id SagemakerUserProfile#s3_kms_key_id}.
     *
     * @stability stable
     */
    readonly s3KmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#s3_output_path SagemakerUserProfile#s3_output_path}.
     *
     * @stability stable
     */
    readonly s3OutputPath?: string;
}
export declare function sagemakerUserProfileUserSettingsSharingSettingsToTerraform(struct?: SagemakerUserProfileUserSettingsSharingSettingsOutputReference | SagemakerUserProfileUserSettingsSharingSettings): any;
/**
 * @stability stable
 */
export declare class SagemakerUserProfileUserSettingsSharingSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerUserProfileUserSettingsSharingSettings | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerUserProfileUserSettingsSharingSettings | undefined);
    private _notebookOutputOption?;
    /**
     * @stability stable
     */
    get notebookOutputOption(): string;
    /**
     * @stability stable
     */
    set notebookOutputOption(value: string);
    /**
     * @stability stable
     */
    resetNotebookOutputOption(): void;
    /**
     * @stability stable
     */
    get notebookOutputOptionInput(): string | undefined;
    private _s3KmsKeyId?;
    /**
     * @stability stable
     */
    get s3KmsKeyId(): string;
    /**
     * @stability stable
     */
    set s3KmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetS3KmsKeyId(): void;
    /**
     * @stability stable
     */
    get s3KmsKeyIdInput(): string | undefined;
    private _s3OutputPath?;
    /**
     * @stability stable
     */
    get s3OutputPath(): string;
    /**
     * @stability stable
     */
    set s3OutputPath(value: string);
    /**
     * @stability stable
     */
    resetS3OutputPath(): void;
    /**
     * @stability stable
     */
    get s3OutputPathInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface SagemakerUserProfileUserSettingsTensorBoardAppSettingsDefaultResourceSpec {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#instance_type SagemakerUserProfile#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#lifecycle_config_arn SagemakerUserProfile#lifecycle_config_arn}.
     *
     * @stability stable
     */
    readonly lifecycleConfigArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#sagemaker_image_arn SagemakerUserProfile#sagemaker_image_arn}.
     *
     * @stability stable
     */
    readonly sagemakerImageArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#sagemaker_image_version_arn SagemakerUserProfile#sagemaker_image_version_arn}.
     *
     * @stability stable
     */
    readonly sagemakerImageVersionArn?: string;
}
export declare function sagemakerUserProfileUserSettingsTensorBoardAppSettingsDefaultResourceSpecToTerraform(struct?: SagemakerUserProfileUserSettingsTensorBoardAppSettingsDefaultResourceSpecOutputReference | SagemakerUserProfileUserSettingsTensorBoardAppSettingsDefaultResourceSpec): any;
/**
 * @stability stable
 */
export declare class SagemakerUserProfileUserSettingsTensorBoardAppSettingsDefaultResourceSpecOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerUserProfileUserSettingsTensorBoardAppSettingsDefaultResourceSpec | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerUserProfileUserSettingsTensorBoardAppSettingsDefaultResourceSpec | undefined);
    private _instanceType?;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    set instanceType(value: string);
    /**
     * @stability stable
     */
    resetInstanceType(): void;
    /**
     * @stability stable
     */
    get instanceTypeInput(): string | undefined;
    private _lifecycleConfigArn?;
    /**
     * @stability stable
     */
    get lifecycleConfigArn(): string;
    /**
     * @stability stable
     */
    set lifecycleConfigArn(value: string);
    /**
     * @stability stable
     */
    resetLifecycleConfigArn(): void;
    /**
     * @stability stable
     */
    get lifecycleConfigArnInput(): string | undefined;
    private _sagemakerImageArn?;
    /**
     * @stability stable
     */
    get sagemakerImageArn(): string;
    /**
     * @stability stable
     */
    set sagemakerImageArn(value: string);
    /**
     * @stability stable
     */
    resetSagemakerImageArn(): void;
    /**
     * @stability stable
     */
    get sagemakerImageArnInput(): string | undefined;
    private _sagemakerImageVersionArn?;
    /**
     * @stability stable
     */
    get sagemakerImageVersionArn(): string;
    /**
     * @stability stable
     */
    set sagemakerImageVersionArn(value: string);
    /**
     * @stability stable
     */
    resetSagemakerImageVersionArn(): void;
    /**
     * @stability stable
     */
    get sagemakerImageVersionArnInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface SagemakerUserProfileUserSettingsTensorBoardAppSettings {
    /**
     * default_resource_spec block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#default_resource_spec SagemakerUserProfile#default_resource_spec}
     *
     * @stability stable
     */
    readonly defaultResourceSpec: SagemakerUserProfileUserSettingsTensorBoardAppSettingsDefaultResourceSpec;
}
export declare function sagemakerUserProfileUserSettingsTensorBoardAppSettingsToTerraform(struct?: SagemakerUserProfileUserSettingsTensorBoardAppSettingsOutputReference | SagemakerUserProfileUserSettingsTensorBoardAppSettings): any;
/**
 * @stability stable
 */
export declare class SagemakerUserProfileUserSettingsTensorBoardAppSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerUserProfileUserSettingsTensorBoardAppSettings | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerUserProfileUserSettingsTensorBoardAppSettings | undefined);
    private _defaultResourceSpec;
    /**
     * @stability stable
     */
    get defaultResourceSpec(): SagemakerUserProfileUserSettingsTensorBoardAppSettingsDefaultResourceSpecOutputReference;
    /**
     * @stability stable
     */
    putDefaultResourceSpec(value: SagemakerUserProfileUserSettingsTensorBoardAppSettingsDefaultResourceSpec): void;
    /**
     * @stability stable
     */
    get defaultResourceSpecInput(): SagemakerUserProfileUserSettingsTensorBoardAppSettingsDefaultResourceSpec | undefined;
}
/**
 * @stability stable
 */
export interface SagemakerUserProfileUserSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#execution_role SagemakerUserProfile#execution_role}.
     *
     * @stability stable
     */
    readonly executionRole: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#security_groups SagemakerUserProfile#security_groups}.
     *
     * @stability stable
     */
    readonly securityGroups?: string[];
    /**
     * jupyter_server_app_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#jupyter_server_app_settings SagemakerUserProfile#jupyter_server_app_settings}
     *
     * @stability stable
     */
    readonly jupyterServerAppSettings?: SagemakerUserProfileUserSettingsJupyterServerAppSettings;
    /**
     * kernel_gateway_app_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#kernel_gateway_app_settings SagemakerUserProfile#kernel_gateway_app_settings}
     *
     * @stability stable
     */
    readonly kernelGatewayAppSettings?: SagemakerUserProfileUserSettingsKernelGatewayAppSettings;
    /**
     * sharing_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#sharing_settings SagemakerUserProfile#sharing_settings}
     *
     * @stability stable
     */
    readonly sharingSettings?: SagemakerUserProfileUserSettingsSharingSettings;
    /**
     * tensor_board_app_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile#tensor_board_app_settings SagemakerUserProfile#tensor_board_app_settings}
     *
     * @stability stable
     */
    readonly tensorBoardAppSettings?: SagemakerUserProfileUserSettingsTensorBoardAppSettings;
}
export declare function sagemakerUserProfileUserSettingsToTerraform(struct?: SagemakerUserProfileUserSettingsOutputReference | SagemakerUserProfileUserSettings): any;
/**
 * @stability stable
 */
export declare class SagemakerUserProfileUserSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerUserProfileUserSettings | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerUserProfileUserSettings | undefined);
    private _executionRole?;
    /**
     * @stability stable
     */
    get executionRole(): string;
    /**
     * @stability stable
     */
    set executionRole(value: string);
    /**
     * @stability stable
     */
    get executionRoleInput(): string | undefined;
    private _securityGroups?;
    /**
     * @stability stable
     */
    get securityGroups(): string[];
    /**
     * @stability stable
     */
    set securityGroups(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroups(): void;
    /**
     * @stability stable
     */
    get securityGroupsInput(): string[] | undefined;
    private _jupyterServerAppSettings;
    /**
     * @stability stable
     */
    get jupyterServerAppSettings(): SagemakerUserProfileUserSettingsJupyterServerAppSettingsOutputReference;
    /**
     * @stability stable
     */
    putJupyterServerAppSettings(value: SagemakerUserProfileUserSettingsJupyterServerAppSettings): void;
    /**
     * @stability stable
     */
    resetJupyterServerAppSettings(): void;
    /**
     * @stability stable
     */
    get jupyterServerAppSettingsInput(): SagemakerUserProfileUserSettingsJupyterServerAppSettings | undefined;
    private _kernelGatewayAppSettings;
    /**
     * @stability stable
     */
    get kernelGatewayAppSettings(): SagemakerUserProfileUserSettingsKernelGatewayAppSettingsOutputReference;
    /**
     * @stability stable
     */
    putKernelGatewayAppSettings(value: SagemakerUserProfileUserSettingsKernelGatewayAppSettings): void;
    /**
     * @stability stable
     */
    resetKernelGatewayAppSettings(): void;
    /**
     * @stability stable
     */
    get kernelGatewayAppSettingsInput(): SagemakerUserProfileUserSettingsKernelGatewayAppSettings | undefined;
    private _sharingSettings;
    /**
     * @stability stable
     */
    get sharingSettings(): SagemakerUserProfileUserSettingsSharingSettingsOutputReference;
    /**
     * @stability stable
     */
    putSharingSettings(value: SagemakerUserProfileUserSettingsSharingSettings): void;
    /**
     * @stability stable
     */
    resetSharingSettings(): void;
    /**
     * @stability stable
     */
    get sharingSettingsInput(): SagemakerUserProfileUserSettingsSharingSettings | undefined;
    private _tensorBoardAppSettings;
    /**
     * @stability stable
     */
    get tensorBoardAppSettings(): SagemakerUserProfileUserSettingsTensorBoardAppSettingsOutputReference;
    /**
     * @stability stable
     */
    putTensorBoardAppSettings(value: SagemakerUserProfileUserSettingsTensorBoardAppSettings): void;
    /**
     * @stability stable
     */
    resetTensorBoardAppSettings(): void;
    /**
     * @stability stable
     */
    get tensorBoardAppSettingsInput(): SagemakerUserProfileUserSettingsTensorBoardAppSettings | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile aws_sagemaker_user_profile}.
 *
 * @stability stable
 */
export declare class SagemakerUserProfile extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_user_profile aws_sagemaker_user_profile} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SagemakerUserProfileConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _domainId?;
    /**
     * @stability stable
     */
    get domainId(): string;
    /**
     * @stability stable
     */
    set domainId(value: string);
    /**
     * @stability stable
     */
    get domainIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get homeEfsFileSystemUid(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _singleSignOnUserIdentifier?;
    /**
     * @stability stable
     */
    get singleSignOnUserIdentifier(): string;
    /**
     * @stability stable
     */
    set singleSignOnUserIdentifier(value: string);
    /**
     * @stability stable
     */
    resetSingleSignOnUserIdentifier(): void;
    /**
     * @stability stable
     */
    get singleSignOnUserIdentifierInput(): string | undefined;
    private _singleSignOnUserValue?;
    /**
     * @stability stable
     */
    get singleSignOnUserValue(): string;
    /**
     * @stability stable
     */
    set singleSignOnUserValue(value: string);
    /**
     * @stability stable
     */
    resetSingleSignOnUserValue(): void;
    /**
     * @stability stable
     */
    get singleSignOnUserValueInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _userProfileName?;
    /**
     * @stability stable
     */
    get userProfileName(): string;
    /**
     * @stability stable
     */
    set userProfileName(value: string);
    /**
     * @stability stable
     */
    get userProfileNameInput(): string | undefined;
    private _userSettings;
    /**
     * @stability stable
     */
    get userSettings(): SagemakerUserProfileUserSettingsOutputReference;
    /**
     * @stability stable
     */
    putUserSettings(value: SagemakerUserProfileUserSettings): void;
    /**
     * @stability stable
     */
    resetUserSettings(): void;
    /**
     * @stability stable
     */
    get userSettingsInput(): SagemakerUserProfileUserSettings | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
