import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS SageMaker.
 *
 * @stability stable
 */
export interface SagemakerWorkteamConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam#description SagemakerWorkteam#description}.
     *
     * @stability stable
     */
    readonly description: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam#tags SagemakerWorkteam#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam#tags_all SagemakerWorkteam#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam#workforce_name SagemakerWorkteam#workforce_name}.
     *
     * @stability stable
     */
    readonly workforceName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam#workteam_name SagemakerWorkteam#workteam_name}.
     *
     * @stability stable
     */
    readonly workteamName: string;
    /**
     * member_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam#member_definition SagemakerWorkteam#member_definition}
     *
     * @stability stable
     */
    readonly memberDefinition: SagemakerWorkteamMemberDefinition[] | cdktf.IResolvable;
    /**
     * notification_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam#notification_configuration SagemakerWorkteam#notification_configuration}
     *
     * @stability stable
     */
    readonly notificationConfiguration?: SagemakerWorkteamNotificationConfiguration;
}
/**
 * @stability stable
 */
export interface SagemakerWorkteamMemberDefinitionCognitoMemberDefinition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam#client_id SagemakerWorkteam#client_id}.
     *
     * @stability stable
     */
    readonly clientId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam#user_group SagemakerWorkteam#user_group}.
     *
     * @stability stable
     */
    readonly userGroup: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam#user_pool SagemakerWorkteam#user_pool}.
     *
     * @stability stable
     */
    readonly userPool: string;
}
export declare function sagemakerWorkteamMemberDefinitionCognitoMemberDefinitionToTerraform(struct?: SagemakerWorkteamMemberDefinitionCognitoMemberDefinitionOutputReference | SagemakerWorkteamMemberDefinitionCognitoMemberDefinition): any;
/**
 * @stability stable
 */
export declare class SagemakerWorkteamMemberDefinitionCognitoMemberDefinitionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerWorkteamMemberDefinitionCognitoMemberDefinition | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerWorkteamMemberDefinitionCognitoMemberDefinition | undefined);
    private _clientId?;
    /**
     * @stability stable
     */
    get clientId(): string;
    /**
     * @stability stable
     */
    set clientId(value: string);
    /**
     * @stability stable
     */
    get clientIdInput(): string | undefined;
    private _userGroup?;
    /**
     * @stability stable
     */
    get userGroup(): string;
    /**
     * @stability stable
     */
    set userGroup(value: string);
    /**
     * @stability stable
     */
    get userGroupInput(): string | undefined;
    private _userPool?;
    /**
     * @stability stable
     */
    get userPool(): string;
    /**
     * @stability stable
     */
    set userPool(value: string);
    /**
     * @stability stable
     */
    get userPoolInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface SagemakerWorkteamMemberDefinitionOidcMemberDefinition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam#groups SagemakerWorkteam#groups}.
     *
     * @stability stable
     */
    readonly groups: string[];
}
export declare function sagemakerWorkteamMemberDefinitionOidcMemberDefinitionToTerraform(struct?: SagemakerWorkteamMemberDefinitionOidcMemberDefinitionOutputReference | SagemakerWorkteamMemberDefinitionOidcMemberDefinition): any;
/**
 * @stability stable
 */
export declare class SagemakerWorkteamMemberDefinitionOidcMemberDefinitionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerWorkteamMemberDefinitionOidcMemberDefinition | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerWorkteamMemberDefinitionOidcMemberDefinition | undefined);
    private _groups?;
    /**
     * @stability stable
     */
    get groups(): string[];
    /**
     * @stability stable
     */
    set groups(value: string[]);
    /**
     * @stability stable
     */
    get groupsInput(): string[] | undefined;
}
/**
 * @stability stable
 */
export interface SagemakerWorkteamMemberDefinition {
    /**
     * cognito_member_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam#cognito_member_definition SagemakerWorkteam#cognito_member_definition}
     *
     * @stability stable
     */
    readonly cognitoMemberDefinition?: SagemakerWorkteamMemberDefinitionCognitoMemberDefinition;
    /**
     * oidc_member_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam#oidc_member_definition SagemakerWorkteam#oidc_member_definition}
     *
     * @stability stable
     */
    readonly oidcMemberDefinition?: SagemakerWorkteamMemberDefinitionOidcMemberDefinition;
}
export declare function sagemakerWorkteamMemberDefinitionToTerraform(struct?: SagemakerWorkteamMemberDefinition | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface SagemakerWorkteamNotificationConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam#notification_topic_arn SagemakerWorkteam#notification_topic_arn}.
     *
     * @stability stable
     */
    readonly notificationTopicArn?: string;
}
export declare function sagemakerWorkteamNotificationConfigurationToTerraform(struct?: SagemakerWorkteamNotificationConfigurationOutputReference | SagemakerWorkteamNotificationConfiguration): any;
/**
 * @stability stable
 */
export declare class SagemakerWorkteamNotificationConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerWorkteamNotificationConfiguration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerWorkteamNotificationConfiguration | undefined);
    private _notificationTopicArn?;
    /**
     * @stability stable
     */
    get notificationTopicArn(): string;
    /**
     * @stability stable
     */
    set notificationTopicArn(value: string);
    /**
     * @stability stable
     */
    resetNotificationTopicArn(): void;
    /**
     * @stability stable
     */
    get notificationTopicArnInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam aws_sagemaker_workteam}.
 *
 * @stability stable
 */
export declare class SagemakerWorkteam extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_workteam aws_sagemaker_workteam} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SagemakerWorkteamConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get subdomain(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _workforceName?;
    /**
     * @stability stable
     */
    get workforceName(): string;
    /**
     * @stability stable
     */
    set workforceName(value: string);
    /**
     * @stability stable
     */
    get workforceNameInput(): string | undefined;
    private _workteamName?;
    /**
     * @stability stable
     */
    get workteamName(): string;
    /**
     * @stability stable
     */
    set workteamName(value: string);
    /**
     * @stability stable
     */
    get workteamNameInput(): string | undefined;
    private _memberDefinition?;
    /**
     * @stability stable
     */
    get memberDefinition(): SagemakerWorkteamMemberDefinition[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set memberDefinition(value: SagemakerWorkteamMemberDefinition[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get memberDefinitionInput(): cdktf.IResolvable | SagemakerWorkteamMemberDefinition[] | undefined;
    private _notificationConfiguration;
    /**
     * @stability stable
     */
    get notificationConfiguration(): SagemakerWorkteamNotificationConfigurationOutputReference;
    /**
     * @stability stable
     */
    putNotificationConfiguration(value: SagemakerWorkteamNotificationConfiguration): void;
    /**
     * @stability stable
     */
    resetNotificationConfiguration(): void;
    /**
     * @stability stable
     */
    get notificationConfigurationInput(): SagemakerWorkteamNotificationConfiguration | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
