import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Security Hub.
 *
 * @stability stable
 */
export interface SecurityhubProductSubscriptionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_product_subscription#product_arn SecurityhubProductSubscription#product_arn}.
     *
     * @stability stable
     */
    readonly productArn: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/securityhub_product_subscription aws_securityhub_product_subscription}.
 *
 * @stability stable
 */
export declare class SecurityhubProductSubscription extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/securityhub_product_subscription aws_securityhub_product_subscription} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SecurityhubProductSubscriptionConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _productArn?;
    /**
     * @stability stable
     */
    get productArn(): string;
    /**
     * @stability stable
     */
    set productArn(value: string);
    /**
     * @stability stable
     */
    get productArnInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
