import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Service Catalog.
 *
 * @stability stable
 */
export interface ServicecatalogBudgetResourceAssociationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_budget_resource_association#budget_name ServicecatalogBudgetResourceAssociation#budget_name}.
     *
     * @stability stable
     */
    readonly budgetName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_budget_resource_association#resource_id ServicecatalogBudgetResourceAssociation#resource_id}.
     *
     * @stability stable
     */
    readonly resourceId: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_budget_resource_association aws_servicecatalog_budget_resource_association}.
 *
 * @stability stable
 */
export declare class ServicecatalogBudgetResourceAssociation extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_budget_resource_association aws_servicecatalog_budget_resource_association} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ServicecatalogBudgetResourceAssociationConfig);
    private _budgetName?;
    /**
     * @stability stable
     */
    get budgetName(): string;
    /**
     * @stability stable
     */
    set budgetName(value: string);
    /**
     * @stability stable
     */
    get budgetNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _resourceId?;
    /**
     * @stability stable
     */
    get resourceId(): string;
    /**
     * @stability stable
     */
    set resourceId(value: string);
    /**
     * @stability stable
     */
    get resourceIdInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
