import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Simple Email Service.
 *
 * @stability stable
 */
export interface SesIdentityNotificationTopicConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_identity_notification_topic#identity SesIdentityNotificationTopic#identity}.
     *
     * @stability stable
     */
    readonly identity: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_identity_notification_topic#include_original_headers SesIdentityNotificationTopic#include_original_headers}.
     *
     * @stability stable
     */
    readonly includeOriginalHeaders?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_identity_notification_topic#notification_type SesIdentityNotificationTopic#notification_type}.
     *
     * @stability stable
     */
    readonly notificationType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_identity_notification_topic#topic_arn SesIdentityNotificationTopic#topic_arn}.
     *
     * @stability stable
     */
    readonly topicArn?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ses_identity_notification_topic aws_ses_identity_notification_topic}.
 *
 * @stability stable
 */
export declare class SesIdentityNotificationTopic extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ses_identity_notification_topic aws_ses_identity_notification_topic} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SesIdentityNotificationTopicConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _identity?;
    /**
     * @stability stable
     */
    get identity(): string;
    /**
     * @stability stable
     */
    set identity(value: string);
    /**
     * @stability stable
     */
    get identityInput(): string | undefined;
    private _includeOriginalHeaders?;
    /**
     * @stability stable
     */
    get includeOriginalHeaders(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set includeOriginalHeaders(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIncludeOriginalHeaders(): void;
    /**
     * @stability stable
     */
    get includeOriginalHeadersInput(): boolean | cdktf.IResolvable | undefined;
    private _notificationType?;
    /**
     * @stability stable
     */
    get notificationType(): string;
    /**
     * @stability stable
     */
    set notificationType(value: string);
    /**
     * @stability stable
     */
    get notificationTypeInput(): string | undefined;
    private _topicArn?;
    /**
     * @stability stable
     */
    get topicArn(): string;
    /**
     * @stability stable
     */
    set topicArn(value: string);
    /**
     * @stability stable
     */
    resetTopicArn(): void;
    /**
     * @stability stable
     */
    get topicArnInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
