import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Simple Email Service.
 *
 * @stability stable
 */
export interface SesReceiptRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#after SesReceiptRule#after}.
     *
     * @stability stable
     */
    readonly after?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#enabled SesReceiptRule#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#name SesReceiptRule#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#recipients SesReceiptRule#recipients}.
     *
     * @stability stable
     */
    readonly recipients?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#rule_set_name SesReceiptRule#rule_set_name}.
     *
     * @stability stable
     */
    readonly ruleSetName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#scan_enabled SesReceiptRule#scan_enabled}.
     *
     * @stability stable
     */
    readonly scanEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#tls_policy SesReceiptRule#tls_policy}.
     *
     * @stability stable
     */
    readonly tlsPolicy?: string;
    /**
     * add_header_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#add_header_action SesReceiptRule#add_header_action}
     *
     * @stability stable
     */
    readonly addHeaderAction?: SesReceiptRuleAddHeaderAction[] | cdktf.IResolvable;
    /**
     * bounce_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#bounce_action SesReceiptRule#bounce_action}
     *
     * @stability stable
     */
    readonly bounceAction?: SesReceiptRuleBounceAction[] | cdktf.IResolvable;
    /**
     * lambda_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#lambda_action SesReceiptRule#lambda_action}
     *
     * @stability stable
     */
    readonly lambdaAction?: SesReceiptRuleLambdaAction[] | cdktf.IResolvable;
    /**
     * s3_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#s3_action SesReceiptRule#s3_action}
     *
     * @stability stable
     */
    readonly s3Action?: SesReceiptRuleS3Action[] | cdktf.IResolvable;
    /**
     * sns_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#sns_action SesReceiptRule#sns_action}
     *
     * @stability stable
     */
    readonly snsAction?: SesReceiptRuleSnsAction[] | cdktf.IResolvable;
    /**
     * stop_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#stop_action SesReceiptRule#stop_action}
     *
     * @stability stable
     */
    readonly stopAction?: SesReceiptRuleStopAction[] | cdktf.IResolvable;
    /**
     * workmail_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#workmail_action SesReceiptRule#workmail_action}
     *
     * @stability stable
     */
    readonly workmailAction?: SesReceiptRuleWorkmailAction[] | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface SesReceiptRuleAddHeaderAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#header_name SesReceiptRule#header_name}.
     *
     * @stability stable
     */
    readonly headerName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#header_value SesReceiptRule#header_value}.
     *
     * @stability stable
     */
    readonly headerValue: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#position SesReceiptRule#position}.
     *
     * @stability stable
     */
    readonly position: number;
}
export declare function sesReceiptRuleAddHeaderActionToTerraform(struct?: SesReceiptRuleAddHeaderAction | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface SesReceiptRuleBounceAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#message SesReceiptRule#message}.
     *
     * @stability stable
     */
    readonly message: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#position SesReceiptRule#position}.
     *
     * @stability stable
     */
    readonly position: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#sender SesReceiptRule#sender}.
     *
     * @stability stable
     */
    readonly sender: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#smtp_reply_code SesReceiptRule#smtp_reply_code}.
     *
     * @stability stable
     */
    readonly smtpReplyCode: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#status_code SesReceiptRule#status_code}.
     *
     * @stability stable
     */
    readonly statusCode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#topic_arn SesReceiptRule#topic_arn}.
     *
     * @stability stable
     */
    readonly topicArn?: string;
}
export declare function sesReceiptRuleBounceActionToTerraform(struct?: SesReceiptRuleBounceAction | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface SesReceiptRuleLambdaAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#function_arn SesReceiptRule#function_arn}.
     *
     * @stability stable
     */
    readonly functionArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#invocation_type SesReceiptRule#invocation_type}.
     *
     * @stability stable
     */
    readonly invocationType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#position SesReceiptRule#position}.
     *
     * @stability stable
     */
    readonly position: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#topic_arn SesReceiptRule#topic_arn}.
     *
     * @stability stable
     */
    readonly topicArn?: string;
}
export declare function sesReceiptRuleLambdaActionToTerraform(struct?: SesReceiptRuleLambdaAction | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface SesReceiptRuleS3Action {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#bucket_name SesReceiptRule#bucket_name}.
     *
     * @stability stable
     */
    readonly bucketName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#kms_key_arn SesReceiptRule#kms_key_arn}.
     *
     * @stability stable
     */
    readonly kmsKeyArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#object_key_prefix SesReceiptRule#object_key_prefix}.
     *
     * @stability stable
     */
    readonly objectKeyPrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#position SesReceiptRule#position}.
     *
     * @stability stable
     */
    readonly position: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#topic_arn SesReceiptRule#topic_arn}.
     *
     * @stability stable
     */
    readonly topicArn?: string;
}
export declare function sesReceiptRuleS3ActionToTerraform(struct?: SesReceiptRuleS3Action | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface SesReceiptRuleSnsAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#encoding SesReceiptRule#encoding}.
     *
     * @stability stable
     */
    readonly encoding?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#position SesReceiptRule#position}.
     *
     * @stability stable
     */
    readonly position: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#topic_arn SesReceiptRule#topic_arn}.
     *
     * @stability stable
     */
    readonly topicArn: string;
}
export declare function sesReceiptRuleSnsActionToTerraform(struct?: SesReceiptRuleSnsAction | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface SesReceiptRuleStopAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#position SesReceiptRule#position}.
     *
     * @stability stable
     */
    readonly position: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#scope SesReceiptRule#scope}.
     *
     * @stability stable
     */
    readonly scope: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#topic_arn SesReceiptRule#topic_arn}.
     *
     * @stability stable
     */
    readonly topicArn?: string;
}
export declare function sesReceiptRuleStopActionToTerraform(struct?: SesReceiptRuleStopAction | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface SesReceiptRuleWorkmailAction {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#organization_arn SesReceiptRule#organization_arn}.
     *
     * @stability stable
     */
    readonly organizationArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#position SesReceiptRule#position}.
     *
     * @stability stable
     */
    readonly position: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule#topic_arn SesReceiptRule#topic_arn}.
     *
     * @stability stable
     */
    readonly topicArn?: string;
}
export declare function sesReceiptRuleWorkmailActionToTerraform(struct?: SesReceiptRuleWorkmailAction | cdktf.IResolvable): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule aws_ses_receipt_rule}.
 *
 * @stability stable
 */
export declare class SesReceiptRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ses_receipt_rule aws_ses_receipt_rule} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SesReceiptRuleConfig);
    private _after?;
    /**
     * @stability stable
     */
    get after(): string;
    /**
     * @stability stable
     */
    set after(value: string);
    /**
     * @stability stable
     */
    resetAfter(): void;
    /**
     * @stability stable
     */
    get afterInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _recipients?;
    /**
     * @stability stable
     */
    get recipients(): string[];
    /**
     * @stability stable
     */
    set recipients(value: string[]);
    /**
     * @stability stable
     */
    resetRecipients(): void;
    /**
     * @stability stable
     */
    get recipientsInput(): string[] | undefined;
    private _ruleSetName?;
    /**
     * @stability stable
     */
    get ruleSetName(): string;
    /**
     * @stability stable
     */
    set ruleSetName(value: string);
    /**
     * @stability stable
     */
    get ruleSetNameInput(): string | undefined;
    private _scanEnabled?;
    /**
     * @stability stable
     */
    get scanEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set scanEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetScanEnabled(): void;
    /**
     * @stability stable
     */
    get scanEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _tlsPolicy?;
    /**
     * @stability stable
     */
    get tlsPolicy(): string;
    /**
     * @stability stable
     */
    set tlsPolicy(value: string);
    /**
     * @stability stable
     */
    resetTlsPolicy(): void;
    /**
     * @stability stable
     */
    get tlsPolicyInput(): string | undefined;
    private _addHeaderAction?;
    /**
     * @stability stable
     */
    get addHeaderAction(): SesReceiptRuleAddHeaderAction[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set addHeaderAction(value: SesReceiptRuleAddHeaderAction[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAddHeaderAction(): void;
    /**
     * @stability stable
     */
    get addHeaderActionInput(): cdktf.IResolvable | SesReceiptRuleAddHeaderAction[] | undefined;
    private _bounceAction?;
    /**
     * @stability stable
     */
    get bounceAction(): SesReceiptRuleBounceAction[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set bounceAction(value: SesReceiptRuleBounceAction[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetBounceAction(): void;
    /**
     * @stability stable
     */
    get bounceActionInput(): cdktf.IResolvable | SesReceiptRuleBounceAction[] | undefined;
    private _lambdaAction?;
    /**
     * @stability stable
     */
    get lambdaAction(): SesReceiptRuleLambdaAction[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set lambdaAction(value: SesReceiptRuleLambdaAction[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetLambdaAction(): void;
    /**
     * @stability stable
     */
    get lambdaActionInput(): cdktf.IResolvable | SesReceiptRuleLambdaAction[] | undefined;
    private _s3Action?;
    /**
     * @stability stable
     */
    get s3Action(): SesReceiptRuleS3Action[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set s3Action(value: SesReceiptRuleS3Action[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetS3Action(): void;
    /**
     * @stability stable
     */
    get s3ActionInput(): cdktf.IResolvable | SesReceiptRuleS3Action[] | undefined;
    private _snsAction?;
    /**
     * @stability stable
     */
    get snsAction(): SesReceiptRuleSnsAction[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set snsAction(value: SesReceiptRuleSnsAction[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSnsAction(): void;
    /**
     * @stability stable
     */
    get snsActionInput(): cdktf.IResolvable | SesReceiptRuleSnsAction[] | undefined;
    private _stopAction?;
    /**
     * @stability stable
     */
    get stopAction(): SesReceiptRuleStopAction[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set stopAction(value: SesReceiptRuleStopAction[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetStopAction(): void;
    /**
     * @stability stable
     */
    get stopActionInput(): cdktf.IResolvable | SesReceiptRuleStopAction[] | undefined;
    private _workmailAction?;
    /**
     * @stability stable
     */
    get workmailAction(): SesReceiptRuleWorkmailAction[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set workmailAction(value: SesReceiptRuleWorkmailAction[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetWorkmailAction(): void;
    /**
     * @stability stable
     */
    get workmailActionInput(): cdktf.IResolvable | SesReceiptRuleWorkmailAction[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
