import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Shield Protection.
 *
 * @stability stable
 */
export interface ShieldProtectionHealthCheckAssociationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/shield_protection_health_check_association#health_check_arn ShieldProtectionHealthCheckAssociation#health_check_arn}.
     *
     * @stability stable
     */
    readonly healthCheckArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/shield_protection_health_check_association#shield_protection_id ShieldProtectionHealthCheckAssociation#shield_protection_id}.
     *
     * @stability stable
     */
    readonly shieldProtectionId: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/shield_protection_health_check_association aws_shield_protection_health_check_association}.
 *
 * @stability stable
 */
export declare class ShieldProtectionHealthCheckAssociation extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/shield_protection_health_check_association aws_shield_protection_health_check_association} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ShieldProtectionHealthCheckAssociationConfig);
    private _healthCheckArn?;
    /**
     * @stability stable
     */
    get healthCheckArn(): string;
    /**
     * @stability stable
     */
    set healthCheckArn(value: string);
    /**
     * @stability stable
     */
    get healthCheckArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _shieldProtectionId?;
    /**
     * @stability stable
     */
    get shieldProtectionId(): string;
    /**
     * @stability stable
     */
    set shieldProtectionId(value: string);
    /**
     * @stability stable
     */
    get shieldProtectionIdInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
