import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Simple Notification Service.
 *
 * @stability stable
 */
export interface SnsSmsPreferencesConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_sms_preferences#default_sender_id SnsSmsPreferences#default_sender_id}.
     *
     * @stability stable
     */
    readonly defaultSenderId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_sms_preferences#default_sms_type SnsSmsPreferences#default_sms_type}.
     *
     * @stability stable
     */
    readonly defaultSmsType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_sms_preferences#delivery_status_iam_role_arn SnsSmsPreferences#delivery_status_iam_role_arn}.
     *
     * @stability stable
     */
    readonly deliveryStatusIamRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_sms_preferences#delivery_status_success_sampling_rate SnsSmsPreferences#delivery_status_success_sampling_rate}.
     *
     * @stability stable
     */
    readonly deliveryStatusSuccessSamplingRate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_sms_preferences#monthly_spend_limit SnsSmsPreferences#monthly_spend_limit}.
     *
     * @stability stable
     */
    readonly monthlySpendLimit?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_sms_preferences#usage_report_s3_bucket SnsSmsPreferences#usage_report_s3_bucket}.
     *
     * @stability stable
     */
    readonly usageReportS3Bucket?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/sns_sms_preferences aws_sns_sms_preferences}.
 *
 * @stability stable
 */
export declare class SnsSmsPreferences extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/sns_sms_preferences aws_sns_sms_preferences} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: SnsSmsPreferencesConfig);
    private _defaultSenderId?;
    /**
     * @stability stable
     */
    get defaultSenderId(): string;
    /**
     * @stability stable
     */
    set defaultSenderId(value: string);
    /**
     * @stability stable
     */
    resetDefaultSenderId(): void;
    /**
     * @stability stable
     */
    get defaultSenderIdInput(): string | undefined;
    private _defaultSmsType?;
    /**
     * @stability stable
     */
    get defaultSmsType(): string;
    /**
     * @stability stable
     */
    set defaultSmsType(value: string);
    /**
     * @stability stable
     */
    resetDefaultSmsType(): void;
    /**
     * @stability stable
     */
    get defaultSmsTypeInput(): string | undefined;
    private _deliveryStatusIamRoleArn?;
    /**
     * @stability stable
     */
    get deliveryStatusIamRoleArn(): string;
    /**
     * @stability stable
     */
    set deliveryStatusIamRoleArn(value: string);
    /**
     * @stability stable
     */
    resetDeliveryStatusIamRoleArn(): void;
    /**
     * @stability stable
     */
    get deliveryStatusIamRoleArnInput(): string | undefined;
    private _deliveryStatusSuccessSamplingRate?;
    /**
     * @stability stable
     */
    get deliveryStatusSuccessSamplingRate(): string;
    /**
     * @stability stable
     */
    set deliveryStatusSuccessSamplingRate(value: string);
    /**
     * @stability stable
     */
    resetDeliveryStatusSuccessSamplingRate(): void;
    /**
     * @stability stable
     */
    get deliveryStatusSuccessSamplingRateInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _monthlySpendLimit?;
    /**
     * @stability stable
     */
    get monthlySpendLimit(): number;
    /**
     * @stability stable
     */
    set monthlySpendLimit(value: number);
    /**
     * @stability stable
     */
    resetMonthlySpendLimit(): void;
    /**
     * @stability stable
     */
    get monthlySpendLimitInput(): number | undefined;
    private _usageReportS3Bucket?;
    /**
     * @stability stable
     */
    get usageReportS3Bucket(): string;
    /**
     * @stability stable
     */
    set usageReportS3Bucket(value: string);
    /**
     * @stability stable
     */
    resetUsageReportS3Bucket(): void;
    /**
     * @stability stable
     */
    get usageReportS3BucketInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
