import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS SSO Admin.
 *
 * @stability stable
 */
export interface SsoadminPermissionSetInlinePolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_permission_set_inline_policy#inline_policy SsoadminPermissionSetInlinePolicy#inline_policy}.
     *
     * @stability stable
     */
    readonly inlinePolicy: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_permission_set_inline_policy#instance_arn SsoadminPermissionSetInlinePolicy#instance_arn}.
     *
     * @stability stable
     */
    readonly instanceArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_permission_set_inline_policy#permission_set_arn SsoadminPermissionSetInlinePolicy#permission_set_arn}.
     *
     * @stability stable
     */
    readonly permissionSetArn: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_permission_set_inline_policy aws_ssoadmin_permission_set_inline_policy}.
 *
 * @stability stable
 */
export declare class SsoadminPermissionSetInlinePolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_permission_set_inline_policy aws_ssoadmin_permission_set_inline_policy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SsoadminPermissionSetInlinePolicyConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _inlinePolicy?;
    /**
     * @stability stable
     */
    get inlinePolicy(): string;
    /**
     * @stability stable
     */
    set inlinePolicy(value: string);
    /**
     * @stability stable
     */
    get inlinePolicyInput(): string | undefined;
    private _instanceArn?;
    /**
     * @stability stable
     */
    get instanceArn(): string;
    /**
     * @stability stable
     */
    set instanceArn(value: string);
    /**
     * @stability stable
     */
    get instanceArnInput(): string | undefined;
    private _permissionSetArn?;
    /**
     * @stability stable
     */
    get permissionSetArn(): string;
    /**
     * @stability stable
     */
    set permissionSetArn(value: string);
    /**
     * @stability stable
     */
    get permissionSetArnInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
