import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Storage Gateway.
 *
 * @stability stable
 */
export interface StoragegatewayNfsFileShareConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#audit_destination_arn StoragegatewayNfsFileShare#audit_destination_arn}.
     *
     * @stability stable
     */
    readonly auditDestinationArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#client_list StoragegatewayNfsFileShare#client_list}.
     *
     * @stability stable
     */
    readonly clientList: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#default_storage_class StoragegatewayNfsFileShare#default_storage_class}.
     *
     * @stability stable
     */
    readonly defaultStorageClass?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#file_share_name StoragegatewayNfsFileShare#file_share_name}.
     *
     * @stability stable
     */
    readonly fileShareName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#gateway_arn StoragegatewayNfsFileShare#gateway_arn}.
     *
     * @stability stable
     */
    readonly gatewayArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#guess_mime_type_enabled StoragegatewayNfsFileShare#guess_mime_type_enabled}.
     *
     * @stability stable
     */
    readonly guessMimeTypeEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#kms_encrypted StoragegatewayNfsFileShare#kms_encrypted}.
     *
     * @stability stable
     */
    readonly kmsEncrypted?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#kms_key_arn StoragegatewayNfsFileShare#kms_key_arn}.
     *
     * @stability stable
     */
    readonly kmsKeyArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#location_arn StoragegatewayNfsFileShare#location_arn}.
     *
     * @stability stable
     */
    readonly locationArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#notification_policy StoragegatewayNfsFileShare#notification_policy}.
     *
     * @stability stable
     */
    readonly notificationPolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#object_acl StoragegatewayNfsFileShare#object_acl}.
     *
     * @stability stable
     */
    readonly objectAcl?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#read_only StoragegatewayNfsFileShare#read_only}.
     *
     * @stability stable
     */
    readonly readOnly?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#requester_pays StoragegatewayNfsFileShare#requester_pays}.
     *
     * @stability stable
     */
    readonly requesterPays?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#role_arn StoragegatewayNfsFileShare#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#squash StoragegatewayNfsFileShare#squash}.
     *
     * @stability stable
     */
    readonly squash?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#tags StoragegatewayNfsFileShare#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#tags_all StoragegatewayNfsFileShare#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * cache_attributes block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#cache_attributes StoragegatewayNfsFileShare#cache_attributes}
     *
     * @stability stable
     */
    readonly cacheAttributes?: StoragegatewayNfsFileShareCacheAttributes;
    /**
     * nfs_file_share_defaults block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#nfs_file_share_defaults StoragegatewayNfsFileShare#nfs_file_share_defaults}
     *
     * @stability stable
     */
    readonly nfsFileShareDefaults?: StoragegatewayNfsFileShareNfsFileShareDefaults;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#timeouts StoragegatewayNfsFileShare#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: StoragegatewayNfsFileShareTimeouts;
}
/**
 * @stability stable
 */
export interface StoragegatewayNfsFileShareCacheAttributes {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#cache_stale_timeout_in_seconds StoragegatewayNfsFileShare#cache_stale_timeout_in_seconds}.
     *
     * @stability stable
     */
    readonly cacheStaleTimeoutInSeconds?: number;
}
export declare function storagegatewayNfsFileShareCacheAttributesToTerraform(struct?: StoragegatewayNfsFileShareCacheAttributesOutputReference | StoragegatewayNfsFileShareCacheAttributes): any;
/**
 * @stability stable
 */
export declare class StoragegatewayNfsFileShareCacheAttributesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): StoragegatewayNfsFileShareCacheAttributes | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: StoragegatewayNfsFileShareCacheAttributes | undefined);
    private _cacheStaleTimeoutInSeconds?;
    /**
     * @stability stable
     */
    get cacheStaleTimeoutInSeconds(): number;
    /**
     * @stability stable
     */
    set cacheStaleTimeoutInSeconds(value: number);
    /**
     * @stability stable
     */
    resetCacheStaleTimeoutInSeconds(): void;
    /**
     * @stability stable
     */
    get cacheStaleTimeoutInSecondsInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface StoragegatewayNfsFileShareNfsFileShareDefaults {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#directory_mode StoragegatewayNfsFileShare#directory_mode}.
     *
     * @stability stable
     */
    readonly directoryMode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#file_mode StoragegatewayNfsFileShare#file_mode}.
     *
     * @stability stable
     */
    readonly fileMode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#group_id StoragegatewayNfsFileShare#group_id}.
     *
     * @stability stable
     */
    readonly groupId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#owner_id StoragegatewayNfsFileShare#owner_id}.
     *
     * @stability stable
     */
    readonly ownerId?: string;
}
export declare function storagegatewayNfsFileShareNfsFileShareDefaultsToTerraform(struct?: StoragegatewayNfsFileShareNfsFileShareDefaultsOutputReference | StoragegatewayNfsFileShareNfsFileShareDefaults): any;
/**
 * @stability stable
 */
export declare class StoragegatewayNfsFileShareNfsFileShareDefaultsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): StoragegatewayNfsFileShareNfsFileShareDefaults | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: StoragegatewayNfsFileShareNfsFileShareDefaults | undefined);
    private _directoryMode?;
    /**
     * @stability stable
     */
    get directoryMode(): string;
    /**
     * @stability stable
     */
    set directoryMode(value: string);
    /**
     * @stability stable
     */
    resetDirectoryMode(): void;
    /**
     * @stability stable
     */
    get directoryModeInput(): string | undefined;
    private _fileMode?;
    /**
     * @stability stable
     */
    get fileMode(): string;
    /**
     * @stability stable
     */
    set fileMode(value: string);
    /**
     * @stability stable
     */
    resetFileMode(): void;
    /**
     * @stability stable
     */
    get fileModeInput(): string | undefined;
    private _groupId?;
    /**
     * @stability stable
     */
    get groupId(): string;
    /**
     * @stability stable
     */
    set groupId(value: string);
    /**
     * @stability stable
     */
    resetGroupId(): void;
    /**
     * @stability stable
     */
    get groupIdInput(): string | undefined;
    private _ownerId?;
    /**
     * @stability stable
     */
    get ownerId(): string;
    /**
     * @stability stable
     */
    set ownerId(value: string);
    /**
     * @stability stable
     */
    resetOwnerId(): void;
    /**
     * @stability stable
     */
    get ownerIdInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface StoragegatewayNfsFileShareTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#create StoragegatewayNfsFileShare#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#delete StoragegatewayNfsFileShare#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share#update StoragegatewayNfsFileShare#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function storagegatewayNfsFileShareTimeoutsToTerraform(struct?: StoragegatewayNfsFileShareTimeoutsOutputReference | StoragegatewayNfsFileShareTimeouts | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export declare class StoragegatewayNfsFileShareTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): StoragegatewayNfsFileShareTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: StoragegatewayNfsFileShareTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share aws_storagegateway_nfs_file_share}.
 *
 * @stability stable
 */
export declare class StoragegatewayNfsFileShare extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_nfs_file_share aws_storagegateway_nfs_file_share} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: StoragegatewayNfsFileShareConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _auditDestinationArn?;
    /**
     * @stability stable
     */
    get auditDestinationArn(): string;
    /**
     * @stability stable
     */
    set auditDestinationArn(value: string);
    /**
     * @stability stable
     */
    resetAuditDestinationArn(): void;
    /**
     * @stability stable
     */
    get auditDestinationArnInput(): string | undefined;
    private _clientList?;
    /**
     * @stability stable
     */
    get clientList(): string[];
    /**
     * @stability stable
     */
    set clientList(value: string[]);
    /**
     * @stability stable
     */
    get clientListInput(): string[] | undefined;
    private _defaultStorageClass?;
    /**
     * @stability stable
     */
    get defaultStorageClass(): string;
    /**
     * @stability stable
     */
    set defaultStorageClass(value: string);
    /**
     * @stability stable
     */
    resetDefaultStorageClass(): void;
    /**
     * @stability stable
     */
    get defaultStorageClassInput(): string | undefined;
    private _fileShareName?;
    /**
     * @stability stable
     */
    get fileShareName(): string;
    /**
     * @stability stable
     */
    set fileShareName(value: string);
    /**
     * @stability stable
     */
    resetFileShareName(): void;
    /**
     * @stability stable
     */
    get fileShareNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get fileshareId(): string;
    private _gatewayArn?;
    /**
     * @stability stable
     */
    get gatewayArn(): string;
    /**
     * @stability stable
     */
    set gatewayArn(value: string);
    /**
     * @stability stable
     */
    get gatewayArnInput(): string | undefined;
    private _guessMimeTypeEnabled?;
    /**
     * @stability stable
     */
    get guessMimeTypeEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set guessMimeTypeEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetGuessMimeTypeEnabled(): void;
    /**
     * @stability stable
     */
    get guessMimeTypeEnabledInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsEncrypted?;
    /**
     * @stability stable
     */
    get kmsEncrypted(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set kmsEncrypted(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetKmsEncrypted(): void;
    /**
     * @stability stable
     */
    get kmsEncryptedInput(): boolean | cdktf.IResolvable | undefined;
    private _kmsKeyArn?;
    /**
     * @stability stable
     */
    get kmsKeyArn(): string;
    /**
     * @stability stable
     */
    set kmsKeyArn(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyArn(): void;
    /**
     * @stability stable
     */
    get kmsKeyArnInput(): string | undefined;
    private _locationArn?;
    /**
     * @stability stable
     */
    get locationArn(): string;
    /**
     * @stability stable
     */
    set locationArn(value: string);
    /**
     * @stability stable
     */
    get locationArnInput(): string | undefined;
    private _notificationPolicy?;
    /**
     * @stability stable
     */
    get notificationPolicy(): string;
    /**
     * @stability stable
     */
    set notificationPolicy(value: string);
    /**
     * @stability stable
     */
    resetNotificationPolicy(): void;
    /**
     * @stability stable
     */
    get notificationPolicyInput(): string | undefined;
    private _objectAcl?;
    /**
     * @stability stable
     */
    get objectAcl(): string;
    /**
     * @stability stable
     */
    set objectAcl(value: string);
    /**
     * @stability stable
     */
    resetObjectAcl(): void;
    /**
     * @stability stable
     */
    get objectAclInput(): string | undefined;
    /**
     * @stability stable
     */
    get path(): string;
    private _readOnly?;
    /**
     * @stability stable
     */
    get readOnly(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set readOnly(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetReadOnly(): void;
    /**
     * @stability stable
     */
    get readOnlyInput(): boolean | cdktf.IResolvable | undefined;
    private _requesterPays?;
    /**
     * @stability stable
     */
    get requesterPays(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set requesterPays(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetRequesterPays(): void;
    /**
     * @stability stable
     */
    get requesterPaysInput(): boolean | cdktf.IResolvable | undefined;
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
    private _squash?;
    /**
     * @stability stable
     */
    get squash(): string;
    /**
     * @stability stable
     */
    set squash(value: string);
    /**
     * @stability stable
     */
    resetSquash(): void;
    /**
     * @stability stable
     */
    get squashInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _cacheAttributes;
    /**
     * @stability stable
     */
    get cacheAttributes(): StoragegatewayNfsFileShareCacheAttributesOutputReference;
    /**
     * @stability stable
     */
    putCacheAttributes(value: StoragegatewayNfsFileShareCacheAttributes): void;
    /**
     * @stability stable
     */
    resetCacheAttributes(): void;
    /**
     * @stability stable
     */
    get cacheAttributesInput(): StoragegatewayNfsFileShareCacheAttributes | undefined;
    private _nfsFileShareDefaults;
    /**
     * @stability stable
     */
    get nfsFileShareDefaults(): StoragegatewayNfsFileShareNfsFileShareDefaultsOutputReference;
    /**
     * @stability stable
     */
    putNfsFileShareDefaults(value: StoragegatewayNfsFileShareNfsFileShareDefaults): void;
    /**
     * @stability stable
     */
    resetNfsFileShareDefaults(): void;
    /**
     * @stability stable
     */
    get nfsFileShareDefaultsInput(): StoragegatewayNfsFileShareNfsFileShareDefaults | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): StoragegatewayNfsFileShareTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: StoragegatewayNfsFileShareTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): StoragegatewayNfsFileShareTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
