import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS VPC.
 *
 * @stability stable
 */
export interface DataAwsVpcIpamPoolConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/vpc_ipam_pool#allocation_resource_tags DataAwsVpcIpamPool#allocation_resource_tags}.
     *
     * @stability stable
     */
    readonly allocationResourceTags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/vpc_ipam_pool#id DataAwsVpcIpamPool#id}.
     *
     * @stability stable
     */
    readonly id?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/vpc_ipam_pool#ipam_pool_id DataAwsVpcIpamPool#ipam_pool_id}.
     *
     * @stability stable
     */
    readonly ipamPoolId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/vpc_ipam_pool#tags DataAwsVpcIpamPool#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/vpc_ipam_pool#filter DataAwsVpcIpamPool#filter}
     *
     * @stability stable
     */
    readonly filter?: DataAwsVpcIpamPoolFilter[] | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface DataAwsVpcIpamPoolFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/vpc_ipam_pool#name DataAwsVpcIpamPool#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/vpc_ipam_pool#values DataAwsVpcIpamPool#values}.
     *
     * @stability stable
     */
    readonly values: string[];
}
export declare function dataAwsVpcIpamPoolFilterToTerraform(struct?: DataAwsVpcIpamPoolFilter | cdktf.IResolvable): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/vpc_ipam_pool aws_vpc_ipam_pool}.
 *
 * @stability stable
 */
export declare class DataAwsVpcIpamPool extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/vpc_ipam_pool aws_vpc_ipam_pool} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsVpcIpamPoolConfig);
    /**
     * @stability stable
     */
    get addressFamily(): string;
    /**
     * @stability stable
     */
    get allocationDefaultNetmaskLength(): number;
    /**
     * @stability stable
     */
    get allocationMaxNetmaskLength(): number;
    /**
     * @stability stable
     */
    get allocationMinNetmaskLength(): number;
    private _allocationResourceTags?;
    /**
     * @stability stable
     */
    get allocationResourceTags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set allocationResourceTags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetAllocationResourceTags(): void;
    /**
     * @stability stable
     */
    get allocationResourceTagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get autoImport(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get awsService(): string;
    /**
     * @stability stable
     */
    get description(): string;
    private _id?;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    set id(value: string);
    /**
     * @stability stable
     */
    resetId(): void;
    /**
     * @stability stable
     */
    get idInput(): string | undefined;
    private _ipamPoolId?;
    /**
     * @stability stable
     */
    get ipamPoolId(): string;
    /**
     * @stability stable
     */
    set ipamPoolId(value: string);
    /**
     * @stability stable
     */
    resetIpamPoolId(): void;
    /**
     * @stability stable
     */
    get ipamPoolIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get ipamScopeId(): string;
    /**
     * @stability stable
     */
    get ipamScopeType(): string;
    /**
     * @stability stable
     */
    get locale(): string;
    /**
     * @stability stable
     */
    get poolDepth(): number;
    /**
     * @stability stable
     */
    get publiclyAdvertisable(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get sourceIpamPoolId(): string;
    /**
     * @stability stable
     */
    get state(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsVpcIpamPoolFilter[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set filter(value: DataAwsVpcIpamPoolFilter[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): cdktf.IResolvable | DataAwsVpcIpamPoolFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
