import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS VPC.
 *
 * @stability stable
 */
export interface DefaultVpcConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/default_vpc#enable_classiclink DefaultVpc#enable_classiclink}.
     *
     * @stability stable
     */
    readonly enableClassiclink?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/default_vpc#enable_classiclink_dns_support DefaultVpc#enable_classiclink_dns_support}.
     *
     * @stability stable
     */
    readonly enableClassiclinkDnsSupport?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/default_vpc#enable_dns_hostnames DefaultVpc#enable_dns_hostnames}.
     *
     * @stability stable
     */
    readonly enableDnsHostnames?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/default_vpc#enable_dns_support DefaultVpc#enable_dns_support}.
     *
     * @stability stable
     */
    readonly enableDnsSupport?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/default_vpc#ipv4_ipam_pool_id DefaultVpc#ipv4_ipam_pool_id}.
     *
     * @stability stable
     */
    readonly ipv4IpamPoolId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/default_vpc#ipv4_netmask_length DefaultVpc#ipv4_netmask_length}.
     *
     * @stability stable
     */
    readonly ipv4NetmaskLength?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/default_vpc#ipv6_cidr_block DefaultVpc#ipv6_cidr_block}.
     *
     * @stability stable
     */
    readonly ipv6CidrBlock?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/default_vpc#ipv6_cidr_block_network_border_group DefaultVpc#ipv6_cidr_block_network_border_group}.
     *
     * @stability stable
     */
    readonly ipv6CidrBlockNetworkBorderGroup?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/default_vpc#ipv6_ipam_pool_id DefaultVpc#ipv6_ipam_pool_id}.
     *
     * @stability stable
     */
    readonly ipv6IpamPoolId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/default_vpc#ipv6_netmask_length DefaultVpc#ipv6_netmask_length}.
     *
     * @stability stable
     */
    readonly ipv6NetmaskLength?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/default_vpc#tags DefaultVpc#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/default_vpc#tags_all DefaultVpc#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/default_vpc aws_default_vpc}.
 *
 * @stability stable
 */
export declare class DefaultVpc extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/default_vpc aws_default_vpc} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DefaultVpcConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get assignGeneratedIpv6CidrBlock(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get cidrBlock(): string;
    /**
     * @stability stable
     */
    get defaultNetworkAclId(): string;
    /**
     * @stability stable
     */
    get defaultRouteTableId(): string;
    /**
     * @stability stable
     */
    get defaultSecurityGroupId(): string;
    /**
     * @stability stable
     */
    get dhcpOptionsId(): string;
    private _enableClassiclink?;
    /**
     * @stability stable
     */
    get enableClassiclink(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enableClassiclink(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnableClassiclink(): void;
    /**
     * @stability stable
     */
    get enableClassiclinkInput(): boolean | cdktf.IResolvable | undefined;
    private _enableClassiclinkDnsSupport?;
    /**
     * @stability stable
     */
    get enableClassiclinkDnsSupport(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enableClassiclinkDnsSupport(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnableClassiclinkDnsSupport(): void;
    /**
     * @stability stable
     */
    get enableClassiclinkDnsSupportInput(): boolean | cdktf.IResolvable | undefined;
    private _enableDnsHostnames?;
    /**
     * @stability stable
     */
    get enableDnsHostnames(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enableDnsHostnames(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnableDnsHostnames(): void;
    /**
     * @stability stable
     */
    get enableDnsHostnamesInput(): boolean | cdktf.IResolvable | undefined;
    private _enableDnsSupport?;
    /**
     * @stability stable
     */
    get enableDnsSupport(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enableDnsSupport(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnableDnsSupport(): void;
    /**
     * @stability stable
     */
    get enableDnsSupportInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get instanceTenancy(): string;
    private _ipv4IpamPoolId?;
    /**
     * @stability stable
     */
    get ipv4IpamPoolId(): string;
    /**
     * @stability stable
     */
    set ipv4IpamPoolId(value: string);
    /**
     * @stability stable
     */
    resetIpv4IpamPoolId(): void;
    /**
     * @stability stable
     */
    get ipv4IpamPoolIdInput(): string | undefined;
    private _ipv4NetmaskLength?;
    /**
     * @stability stable
     */
    get ipv4NetmaskLength(): number;
    /**
     * @stability stable
     */
    set ipv4NetmaskLength(value: number);
    /**
     * @stability stable
     */
    resetIpv4NetmaskLength(): void;
    /**
     * @stability stable
     */
    get ipv4NetmaskLengthInput(): number | undefined;
    /**
     * @stability stable
     */
    get ipv6AssociationId(): string;
    private _ipv6CidrBlock?;
    /**
     * @stability stable
     */
    get ipv6CidrBlock(): string;
    /**
     * @stability stable
     */
    set ipv6CidrBlock(value: string);
    /**
     * @stability stable
     */
    resetIpv6CidrBlock(): void;
    /**
     * @stability stable
     */
    get ipv6CidrBlockInput(): string | undefined;
    private _ipv6CidrBlockNetworkBorderGroup?;
    /**
     * @stability stable
     */
    get ipv6CidrBlockNetworkBorderGroup(): string;
    /**
     * @stability stable
     */
    set ipv6CidrBlockNetworkBorderGroup(value: string);
    /**
     * @stability stable
     */
    resetIpv6CidrBlockNetworkBorderGroup(): void;
    /**
     * @stability stable
     */
    get ipv6CidrBlockNetworkBorderGroupInput(): string | undefined;
    private _ipv6IpamPoolId?;
    /**
     * @stability stable
     */
    get ipv6IpamPoolId(): string;
    /**
     * @stability stable
     */
    set ipv6IpamPoolId(value: string);
    /**
     * @stability stable
     */
    resetIpv6IpamPoolId(): void;
    /**
     * @stability stable
     */
    get ipv6IpamPoolIdInput(): string | undefined;
    private _ipv6NetmaskLength?;
    /**
     * @stability stable
     */
    get ipv6NetmaskLength(): number;
    /**
     * @stability stable
     */
    set ipv6NetmaskLength(value: number);
    /**
     * @stability stable
     */
    resetIpv6NetmaskLength(): void;
    /**
     * @stability stable
     */
    get ipv6NetmaskLengthInput(): number | undefined;
    /**
     * @stability stable
     */
    get mainRouteTableId(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
