import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS VPC.
 *
 * @stability stable
 */
export interface VpcEndpointConnectionNotificationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_endpoint_connection_notification#connection_events VpcEndpointConnectionNotification#connection_events}.
     *
     * @stability stable
     */
    readonly connectionEvents: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_endpoint_connection_notification#connection_notification_arn VpcEndpointConnectionNotification#connection_notification_arn}.
     *
     * @stability stable
     */
    readonly connectionNotificationArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_endpoint_connection_notification#vpc_endpoint_id VpcEndpointConnectionNotification#vpc_endpoint_id}.
     *
     * @stability stable
     */
    readonly vpcEndpointId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_endpoint_connection_notification#vpc_endpoint_service_id VpcEndpointConnectionNotification#vpc_endpoint_service_id}.
     *
     * @stability stable
     */
    readonly vpcEndpointServiceId?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/vpc_endpoint_connection_notification aws_vpc_endpoint_connection_notification}.
 *
 * @stability stable
 */
export declare class VpcEndpointConnectionNotification extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/vpc_endpoint_connection_notification aws_vpc_endpoint_connection_notification} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: VpcEndpointConnectionNotificationConfig);
    private _connectionEvents?;
    /**
     * @stability stable
     */
    get connectionEvents(): string[];
    /**
     * @stability stable
     */
    set connectionEvents(value: string[]);
    /**
     * @stability stable
     */
    get connectionEventsInput(): string[] | undefined;
    private _connectionNotificationArn?;
    /**
     * @stability stable
     */
    get connectionNotificationArn(): string;
    /**
     * @stability stable
     */
    set connectionNotificationArn(value: string);
    /**
     * @stability stable
     */
    get connectionNotificationArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get notificationType(): string;
    /**
     * @stability stable
     */
    get state(): string;
    private _vpcEndpointId?;
    /**
     * @stability stable
     */
    get vpcEndpointId(): string;
    /**
     * @stability stable
     */
    set vpcEndpointId(value: string);
    /**
     * @stability stable
     */
    resetVpcEndpointId(): void;
    /**
     * @stability stable
     */
    get vpcEndpointIdInput(): string | undefined;
    private _vpcEndpointServiceId?;
    /**
     * @stability stable
     */
    get vpcEndpointServiceId(): string;
    /**
     * @stability stable
     */
    set vpcEndpointServiceId(value: string);
    /**
     * @stability stable
     */
    resetVpcEndpointServiceId(): void;
    /**
     * @stability stable
     */
    get vpcEndpointServiceIdInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
