import { Wafv2RuleGroupCustomResponseBody, Wafv2RuleGroupRule, Wafv2RuleGroupVisibilityConfig } from './wafv2-rule-group-structs';
import { Wafv2RuleGroupVisibilityConfigOutputReference } from './wafv2-rule-group-structs';
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS WAF V2.
 *
 * @stability stable
 */
export interface Wafv2RuleGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_rule_group#capacity Wafv2RuleGroup#capacity}.
     *
     * @stability stable
     */
    readonly capacity: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_rule_group#description Wafv2RuleGroup#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_rule_group#name Wafv2RuleGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_rule_group#scope Wafv2RuleGroup#scope}.
     *
     * @stability stable
     */
    readonly scope: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_rule_group#tags Wafv2RuleGroup#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_rule_group#tags_all Wafv2RuleGroup#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * custom_response_body block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_rule_group#custom_response_body Wafv2RuleGroup#custom_response_body}
     *
     * @stability stable
     */
    readonly customResponseBody?: Wafv2RuleGroupCustomResponseBody[] | cdktf.IResolvable;
    /**
     * rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_rule_group#rule Wafv2RuleGroup#rule}
     *
     * @stability stable
     */
    readonly rule?: Wafv2RuleGroupRule[] | cdktf.IResolvable;
    /**
     * visibility_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_rule_group#visibility_config Wafv2RuleGroup#visibility_config}
     *
     * @stability stable
     */
    readonly visibilityConfig: Wafv2RuleGroupVisibilityConfig;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/wafv2_rule_group aws_wafv2_rule_group}.
 *
 * @stability stable
 */
export declare class Wafv2RuleGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/wafv2_rule_group aws_wafv2_rule_group} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Wafv2RuleGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _capacity?;
    /**
     * @stability stable
     */
    get capacity(): number;
    /**
     * @stability stable
     */
    set capacity(value: number);
    /**
     * @stability stable
     */
    get capacityInput(): number | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lockToken(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _scope?;
    /**
     * @stability stable
     */
    get scope(): string;
    /**
     * @stability stable
     */
    set scope(value: string);
    /**
     * @stability stable
     */
    get scopeInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _customResponseBody?;
    /**
     * @stability stable
     */
    get customResponseBody(): Wafv2RuleGroupCustomResponseBody[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set customResponseBody(value: Wafv2RuleGroupCustomResponseBody[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetCustomResponseBody(): void;
    /**
     * @stability stable
     */
    get customResponseBodyInput(): cdktf.IResolvable | Wafv2RuleGroupCustomResponseBody[] | undefined;
    private _rule?;
    /**
     * @stability stable
     */
    get rule(): Wafv2RuleGroupRule[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set rule(value: Wafv2RuleGroupRule[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetRule(): void;
    /**
     * @stability stable
     */
    get ruleInput(): cdktf.IResolvable | Wafv2RuleGroupRule[] | undefined;
    private _visibilityConfig;
    /**
     * @stability stable
     */
    get visibilityConfig(): Wafv2RuleGroupVisibilityConfigOutputReference;
    /**
     * @stability stable
     */
    putVisibilityConfig(value: Wafv2RuleGroupVisibilityConfig): void;
    /**
     * @stability stable
     */
    get visibilityConfigInput(): Wafv2RuleGroupVisibilityConfig | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
