import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS WorkLink.
 *
 * @stability stable
 */
export interface WorklinkFleetConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet#audit_stream_arn WorklinkFleet#audit_stream_arn}.
     *
     * @stability stable
     */
    readonly auditStreamArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet#device_ca_certificate WorklinkFleet#device_ca_certificate}.
     *
     * @stability stable
     */
    readonly deviceCaCertificate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet#display_name WorklinkFleet#display_name}.
     *
     * @stability stable
     */
    readonly displayName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet#name WorklinkFleet#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet#optimize_for_end_user_location WorklinkFleet#optimize_for_end_user_location}.
     *
     * @stability stable
     */
    readonly optimizeForEndUserLocation?: boolean | cdktf.IResolvable;
    /**
     * identity_provider block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet#identity_provider WorklinkFleet#identity_provider}
     *
     * @stability stable
     */
    readonly identityProvider?: WorklinkFleetIdentityProvider;
    /**
     * network block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet#network WorklinkFleet#network}
     *
     * @stability stable
     */
    readonly network?: WorklinkFleetNetwork;
}
/**
 * @stability stable
 */
export interface WorklinkFleetIdentityProvider {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet#saml_metadata WorklinkFleet#saml_metadata}.
     *
     * @stability stable
     */
    readonly samlMetadata: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet#type WorklinkFleet#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
export declare function worklinkFleetIdentityProviderToTerraform(struct?: WorklinkFleetIdentityProviderOutputReference | WorklinkFleetIdentityProvider): any;
/**
 * @stability stable
 */
export declare class WorklinkFleetIdentityProviderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): WorklinkFleetIdentityProvider | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: WorklinkFleetIdentityProvider | undefined);
    private _samlMetadata?;
    /**
     * @stability stable
     */
    get samlMetadata(): string;
    /**
     * @stability stable
     */
    set samlMetadata(value: string);
    /**
     * @stability stable
     */
    get samlMetadataInput(): string | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface WorklinkFleetNetwork {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet#security_group_ids WorklinkFleet#security_group_ids}.
     *
     * @stability stable
     */
    readonly securityGroupIds: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet#subnet_ids WorklinkFleet#subnet_ids}.
     *
     * @stability stable
     */
    readonly subnetIds: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet#vpc_id WorklinkFleet#vpc_id}.
     *
     * @stability stable
     */
    readonly vpcId: string;
}
export declare function worklinkFleetNetworkToTerraform(struct?: WorklinkFleetNetworkOutputReference | WorklinkFleetNetwork): any;
/**
 * @stability stable
 */
export declare class WorklinkFleetNetworkOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): WorklinkFleetNetwork | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: WorklinkFleetNetwork | undefined);
    private _securityGroupIds?;
    /**
     * @stability stable
     */
    get securityGroupIds(): string[];
    /**
     * @stability stable
     */
    set securityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    get securityGroupIdsInput(): string[] | undefined;
    private _subnetIds?;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    set subnetIds(value: string[]);
    /**
     * @stability stable
     */
    get subnetIdsInput(): string[] | undefined;
    private _vpcId?;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    get vpcIdInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet aws_worklink_fleet}.
 *
 * @stability stable
 */
export declare class WorklinkFleet extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet aws_worklink_fleet} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: WorklinkFleetConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _auditStreamArn?;
    /**
     * @stability stable
     */
    get auditStreamArn(): string;
    /**
     * @stability stable
     */
    set auditStreamArn(value: string);
    /**
     * @stability stable
     */
    resetAuditStreamArn(): void;
    /**
     * @stability stable
     */
    get auditStreamArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get companyCode(): string;
    /**
     * @stability stable
     */
    get createdTime(): string;
    private _deviceCaCertificate?;
    /**
     * @stability stable
     */
    get deviceCaCertificate(): string;
    /**
     * @stability stable
     */
    set deviceCaCertificate(value: string);
    /**
     * @stability stable
     */
    resetDeviceCaCertificate(): void;
    /**
     * @stability stable
     */
    get deviceCaCertificateInput(): string | undefined;
    private _displayName?;
    /**
     * @stability stable
     */
    get displayName(): string;
    /**
     * @stability stable
     */
    set displayName(value: string);
    /**
     * @stability stable
     */
    resetDisplayName(): void;
    /**
     * @stability stable
     */
    get displayNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastUpdatedTime(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _optimizeForEndUserLocation?;
    /**
     * @stability stable
     */
    get optimizeForEndUserLocation(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set optimizeForEndUserLocation(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetOptimizeForEndUserLocation(): void;
    /**
     * @stability stable
     */
    get optimizeForEndUserLocationInput(): boolean | cdktf.IResolvable | undefined;
    private _identityProvider;
    /**
     * @stability stable
     */
    get identityProvider(): WorklinkFleetIdentityProviderOutputReference;
    /**
     * @stability stable
     */
    putIdentityProvider(value: WorklinkFleetIdentityProvider): void;
    /**
     * @stability stable
     */
    resetIdentityProvider(): void;
    /**
     * @stability stable
     */
    get identityProviderInput(): WorklinkFleetIdentityProvider | undefined;
    private _network;
    /**
     * @stability stable
     */
    get network(): WorklinkFleetNetworkOutputReference;
    /**
     * @stability stable
     */
    putNetwork(value: WorklinkFleetNetwork): void;
    /**
     * @stability stable
     */
    resetNetwork(): void;
    /**
     * @stability stable
     */
    get networkInput(): WorklinkFleetNetwork | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
