import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS WorkSpaces.
 *
 * @stability stable
 */
export interface DataAwsWorkspacesDirectoryConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/workspaces_directory#directory_id DataAwsWorkspacesDirectory#directory_id}.
     *
     * @stability stable
     */
    readonly directoryId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/workspaces_directory#tags DataAwsWorkspacesDirectory#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataAwsWorkspacesDirectorySelfServicePermissions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get changeComputeType(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get increaseVolumeSize(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get rebuildWorkspace(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get restartWorkspace(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get switchRunningMode(): cdktf.IResolvable;
}
/**
 * @stability stable
 */
export declare class DataAwsWorkspacesDirectoryWorkspaceAccessProperties extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get deviceTypeAndroid(): string;
    /**
     * @stability stable
     */
    get deviceTypeChromeos(): string;
    /**
     * @stability stable
     */
    get deviceTypeIos(): string;
    /**
     * @stability stable
     */
    get deviceTypeLinux(): string;
    /**
     * @stability stable
     */
    get deviceTypeOsx(): string;
    /**
     * @stability stable
     */
    get deviceTypeWeb(): string;
    /**
     * @stability stable
     */
    get deviceTypeWindows(): string;
    /**
     * @stability stable
     */
    get deviceTypeZeroclient(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsWorkspacesDirectoryWorkspaceCreationProperties extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get customSecurityGroupId(): string;
    /**
     * @stability stable
     */
    get defaultOu(): string;
    /**
     * @stability stable
     */
    get enableInternetAccess(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get enableMaintenanceMode(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get userEnabledAsLocalAdministrator(): cdktf.IResolvable;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/workspaces_directory aws_workspaces_directory}.
 *
 * @stability stable
 */
export declare class DataAwsWorkspacesDirectory extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/workspaces_directory aws_workspaces_directory} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsWorkspacesDirectoryConfig);
    /**
     * @stability stable
     */
    get alias(): string;
    /**
     * @stability stable
     */
    get customerUserName(): string;
    private _directoryId?;
    /**
     * @stability stable
     */
    get directoryId(): string;
    /**
     * @stability stable
     */
    set directoryId(value: string);
    /**
     * @stability stable
     */
    get directoryIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get directoryName(): string;
    /**
     * @stability stable
     */
    get directoryType(): string;
    /**
     * @stability stable
     */
    get dnsIpAddresses(): string[];
    /**
     * @stability stable
     */
    get iamRoleId(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get ipGroupIds(): string[];
    /**
     * @stability stable
     */
    get registrationCode(): string;
    /**
     * @stability stable
     */
    selfServicePermissions(index: string): DataAwsWorkspacesDirectorySelfServicePermissions;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    workspaceAccessProperties(index: string): DataAwsWorkspacesDirectoryWorkspaceAccessProperties;
    /**
     * @stability stable
     */
    workspaceCreationProperties(index: string): DataAwsWorkspacesDirectoryWorkspaceCreationProperties;
    /**
     * @stability stable
     */
    get workspaceSecurityGroupId(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
